/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/
//Global variables
var offlineConfFile = "";
var LoadConfigFile = "";
var LAN_FAMILY_INDEX = "31";
var noselect = false;
var dummyLANID = "1";
var maconlyConfig = false;
var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";
var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";

// values returned if a value is 1 from the backend
var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";

var enableApplyButton = false;
var CurrentLANProgrammed = "";

var gArrConfigFilelist = [];
var gArrConfigIndex = 0;
var count = 0;

//Widget IDs of String fields in the GUI
var GwidgetlistString = [
	"macaddr"
];

//Widget IDs of Hex fields in the GUI
var GwidgetValuelistHex = [
	"subsystemvid",
	"subsystemid"
];

//Widget IDs of Checkbox fields in the GUI
var GwidgetCheckbox = [
	"LED0Enable",
	"LED1Enable",
	"LED2Enable",
	"LED3Enable"
];

var GwidgetlistDropDown = [
	"LED0Function",
	"LED1Function",
	"LED2Function",
	"LED3Function",
	"auxcurrent",
	"pmeSupport",
	"L0Latency",
	"L1Latency",
	"OBFFSupport"
];

var DropDownLEDListFunction = [
	"Link/Activity",
	"Link1000/Activity",
	"Link100/Activity",
	"Link10/Activity",
	"Link100/1000/Activity",
	"Link10/1000/Activity",
	"Link10/100/Activity",
	"Reserved",
	"Duplex/Collision",
	"Collision",
	"Activity",
	"Reserved",
	"Auto-Negotiation Fault",
	"Serial Mode",
	"Force LED Off",
	"Force LED On"
];

var auxcurrentFunction = [
	"0 mA",
	"55 mA",
	"100 mA",
	"160 mA",
	"220 mA",
    "270 mA",
	"320 mA",
	"375 mA"
];

var pmeFunction1 = [
    "D0",
	"D3 Hot",
	"D3 Cold"
];

var L0LatencyFunction = [
    "1 us",
	"2 us",
	"3 us",
	"4 us",
	"5 us",
	"6 us",
	"7 us"
];

var L1LatencyFunction = [
   "1 us",
	"2 us",
	"4 us",
	"8 us",
	"16 us",
	"32 us",
	"64 us"	
];

var OBFFSupportFunction = [
   "Not Supported",
	"Supported using message Signaling only",
	"Supported using WAKE# Signaling only",
	"Supported using WAKE# and message signaling"
];
//Widget IDs of Radio fields in the GUI
var GwidgetlistRadio = [
	"LED0CombineEnable",
	"LED1CombineEnable",
	"LED2CombineEnable",
	"LED3CombineEnable",
	"LED0",
	"LED1",
	"LED2",
	"LED3",
	"LED0Polarity",
	"LED1Polarity",
	"LED2Polarity",
	"LED3Polarity",
	"LEDActivity",
	"LEDRate",
	"LEDPulsing",
	"ClkPowerEnable",
	"LTRSupport",
	"ASPMControl",
	"L1PMSubstates",
	"PciPmL1",
	"PciPmL2",
	"ASPML2",
	"ASPML1",
	"macSpeedDetect",
	"macConfiguration",
	"macDuplexDetection",
	"macDuplexMode",
	"macDuplexPolarity",
	"macEEETxClkStopEnable",
	"macRgmiiTxDelayEnable",
	"macRgmiiRxEnable",
	"macClk125Enable",
	"macRefClk25Enable",
	"macEEEEnable"
];

//Mapping Hex widgets to the meaningful elaborations to print while in error
var Mapping = {
	"macaddr": "MAC Address",
	"subsystemvid": "Subsystem Vendor ID",
	"subsystemid": "Subsystem ID",
	"auxcurrent":"Aux Current",
	"pmeSupport":"PME Support",
	"ClkPowerEnable":"Clock Power Management",
	"ASPMControl":"ASPM Control",
	"L0Latency":"L0 Latency",
	"L1Latency":"L1 Latency",
	"LTRSupport":"LTR Support",
	"OBFFSupport":"OBFF Support",
	"L1PMSubstates":"L1 PM Subststes",
	"PciPmL1":"PCI-PM L1.1 Support",
	"PciPmL2":"PCI-PM L2 Support",
	"ASPML1":"ASPM L1.1 Support",
	"ASPML2":"ASPM L1.2 Support",
	"LED0Function": "LED 0 Function",
	"LED1Function": "LED 1 Function",
	"LED2Function": "LED 2 Function",
	"LED3Function": "LED 3 Function",
	"LED0Enable": "LED 0 Enable",
	"LED1Enable": "LED 1 Enable",
	"LED2Enable": "LED 2 Enable",
	"LED3Enable": "LED 3 Enable",
	"LED0CombineEnable":"LED Combination Enable",
	"LED1CombineEnable":"LED Combination Enable",
	"LED2CombineEnable":"LED Combination Enable",
	"LED3CombineEnable":"LED Combination Enable",
	"LED0": "LED Pulse Stretch Enable",
	"LED1": "LED Pulse Stretch Enable",
	"LED2": "LED Pulse Stretch Enable",
	"LED3": "LED Pulse Stretch Enable",
	"LEDRate":"LED Rate",
	"LEDPulsing":"LED Pulse",
	"LED0Polarity":"LED Polarity",
	"LED1Polarity":"LED Polarity",
	"LED2Polarity":"LED Polarity",
	"LED3Polarity":"LED Polarity",
	"LEDActivity":"LED Activity",
	"macSpeedDetect":"Automatic Speed Detection",
	"macConfiguration":"MAC Configuration",
	"macDuplexMode":"Duplex Mode",
	"macDuplexDetection":"Duplex Mode Detection",
	"macDuplexPolarity":"Duplex Polarity",
	"macEEEEnable":"Energy Efficient Ethernet Enable",
	"macEEETxClkStopEnable":"Energy Efficient Ethernet TX Clock Stop Enable",
	"macRgmiiTxDelayEnable":"RGMII TXC Enable",
	"macRgmiiRxEnable":"RGMII RXC Enable",
	"macClk125Enable":"Generate CLK 125 MHZ Enable",
	"macRefClk25Enable":"Reference CLK 25 MHZ Out Enable",
	"userInitentry":"User Initialization Table"
	
};


function getOfflineConf() {
	offlineConfFile = "";
	var file = document.getElementById("offlineConfFileID").files[0];
	var fileSize = file.size;
	update_status_message("The size of the Configuration file selected is " + fileSize + " Bytes");
	if (file) {
		$("#offlineConfFileID").css({
			background: "white",
			border: "0px"
		});
		offlineConfFile = file.name;
		var saveextension = offlineConfFile.substr(offlineConfFile.lastIndexOf('.') + 1);
		if(saveextension === offlineConfFile)
		{
			offlineConfFile = offlineConfFile + ".bin";
		}
		else if(saveextension === "bin")
		{
			var mesg = ("Selected .bin file to save is :" + offlineConfFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .bin");
			update_status_message("Selected File Type is not supported.Supported File type is .bin");
			$("#offlineConfFileID").val('');
			$("#offlineConfFileID").css({
			background: "white",
			border: "0px"
			});
			offlineConfFile="";
			return;
		}
	} else {
		$("#offlineConfFileID").css({
			background: "yellow",
			border: "3px red solid"
		});
		update_status_message("No configuration file(.bin) is selected.");
		offlineConfFile = "";
		alert("No configuration file(.bin) is selected.");
	}
}

function startReadcfg() {
	clearLANWidgetMap();
	setLoadAction(true);
	LoadConfFile = "";
	var fileextension;
	var file = document.getElementById("offlineConfload").files[0];
	var fileSize = file.size;
	var Filelist = "";
	var canAllow = false;
	var fileSize = file.size;
	LoadConfFile = file.name;
	fileextension = LoadConfFile.substr(LoadConfFile.lastIndexOf('.') + 1);
	if(fileextension == "bin" || fileextension == "ini")
	{
		update_status_message("The size of the Configuration file selected is " + fileSize + " Bytes.");
	} else {
		alert("Selected File Type is not supported. Please Select File type : .bin/.ini");
		//reset_file_input();
		$("#offlineConfload").val('');
		$("#offlineConfload").css({
			background: "white",
			border: "0px"
			});
		LoadConfFile ="";
		return;
	}

	if (file) {
		if (fileextension == "ini") {
			if (fileSize > 0) {
				canAllow = true;
			} else {
				update_status_message("The size of configuration file \"" + file.name + "\" is empty.");
				LoadConfFile = "";
				alert("The size of configuration file \"" + file.name + "\" is empty.");
				return;
			}
		} else if (fileextension == "bin") {
			if (fileSize <= 512) {
				canAllow = true;
			} else {
				update_status_message("The size of configuration file \"" + file.name + "\" cannot exceed 512 bytes.");
				LoadConfFile = "";
				alert("The size of configuration file \"" + file.name + "\" cannot exceed 512 bytes.");
				return;
			}
		} else {
			//Do nothing	
		}
	}
	
	if (canAllow) {
		$("#offlineConfload").css({
			background: "white",
			border: "0px"
		});
	}
	if (gArrConfigIndex > 15)
	{
		alert("Max configuration file count is 15");
		return;
	}
	gArrConfigFilelist[gArrConfigIndex++] = LoadConfFile;
	var Texttodisplay = "Loaded Configuration files are ";
	for(var i = 0; i < gArrConfigIndex; i++)
	{
		Filelist = Filelist + gArrConfigFilelist[i] + ",";
	}
	update_status_message(Texttodisplay + Filelist);
	//overrideDefaultOfflineConfig function will return strap values in LoadConfFile
	//Return string format is "widget:value###widget:value.."
	populateDefaultValues();
	
}

//Document START
$(document).ready(function () {
	$("#Apply").attr('disabled', true);
	$("#Reset").attr('disabled', true);
	
	$('#SaveFileField').hide();
	$('#SaveFileField').attr('disabled', 'disabled');
	$('#LoadFileField').removeAttr('disabled');
	$("#LoadFileField").attr('disabled', true);
	$('#LoadFileField').show();
	$("#LoadFileField").attr('disabled', true);

	update_status_message("Offline Configuration");
	clearLANWidgetMap();
});
//Document END

var sku;
$('#selectsku_pcie li').on('click', function() {
	$('#nav').show();
	$('#close').hide();
	$('#sfield').hide();
	$('#removeEntry').hide();
	document.getElementById("overlay").setAttribute("class","col-xs-2");
	sku = $(this).text();
	update_status_message("Selected SKU is :" + sku);
	clearLANWidgetMap();
	gArrConfigIndex = 0;
	changecount = 0;
	$("#Reset").attr('disabled', false);
	reset_file_input();
	offlineConfFile="";
	enable_all_fields();
	set_changed_fields_border_default();
	populateDefaultValues();
	$('#RemoveTableSection').hide();
	if ((sku == "LAN7430")) 
	{
		$("#duplexPolarity").attr('disabled', true);
		$("#LedTab").show();
		$("#showfor7431").hide();
	} else if((sku == "LAN7431")){
		//$("#NotForLAN7400").show();
		$("#duplexPolarity").attr('disabled', false);
		$("#LedTab").hide();
		$("#showfor7431").show();
	}
	
});

(function ($) {
    set_changed_fields_border_default = function () {
        $("input[type='text']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='number']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='checkbox']").each(function() {
            $(this).parent().removeClass("highlight");
        });

        $("input[type='radio']").each(function() {
            $(this).parent().removeClass("highlight");
        });
		
		$("#ConfigLocationGroup").parent().removeClass("highlight");
		
		//LEDCombineEnableGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "CombineEnableGroup";
			$(wid).parent().removeClass("highlight");
		}	
		
		//LEDPolarityGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "PolarityGroup";
			$(wid).parent().removeClass("highlight");
		}
		//LEDGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "Group";
			$(wid).parent().removeClass("highlight");
		}
		
		//LEDRate
		wid = "#LEDRate" + "Group";
		$(wid).parent().removeClass("highlight");
		
		//LEDRate
		wid = "#LEDPulsing" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#LEDActivity" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#LTRSupport" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ClkPowerEnable" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPMControl" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#L1PMSubstates" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#PciPmL2" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#PciPmL1" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPML2" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPML1" + "Group";
		$(wid).parent().removeClass("highlight");
		
        $(".dropdown li a").each(function () {
            var parent = $(this).closest('div');
            $(parent).css('border-color', 'transparent');
        });
		
		  $("#macConfigurationGroup").parent().removeClass("highlight");
		  $("#macDuplexModeGroup").parent().removeClass("highlight");
		  $("#macSpeedDetectGroup").parent().removeClass("highlight");
		  $("#macDuplexDetectionGroup").parent().removeClass("highlight");
		  $("#macDuplexPolarityGroup").parent().removeClass("highlight");
		  $("#macEEEEnableGroup").parent().removeClass("highlight");
		  $("#macEEETxClkStopEnableGroup").parent().removeClass("highlight");
		  $("#macRgmiiTxDelayEnableGroup").parent().removeClass("highlight");
		  $("#macRgmiiRxEnableGroup").parent().removeClass("highlight");
		  $("#macRefClk25EnableGroup").parent().removeClass("highlight");
		  $("#macClk125EnableGroup").parent().removeClass("highlight");
	};
})(jQuery);

(function ($) {
    reset_file_input = function () {
        $("input[type='file']").val('');
		
		$("input[type='file']").css({
						background: "white",
						border: "0px"
						});
    };
})(jQuery);

function enable_all_fields() {
	$("#MAC_Section").attr('disabled', false);
	$("#config_Section").attr('disabled', false);
	$("#DI_Hex_Section").attr('disabled', false);
	$("#devicecap2_Section").attr('disabled', false);
	$("#DeviceCap_Section").attr('disabled', false);
	$("#powerTab_Section").attr('disabled', false);
	$("#ASPM_Section").attr('disabled', false);
	$("#PM_Section").attr('disabled', false);
	$("#macconfig_Section").attr('disabled', false);
	$("#LEDBehavior_Section").attr('disabled', false);
	$("#LED0_Section").attr('disabled', false);
	$("#LED1_Section").attr('disabled', false);
	$("#LED2_Section").attr('disabled', false);
	$("#LED3_Section").attr('disabled', false);
	document.getElementById("AddNewEntry").disabled = false;
	
}

function disable_all_fields() {
	$("#config_Section").attr('disabled', true);
	$("#DI_Hex_Section").attr('disabled', true);
	$("#devicecap2_Section").attr('disabled', true);
	$("#DeviceCap_Section").attr('disabled', true);
	$("#powerTab_Section").attr('disabled', true);
	$("#ASPM_Section").attr('disabled', true);
	$("#PM_Section").attr('disabled', true);
	$("#macconfig_Section").attr('disabled', true);
	$("#LEDBehavior_Section").attr('disabled', true);
	$("#LED0_Section").attr('disabled', true);
	$("#LED1_Section").attr('disabled', true);
	$("#LED2_Section").attr('disabled', true);
	$("#LED3_Section").attr('disabled', true);
	document.getElementById("AddNewEntry").disabled = true;
		
}

//Onclick event for dropdown STARTS
$(document).on('click', '.dropdown li a', function (event) {
	// this code is for making the current selection appear with caret
	var $target = $(event.currentTarget);

	$target.closest('.btn-group')
	.find('[data-bind]').text($target.text())
	.end()
	.children('.dropdown-toggle').dropdown('toggle');
	var selop = $(this).text();
	console.log("Selected Option - All dropdowns:" + selop);
});
//Onclick event for dropdown ENDS

function setOfflineConf() {
	setFileType("bin", 1);
}
function getOfflineConftype() {
	setFileType("bin_ini", 0);
}

// Reset all fields
$("#Reset").click(function() {
	
	var div;
	userIncrement = 0;
	$('#linkuser').hide();
	while (div = document.getElementById('check')) {
		div.parentNode.removeChild(div);
	}
	count = 0;
	htcount = 0;
	userIncrement = 0;
				
	$('#RemoveTableSection').hide();
	$("input[id=userAddress]").parent().parent().parent().parent().removeClass("highlight");
	$("input[id=userAddress]").val("");
	$("input[id=userValue1]").val("");
	$("input[id=userValue2]").val("");
	$("input[id=userValue3]").val("");
	$("input[id=userValue4]").val("");
	$("input[id=byteEnable1]").prop('checked',false); 
	$("input[id=byteEnable2]").prop('checked',false); 
	$("input[id=byteEnable3]").prop('checked',false); 
	$("input[id=byteEnable4]").prop('checked',false); 
	clearLANWidgetMap();
	setConfigMode(true, sku);
	setLoadAction(false);
	populateDefaultValues();
	offlineConfFile="";
	LoadConfFile = "";
	gArrConfigIndex = 0;
	changecount =0;
	switchloadsave(changecount);
	reset_file_input();
	$("input[type='file']").val('');	
	$("#Apply").attr('disabled',true);
	// Change border back to default color from red
	set_changed_fields_border_default();
	resetVariables();
});
// End of Reset all fields


//Populating the default widget values based on the SKU
function populateDefaultValues() {
	
	var skuName = sku; //Get from the dropdown
	
	//Setting the configuration mode to offline in the backend
	setConfigMode(true, skuName);

	// Updating GwidgetlistString
	$.each(GwidgetlistString, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, value);
		if(widgetValue === "") {
			$(widgetid).val(stringnullvalue);
		} else {
			$(widgetid).val(widgetValue);
		}
	});

	// Updating GwidgetValuelistHex
	$.each(GwidgetValuelistHex, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, value);
		var decvalue = parseInt(widgetValue,10);
		var hexstring = decvalue.toString(16);
		$(widgetid).val(hexstring);
	});

	// Updating GwidgetlistCheckbox
	$.each(GwidgetCheckbox, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, value);
		
		if ( widgetValue == checkbox_checked_value )
		{
			$(widgetid).prop('checked',true);     
			// If there are corresponding fieldsets - enable them 
			$(widgetid).trigger("change"); 
			set_changed_fields_border_default();
		}
		else {
			$(widgetid).prop('checked',false);
			// If there are corresponding fieldsets - disable them 
			$(widgetid).trigger("change"); 
			set_changed_fields_border_default();
		}
	});

	// Updating GwidgetlistRadio
	$.each(GwidgetlistRadio, function( index, value ) {
		var groupname = value +"Group";
		var widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, value);
		if(value == "L1PMSubstates")
			{
				if((widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, "L1PMSubstates")) == 0)
				{
					$("#hideL1xbits").attr('disabled', true);
				}
				else
				{
					$("#hideL1xbits").attr('disabled', false);
				}
			}
			
			if(value == "macSpeedDetect")
			{
				if((widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, "macSpeedDetect")) == 1)
				{
					$("#macConfig").attr('disabled', true);
				}
				else
				{
					$("#macConfig").attr('disabled', false);
				}
			}
			
			if(value == "macDuplexDetection")
			{
				if((widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, "macDuplexDetection")) == 1)
				{
					$("#duplexMode").attr('disabled', true);
					$("#duplexPolarity").attr('disabled', true);
				}
				else
				{
					$("#duplexMode").attr('disabled', true);
					$("#duplexPolarity").attr('disabled', false);
				}
			}
			if(value == "macConfiguration") 
			{
				if(widgetValue == 3) {
					widgetValue = 2;
				}
			}
			
		var nameofcontrol = "input[name=" + groupname + "][value=" + widgetValue + "]";
		$(nameofcontrol).prop("checked", true);
		set_changed_fields_border_default();
	});

	// Updating GwidgetlistDropDown
	$.each(GwidgetlistDropDown, function( index, value ) {
		var widgetValue = getLANWidgetValue(LAN_FAMILY_INDEX, value);
		var decval = parseInt(widgetValue,10);
		var nameofcontrol = "." + value;
		var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";
		var selText = "None";

		if ((value == "LED0Function") || (value == "LED1Function") ||
			(value == "LED2Function") || (value == "LED3Function"))
			{
				$.each(DropDownLEDListFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "auxcurrent")
			{
				$.each(auxcurrentFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "pmeSupport")
			{
				$.each(pmeFunction1, function( index, valuelist ) {
					if(decval == 1)
					{
						selText = "D0";
					}
					if(decval == 8)
					{
						selText = "D3 Hot";
					}
					if(decval == 16)
					{
						selText = "D3 Cold";
					}
				});
			}
			
			if (value == "L0Latency")
			{
				$.each(L0LatencyFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "L1Latency")
			{
				$.each(L1LatencyFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
			
			if (value == "OBFFSupport")
			{
				$.each(OBFFSupportFunction, function( index, valuelist ) {
					if ( index == decval)
					{
						selText = valuelist;
					}
				});
			}
				
			// Update fields based on obtained value
		$(nameofcontrol)
	   .find(nameofcontrol1).text(selText)
		.children('.dropdown-toggle').dropdown('toggle');
	});
	
	//Handling User Initialization table
	var user_enableVal = getLANWidgetValue(LAN_FAMILY_INDEX, "userInitentry");
	var offset;
	var configOffset;
	var addressOffset;
	var address;
	var valueOffset1;
	var valueOffset2;
	var valueOffset3;
	var valueOffset4;
	var inc = 0;
	
	
	for (var index = 0; index < user_enableVal.length; index++)
	{
		var splituser_enableVal = user_enableVal.split('+');
		if(splituser_enableVal[index] == "START_OFFSET")
		{
			$('#RemoveTableSection').show();
			userIncrement++;
			count++;
			$('#linkuser').show();
			var objTo = document.getElementById('dynamicUsertable')
			var divtest = document.createElement("div");
			divtest.innerHTML = '<div id = "check"><div id = "che'+inc+'"><div class="container"> <div class="row"><div class="col-sm-3"> <p class="text-muted">Register Address Space</p> <div class="form-group"> <div class="col-sm-4" id="userConfig'+inc+'Group" onchange="updateFCWValue()"> <input type="radio" name="userConfig'+inc+'Group" id="userConfig'+inc+1+'" value="0" /><label for="userConfig'+inc+1+'" >CSR</label>  </br> <input type="radio" name="userConfig'+inc+'Group" id="userConfig'+inc+'" value="1" /><label for="userConfig'+inc+'" >PCIe</label> </div></div></div> <div class="col-sm-3"> <p class="text-muted">CSR/PCIecfg Register Address(Hex)</p> <div class="form-group"> <div class="col-sm-6" align = "center"> </br> <input id="userAddress" maxlength = "4" type="text" class="form-control" placeholder="Address"> </div></div></div> <div class="col-sm-6"><p class="text-muted">CSR/PCIecfg Register Value(Hex)</p> <div class="form-group"><div class="col-sm-3"><input id="byteEnable1" type="checkbox" ><label> Byte3(MSB)</label><input maxlength = "2" id="userValue1" type="text" class="form-control" placeholder="Value" onchange = "value1Change()"></div><div class="col-sm-3"><input id="byteEnable2" type="checkbox" ><label>Byte 2</label><input id="userValue2" maxlength = "2" type="text" class="form-control" placeholder="Value" onchange = "value2Change()"></div><div class="col-sm-3"><input id="byteEnable3" type="checkbox" ><label>Byte 1</label><input id="userValue3" maxlength = "2" type="text" class="form-control" placeholder="Value" onchange = "value3Change()"></div><div class="col-sm-3"><input id="byteEnable4" type="checkbox" ><label>Byte 0(LSB)</label><input id="userValue4" maxlength = "2" type="text" class="form-control" placeholder="Value" onchange = "value4Change()"></div></div><label for="singleClose" data-toggle="tooltip" title="Click to Remove Entry" data-container="body"><span class="popupClose" id = "singleClose" onClick = "$(this).parent().parent().parent().parent().remove();remEntry() " onchange = "changeSave()" oncut="changeClose()"></span></label></div></div></div></div></div>';
			objTo.appendChild(divtest);
			
			offset = splituser_enableVal[index+1];
			addressOffset = splituser_enableVal[index+3];
			configOffset = splituser_enableVal[index+2];
			var splitconfigOffset = configOffset.split("");
			
			if((splitconfigOffset[1] & 8) == 8)
			{
				var controlName = "div#che"+inc+" input[name=userConfig"+inc+"Group][value=1]";
				$(controlName).prop("checked", true);
			}
			else 
			{
				var controlName = "div#che"+inc+" input[name=userConfig"+inc+"Group][value=0]";
				$(controlName).prop("checked", true);
			}
			splitconfigOffset[1] = splitconfigOffset[1] & 7;
			splitconfigOffset = splitconfigOffset[1]+addressOffset;
			splitconfigOffset= parseInt(splitconfigOffset,16);
			address = splitconfigOffset << 2;
			address = address.toString(16);
			
			$('div#che'+inc+' input[id="userAddress"]').val(address);
			
			if(((parseInt(configOffset,16)) & 128) == 128)
			{
				valueOffset1 = splituser_enableVal[index+4];
				$("div#che"+inc+" input[id=byteEnable1]").prop('checked',true);   
			} else {
				valueOffset1 = 00;
				$("div#che"+inc+" input[id=byteEnable1]").prop('checked',false);  
			}
			
			if(((parseInt(configOffset,16)) & 64) == 64)
			{
				valueOffset2 = splituser_enableVal[index+5];
				$("div#che"+inc+" input[id=byteEnable2]").prop('checked',true);  
			} else {
				valueOffset2 = 00;
				$("div#che"+inc+" input[id=byteEnable2]").prop('checked',false); 
			}
			
			if(((parseInt(configOffset,16)) & 32) == 32)
			{
				valueOffset3 = splituser_enableVal[index+6];
				$("div#che"+inc+" input[id=byteEnable3]").prop('checked',true);    
			} else {
				valueOffset3 = 00;
				$("div#che"+inc+" input[id=byteEnable3]").prop('checked',false);
			}
			
			if(((parseInt(configOffset,16)) & 16) == 16)
			{
				valueOffset4 = splituser_enableVal[index+7];
				$("div#che"+inc+" input[id=byteEnable4]").prop('checked',true);    
			} else {
				valueOffset4 = 00;
				$("div#che"+inc+" input[id=byteEnable4]").prop('checked',false);   
			}
			$('div#che'+inc+' input[id="userValue1"]').val(valueOffset1);
			$('div#che'+inc+' input[id="userValue2"]').val(valueOffset2);
			$('div#che'+inc+' input[id="userValue3"]').val(valueOffset3);
			$('div#che'+inc+' input[id="userValue4"]').val(valueOffset4);
			inc++;
		}
	}
}

//Apply changes function
$("#Apply").click(function() {
	//Array to save the widgets and their values which were changed.
	var deltaobj = [];
	
	//List of widgets to display on the alert
	var widgetsToDisplay = [];
	var modifiedWidgets = [];
	
	//flag for alert message
	var errorFlag = false;
	
	if (offlineConfFile == "") {
		update_status_message("Please select a file to save the offline Configuration.");
		alert("Please select a file to save the offline Configuration.");
		return;
	}

	var memType = $("#Memgroup").find(':checked').val();
	
	if ((memType == "") || (typeof memType == 'undefined')) {
		update_status_message("Please select the appropriate memory(OTP/EEPROM) for which configuration file must be generated.");
		alert("Please select the appropriate memory(OTP/EEPROM) for which configuration file must be generated.");
		return;
	}
	
	if (memType == 1) {
		var eepromsizeChosen = $("#eepromchoicegroup").find(':checked').val();

		if ((eepromsizeChosen == "") || (typeof eepromsizeChosen == 'undefined')) {
			update_status_message("Please select the EEPROM size for which the configuration file is to be generated.");
			alert("Please select the EEPROM size for which the configuration file is to be generated.");
			return;
		}
	}
	
	//TO DO: String length constraint check and coding
	//String Descriptors
	$.each(GwidgetlistString, function( index1, value1 ) {
		var widgetid = "#" + value1;
		var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, value1);
		if((typeof oldval== 'undefined') || (oldval =="undefined"))
		{
			errorFlag = true;
			return;
		}
		var newval = $(widgetid).val();
		
		if (value1 == "macaddr") {
			//Ignore as this is not part of the string descriptor
			
			//Validate the new MAC address entered
			var isMACok = ValidateMac(newval);

			if (!isMACok) {
				//update_status_message("Please enter a valid MAC address.");
				//alert("Please enter a valid MAC address.");
				errorFlag = true;
				return;
			}
		} else {
			if (newval == stringnullvalue) {
				newval = "";
			}
			StringList.push(value1, newval);
		}
		var that = $( widgetid ), parent = that.closest('fieldset');
		var checkdisabled = $(parent).prop( "disabled" );
		if ((newval == stringnullvalue) || (newval == oldval))
		{
			// do nothing no change detected.
		}
		else if (checkdisabled)
		{
			// Change detected but field is disabled - So do nothing
		}
		else {
			if (jQuery.isEmptyObject(newval)) {
				newval = "";
			}
			
			if ((value1 == "macaddr") && isMACok) {
				deltaobj.push(value1, newval);
				modifiedWidgets.push(value1);
			}
		}
	}); //End of $.each(GwidgetlistString, function( index1, value1 )*/
	
	//Hex Descriptors
	$.each(GwidgetValuelistHex, function( index1, value1 ) {
		var widgetid = "#" + value1;
		var oldval;
		var newval;
		var isOk;
			
		oldval = parseInt(getLANWidgetValue(LAN_FAMILY_INDEX, value1), 10);
		newval = parseInt($(widgetid).val(), 16);
		isOk = /^[0-9A-Fa-f]{1,4}$/i.test($(widgetid).val());
			
		if (!isOk) {
			update_status_message("The value entered for \"" + Mapping[value1] + "\" must be a hexadecimal value.");
			alert("The value entered for \"" + Mapping[value1] + "\" must be a hexadecimal value.");
			errorFlag = true;
		}
			
		if (!isOk) {
			// Do nothing. The value entered does not meet the expected pattern.
		} else {
			if ((oldval === newval) || isNaN(newval)) {
				//Do nothing
			} else {
				var valueToSet;
					
				var that = $( widgetid ), parent = that.closest('fieldset');
				var checkdisabled = $(parent).prop( "disabled" );
				if (checkdisabled)
				{
					// Change detected but field is disabled - So do nothing
				}
				else {
					decvalue = parseInt(newval,10);
					// convert number to string and then string to hex
					valueToSet = "0x" + (decvalue.toString(16));
					deltaobj.push(value1,valueToSet);
					modifiedWidgets.push(value1);
				}	
			}
		}
	});

	///Radio buttons
	$.each(GwidgetlistRadio, function(index2, value1) {
		var widgetgroupname = '#' + value1 +"Group";
		var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, value1);
		var newval = $(widgetgroupname).find(':checked').val();
		var that = $( widgetgroupname ), parent = that.closest('fieldset');
		var checkdisabled = $(parent).prop( "disabled" );
		if ((oldval === newval) || jQuery.isEmptyObject(newval))
		{
			// do nothing
		}
		else if (checkdisabled)
		{
			// Change detected but field is disabled - So do nothing
		}
		else
		{
			deltaobj.push(value1, newval);
			modifiedWidgets.push(value1);
		}
	});
	
	//Checkbox
	$.each(GwidgetCheckbox, function( index2, value1 ) {
		var widgetid = "#" + value1;
		var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, value1);
		var newval = checkbox_unchecked_value;
		var that = $( widgetid ), parent = that.closest('fieldset');
		var checkdisabled = $(parent).prop( "disabled" );
		if($(widgetid).is(':checked'))
		{
			newval = checkbox_checked_value;
		}
		
		// Enabled - check the previous value and determine delta                              
		if (oldval == newval) {
			// do nothing - no change in value
		} else if (checkdisabled) {
			// Change detected but field is disabled - So do nothing
		} else {
			deltaobj.push(value1, newval);
			modifiedWidgets.push(value1);
		}
	});
	
	$.each(GwidgetlistDropDown, function(index2, value1) {
		var nameofcontrol = "." + value1;
		var nameofcontrol1 = "[data-bind=\"" + value1 + "label\"]";
		var selText = $(nameofcontrol).find(nameofcontrol1).text();
		var newindexofdropdownlist;
		var that = $( nameofcontrol ), parent = that.closest('fieldset');
		var checkdisabled = $(parent).prop( "disabled" );

		if ((value1 == "LED0Function") || (value1 == "LED1Function") ||
			(value1 == "LED2Function") || (value1 == "LED3Function"))
			{
				$.each(DropDownLEDListFunction, function(index, valuelist) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			if (value1 == "auxcurrent")
			{
				$.each(auxcurrentFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
				
			}
			
			if (value1 == "pmeSupport")
			{
				$.each(pmeFunction1, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						if(selText == "D0")
						{
							newindexofdropdownlist = 1;
						}
						if(selText == "D3 Hot")
						{
							newindexofdropdownlist = 8;
						}
						if(selText == "D3 Cold")
						{
							newindexofdropdownlist = 16;
						}
					}
				});
			}
			
			if (value1 == "L0Latency")
			{
				$.each(L0LatencyFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			if (value1 == "L1Latency")
			{
				$.each(L1LatencyFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			if (value1 == "OBFFSupport")
			{
				$.each(OBFFSupportFunction, function( index, valuelist ) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, value1);

		if (newindexofdropdownlist || newindexofdropdownlist == 0) {
			if ((newindexofdropdownlist == oldval))
			{
				// no change
			} else if (checkdisabled) {
				// Change detected but field is disabled - So do nothing
			} else {
				var dummyNewindexofdropdownlist = newindexofdropdownlist.toString(16);
				deltaobj.push(value1, dummyNewindexofdropdownlist);
				modifiedWidgets.push(value1);
			}
		}
	});
	
	
		//Handling User Initialization table
	var user_enableVal = getLANWidgetValue(LAN_FAMILY_INDEX, "userInitentry");
	//var user_enableVal = "START_OFFSET+26+F0+1C+78+56+34+12+START_OFFSET+27+F8+1C+72+56+34+12+";
	var offset;
	var configOffset;
	var addressOffset;
	var address;
	var valueOffset1;
	var valueOffset2;
	var valueOffset3;
	var valueOffset4;
	var changeValue = false;
	var firstconfigOffset;
	var incn = 0;
	
	for (var index = 0; index < user_enableVal.length; index++)
	{
		var splituser_enableVal = user_enableVal.split('+');
		if(splituser_enableVal[index] == "START_OFFSET")
		{
			if(index == 0)
			{
				offset = splituser_enableVal[index+1];
			} else 
			{
				offset = parseInt(offset,16);
				offset = offset + parseInt(6);
				offset = offset.toString(16);
			}
			addressOffset = splituser_enableVal[index+3];
			configOffset = splituser_enableVal[index+2];
			var splitconfigOffset = configOffset.split("");
			
			
			if((splitconfigOffset[1] & 8) == 8)
			{
				if( $("div#che"+incn+" input[name=userConfig"+incn+"Group][value=0]").is(':checked')) {
						changeValue = true;
						firstconfigOffset = configOffset & 0xF7;
				} else {
					firstconfigOffset = configOffset;
				}
			} else {
					
				if($("div#che"+incn+" input[name=userConfig"+incn+"Group][value=1]").is(':checked')) {
					changeValue = true;
					firstconfigOffset = configOffset | 0x08;
				} else {
					firstconfigOffset = configOffset;
				}
			}
			
			
			splitconfigOffset[1] = splitconfigOffset[1] & 7;
			splitconfigOffset = splitconfigOffset[1]+addressOffset;
			splitconfigOffset= parseInt(splitconfigOffset,16);
			address = splitconfigOffset << 2;
			address = address.toString(16);
			
			if(address != $('div#che'+incn+' input[id="userAddress"]').val()) {
				changeValue = true;
				address = $('div#che'+incn+' input[id="userAddress"]').val();
				address = parseInt(address,16);
				address = address >>> 2;
				address = address & 0xFF;
			} else {
				address = addressOffset;
			}
			
			if((address & 0x0) == 0x0) {
				firstconfigOffset = firstconfigOffset | 0x0;
			} 
			else if((address & 0x1c00) == 0x1c00) {
				firstconfigOffset = firstconfigOffset | 0x07;
			} else if((address & 0x0400) == 0x0400) {
				firstconfigOffset = firstconfigOffset | 0x01;
			}  else if((address & 0x0800) == 0x0800) {
				firstconfigOffset = firstconfigOffset | 0x02;
			}  else if((address & 0x0c00) == 0x0c00) {
				firstconfigOffset = firstconfigOffset | 0x03;
			}  else if((address & 0x1000) == 0x1000) {
				firstconfigOffset = firstconfigOffset | 0x04;
			}  else if((address & 0x1400) == 0x1400) {
				firstconfigOffset = firstconfigOffset | 0x05;
			}  else if((address & 0x1800) == 0x1800) {
				firstconfigOffset = firstconfigOffset | 0x06;
			}  
			
			if(((parseInt(configOffset,16)) & 128) == 128)
			{
				valueOffset1 = splituser_enableVal[index+4];
				firstconfigOffset = firstconfigOffset | 0x80;
			} else {
				firstconfigOffset &= 0x7f;
				valueOffset1 = 00;
			}
			if(((parseInt(configOffset,16)) & 64) == 64)
			{
				valueOffset2 = splituser_enableVal[index+5];
				firstconfigOffset = firstconfigOffset | 0x40;
			} else {
				valueOffset2 = 00;
				firstconfigOffset &= 0xBF;
			}
			if(((parseInt(configOffset,16)) & 64) == 64)
			{
				valueOffset3 = splituser_enableVal[index+6];
				firstconfigOffset = firstconfigOffset | 0x20;
			} else {
				valueOffset3 = 00;
				firstconfigOffset &= 0xDF;
			}
			if(((parseInt(configOffset,16)) & 16) == 16)
			{
				valueOffset4 = splituser_enableVal[index+7];
				firstconfigOffset = firstconfigOffset | 0x10;
			} else {
				valueOffset4 = 00;
				firstconfigOffset &= 0xEF;
			}
			if(valueOffset1 != ($('div#che'+incn+' input[id="userValue1"]').val())) {
				changeValue = true;
				valueOffset1 = $('div#che'+incn+' input[id="userValue1"]').val();
			}
			if(valueOffset2 != ($('div#che'+incn+' input[id="userValue2"]').val())) {
				changeValue = true;
				valueOffset2 = $('div#che'+incn+' input[id="userValue2"]').val();
			}
			if(valueOffset3 != ($('div#che'+incn+' input[id="userValue3"]').val())) {
				changeValue = true;
				valueOffset3 = $('div#che'+incn+' input[id="userValue3"]').val();
			}
			if(valueOffset4 != ($('div#che'+incn+' input[id="userValue4"]').val())) {
				changeValue = true;
				valueOffset4 = $('div#che'+incn+' input[id="userValue4"]').val();
			}
			firstconfigOffset = firstconfigOffset.toString(16);
			address = address.toString(16);
			
			if(changeValue) {
				if(entryRemove || tableRemove)
				{
					RegString = "START_OFFSET"+"+"+(offset)+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00";
					removeflag--;
					if(removeflag == 0)
					{
						entryRemove = false;
					}
				} else {
				RegString = "START_OFFSET"+"+"+(offset)+"+"+firstconfigOffset+"+"+address+"+"+valueOffset1+"+"+valueOffset2+"+"+valueOffset3+"+"+valueOffset4;
				}
				deltaobj.push("userInitentry", RegString);
				modifiedWidgets.push("userInitentry");
				changeValue = false;
				
			}
			incn++;
		}
	}
	
		if(htcount != 0) {
			count++;
			var valueOffset1;
			var valueOffset2;
			var valueOffset3;
			var valueOffset4;
			var byteEnable1;
			var byteEnable2;
			var byteEnable3;
			var byteEnable4;
			var userConfig;
			
			for (count; count <= userIncrement ; count++) {
				if((typeof offset== 'undefined') || (offset =="undefined")) {
					offset = 26;
				} else {
					offset = parseInt(offset,16);
					offset = offset + parseInt(6);
					offset = offset.toString(16);
				}
				if($("div#che"+count+" input[name=userConfig"+count+"Group][value=1]").is(':checked'))
				{
					userConfig = "1";
				} else 
				{
					userConfig = "0";
				}
				var address = $('div#che'+count+' input[id="userAddress"]').val();
				
				if($("div#che"+count+" input[id=byteEnable1]").is(':checked')) {
					valueOffset1 = $('div#che'+count+' input[id="userValue1"]').val();
					byteEnable1 = "1";
				} else {
					valueOffset1 = 00;
					byteEnable1 = "0";
				}
				
				if($("div#che"+count+" input[id=byteEnable2]").is(':checked')) {
					valueOffset2 = $('div#che'+count+' input[id="userValue2"]').val();
					byteEnable2 = "1";
				} else {
					valueOffset2 = 00;
					byteEnable2 = "0";
				}
				
				if($("div#che"+count+" input[id=byteEnable3]").is(':checked')) {
					valueOffset3 = $('div#che'+count+' input[id="userValue3"]').val();
					byteEnable3 = "1";
				} else {
					valueOffset3 = 00;
					byteEnable3 = "0";
				}
				
				if($("div#che"+count+" input[id=byteEnable4]").is(':checked')) {
					valueOffset4 = $('div#che'+count+' input[id="userValue4"]').val();
					byteEnable4  = "1";
				} else {
					valueOffset4 = 00;
					byteEnable4 = "0";
				}
				
				address = parseInt(address,16);
				var newconfig = 000;
				if((address & 0x1c00) == 0x1c00) {
					newconfig = 111;
				} else if((address & 0x0400) == 0x0400) {
					newconfig = 001;
				}  else if((address & 0x0800) == 0x0800) {
					newconfig = 010;
				}  else if((address & 0x0c00) == 0x0c00) {
					newconfig = 011;
				}  else if((address & 0x1000) == 0x1000) {
					newconfig = 100;
				}  else if((address & 0x1400) == 0x1400) {
					newconfig = 101;
				}  else if((address & 0x1800) == 0x1800) {
					newconfig = 110;
				}  
			
				userConfig = byteEnable1+byteEnable2+byteEnable3+byteEnable4+userConfig+newconfig;
				userConfig = parseInt(userConfig,2).toString(10);;
				if(newconfig == 0) {
					userConfig = userConfig << 2;
				}
				userConfig = userConfig & 255;
				userConfig = userConfig.toString(16);
				
				address = address >> 2;
				address = address & 255;
				address = address.toString(16);
				if(entryRemove || tableRemove)
				{
					if(entryRemove) {
						offset = "00";
					}
					RegString = "START_OFFSET"+"+"+offset+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00"+"+"+"00";
					entryRemove = false;
				} else {
				RegString = "START_OFFSET"+"+"+(offset)+"+"+userConfig+"+"+address+"+"+valueOffset1+"+"+valueOffset2+"+"+valueOffset3+"+"+valueOffset4;
				}
				deltaobj.push("userInitentry", RegString);
				modifiedWidgets.push("userInitentry");
			}
		}
		
	var skuName = sku;
	///////////////////////////////////////////////////
	
	//End of Special Checkbox widgets
	var stringToSet = "";
	var wKey;
	var wVal;
	var flag = 0;
	
	if (deltaobj.length != 0) {
		for (var i = deltaobj.length; i >= 0; i = i - 2) {
			wKey = deltaobj[i];
			wVal = deltaobj[i+1];
			if ((typeof wKey === 'undefined') || (typeof wVal === 'undefined')) {
				// Do nothing
			} else {
				stringToSet = wKey + ",,," + wVal + ";;;" + stringToSet;
				flag++;
			}
		}
	}

	if (flag == 0 && errorFlag == false)
	{
		alert("No changes detected for offline configuration.");
		update_status_message("No changes detected for offline configuration.");
	} else {
		if(errorFlag == false)
		{
			var displayChange = "";
			
			for (var i = 0; i < modifiedWidgets.length; i++) {
				if(i%4 == 0)
				{
					if (displayChange) {
						displayChange = "\n" + Mapping[modifiedWidgets[i]] + ", " + displayChange;
					} else {
						displayChange = Mapping[modifiedWidgets[i]];
					}
				} else {
					if (displayChange) {
						displayChange = Mapping[modifiedWidgets[i]] + ", " + displayChange;
					}
				}
			}
			//Configuration must be generated for which type of memory
			var memType = $("#Memgroup").find(':checked').val();
			var memConfig = $("#eepromConfigGroup").find(':checked').val();
			var eepromSize = $("#eepromchoicegroup").find(':checked').val();
			var memorytypeChoosen;
			
			if((memType == "1") && (typeof memConfig == 'undefined')) {
				alert("Please choose the appropriate EEPROM Configuration.");
				update_status_message("Please choose the appropriate EEPROM Configuration.");
				userIncrement = userIncrement -1 ;
				return;
			}
		
			if((memType == "1") && (memConfig == "1")) {
				if(eepromSize == "256") {
					memorytypeChoosen = "1";
				}
				else {
					memorytypeChoosen = "4";
				}
			} else if(memType == "2") {
				memorytypeChoosen = "2";
			} else if((memType == "1") && (memConfig == "0")) {
				if(eepromSize == "256") {
					memorytypeChoosen = "3";
				} else {
					memorytypeChoosen = "5";
				}
			} 
			
			if($("input[id=userAddress]").val() == "") {
					alert("Provide CSR/PCIe Register address to proceed.");
					return;
			}
			
			if($("div#che"+count+" input[id=byteEnable1]").is(':checked')) {
			if($("input[id=userValue1]").val() == "") {
				alert("Provide CSR/PCIe Register values to proceed.");
				return;
				}
			}
			
			if($("div#che"+count+" input[id=byteEnable2]").is(':checked')) {
			if($("input[id=userValue2]").val() == "") {
				alert("Provide CSR/PCIe Register values to proceed.");
				return;
				}
			}
			
			if($("div#che"+count+" input[id=byteEnable3]").is(':checked')) {
			if($("input[id=userValue3]").val() == "") {
				alert("Provide CSR/PCIe Register values to proceed.");
				return;
				}
			}
			
			if($("div#che"+count+" input[id=byteEnable4]").is(':checked')) {
			if($("input[id=userValue4]").val() == "") {
				alert("Provide CSR/PCIe Register values to proceed.");
				return;
				}
			}
			if($("input[id=userAddress]").val() != "") {
				if($("input[id=userValue4]").val() == "") {
					if($("input[id=userValue3]").val() == "") {
						if($("input[id=userValue2]").val() == "") {
							if($("input[id=userValue1]").val() == "") {
								alert("Provide CSR/PCIe Register values to proceed.");
							}
						}
					}
				}
			}
			if($("input[id=userValue4]").val() == "") {
				if($("input[id=userValue3]").val() == "") {
					if($("input[id=userValue2]").val() == "") {
						if($("input[id=userValue1]").val() == "") {
							if($("input[id=userAddress]").val() != "") {
								alert("Provide CSR/PCIe Register Address to proceed.");
							}
						}
					}
				}
			}
			
			var option = confirm("Configuration file will be generated with the following device settings\n" + displayChange);
			
			if (option) {
				var result = setLANOfflineConfiguration(sku, memorytypeChoosen, stringToSet);
				
				if (result) {
					alert("Offline configuration was created successfully");
					update_status_message("Offline configuration was created successfully for the following widgets.\n" + displayChange);
					count = count-htcount-1;
				} else {
					alert("Offline configuration failed.");
					count = count-htcount-1;
					update_status_message("Offline configuration failed.");		
				}
			} else {
				
				count = count-htcount-1;
				update_status_message("Generation of configuration file was terminated by the user.");
			}
		}
	}
	
	//Required clean up action
	errorFlag = false;
	RegString = false;
	resetVariables();
});

$("#eepromConfigGroup").change(function() {
	var memConfig = $("#eepromConfigGroup").find(':checked').val();
	if(memConfig == 0) {
		disable_all_fields();
		if(maconlyConfig)
		{
			set_changed_fields_border_default();
			$("#macaddr").css('border-color', 'red');
		}
		else 
		{
			document.getElementById("Reset").click();
		}
	} else {
		enable_all_fields();
		
	}
});

(function ($) {
    update_status_message = function (mesg) {
        var currentdate = new Date(); 
        currentdate+''; 
        var datetime = currentdate.toLocaleString();
        $("#DSStatusMessage").append( datetime +":"+ mesg + "\n");
        $("#DSStatusMessage").animate({
            scrollTop:$("#DSStatusMessage")[0].scrollHeight - $("#DSStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

function resetVariables () {
	userInitentry_check = 0;
	macaddr_check = 0;
	subsystemvid_check = 0;
	byteOffset_check = 0;
	subsystemid_check = 0;
	auxcurrent_check = 0;
	pmeSupport_check = 0;
	ClkPowerEnable_check = 0;
	ASPMControl_check = 0;
	L0Latency_check = 0;
	L1Latency_check = 0;
	LTRSupport_check = 0;
	OBFFSupport_check = 0;
	L1PMSubstates_check = 0;
	PciPmL1_check = 0;
	PciPmL2_check = 0;
	ASPML1_check = 0;
	ASPML2_check = 0;
	LED0Function_check = 0;
	LED1Function_check = 0;
	LED2Function_check = 0;
	LED3Function_check = 0;
	LED0Enable_check = 0;
	LED1Enable_check = 0;
	LED2Enable_check = 0;
	LED3Enable_check = 0;
	LED0CombineEnable_check = 0;
	LED1CombineEnable_check = 0;
	LED2CombineEnable_check = 0;
	LED3CombineEnable_check = 0;
	LED0_check = 0;
	LED1_check = 0;
	LED2_check = 0;
	LED3_check = 0;
	LEDRate_check = 0;
	LEDPulsing_check = 0;
	LED0Polarity_check = 0;
	LED1Polarity_check = 0;
	LED2Polarity_check = 0;
	LED3Polarity_check = 0;
	LEDActivity_check = 0;
	macSpeedDetect_check = 0;
	macConfiguration_check = 0;
	macDuplexMode_check = 0;
	macDuplexDetection_check = 0;
	macDuplexPolarity_check = 0;
	macEEEEnable_check = 0;
	macEEETxClkStopEnable_check = 0;
	macRgmiiTxDelayEnable_check = 0;
	macRgmiiRxEnable_check = 0;
	macClk125Enable_check = 0;
	macRefClk25Enable_check = 0;
	
 }
 
 function ValidateMac(currMac) {
	
	var MacValue = currMac.split(":");
	
	var maclength = MacValue.length;
	
	if(maclength < 6 || maclength > 6)
	{
		alert("The Given MAC Address is not valid.Mac Address should be for Example = 00:80:0F:10:20:01");
		return false;
	}
	MacValue[0] = parseInt(MacValue[0],16);
	if((MacValue[0] & 0x01) === 0x01)
	{
		alert("MAC Address should not be a Multicast or Broadcast address.");
		return false;
	}
	
	var regex = /^([0-9a-fA-F]{2}[:-]){5}([0-9A-F]{2})$/;
  
	var isMacOKAddr = regex.test(currMac);
	
	if(!isMacOKAddr)
	{
		alert("The Given MAC Address is not a valid Mac Address.");
		return false;
	}

	return true;
}
