/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/
var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";

var DropDownPHYBOOST = [
"Nominal 17.78 mA",
"5% below nominal",
"10% above nominal",
"5% above nominal",
"20% above nominal",
"15% above nominal",
"30% above nominal",
"25% above nominal"
];
// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [
"Nominal 100mV",
"12.5mV below nominal",
"25mV below nominal",
"37.5mV below nominal",
"50mV below nominal",
"62.5mV below nominal",
"25mV above nominal",
"12.5mV above nominal"
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall = [
"Default",
"+18%",
"-18%",
"-12%"
];

var NCMMAP = [
"hce1_vid",
"hce1_pid",
"hce1_did",
"hce1_languageid",
"hce1_manufacturer",
"hce1_product",
"hce1_string5",
"hce2_vid",
"hce2_pid",
"hce2_did",
"hce2_languageid",
"hce2_manufacturer",
"hce2_product",
"hce2_string5"
];

var NCMMAPcopy = [
"#hce_vid",
"#hce_pid",
"#hce_did",
"#hce_languageid",
"#hce_manufacturer",
"#hce_product",
"#hce_serial",
"#hce_vid",
"#hce_pid",
"#hce_did",
"#hce_languageid",
"#hce_manufacturer",
"#hce_product",
"#hce_serial"
];

var NCMMAPhigh = [
"#hce1_vid",
"#hce1_pid",
"#hce1_did",
"#hce1_languageid",
"#hce1_manufacturer",
"#hce1_product",
"#hce1_string5",
"#hce2_vid",
"#hce2_pid",
"#hce2_did",
"#hce2_languageid",
"#hce2_manufacturer",
"#hce2_product",
"#hce2_string5"
];

(function ($) {
    set_changed_fields_border_default = function () {
    	
        $("input[type='text']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='number']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='checkbox']").each(function() {
            $(this).parent().removeClass("highlight");
        });

        $("input[type='radio']").each(function() {
            $(this).parent().removeClass("highlight");
        });
		
		
		// TODO IS IT NOT COVERED ABOVE
		
		$("#downstreamBCsettingport1group").parent().removeClass("highlight");
		$("#downstreamBCsettingport2group").parent().removeClass("highlight");
		$("#downstreamBCsettingport3group").parent().removeClass("highlight");
		$("#downstreamBCsettingport4group").parent().removeClass("highlight");
		$("#downstreamBCsettingport5group").parent().removeClass("highlight");
		$("#downstreamBCsettingport6group").parent().removeClass("highlight");
		$("#i2senablegroup").parent().removeClass("highlight");
		$("#i2senablehidgroup").parent().removeClass("highlight");
		
		$("#port5splittinggroup").parent().removeClass("highlight");
		$("#port4splittinggroup").parent().removeClass("highlight");
		$("#port3splittinggroup").parent().removeClass("highlight");	
			
		$("#hubpowergroup").parent().removeClass("highlight");
		$("#cdcenablegroup").parent().removeClass("highlight");

        $(".dropdown li a").each(function () {
            var parent = $(this).closest('div');
            $(parent).css('border-color', 'transparent');
        });
    };
})(jQuery);

(function ($) {
reset_fields = function () {
    	
        $("input[type='text']").val('');
        $("input[type='number']").val('');
        $("input[type='checkbox']").removeAttr("checked");
        $("input[type='radio']").removeAttr("checked");
        
        // resetting the Dynamic DCP ports
        $("#P1_DCP_OFF").attr('checked', 'checked');
        $("#P2_DCP_OFF").attr('checked', 'checked');
        $("#P3_DCP_OFF").attr('checked', 'checked');
        $("#P4_DCP_OFF").attr('checked', 'checked');
    		$('#RegisterDumpField').hide();
    		$("#P5_DCP_OFF").attr('checked', 'checked');
    		$("#P6_DCP_OFF").attr('checked', 'checked');
               
       
		$("#configMemprogressbar").css('width', "0%");
		$("#configMemprogressbar").html("<p>  </p>");
					
		iniFile = "";
		gb_RegString = "";
		directRegString = "";
		
		//Resetting the DRA 
		
		var nameofcontrol = "input[name= Regoperationgroup][value=0]";
		$(nameofcontrol).prop("checked", true);
		
		//Resetting the Dump memory option to Configuration memory
	    nameofcontrol = "input[name= MemDumpoperationgroup][value=0]";
		$(nameofcontrol).prop("checked", true);
		
		$("#regdumpinput").hide();
				
		reset_file_input();
		
		reset_roleswitch();
		
		reset_DCP();
		
		//Resetting Live update		
		$("#CBadvancedOption").prop("checked", false);		
		$("#xdataaddress").val("");
		$("#xdatavalue").val("");
		$("#RegisterLength").val("");
		
		//resetting I2C frequency
	
		$('.I2CFrequency1').find('[data-bind="I2CFrequencylabel"]').text("Select Frequency")
		.children('.dropdown-toggle').dropdown('toggle');
			
				
    };
})(jQuery);

(function ($) {
	
    reset_roleswitch = function () {
		
		
		//Resetting the Role Switch
		
		nameofcontrol = "input[name= RoleSwitchgroup][value=1]";
		$(nameofcontrol).prop("checked", true);
		
		nameofcontrol = "input[name= ENUMTOUTgroup][value=0]";
		$(nameofcontrol).prop("checked", true);
		
		$("#FlexConfig").prop("checked", false);
		
		$('.RoleSwitchport1').find('[data-bind="RoleSwitchportlabel"]').text("1")
		.children('.dropdown-toggle').dropdown('toggle');
				
       
    };
    
})(jQuery);

(function ($) {
	
    reset_DCP = function () {
		
		
		//Resetting the DCP fields
		
		nameofcontrol = "input[name= DCPmodegroup][value=1]";
		$(nameofcontrol).prop("checked", true);
	
		$("#dcpport1sel").prop("checked", false);
		$("#dcpport2sel").prop("checked", false);
		$("#dcpport3sel").prop("checked", false);
		$("#dcpport4sel").prop("checked", false);
		$("#dcpport5sel").prop("checked", false);
		$("#dcpport6sel").prop("checked", false);
				
       
    };
    
})(jQuery);

(function ($) {
    reset_file_input = function () {
        $("input[type='file']").val('');
		$("input[type='file']").css({
						background: "white",
						border: "0px"
						});
		$("#eraseFW").removeAttr("checked");
    };
})(jQuery);

(function ($) {
disable_fields = function () {
    	
    	// Disabling the input type fields
    	
        $("input[type='text']").attr('disabled', true);
        $("input[type='number']").attr('disabled', true);
        $("input[type='checkbox']").attr('disabled', true);
        $("input[type='radio']").attr('disabled', true);
		$("input[type='file']").attr('disabled', true);
		$("#dumpfileid").attr('disabled', true);
		
		
		// Disabling the submit buttons
		$("#Preview").attr('disabled', true);
		$("#Apply").attr('disabled', true);
		$("#RestoreFacDefaults").attr('disabled', true);
		
		
		//Disabling all buttons
		$(':button').prop('disabled', true);
		
		$('#DevMgmtDD').prop('disabled', false);
		
		
    };
})(jQuery);

(function ($) {
enable_fields = function () {
    	
    	//Enabling all buttons
		$(':button').prop('disabled', false);
		
		$("input[type='text']").attr('disabled', false);
        $("input[type='number']").attr('disabled', false);
        $("input[type='checkbox']").attr('disabled', false);
        $("input[type='radio']").attr('disabled', false);
		$("input[type='file']").attr('disabled', false);
		$("#dumpfileid").attr('disabled', false);
		
		//$('#nrdeviceport5').attr("disabled", 'disabled');  	     
		$("#partnumber").attr('disabled', true);
		$("#ConfigLocation").attr('disabled', true);
		$("#FirmwareLocation").attr('disabled', true);
		$("#ConfigMode").attr('disabled', true);
		$("#ProgrammedConfigCount").attr('disabled', true);
		$("#RemainingConfigCount").attr('disabled', true);
		$("#previewPrecent").attr('disabled', true);
		$("#bytesProgrammed").attr('disabled', true);
		$("#selectedhubinput").attr('disabled', true);
		$('.dropdown-toggle').removeClass('disabled');
		$('.btn').removeAttr('disabled');
		$("#usb3uuid").attr('disabled', true);
				
		// Enabling the submit buttons
		$("#Preview").attr('disabled', false);
		$("#Apply").attr('disabled', false);
		$("#RestoreFacDefaults").attr('disabled', false);
		/*$("#hcefieldset").attr("disabled", true);
		$("#hce2fieldset").attr("disabled", "");
		$('#hce1_languageid').attr("disabled", 'disabled');  	     
		$('#hce1_manufacturer').attr("disabled", 'disabled'); 
		$('#hce1_product').attr("disabled", 'disabled'); 
		$('#hce1_string5').attr("disabled", 'disabled'); 
		$('#hce2_languageid').attr("disabled", 'disabled');  	     
		$('#hce2_manufacturer').attr("disabled", 'disabled'); 
		$('#hce2_product').attr("disabled", 'disabled'); 
		$('#hce2_string5').attr("disabled", 'disabled'); */
					
	};
})(jQuery);

//GwidgetlistHex starts
$("#vid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "vid"), 10);
	var newval = parseInt($("#vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#pid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "pid"), 10);
	var newval = parseInt($("#pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#did").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "did"), 10);
	var newval = parseInt($("#did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usbvcd").change(function () {
	var usbvcdVal = parseInt(getWidgetValue(gb_HUB_ID, "usbvcd"), 10);
	var dot = ".";
	var hexvalue = (usbvcdVal.toString(16));
	var position = 1;
	var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
	oldval = hexstring;
	newval = $("#usbvcd").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#languageid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "languageid"), 10);
	var newval = parseInt($("#languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});


$("#usb3vid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "usb3vid"), 10);
	var newval = parseInt($("#usb3vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3pid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "usb3pid"), 10);
	var newval = parseInt($("#usb3pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3did").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "usb3did"), 10);
	var newval = parseInt($("#usb3did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3vcd").change(function () {
	var usb3vcdVal = parseInt(getWidgetValue(gb_HUB_ID, "usb3vcd"), 10);
	var dot = ".";
	var hexvalue = (usb3vcdVal.toString(16));
	var position = 1;
	var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
	oldval = hexstring;
	newval = $("#usb3vcd").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3languageid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "usb3languageid"), 10);
	var newval = parseInt($("#usb3languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce_vid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce_vid"), 10);
	var newval = parseInt($("#hce_vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce_pid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce_pid"), 10);
	var newval = parseInt($("#hce_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce_did").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce_did"), 10);
	var newval = parseInt($("#hce_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce_languageid"), 10);
	var newval = parseInt($("#hce_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce1_vid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce1_vid"), 10);
	var newval = parseInt($("#hce1_vid").val(), 16);
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce1_pid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce1_pid"), 10);
	var newval = parseInt($("#hce1_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce1_did").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce1_did"), 10);
	var newval = parseInt($("#hce1_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});



$("#hce1_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce1_languageid"), 10);
	var newval = parseInt($("#hce1_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce2_vid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce2_vid"), 10);
	var newval = parseInt($("#hce2_vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce2_pid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce2_pid"), 10);
	var newval = parseInt($("#hce2_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce2_did").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce2_did"), 10);
	var newval = parseInt($("#hce2_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});



$("#hce2_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(gb_HUB_ID, "hce2_languageid"), 10);
	var newval = parseInt($("#hce2_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
//GwidgetlistHex Ends

//GwidgetlistString Starts
$("#manufacturer").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "manufacturer");
	var newval = $("#manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#product").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "product");
	var newval = $("#product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#serial").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "serial");
	var newval = $("#serial").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce_manufacturer").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce_manufacturer");
	var newval = $("#hce_manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce_product").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce_product");
	var newval = $("#hce_product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce_serial").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce_serial");
	var newval = $("#hce_serial").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3manufacturer").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3manufacturer");
	var newval = $("#usb3manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3product").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3product");
	var newval = $("#usb3product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3serial").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3serial");
	var newval = $("#usb3serial").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#usb3uuid").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3uuid");
	var newval = $("#usb3uuid").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce1_manufacturer").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce1_manufacturer");
	var newval = $("#hce1_manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce1_product").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce1_product");
	var newval = $("#hce1_product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce1_string5").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce1_string5");
	var newval = $("#hce1_string5").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce1_macaddr").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce1_macaddr");
	var newval = $("#hce1_macaddr").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce1_eapproduct").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce1_eapproduct");
	var newval = $("#hce1_eapproduct").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce1_eapinterface").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce1_eapinterface");
	var newval = $("#hce1_eapinterface").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce2_manufacturer").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce2_manufacturer");
	var newval = $("#hce2_manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hce2_product").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce2_product");
	var newval = $("#hce2_product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce2_string5").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce2_string5");
	var newval = $("#hce2_string5").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce2_macaddr").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce2_macaddr");
	var newval = $("#hce2_macaddr").val();
	

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce2_eapproduct").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce2_eapproduct");
	var newval = $("#hce2_eapproduct").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#hce2_eapinterface").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hce2_eapinterface");
	var newval = $("#hce2_eapinterface").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
//GwidgetlistString Ends

//GwidgetlistInt Starts
$("#maxpowerself").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "maxpowerself");
	oldval = parseInt(oldval,10) * 2;
	var newval = parseInt($("#maxpowerself").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hubcmaxpowerself").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hubcmaxpowerself");
	oldval = parseInt(oldval,10);
	var newval = parseInt($("#hubcmaxpowerself").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#maxpowerbus").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "maxpowerbus");
	oldval = parseInt(oldval,10) * 2;
	var newval = parseInt($("#maxpowerbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hubcmaxpowerbus").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hubcmaxpowerbus");
	oldval = parseInt(oldval,10);
	var newval = parseInt($("#hubcmaxpowerbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#hub3maxpowerselfbus").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hub3maxpowerselfbus");
	oldval = parseInt(oldval,10) * 8;
	var newval = parseInt($("#hub3maxpowerselfbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});
$("#power_ontime").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "power_ontime");
	oldval = parseInt(oldval,10)*2;
	var newval = parseInt($("#power_ontime").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
	} else {
		$(this).css('border-color', 'red');
	}
});

//GwidgetlistInt Ends
/*$("#copyNCM").change(function () {
	
	for (var i = 0;i<= 13;i++) {
		var widgetname = i;
		var oldval;
		var newval ;
		if(NCMMAP[widgetname] == "hce1_did" || NCMMAP[widgetname] == "hce1_pid" || NCMMAP[widgetname] == "hce1_vid" || NCMMAP[widgetname] == "hce1_languageid" || NCMMAP[widgetname] == "hce2_languageid" ||
		NCMMAP[widgetname] == "hce2_did" || NCMMAP[widgetname] == "hce2_pid" || NCMMAP[widgetname] == "hce2_vid") {
			oldval = parseInt(getWidgetValue(gb_HUB_ID, NCMMAP[widgetname]),10);
		} else {
			oldval = getWidgetValue(gb_HUB_ID, NCMMAP[widgetname]);
		}
		
		if(NCMMAP[widgetname] == "hce1_did" || NCMMAP[widgetname] == "hce1_pid" || NCMMAP[widgetname] == "hce1_vid" || NCMMAP[widgetname] == "hce1_languageid" || NCMMAP[widgetname] == "hce2_languageid" ||
		NCMMAP[widgetname] == "hce2_did" || NCMMAP[widgetname] == "hce2_pid" || NCMMAP[widgetname] == "hce2_vid") {
			
			newval = parseInt($(NCMMAPcopy[widgetname]).val(),16);
		} else {
			newval = $(NCMMAPcopy[widgetname]).val();
		}

		if (oldval == newval) {
			$(NCMMAPhigh[widgetname]).css('border-color', 'LightGray');
		} else {
			$(NCMMAPhigh[widgetname]).css('border-color', 'red');
		}
	}
	
});*/
//GwidgetlistCheckbox Starts
// $("#flexconnect").change(function () {
	// var oldval = getWidgetValue(gb_HUB_ID, "flexconnect");
	// var newval = checkbox_unchecked_value;
	// if($("#flexconnect").is(':checked'))
	// {
		// newval = checkbox_checked_value;
	// }
	// if((newval == checkbox_unchecked_value))
	// {
		// var usb3flexval = checkbox_unchecked_value; ;
		// if($("#usb3flexconnect").is(':checked'))
		// {
			// usb3flexval = checkbox_checked_value;
		// }
		// if(usb3flexval == checkbox_unchecked_value)
		// {
			// var parent = $("#flexportUL li").closest('div');
			// $(parent).css('border-color', 'transparent');
		// }
	// }
	
	// if (oldval == newval) {
		// $(this).parent().removeClass("highlight");
	// } else {
		// $(this).parent().addClass("highlight");
	// }
// });
// //GwidgetlistCheckbox Starts
// $("#usb3flexconnect").change(function () {
	// var oldval = getWidgetValue(gb_HUB_ID, "usb3flexconnect");
	// var newval = checkbox_unchecked_value;
	// if($("#usb3flexconnect").is(':checked'))
	// {
		// newval = checkbox_checked_value;
	// }
	// if((newval == checkbox_unchecked_value))
	// {
		// var flexval = checkbox_unchecked_value; ;
		// if($("#flexconnect").is(':checked'))
		// {
			// flexval = checkbox_checked_value;
		// }
		// if(flexval == checkbox_unchecked_value)
		// {
			// var parent = $("#flexportUL li").closest('div');
			// $(parent).css('border-color', 'transparent');
		// }
	// }
	// if (oldval == newval) {
		// $(this).parent().removeClass("highlight");
	// } else {
		// $(this).parent().addClass("highlight");
	// }
// });

$("#FlexConfig").change(function () {
	var Product = getProduct();
	var oldval = getWidgetValue(gb_HUB_ID, "LoadFlxCfgArea");
	
	var newval = checkbox_unchecked_value;
	if($("#FlexConfig").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#hsdisable").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hsdisable");
	var newval = checkbox_unchecked_value;
	if($("#hsdisable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#hceenable").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hceenable");
	var newval = checkbox_unchecked_value;
	if($("#hceenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});


$("#lpmenable").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "lpmenable");
	var newval = checkbox_unchecked_value;
	if($("#lpmenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#cdcenable").change(function () {
	
	var oldval = getWidgetValue(gb_HUB_ID, "cdcenable");
	var newval = checkbox_unchecked_value;
	if($("#cdcenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}	
});


$("#swapupstreamdpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapupstreamdpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapupstreamdpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swapupstreamhsic").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapupstreamhsic");
	var newval = checkbox_unchecked_value;
	if($("#swapupstreamhsic").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swapport1dpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapport1dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport1dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swapport2dpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapport2dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport2dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swapport3dpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapport3dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport3dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swapport4dpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapport4dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport4dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#swapport5dpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapport5dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport5dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swapport6dpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapport6dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport6dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swapport7dpdm").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swapport7dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport7dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#nrdeviceport1").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "nrdeviceport1");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr1UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		nr1UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#nrdeviceport2").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "nrdeviceport2");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr2UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		nr2UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#nrdeviceport3").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "nrdeviceport3");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr3UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		nr3UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#nrdeviceport4").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "nrdeviceport4");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr4UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		nr4UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#nrdeviceport5").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "nrdeviceport5");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr5UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		nr5UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#nrdeviceport6").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "nrdeviceport6");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr6UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		nr6UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#nrdeviceport7").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "nrdeviceport7");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr7UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		nr7UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#usb3nrdeviceport1").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3nrdeviceport1");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr1UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		usb3nr1UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#usb3nrdeviceport2").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3nrdeviceport2");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr2UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		usb3nr2UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#usb3nrdeviceport3").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3nrdeviceport3");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr3UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		usb3nr3UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#usb3nrdeviceport4").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3nrdeviceport4");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr4UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		usb3nr4UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#usb3nrdeviceport5").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3nrdeviceport5");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr5UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		usb3nr5UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#usb3nrdeviceport6").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3nrdeviceport6");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr6UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		usb3nr6UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#usb3nrdeviceport7").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3nrdeviceport7");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr7UserModified = false;
		$(this).parent().removeClass("highlight");
	} else {
		usb3nr7UserModified = true;
		$(this).parent().addClass("highlight");
	}
});

$("#swappin1").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swappin1");
	var newval = checkbox_unchecked_value;
	if($("#swappin1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swappin2").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swappin2");
	var newval = checkbox_unchecked_value;
	if($("#swappin2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swappin3").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swappin3");
	var newval = checkbox_unchecked_value;
	if($("#swappin3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#swappin4").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "swappin4");
	var newval = checkbox_unchecked_value;
	if($("#swappin4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#enableport1").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "enableport1");
	var newval = checkbox_unchecked_value;
	if($("#enableport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#enableport2").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "enableport2");
	var newval = checkbox_unchecked_value;
	if($("#enableport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#enableport3").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "enableport3");
	var newval = checkbox_unchecked_value;
	if($("#enableport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#enableport4").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "enableport4");
	var newval = checkbox_unchecked_value;
	if($("#enableport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#enableport5").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "enableport5");
	var newval = checkbox_unchecked_value;
	if($("#enableport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#enableport6").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "enableport6");
	var newval = checkbox_unchecked_value;
	if($("#enableport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#enableport7").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "enableport7");
	var newval = checkbox_unchecked_value;
	if($("#enableport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

//USB3 Enable port widgets
$("#usb3enableport1").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3enableport1");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#usb3enableport2").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3enableport2");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#usb3enableport3").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3enableport3");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#usb3enableport4").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3enableport4");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#usb3enableport5").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3enableport5");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#usb3enableport6").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3enableport6");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#usb3enableport7").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "usb3enableport7");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#pdport1").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "pdport1");
	var newval = checkbox_unchecked_value;
	if($("#pdport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#pdport3").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "pdport3");
	var newval = checkbox_unchecked_value;
	if($("#pdport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#pdupstream").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "pdupstream");
	var newval = checkbox_unchecked_value;
	if($("#pdupstream").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
//GwidgetlistCheckbox Ends

//GwidgetlistRadio Starts
//Port split for Port 5 and Port 6
$("#port5splittinggroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "port5splitting");
	var newval = $("#port5splittinggroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#port4splittinggroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "port4splitting");
	var newval = $("#port4splittinggroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#port3splittinggroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "port3splitting");
	var newval = $("#port3splittinggroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});



$("#pstimeoutgroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "pstimeout");
	var newval = $("#pstimeoutgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#hubpowergroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "hubpower");
	var newval = $("#hubpowergroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#i2senable").change(function () {
	
	var oldval = getWidgetValue(gb_HUB_ID, "i2senable");
	var newval = $("#i2senable").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
$("#i2senablegroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "i2senable");
	var newval = $("#i2senablegroup").find(':checked').val();
	
	if(newval == "0")
	{
		document.getElementById("speakermeute").disabled=true;
		document.getElementById("bothms").disabled=true;
		document.getElementById("bothms1").disabled=true;
	}
	else if(newval == "1") {
		document.getElementById("speakermeute").disabled=false;
		document.getElementById("bothms").disabled=true;
		document.getElementById("bothms1").disabled=true;
	} else if(newval == "2") {
		document.getElementById("speakermeute").disabled=true;
		document.getElementById("bothms").disabled=false;
		document.getElementById("bothms1").disabled=true;
		
	} else if(newval == "3") {
		document.getElementById("speakermeute").disabled=false;
		document.getElementById("bothms").disabled=false;
		document.getElementById("bothms1").disabled=false;
	}

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#i2senablehidgroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "i2senablehid");
	var newval = $("#i2senablehidgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});


$("#i2senablehid").change(function () {
	
	var oldval = getWidgetValue(gb_HUB_ID, "i2senablehid");
	var newval = $("#i2senablehid").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#upstreambatterysettingsgroup").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "upstreambatterysettings");
	var newval = $("#upstreambatterysettingsgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#downstreamBCsettingport1group").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "downstreamBCsettingport1");
	var newval = $("#downstreamBCsettingport1group").find(':checked').val();
	
	if(oldval !=0 && oldval != 1 && oldval!=2) //Default values will be 0,1,2
	{
		oldval = "3";
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#downstreamBCsettingport2group").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "downstreamBCsettingport2");
	var newval = $("#downstreamBCsettingport2group").find(':checked').val();
	if(oldval !=0 && oldval != 1 && oldval!=2) //Default values will be 0,1,2
	{
		oldval = "3";
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#downstreamBCsettingport3group").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "downstreamBCsettingport3");
	var newval = $("#downstreamBCsettingport3group").find(':checked').val();
	if(oldval !=0 && oldval != 1 && oldval!=2) //Default values will be 0,1,2
	{
		oldval = "3";
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#downstreamBCsettingport4group").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "downstreamBCsettingport4");
	var newval = $("#downstreamBCsettingport4group").find(':checked').val();
	if(oldval !=0 && oldval != 1 && oldval!=2) //Default values will be 0,1,2
	{
		oldval = "3";
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#downstreamBCsettingport5group").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "downstreamBCsettingport5");
	var newval = $("#downstreamBCsettingport5group").find(':checked').val();
	if(oldval !=0 && oldval != 1 && oldval!=2) //Default values will be 0,1,2
	{
		oldval = "3";
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});

$("#downstreamBCsettingport6group").change(function () {
	var oldval = getWidgetValue(gb_HUB_ID, "downstreamBCsettingport6");
	var newval = $("#downstreamBCsettingport6group").find(':checked').val();
	if(oldval !=0 && oldval != 1 && oldval!=2) //Default values will be 0,1,2
	{
		oldval = "3";
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});
//USB2 Dynamic port mapping
$('#USB2Port1MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "port1mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB2Port2MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "port2mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB2Port3MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "port3mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB2Port4MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "port4mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB2Port5MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "port5mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB2Port6MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "port6mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB2Port7MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "port7mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

//End of USB2 Dynamic port mapping

//USB3 Dynamic port mapping
$('#USB3Port1MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "usb3port1mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB3Port2MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "usb3port2mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB3Port3MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "usb3port3mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB3Port4MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "usb3port4mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB3Port5MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "usb3port5mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB3Port6MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "usb3port6mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

$('#USB3Port7MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(gb_HUB_ID, "usb3port7mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});

//End of USB3 Dynamic port mapping

$('#PHYBOOSTUL li').on('click', function() {
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOST")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}

});
$('#PHYBOOSTULdownstreamport1 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport1")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#PHYBOOSTULdownstreamport2 li').on('click', function() {
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport2")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#PHYBOOSTULdownstreamport3 li').on('click', function() {
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport3")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#PHYBOOSTULdownstreamport4 li').on('click', function() {
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport4")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#PHYBOOSTULdownstreamport5 li').on('click', function() {
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport5")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#PHYBOOSTULdownstreamport6 li').on('click', function() {
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport6")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#PHYBOOSTULdownstreamport7 li').on('click', function() {
	var oldval = DropDownPHYBOOST[getWidgetValue(gb_HUB_ID, "PHYBOOSTdownstreamport7")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHUL li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCH")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else {
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHULdownstreamport1 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport1")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHULdownstreamport2 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport2")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHULdownstreamport3 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport3")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHULdownstreamport4 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport4")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHULdownstreamport5 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport5")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHULdownstreamport6 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport6")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#SQUELCHULdownstreamport7 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(gb_HUB_ID, "SQUELCHdownstreamport7")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#downstreamport1HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "downstreamport1HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#downstreamport2HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "downstreamport2HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#downstreamport3HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "downstreamport3HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#downstreamport4HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "downstreamport4HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#downstreamport5HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "downstreamport5HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#downstreamport6HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "downstreamport6HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#downstreamport7HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "downstreamport7HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
$('#upstreamHsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(gb_HUB_ID, "upstreamHsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');	
	}
});
// $('#flexportUL li').on('click', function(){
	
	
	// var oldval = getWidgetValue(gb_HUB_ID, "flexport");
	// var newval =$(this).text();
	// if(oldval == newval)
	// {
		// var parent = $(this).closest('div');
        // $(parent).css('border-color', 'transparent');
	// }
	// else{
		
	
		// var parent = $(this).closest('div');
        // $(parent).css('border-color', 'red');	
	// }
// });
// $('#usb3flexportUL li').on('click', function(){
	
	
	// var oldval = getWidgetValue(gb_HUB_ID, "usb3flexport");
	// var newval =$(this).text();
	// if(oldval == newval)
	// {
		// var parent = $(this).closest('div');
        // $(parent).css('border-color', 'transparent');
	// }
	// else{
		
	
		// var parent = $(this).closest('div');
        // $(parent).css('border-color', 'red');	
	// }
// });
//GwidgetlistRadio Ends

//GwidgetlistDropDown Starts
/*$("#PHYBOOST").change(function () {
	var nameofcontrol = ".PHYBOOST1";
	var nameofcontrol1 = "[data-bind=\"PHYBOOSTlabel\"]";
	var newval = $(nameofcontrol).find(nameofcontrol1).text();
	var oldval = getWidgetValue(gb_HUB_ID, "PHYBOOST");
	var parent = $(this).closest('div');
	
	if (oldval == newval) {
        $(parent).css('border-color', 'transparent');
	} else {
        $(parent).css('border-color', 'red');
	}
});*/
