/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
 */

//Global variables
var RegString = "";
var offlineConfFile = "";
var LoadConfigFile = "";
var HUB_FAMILY_INDEX = "5";
var dummyHubID = "5";
var numberofportState = false;
var usb3numberofportState = false;
var noselect = false;
var portsAvailable;
var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";

var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";
var gINIFileSelected = false;
var gApply = false;
var FirstMergecfgFile = "";
var SecondMergecfgFile = "";
var mergeConfFile = "";
var ParseCfgFileExt = "";
var parseConfigFile = "";
var parseSaveFile = "";

//flags for INI file programming
var iniFile = "";
var iniFile_fullPath ="";


var USB7202_PortMap = ["0", "1", "3", "2", "4", "0", "5", "6"];
var USB725x_PortMap = ["0", "1", "4", "2", "0", "3", "5", "6"];
var USB7256_PortMap = ["0", "1", "5", "2", "3", "4", "6", "7"];
var USB7206_PortMap = ["0", "1", "2", "3", "4", "5", "6", "7"];

// Port type widgets
var GwidgetlistPortType = [ 
"port1type", 
"port2type", 
"port3type", 
"port4type",
"port5type", 
"port6type" 
];
// Widget ID of hex fields in the GUI
var GwidgetlistHex = [ 
"vid",
"pid",
"did",
"usbvcd",
"languageid",
"hce_vid",
"hce_pid", 
"hce_did", 
"hce_languageid", 
"hce1_vid", 
"hce1_pid",
"hce1_did", 
"hce1_languageid", 
"hce2_vid", 
"hce2_pid", 
"hce2_did",
"hce2_languageid",
// USB3 related
"usb3vid",
"usb3pid", 
"usb3did", 
"usb3vcd", 
"usb3languageid",
];

// Widget ID of string fields in the GUI
var GwidgetlistString = [ 
"manufacturer", 
"product", 
"serial",
"hce_manufacturer", 
"hce_product", 
"hce_serial", 
"hce1_manufacturer",
"hce1_product",
"hce1_macaddr", 
"hce1_string5", 
"hce1_eapproduct",
"hce1_eapinterface",
"hce2_manufacturer", 
"hce2_product",
"hce2_macaddr",
"hce2_string5", 
"hce2_eapproduct",
"hce2_eapinterface",
// USB3 related
"usb3manufacturer", 
"usb3product", 
"usb3serial", 
"usb3uuid"
];

// Widget ID of decimal fields in the GUI
var GwidgetlistInt = [ 
"maxpowerself", 
"hubcmaxpowerself", 
"maxpowerbus",
"hubcmaxpowerbus", 
"hub3maxpowerselfbus" ,
"power_ontime"
];

// Widgets that are checkboxes in GUI
var GwidgetlistCheckbox11 = [ 
//"flexconnect", 
//"usb3flexconnect", 
"hsdisable",
"hceenable", 
"cdcenable",
"lpmenable", 
"swapupstreamdpdm", 
"swapport1dpdm", 
"swapport2dpdm",
"swapport3dpdm", 
"swapport4dpdm", 
"swapport5dpdm", 
"swapport6dpdm",
"enableport1", 
"enableport2", 
"enableport3", 
"enableport4",
"enableport5", 
"enableport6", 
"nrdeviceport1", 
"nrdeviceport2",
"nrdeviceport3", 
"nrdeviceport4", 
"nrdeviceport5", 
"nrdeviceport6",
"usb3enableport1", 
"usb3enableport2", 
"usb3enableport3",
"usb3enableport4", 
"usb3enableport5", 
"usb3nrdeviceport5",
"usb3nrdeviceport4", 
"usb3nrdeviceport3", 
"usb3nrdeviceport2",
"usb3nrdeviceport1",
"pdport1",
"pdport3",
"pdupstream"
];

// Widgets that are radio buttons in GUI
var GwidgetlistRadio = [ 
"hubpower", 
"downstreamBCsettingport1", 
"downstreamBCsettingport2",
"downstreamBCsettingport3", 
"downstreamBCsettingport4",
"downstreamBCsettingport5", 
"downstreamBCsettingport6",
"port5splitting", 
"port4splitting", 
"port3splitting", 
"pstimeout",
"i2senable",
"i2senablehid"
];

// Lookup for Flexport selection
//var DropDownflexport = [ "", "1", "2", "3", "4", "5", "6" ];

var minihostconnectFunction = {
"USB 1.1 DFP" : "0",
"Connect to the USB2 hub in USB 1.1 Mode" : "2",
"Connect in USB2 Mode" : "3",
"Connect in USB 3 Gen 1 Mode" : "4",
"Connect in USB 3 Gen 2 Mode" : "5",
"Unlimited Connection" : "7"
};
var deviceclass = {
	"Device" : "00",
	"Audio" : "01",
	"Communications and CDC Control" : "02",
	"HID – Human Interface Device" : "03",
	"Physical" : "05",
	"Still Imaging" : "06",
	"Printer" : "07",
	"Mass Storage" : "08",
	"Hub" : "09",
	"CDC-Data":"0A",
	"Smart Card":"0B",
	"Content Security":"0D",
	"Video" : "0E",
	"Personal Healthcare" : "0F",
	"Audio/Video Devices" : "10",
	"Billboard Device" : "11",
	"USB Type-C Bridge Device" : "12",
	"Diagnostic Device" : "DC",
	"Wireless Controller" : "E0",
    	"Miscellaneous" : "EF",
	"Application Specific" : "FE",
   	"Vendor Specific" : "FF"
};

// Widgets that are Drop Down in GUI
var GwidgetlistDropDown = [ 
"PHYBOOST", 
"SQUELCH", 
"upstreamHsRiseFall",
"PHYBOOSTdownstreamport1", 
"SQUELCHdownstreamport1",
"downstreamport1HsRiseFall", 
"PHYBOOSTdownstreamport2",
"SQUELCHdownstreamport2", 
"downstreamport2HsRiseFall",
"PHYBOOSTdownstreamport3", 
"SQUELCHdownstreamport3",
"downstreamport3HsRiseFall",
"PHYBOOSTdownstreamport4",
"SQUELCHdownstreamport4", 
"downstreamport4HsRiseFall",
"PHYBOOSTdownstreamport5", 
"SQUELCHdownstreamport5",
"downstreamport5HsRiseFall", 
"PHYBOOSTdownstreamport6",
"SQUELCHdownstreamport6", 
"downstreamport6HsRiseFall", 
//"flexport"
];

// Document START
$(document).ready(function() 
{
	// Display widgets with respect to the type of Microchip product selected.
	$("#Apply").attr('disabled', true);
	$("#Reset").attr('disabled', true);

	$('#SaveFileField').hide();
	$('#SaveFileField').attr('disabled', 'disabled');
	$('#LoadFileField').removeAttr('disabled');
	$("#LoadFileField").attr('disabled', true);
	$('#LoadFileField').show();
	$("#LoadFileField").attr('disabled', true);

	update_status_message("Offline Configuration");
	clearWidgetMap();

	$("#devicedescriptortab").attr('disabled', true);
	$("#stringdescriptortab").attr('disabled', true);
	$("#USB3devicedescriptortab").attr('disabled', true);
	$('#showtipforport6split').hide();
	$("#USB3stringdescriptortab").attr('disabled', true);
	$("#USB3otherdescriptortab").attr('disabled', true);
	$("#upstreamtab").attr('disabled', true);
	$("#downstreamtab").attr('disabled', true);
	$("#Bdownstreamtab").attr('disabled', true);
	$("#USB3_Bdownstreamtab").attr('disabled', true);
	$("#uchtab").attr('disabled', true);
	$('#showtipforport5split').hide();
	$("#advancedtab").attr('disabled', true);
	$("#specialtab").attr('disabled', true);
	$("#registerVal").attr('disabled', true);
	$("#registerFile").attr('disabled', true);
	$("#cdctab").attr('disabled', true);
	$('#PORTSplittingfieldset').hide();
	// Enable all port BC fields
	$('#BdownstreamUSBport1').removeAttr('disabled');
	$('#BdownstreamUSBport2').removeAttr('disabled');
	$('#BdownstreamUSBport3').removeAttr('disabled');
	$('#BdownstreamUSBport4').removeAttr('disabled');
	$('#BdownstreamUSBport5').removeAttr('disabled');
	$('#BdownstreamUSBport6').removeAttr('disabled');
	$('#BdownstreamUSBport7').removeAttr('disabled');

	$('#BdownstreamUSBport1').show();
	$('#BdownstreamUSBport2').show();
	$('#BdownstreamUSBport3').show();
	$('#BdownstreamUSBport4').show();
	$('#BdownstreamUSBport5').show();
	$('#BdownstreamUSBport6').show();
	$('#BdownstreamUSBport7').show();
});
// Document END

$('#selectsku_USB72 li').on('click',function() 
{
	$('#nav').show();
	$('#close').hide();
	$('#sfield').hide();
	document.getElementById("overlay")
			.setAttribute("class", "col-xs-2");
	gb_sku = $(this).text();
	update_status_message("Selected SKU is :" + gb_sku);
	
	//document.getElementById("copyNCM").checked = false;
	Reset_innerHTML();
	
	$("#vidpidmaskrule").hide();
	$("#vidpidrule").hide();
	$("#deviceclassrule").hide();
	$('#addminihostrule').hide();
	$('#minihostoverwriteexistingrule').hide();
	var nameofcontrol = ".minihostruletype";
	var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
	.children('.dropdown-toggle').dropdown('toggle');
	var nameofcontrol = ".minihostexistingrule";
	var nameofcontrol1 = "[data-bind=\"" + "minihostexistingrule" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Index")
	.children('.dropdown-toggle').dropdown('toggle');
	$('#minihostruleindex').hide();
	Reset_miniHostDiv();
	Reset_miniHostVariables();
	
	
	$("input[type='file']").val('');

	// show/hide ports based on SKU
	if (gb_sku === "USB7202") 
	{
		custom_dos_portorder (gb_sku);
		
		$('#BPORT4fieldset').show();
		$('#BPORT5fieldset').hide();
		$('#BPORT6fieldset').hide();
		
		// Hide port 2 usb 3
		$('#BasicPort2Usb3').hide();
	
		
		$("#CDC_Div").show();
		
		//Hide USB3 Port for port 4
		$('#usb3port4mappingdiv').hide();

		// Hide port splitting
		$('#port3Split').hide();
		$('#port4Split').hide();
		$('#port5Split').hide();

		// Hide port5 and 6 in advancedtab
		$('#PORT4fieldset').show();
		$('#PORT5fieldset').hide();
		$('#PORT6fieldset').hide();

		// Show NCM related feilds
		$('#NCMdiv').show();

		// // Show flexconnect
		// $('#otpflex').show();
		//Show/hide Flexport
		//$('#flxprt5').hide();
		//$('#flxprt6').hide();
		
			
		//Power delivery
		$('#disablepdupstream').hide();
		$('#disablepdport1').hide();
		$('#disablepdport3').hide();
		
		$('#minihostfeature').show();
		$('#BCPort1').show();
		$('#BCPort2').show();
		$('#BCPort3').show();
		$('#BCPort4').show();
		$('#BCPort5').show();
		$('#BCPort6').show();
		
		$('#usb3port1div').show();
		$('#usb3port3div').show();
		$('#usb3port4div').show();
		$('#usb3port5div').show();
		
		$('#usb2port1div').show();
		$('#usb2port2div').show();
		$('#usb2port3div').show();
		$('#usb2port4div').show();
		$('#usb2port5div').show();
		$('#usb2port6div').show();
	} 
	else if ((gb_sku === "USB7250") || (gb_sku === "USB7251")
			|| (gb_sku === "USB7252")) 
	{
		custom_dos_portorder (gb_sku);
		$('#BPORT4fieldset').hide();
		$('#BPORT6fieldset').hide();
		$('#BPORT5fieldset').show();
		
		// Hide port 2 usb 3
		$('#BasicPort2Usb3').hide();
		
		// Show port splitting only for port 5 and hide others
		$('#port3Split').hide();
		$('#port4Split').hide();
		$('#port5Split').show();

		// Hide port5 and 6 in advancedtab
		$('#PORT4fieldset').hide();
		$('#PORT6fieldset').hide();
		$('#PORT5fieldset').show();
		
		$("#CDC_Div").show();

		// // Hide flex
		// $('#otpflex').hide();
		//Show/hide Flexport
		//$('#flxprt5').hide();
		//$('#flxprt6').hide();
		
		$('#minihostfeature').hide();
		$('#BCPort1').hide();
		$('#BCPort2').hide();
		$('#BCPort3').hide();
		$('#BCPort4').hide();
		$('#BCPort5').hide();
		$('#BCPort6').hide();
		
		$('#usb3port1div').hide();
		$('#usb3port3div').hide();
		$('#usb3port4div').hide();
		$('#usb3port5div').hide();
		
		$('#usb2port1div').hide();
		$('#usb2port2div').hide();
		$('#usb2port3div').hide();
		$('#usb2port4div').hide();
		$('#usb2port5div').hide();
		$('#usb2port6div').hide();
					
		if (gb_sku === "USB7250") 
		{
			// Show NCM related feilds
			$('#NCMdiv').show();
			
			//Power delivery
			$('#disablepdupstream').show();
			$('#disablepdport1').show();
			$('#disablepdport3').show();
		} 
		else 
		{
			// Hide NCM related feilds
			$('#NCMdiv').hide();
			
			if(gb_sku === "USB7251")
			{
				//Power delivery
				$('#disablepdupstream').show();
				$('#disablepdport1').hide();
				$('#disablepdport3').show();
			}
			if(gb_sku === "USB7252")
			{
				//Power delivery
				$('#disablepdupstream').show();
				$('#disablepdport1').hide();
				$('#disablepdport3').hide();
			}
		}
	} 
	else if (gb_sku === "USB7216" || gb_sku === "USB7206" || gb_sku === "USB7256") 
	{
		custom_dos_portorder(gb_sku);
		$('#BPORT5fieldset').show();
		$('#BPORT6fieldset').show();
		$('#BPORT4fieldset').show();
		
		if(gb_sku === "USB7216" || gb_sku === "USB7256")
		{
			// Hide port 2 usb 3
			$('#BasicPort2Usb3').hide();
		}
		else if(gb_sku === "USB7206")
		{
			// Show port 2 usb 3
			$('#BasicPort2Usb3').show();
		}
		//Show USB3 Port for port 4
		$('#usb3port4mappingdiv').show();

		// Hide port splitting
		$('#port3Split').show();
		$('#port4Split').show();
		$('#port5Split').show();

		// Hide port5 and 6 in advancedtab
		$('#PORT4fieldset').show();
		$('#PORT5fieldset').show();
		$('#PORT6fieldset').show();
		
		// // Hide flex
		// $('#otpflex').hide();
		//Show/hide Flexport
		//$('#flxprt5').show();
		//$('#flxprt6').show();
				
		// Hide NCM related feilds
		$('#NCMdiv').hide();
		
		//Power delivery
		if(gb_sku === "USB7256")
		{
			$('#disablepdupstream').show();
			$('#disablepdport1').hide();
			$('#disablepdport3').hide();
			$('#BCPort1').hide();
			$('#BCPort2').hide();
			$('#BCPort3').hide();
			$('#BCPort4').hide();
			$('#BCPort5').hide();
			$('#BCPort6').hide();
			$('#usb3port1div').hide();
			$('#usb3port3div').hide();
			$('#usb3port4div').hide();
			$('#usb3port5div').hide();
			
			$('#usb2port1div').hide();
			$('#usb2port2div').hide();
			$('#usb2port3div').hide();
			$('#usb2port4div').hide();
			$('#usb2port5div').hide();
			$('#usb2port6div').hide();
		}
		else if(gb_sku === "USB7216") {
			$('#disablepdupstream').hide();
			$('#disablepdport1').hide();
			$('#disablepdport3').hide();
			$('#BCPort1').show();
			$('#BCPort2').show();
			$('#BCPort3').show();
			$('#BCPort4').show();
			$('#BCPort5').show();
			$('#BCPort6').show();
			$('#usb3port1div').show();
			$('#usb3port3div').show();
			$('#usb3port4div').show();
			$('#usb3port5div').show();
			
			$('#usb2port1div').show();
			$('#usb2port2div').show();
			$('#usb2port3div').show();
			$('#usb2port4div').show();
			$('#usb2port5div').show();
			$('#usb2port6div').show();
		}
		else if(gb_sku === "USB7206")
		{
			$('#disablepdupstream').hide();
			$('#disablepdport1').hide();
			$('#disablepdport3').hide();
			$('#BCPort1').show();
			$('#BCPort2').show();
			$('#BCPort3').show();
			$('#BCPort4').show();
			$('#BCPort5').show();
			$('#BCPort6').show();
			$('#usb3port1div').show();
			$('#usb3port3div').show();
			$('#usb3port4div').show();
			$('#usb3port5div').show();
			
			$('#usb2port1div').show();
			$('#usb2port2div').show();
			$('#usb2port3div').show();
			$('#usb2port4div').show();
			$('#usb2port5div').show();
			$('#usb2port6div').show();
		}
		
		$("#CDC_Div").hide();
		
		$('#minihostfeature').hide();
		
		
		
	}

	$('#SaveFileField').hide();
	$('#LoadFileField').show();
	
	clearWidgetMap();
	gArrConfigIndex = 0;
	LoadConfFile = "";
	changecount = 0;
	RegString = "";
	// document.getElementById("myForm").reset();
	$("#Reset").attr('disabled', false);
	// reset_file_input();
	iniFile = "";
	offlineConfFile = "";
	enable_all_fields();
	set_changed_fields_border_default();
	offline_MchpUsbClose();
	var ret = offline_MchpUsbOpen("8", gb_sku);
	if (ret) 
	{
		populateDefaultValues();
	}
});

function formatinput(inputName) {

	//remove space from the argument
	inputName= inputName.trim();
	
	//add spaces after every 2 digits
	var RegVal = $('#'+inputName).val().replace(/(\d{2})/g, '$1 ').replace(/(^\s+|\s+$)/,'');
	//Remove extra spaces
	RegVal = RegVal.replace(/  +/g, ' ');
	//update into text box
	$('#'+inputName).val(RegVal);
}
			
$("#RegEntry").click(function() 
{
	var regOptionChosen = $("#Regoperationgroup").find(
			':checked').val();
	var Regop = "";
	var Regadd = "";
	var RegVal = "";
	var toDisplay="";

	if (typeof regOptionChosen === 'undefined') 
	{
		alert("Please choose an appropriate register operation under the Direct Register Access.");
		return;
	}

	if (regOptionChosen == 0) 
	{
		Regop = "XMODE_WRITE_BYTE";
		toDisplay = "WRE";
	} 
	else if (regOptionChosen == 1) 
	{
		Regop = "XMODE_SET_BITS";
		toDisplay = "SET ";
	} 
	else if (regOptionChosen == 2) 
	{
		Regop = "XMODE_CLEAR_BITS";
		toDisplay = "CLR ";
	} 
	else 
	{
		Regop = "";
		// do nothing
	}
	Regadd = $("#Regaddress").val();
	var isOKAddr = /^[0-9A-Fa-f]{8}$/i.test(Regadd);
	RegVal = "" + $("#Regvalue").val();
	var newRegVal = RegVal.replace(/\s+/g, "");
	var RegValOkay = /^[0-9A-Fa-f]+$/i.test(newRegVal);

	if ((Regadd == "") || (RegVal == "")) 
	{
		alert("Either the value of register address or the register value is not entered under the Direct Register Access.");
		return;
	}

	if (!isOKAddr) 
	{
		alert("The Register Address entered under the Direct Register Access must be a 8 digit hexadecimal number.");
	}

	if (!RegValOkay) 
	{
		alert("The Register value entered under the Direct Register Access is not a valid hexadecimal number.");
	}

	if (RegValOkay && isOKAddr) 
	{
		if (Regop.length == 0) 
		{
			alert("Please choose appropriate register operation.");
		} 
		else 
		{
			if (Regadd && RegVal) 
			{
				if (RegString) {
					RegString = Regop + "+" + Regadd + "+"
							+ newRegVal + "+" + RegString;
				} 
				else 
				{
					RegString = Regop + "+" + Regadd + "+"
							+ newRegVal;
				}
				changecount = changecount + 1;
				switchloadsave(changecount);
				
				update_status_message("Register Address: "
						+ Regadd
						+ " Register Value: "
						+ RegVal
						+ " for operation: "
						+ Regop
						+ " will be added in an ini file and programmed into the hub.");
				update_dra_status_message(toDisplay+"_"+ Regadd + "=" + RegVal);
			} 
			else 
			{
				alert("Either Register address or Register value is not added.");
			}
		}
		document.getElementById("myForm").reset();
	}
});

function setiniType() 
{
	setFileType("ini", 0);
}

function startRead() 
{
	iniFile = "";

	var file = document.getElementById("iniid").files[0];
	if (typeof file === 'undefined') 
	{
		update_status_message("No configuration file(.ini) is selected.");
		iniFile = "";
		if (gINIFileSelected == true) {
			changecount = changecount - 1;
			switchloadsave(changecount);
			gINIFileSelected = false;
		}
		alert("No configuration file(.ini) is selected.");
	} 
	else 
	{
		iniFile = file.name;
		extension = iniFile.substr(iniFile.lastIndexOf('.') + 1);

		if (extension != "ini") 
		{
			alert("Selected File type is not supported. Please Select File type : ini");
			var mesg = ("Selected File type is not supported.Supported File type is .ini");
			update_status_message(mesg);
			iniFile = "";
			// reset_file_input();
			$("#iniid").val('');
			$("#iniid").css({
				background : "white",
				border : "0px"
			});
			errorFlag = true;
			return;
		} 
		else 
		{
			var mesg = ("Selected .ini file to program is :" + iniFile);
			update_status_message(mesg);
			var fileSizeInKb = file.size / 1024;
			update_status_message("The size of the .ini file selected is "
					+ fileSizeInKb.toFixed(2) + " KB");
			$("#iniid").css({
				background : "white",
				border : "0px"
			});
			update_status_message(mesg);
			changecount = changecount + 1;

			switchloadsave(changecount);
			gINIFileSelected = true;
		}
	}
}
// Direct Register Access blocks End

// Onclick event for dropdown STARTS
$(document).on('click','.dropdown li a',function(event) 
{
	// this code is for making the current selection appear with caret
	var $target = $(event.currentTarget);

	$target.closest('.btn-group').find('[data-bind]').text(
			$target.text()).end().children('.dropdown-toggle')
			.dropdown('toggle');
	var selop = $(this).text();
	console.log("Selected Option - All dropdowns:" + selop);
});
// Onclick event for dropdown ENDS

// Lookup for phyboost dropdown value selection
var DropDownPHYBOOST = [ 
"Nominal 17.78 mA", 
"5% below nominal",
"10% above nominal", 
"5% above nominal", 
"20% above nominal",
"15% above nominal", 
"30% above nominal", 
"25% above nominal",
];

// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [ 
"Nominal 100mV", 
"12.5mV below nominal",
"25mV below nominal", 
"37.5mV below nominal", 
"50mV below nominal",
"62.5mV below nominal", 
"25mV above nominal", 
"12.5mV above nominal"
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall = [ "Default", "+18%", "-18%", "-12%" ];


// Mapping widgets to the meaningful elaborations to print while in error
var Mapping = {
	// Hex
	"vid" : "USB2.0 Vendor ID",
	"pid" : "USB2.0 Product ID",
	"did" : "USB2.0 Device ID",
	"usbvcd" : "USB2.0 Version",
	"languageid" : "USB2.0 Language ID",
	"manufacturer" : "USB2.0 Manufacturer",
	"manufacturerlen" : "USB2.0 Manufacturer Length",
	"product" : "USB2.0 Product",
	"productlen" : "USB2.0 Product Length",
	"serial" : "USB2.0 Serial",
	"seriallen" : "USB2.0 Serial Length",
	
	"usb3vid" : "USB3.1 Gen2 Vendor ID",
	"usb3pid" : "USB3.1 Gen2 Product ID",
	"usb3did" : "USB3.1 Gen2 Device ID",
	"usb3vcd" : "USB3.1 Gen2 Version",
	"usb3languageid" : "USB3.1 Gen2 Language ID",
	"usb3manufacturer" : "USB3.1 Gen2 Manufacturer",
	"usb3product" : "USB3.1 Gen2 Product",
	"usb3serial" : "USB3.1 Gen2 Serial",
	"usb3uuid" : "Universal unique ID",
	
	"numberofports" : "Number of Enabled USB2.0 ports",
	"usb3numberofports" : "Number of Enabled USB3.1 Gen2 ports",
	
	
	"pstimeout" : "USB3 Port Split Link TimeOut",
	

	// "flexport" : "USB2 Flex Port",
	// "flexconnect" : "USB2 Flexconnect",
	// "usb3flexconnect" : "USB3.1 Gen2 Hub flexconnect",
	// "usb3flexport" : "USB3.1 Gen2 Hub Flex Port",
	"hceenable" : "Hub Feature Controller State",
	"hce_vid" : "HFC Vendor ID",
	"hce_pid" : "HFC Product ID",
	"hce_did" : "HFC Device ID",
	"hce_languageid" : "HFC Language ID",
	"hce_manufacturer" : "HFC Manufacturer",
	"hce_manufacturerlen" : "HFC Manufacturer Length",
	"hce_product" : "HFC Product",
	"hce_productlen" : "HFC Product Length",
	"hce_serial" : "HFC Serial",
	"hce_seriallen" : "HFC Serial Length",

	"hce1_vid" : "NCM/IAP and IAP/EAP Class Device 1 Vendor ID",
	"hce1_pid" : "NCM/IAP and IAP/EAP Class Device 1 Product ID",
	"hce1_did" : "NCM/IAP and IAP/EAP Class Device 1 Device ID",
	"hce1_languageid" : "NCM/IAP and IAP/EAP Class Device 1 Language ID",
	"hce1_manufacturer" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer",
	"hce1_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer String Length",
	"hce1_product" : "NCM/IAP Class Device 1 Product",
	"hce1_string5" : "NCM/IAP and IAP/EAP Class Device 1 Serial Number",
	"hce1_productlen" : "NCM/IAP Class Device 1 Product String Length",
	"hce1_macaddr" : "NCM/IAP Class Device 1 MAC address",
	"hce1_eapproduct" : "IAP/EAP Class Device 1 Product String",
	"hce1_eapinterface" : "IAP/EAP Class Device 1 Interface String",
	

	"hce2_vid" : "NCM/IAP and IAP/EAP Class Device 2 Vendor ID",
	"hce2_pid" : "NCM/IAP and IAP/EAP Class Device 2 Product ID",
	"hce2_did" : "NCM/IAP and IAP/EAP Class Device 2 Device ID",
	"hce2_languageid" : "NCM/IAP and IAP/EAP Class Device 2 Language ID",
	"hce2_manufacturer" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer",
	"hce2_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer String Length",
	"hce2_product" : "NCM/IAP Class Device 2 Product",
	"hce2_productlen" : "NCM/IAP Class Device 2 Product String Length",
	"hce2_string5" : "NCM/IAP and IAP/EAP Class Device 2 Serial Number",
	"hce2_macaddr" : "NCM/IAP Class Device 2 MAC address",
	"hce2_eapproduct" : "IAP/EAP Class Device 2 Product String",
	"hce2_eapinterface" : "IAP/EAP Class Device 2 Interface String",
	
	"i2senable" : "I2S Feature Select",
	"i2senablehid" : "HID Feature Select",
	"power_ontime" : "Power-on time",
	"cdcenable":"CDC State",
	"hubpower" : "Hub Power",
	"maxpowerself" : "USB2.0 Hub Max Power(Self)",
	"hubcmaxpowerself" : "Hub Circuit Max Power (Self)",
	"maxpowerbus" : "USB2.0 Hub Max Power (Bus)",
	"hubcmaxpowerbus" : "Hub Circuit Max Power (Bus)",
	"hub3maxpowerselfbus" : "USB3.1 Gen2 Max Power",
	"hsdisable" : "Hub Full Speed Mode",
	"lpmenable" : "LPM State",
	"xdataentry" : "Direct Register Access",
	"xdataprogram" : "ini File",
	
	"minihost_vidpidrule" : "MiniHost VID PID Rule",
	"minihost_vidpidmaskrule" : "MiniHost VID PID Mask Rule",
	"minihost_deviceclassrule" : "Minihost Device Class Rule",
	
	"pdport1" : "Port 1 Power delivery",
	"pdport3" : "Port 2 Power delivery",
	"pdupstream" : "Upstram Port Power delivery",
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port2 Enable/Disable State",
	"enableport3" : "USB2.0 Port3 Enable/Disable State",
	"enableport4" : "USB2.0 Port4 Enable/Disable State",
	"enableport5" : "USB2.0 Port5 Enable/Disable State",
	"enableport6" : "USB2.0 Port6 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port2 Logical mapping",
	"port3mapping" : "USB2.0 Port3 Logical mapping",
	"port4mapping" : "USB2.0 Port4 Logical mapping",
	"port5mapping" : "USB2.0 Port5 Logical mapping",
	"port6mapping" : "USB2.0 Port6 Logical mapping",
	"port7mapping" : "USB2.0 Port7 Logical mapping",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port3 Non-removable State",
	"nrdeviceport4" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port5 Non-removable State",
	"nrdeviceport6" : "USB2.0 Port6 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port3 Enable/Disable State",
	"usb3enableport4" : "USB3.1 Gen2 Port4 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port5 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port3 Logical mapping",
	"usb3port4mapping" : "USB3.1 Gen2 Port4 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port5 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdeviceport4" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port5 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port2 Battery charging State",
	"downstreamBCsettingport3" : "Port3 Battery charging State",
	"downstreamBCsettingport4" : "Port4 Battery charging State",
	"downstreamBCsettingport5" : "Port5 Battery charging State",
	"downstreamBCsettingport6" : "Port6 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port2:Swap D+/D-",
	"swapport3dpdm" : "Port3:Swap D+/D-",
	"swapport4dpdm" : "Port4:Swap D+/D-",
	"swapport5dpdm" : "Port5:Swap D+/D-",
	"swapport6dpdm" : "Port6:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port3:PHYBOOST",
	"PHYBOOSTdownstreamport4" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port5:PHYBOOST",
	"PHYBOOSTdownstreamport6" : "Port6:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port2:Varisense",
	"SQUELCHdownstreamport3" : "Port3:Varisense",
	"SQUELCHdownstreamport4" : "Port4:Varisense",
	"SQUELCHdownstreamport5" : "Port5:Varisense",
	"SQUELCHdownstreamport6" : "Port6:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port3:High Speed rise/fall adjust",
	"downstreamport4HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port5:High Speed rise/fall adjust",
	"downstreamport6HsRiseFall" : "Port6:High Speed rise/fall adjust",
	"port3splitting" : "Port 3 Port Splitting",
	"port4splitting" : "Port 4 Port Splitting",
	"port5splitting" : "Port 5 Port Splitting"
	
};

var USB7202_Mapping = {
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port3 Enable/Disable State",
	"enableport3" : "USB2.0 Port2 Enable/Disable State",
	"enableport4" : "USB2.0 Port4 Enable/Disable State",
	"enableport5" : "USB2.0 Port5 Enable/Disable State",
	"enableport6" : "USB2.0 Port6 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port3 Logical mapping",
	"port3mapping" : "USB2.0 Port2 Logical mapping",
	"port4mapping" : "USB2.0 Port4 Logical mapping",
	"port5mapping" : "USB2.0 Port5 Logical mapping",
	"port6mapping" : "USB2.0 Port6 Logical mapping",
	"port7mapping" : "USB2.0 Port7 Logical mapping",
	
	"port3splitting" : "Port 3 Port Splitting",
	"port4splitting" : "Port 4 Port Splitting",
	"port5splitting" : "Port 5 Port Splitting",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port3 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport4" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port5 Non-removable State",
	"nrdeviceport6" : "USB2.0 Port6 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port3 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport4" : "USB3.1 Gen2 Port4 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port5 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port3 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port4mapping" : "USB3.1 Gen2 Port4 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port5 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport4" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port5 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port3 Battery charging State",
	"downstreamBCsettingport3" : "Port2 Battery charging State",
	"downstreamBCsettingport4" : "Port4 Battery charging State",
	"downstreamBCsettingport5" : "Port5 Battery charging State",
	"downstreamBCsettingport6" : "Port6 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port3:Swap D+/D-",
	"swapport3dpdm" : "Port2:Swap D+/D-",
	"swapport4dpdm" : "Port4:Swap D+/D-",
	"swapport5dpdm" : "Port5:Swap D+/D-",
	"swapport6dpdm" : "Port6:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port3:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport4" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port5:PHYBOOST",
	"PHYBOOSTdownstreamport6" : "Port6:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port3:Varisense",
	"SQUELCHdownstreamport3" : "Port2:Varisense",
	"SQUELCHdownstreamport4" : "Port4:Varisense",
	"SQUELCHdownstreamport5" : "Port5:Varisense",
	"SQUELCHdownstreamport6" : "Port6:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port3:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport4HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port5:High Speed rise/fall adjust",
	"downstreamport6HsRiseFall" : "Port6:High Speed rise/fall adjust",
};
var USB725x_Mapping = {
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port4 Enable/Disable State",
	"enableport3" : "USB2.0 Port2 Enable/Disable State",
	"enableport5" : "USB2.0 Port3 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port4 Logical mapping",
	"port3mapping" : "USB2.0 Port2 Logical mapping",
	"port5mapping" : "USB2.0 Port3 Logical mapping",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port3 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port4 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port3 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port4 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port3 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port4 Battery charging State",
	"downstreamBCsettingport3" : "Port2 Battery charging State",
	"downstreamBCsettingport5" : "Port3 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port4:Swap D+/D-",
	"swapport3dpdm" : "Port2:Swap D+/D-",
	"swapport5dpdm" : "Port3:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port3:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port4:Varisense",
	"SQUELCHdownstreamport3" : "Port2:Varisense",
	"SQUELCHdownstreamport5" : "Port3:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port3:High Speed rise/fall adjust",
	
	"port5splitting" : "Port 3 Port Splitting",
};
var USB7256_Mapping = {
	"enableport1" : "USB2.0 Port1 Enable/Disable State",
	"enableport2" : "USB2.0 Port5 Enable/Disable State",
	"enableport3" : "USB2.0 Port2 Enable/Disable State",
	"enableport4" : "USB2.0 Port3 Enable/Disable State",
	"enableport5" : "USB2.0 Port4 Enable/Disable State",
	"enableport6" : "USB2.0 Port6 Enable/Disable State",
	
	"port1mapping" : "USB2.0 Port1 Logical mapping",
	"port2mapping" : "USB2.0 Port5 Logical mapping",
	"port3mapping" : "USB2.0 Port2 Logical mapping",
	"port4mapping" : "USB2.0 Port3 Logical mapping",
	"port5mapping" : "USB2.0 Port4 Logical mapping",
	"port6mapping" : "USB2.0 Port6 Logical mapping",

	"nrdeviceport1" : "USB2.0 Port1 Non-removable State",
	"nrdeviceport2" : "USB2.0 Port5 Non-removable State",
	"nrdeviceport3" : "USB2.0 Port2 Non-removable State",
	"nrdeviceport4" : "USB2.0 Port3 Non-removable State",
	"nrdeviceport5" : "USB2.0 Port4 Non-removable State",
	"nrdeviceport6" : "USB2.0 Port6 Non-removable State",

	"usb3enableport1" : "USB3.1 Gen2 Port1 Enable/Disable State",
	"usb3enableport2" : "USB3.1 Gen2 Port5 Enable/Disable State",
	"usb3enableport3" : "USB3.1 Gen2 Port2 Enable/Disable State",
	"usb3enableport4" : "USB3.1 Gen2 Port3 Enable/Disable State",
	"usb3enableport5" : "USB3.1 Gen2 Port4 Enable/Disable State",

	"usb3port1mapping" : "USB3.1 Gen2 Port1 Logical mapping",
	"usb3port2mapping" : "USB3.1 Gen2 Port5 Logical mapping",
	"usb3port3mapping" : "USB3.1 Gen2 Port2 Logical mapping",
	"usb3port4mapping" : "USB3.1 Gen2 Port3 Logical mapping",
	"usb3port5mapping" : "USB3.1 Gen2 Port4 Logical mapping",

	"usb3nrdeviceport1" : "USB3.1 Gen2 Port1 Non-removable State",
	"usb3nrdeviceport2" : "USB3.1 Gen2 Port5 Non-removable State",
	"usb3nrdeviceport3" : "USB3.1 Gen2 Port2 Non-removable State",
	"usb3nrdeviceport4" : "USB3.1 Gen2 Port3 Non-removable State",
	"usb3nrdeviceport5" : "USB3.1 Gen2 Port4 Non-removable State",
	"usb3nrdevice"	    : "USB3.1 Gen2 Non-removable value",

	"downstreamBCsettingport1" : "Port1 Battery charging State",
	"downstreamBCsettingport2" : "Port5 Battery charging State",
	"downstreamBCsettingport3" : "Port2 Battery charging State",
	"downstreamBCsettingport4" : "Port3 Battery charging State",
	"downstreamBCsettingport5" : "Port4 Battery charging State",
	"downstreamBCsettingport6" : "Port6 Battery charging State",

	"swapport1dpdm" : "Port1:Swap D+/D-",
	"swapport2dpdm" : "Port5:Swap D+/D-",
	"swapport3dpdm" : "Port2:Swap D+/D-",
	"swapport4dpdm" : "Port3:Swap D+/D-",
	"swapport5dpdm" : "Port4:Swap D+/D-",
	"swapport6dpdm" : "Port6:Swap D+/D-",
	"swapupstreamdpdm" : "Upstream Port:Swap D+/D-",

	"PHYBOOSTdownstreamport1" : "Port1:PHYBOOST",
	"PHYBOOSTdownstreamport2" : "Port5:PHYBOOST",
	"PHYBOOSTdownstreamport3" : "Port2:PHYBOOST",
	"PHYBOOSTdownstreamport4" : "Port3:PHYBOOST",
	"PHYBOOSTdownstreamport5" : "Port4:PHYBOOST",
	"PHYBOOSTdownstreamport6" : "Port6:PHYBOOST",
	"PHYBOOST" : "Upstream Port:PHYBOOST",

	"SQUELCHdownstreamport1" : "Port1:Varisense",
	"SQUELCHdownstreamport2" : "Port5:Varisense",
	"SQUELCHdownstreamport3" : "Port2:Varisense",
	"SQUELCHdownstreamport4" : "Port3:Varisense",
	"SQUELCHdownstreamport5" : "Port4:Varisense",
	"SQUELCHdownstreamport6" : "Port6:Varisense",
	"SQUELCH" : "Upstream Port:Varisense",

	"upstreamHsRiseFall" : "Upstream High Speed rise/fall adjust",
	"downstreamport1HsRiseFall" : "Port1:High Speed rise/fall adjust",
	"downstreamport2HsRiseFall" : "Port5:High Speed rise/fall adjust",
	"downstreamport3HsRiseFall" : "Port2:High Speed rise/fall adjust",
	"downstreamport4HsRiseFall" : "Port3:High Speed rise/fall adjust",
	"downstreamport5HsRiseFall" : "Port4:High Speed rise/fall adjust",
	"downstreamport6HsRiseFall" : "Port6:High Speed rise/fall adjust",
	
	"port3splitting" : "Port 2 Port Splitting",
	"port4splitting" : "Port 3 Port Splitting",
	"port5splitting" : "Port 4 Port Splitting",
};

(function($) 
{
	enable_all_fields = function() {
		$("#registerVal").attr('disabled', false);
		$("#registerFile").attr('disabled', false);
		$("#devicedescriptortab").attr('disabled', false);
		$("#stringdescriptortab").attr('disabled', false);
		$("#USB3devicedescriptortab").attr('disabled', false);
		$("#USB3stringdescriptortab").attr('disabled', false);
		$("#USB3otherdescriptortab").attr('disabled', false);
		$("#upstreamtab").attr('disabled', false);
		$("#downstreamtab").attr('disabled', false);
		$("#Bdownstreamtab").attr('disabled', false);
		$("#USB3_Bdownstreamtab").attr('disabled', false);
		$("#uchtab").attr('disabled', false);
		$("#advancedtab").attr('disabled', false);
		$("#specialtab").attr('disabled', false);
		$('#BPORT1fieldset').attr('disabled', false);
		$('#BPORT2fieldset').attr('disabled', false);
		$('#BPORT3fieldset').attr('disabled', false);
		$('#BPORT4fieldset').attr('disabled', false);
		$('#BPORT5fieldset').attr('disabled', false);
		$('#BPORT6fieldset').attr('disabled', false);
		$('#BPORT7fieldset').attr('disabled', false);
		$('#PORT1fieldset').attr('disabled', false);
		$('#PORT2fieldset').attr('disabled', false);
		$('#PORT3fieldset').attr('disabled', false);
		$('#PORT4fieldset').attr('disabled', false);
		$('#PORT5fieldset').attr('disabled', false);
		$('#PORT6fieldset').attr('disabled', false);
		$('#PORT7fieldset').attr('disabled', false);
		$('#cdctab').attr('disabled', false);
	};
})(jQuery);

function getOfflineConf() 
{
	offlineConfFile = "";
	var file = document.getElementById("offlineConfFileID").files[0];
	var fileSizeInKb = file.size / 1024;
	update_status_message("The size of the Configuration file selected is "
			+ fileSizeInKb + " KB");
	if (file) 
	{
		$("#offlineConfFileID").css({
			background : "white",
			border : "0px"
		});
		offlineConfFile = file.name;
		var saveextension = offlineConfFile.substr(offlineConfFile
				.lastIndexOf('.') + 1);
		if (saveextension === offlineConfFile) 
		{
			offlineConfFile = offlineConfFile + ".cfg";
		} 
		else if (saveextension === "cfg") 
		{
			var mesg = ("Selected .cfg file to save is :" + offlineConfFile);
			update_status_message(mesg);
		} 
		else 
		{
			alert("Selected File Type is not supported. Please Select File type : .cfg");
			update_status_message("Selected File Type is not supported.Supported File type is .cfg");
			$("#offlineConfFileID").val('');
			$("#offlineConfFileID").css({
				background : "white",
				border : "0px"
			});
			offlineConfFile = "";
			return;
		}
	} 
	else 
	{
		$("#offlineConfFileID").css({
			background : "yellow",
			border : "3px red solid"
		});
		update_status_message("No configuration file(.cfg) is selected.");
		offlineConfFile = "";
		alert("No configuration file(.cfg) is selected.");
	}
}
var gArrConfigFilelist = [];
var gArrConfigIndex = 0;
function startReadcfg() 
{
	LoadConfFile = "";
	var fileextension;
	var file = document.getElementById("offlineConfload").files[0];
	var fileSizeInKb = file.size / 1024;
	var Filelist = "";
	var canAllow = false;
	var fileSize = file.size;
	LoadConfFile = file.name;
	fileextension = LoadConfFile.substr(LoadConfFile.lastIndexOf('.') + 1);
	
	if (fileextension == "cfg" || fileextension == "dump") 
	{
		update_status_message("The size of the Configuration file selected is "
				+ fileSizeInKb.toFixed(2) + " KB");
	} 
	else 
	{
		alert("Selected File Type is not supported. Please Select File type : .cfg/.dump");
		// reset_file_input();
		$("#offlineConfload").val('');
		$("#offlineConfload").css({
			background : "white",
			border : "0px"
		});
		LoadConfFile = "";
		return;
	}

	if (file) 
	{
		if (fileextension == "dump") 
		{
			if (fileSize == 8192) 
			{
				canAllow = true;
			} 
			else 
			{
				update_status_message("The size of configuration file \""
						+ file.name
						+ "\" should be 8KB for USB58XX/USB59XX hub.");
				LoadConfFile = "";
				alert("The size of configuration file \"" + file.name
						+ "\" should be 8KB for USB58XX/USB59XX hub.");
				return;
			}
		} 
		else if (fileextension == "cfg") 
		{
			if (fileSize <= 8192) 
			{
				canAllow = true;
			} 
			else 
			{
				update_status_message("The size of configuration file \""
						+ file.name
						+ "\" cannot exceed 8KB for USB58XX/USB59XX hub.");
				LoadConfFile = "";
				alert("The size of configuration file \"" + file.name
						+ "\" cannot exceed 8KB for USB58XX/USB59XX hub.");
				return;
			}
		} 
		else 
		{
			// Do nothing
		}
	}

	if (canAllow) 
	{
		$("#offlineConfload").css({
			background : "white",
			border : "0px"
		});
	}

	if (gArrConfigIndex > 15) 
	{
		alert("Max configuration file count is 15");
		return;
	}
	gArrConfigFilelist[gArrConfigIndex++] = LoadConfFile;
	var Texttodisplay = "Loaded Configuration files are ";
	
	for (var i = 0; i < gArrConfigIndex; i++) 
	{
		Filelist = Filelist + gArrConfigFilelist[i] + ",";
	}
	update_status_message(Texttodisplay + Filelist);
	// overrideDefaultOfflineConfig function will return strap values in
	// LoadConfFile
	// Return string format is "widget:value###widget:value.."
	var StrapValues = overrideDefaultOfflineConfig(dummyHubID,LoadConfFile);
	if(StrapValues == null)
	{
		alert("Not a valid file");
	}
	// var Straps = StrapValues.split("###");
	// $.each(Straps, function (idx, value) {
		// var widgetvalpairs = value.split(":");
		// //After load configuration file , there may be new values for straps.
		// //Update to StrapHashMapAfterChange hashmap for later comparison
		// StrapHashMapAfterChange[widgetvalpairs[0]] = widgetvalpairs[1];
	// });
	//reset Values 
	Reset_innerHTML();
	
	$("#vidpidmaskrule").hide();
	$("#vidpidrule").hide();
	$("#deviceclassrule").hide();
	$('#addminihostrule').hide();
	$('#minihostoverwriteexistingrule').hide();
	var nameofcontrol = ".minihostruletype";
	var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
	.children('.dropdown-toggle').dropdown('toggle');
	var nameofcontrol = ".minihostexistingrule";
	var nameofcontrol1 = "[data-bind=\"" + "minihostexistingrule" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Index")
	.children('.dropdown-toggle').dropdown('toggle');
	$('#minihostruleindex').hide();
	Reset_miniHostDiv();
	Reset_miniHostVariables();
	custom_dos_portorder(gb_sku);
	
	populateDefaultValues();
}

// Parse Configuration - Start
function getParseConftype() {
	setFileType("cfg_parse", 0);
}
function setParseSavetype() {
	setFileType("txt",1);
}
function ParseConfigFile(){
	var file = document.getElementById("Parsefileid").files[0];

	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		parseConfigFile = "";
		alert("No configuration file(.cfg) is selected.");

	}else{
		parseConfigFile = file.name;
		extension = parseConfigFile.substr(parseConfigFile.lastIndexOf('.') + 1);
		if((extension != "cfg" && extension != "dump") && extension != "bin")
		{
			alert("Selected File type is not supported. Supported File type : .cfg/.dump/.bin");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			parseConfigFile = "";
			$("#Parsefileid").val('');
			$("#Parsefileid").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}
		else{
			var mesg = ("Selected files to parse is :" + parseConfigFile);
			update_status_message(mesg);
			ParseCfgFileExt = parseConfigFile.replace(/(.*)\.[^.]+$/, "cfg_parse")
			var ParseFileSizeInKb = file.size/1024;
			if(ParseFileSizeInKb > (1024 * 8))
			{
				alert("File size not supported. Maximum File size can be 2KB");
				var mesg = ("File size not supported. Maximum File size can be 2KB");
				update_status_message(mesg);
				parseConfigFile = "";
				$("#Parsefileid").val('');
				$("#Parsefileid").css({
				background: "white",
				border: "0px"
				});
				errorFlag = true;
				return;
			}
			update_status_message("The size of the selected file selected is " + ParseFileSizeInKb.toFixed(2) + " KB");
				$("#Parsefileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}
function ParseSaveFile(){
	parseSaveFile = "";
	var file = document.getElementById("ParseSavefileid").files[0];
	if(file)
	{
		$("#ParseSavefileid").css({
			background: "white",
			border: "0px"
		});
		parseSaveFile = file.name;
		var saveextension = parseSaveFile.substr(parseSaveFile.lastIndexOf('.') + 1);
		if(saveextension === parseSaveFile )
		{
			parseSaveFile = parseSaveFile + ".txt";
		}
		else if(saveextension === "txt")
		{
			var mesg = ("Selected .txt file to save Configuration file parse output is :" + parseSaveFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .txt");
			update_status_message("Selected File Type is not supported.Supported File type is .txt");
			$("#ParseSavefileid").val('');
			$("#ParseSavefileid").css({
			background: "white",
			border: "0px"
			});
			parseSaveFile="";
			return;
		}
	}
	else
	{
		parseSaveFile = "";
	}
}

function Parsefiles(){
	var data = "";
	//Dont allow user to parse when file name is not present
	if($('#saveparse').is(':checked')){
		if(parseSaveFile == "") {
			alert("Please provide file name to proceed");
			return -1;
		}
	}
	data = UsbParseCfgFile(parseSaveFile);
	if(typeof data === 'undefined')
	{
		alert("Failed to parse selected file");
		update_status_message("Failed to parse selected file");
	}
	else
	{
		document.getElementById("ParseConfigureArea").value = data;
		alert("Parse Configuration file Success");
		update_status_message("Parse Configuration file Success");
	}
}

// Parse Configuration - End

function setOfflineConf() 
{
	setFileType("cfg", 1);
}
function getOfflineConftype() 
{
	setFileType("cfg_dump", 0);
}


function MergerReadFirstFile() {
	var file = document.getElementById("Mergerfileid").files[0];
	
	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		FirstMergecfgFile = "";
		alert("No configuration file(.cfg) is selected.");

	} else {
		FirstMergecfgFile = file.name;
		extension = FirstMergecfgFile.substr(FirstMergecfgFile.lastIndexOf('.') + 1);
		if((extension != "cfg"))
		{
			alert("Selected File type is not supported. Select File type : cfg");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			FirstMergecfgFile ="";
			$("#Mergerfileid").val('');
			$("#Mergerfileid").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}else{
			var mesg = ("Selected .cfg files to program are :" + FirstMergecfgFile);
			update_status_message(mesg);
			var firstFileSizeInKb = file.size/1024;
			update_status_message("The size of the .cfg files selected are " + firstFileSizeInKb.toFixed(2) + " KB");
				$("#Mergerfileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}

function MergerReadSecondFile() {
	var file = document.getElementById("Mergerfileid1").files[0];
	
	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		SecondMergecfgFile = "";
		alert("No configuration file(.cfg) is selected.");

	} else {
		SecondMergecfgFile = file.name;
		extension = SecondMergecfgFile.substr(SecondMergecfgFile.lastIndexOf('.') + 1);
		if((extension != "cfg"))
		{
			alert("Selected File type is not supported. Select File type : cfg");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			SecondMergecfgFile ="";
			$("#Mergerfileid1").val('');
			$("#Mergerfileid1").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}else{
			var mesg = ("Selected .cfg files to program are :" + SecondMergecfgFile);
			update_status_message(mesg);
			SecondMergecfgFile = SecondMergecfgFile.replace(/(.*)\.[^.]+$/, "cfg_merge");
			var firstFileSizeInKb = file.size/1024;
			update_status_message("The size of the .cfg files selected are " + firstFileSizeInKb.toFixed(2) + " KB");
				$("#Mergerfileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}

function getmergeConftype() {
	setFileType("cfg", 0);
}

function getmergeSecondConftype() {
	setFileType("cfg_merge", 0);
}

function setmergeConftype() {
	setFileType("cfg_out", 1);
}

function mergefiles() {
	
	var bRet = false;
	
	if(FirstMergecfgFile != "")
	{
		if(SecondMergecfgFile != "") {
			bRet = UsbMergeCfgFile(mergeConfFile);
		} else {
			alert("Please Select File to merge configuration");
			update_status_message("Please Select File to merge configuration");
			return;
		}
	}
	else {
		alert("Please Select File to merge configuration");
		update_status_message("Please Select File to merge configuration");
		return;
	}
	
	if(bRet)
	{
		mergeConfFile = "";
		FirstMergecfgFile = "";
		SecondMergecfgFile = "";
		alert("Merged file was created successfully");
		update_status_message("Merged file was created successfully");
		
	} else {
		alert("Failed to merge two configuration files");
		update_status_message("Failed to merge two configuration files");
	}
}

function getmergeConfFile() {
	mergeConfFile = "";
	var file = document.getElementById("mergeConfFileID").files[0];
	var fileSizeInKb = file.size/1024;
	update_status_message("The size of the Configuration file selected is " + fileSizeInKb + " KB");
	if (file) {
		$("#mergeConfFileID").css({
			background: "white",
			border: "0px"
		});
		mergeConfFile = file.name;
		var saveextension = mergeConfFile.substr(mergeConfFile.lastIndexOf('.') + 1);
		if(saveextension === mergeConfFile)
		{
			mergeConfFile = mergeConfFile + ".cfg";
		}
		else if(saveextension === "cfg")
		{
			var mesg = ("Selected .cfg file to save is :" + mergeConfFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .cfg");
			update_status_message("Selected File Type is not supported.Supported File type is .cfg");
			$("#mergeConfFileID").val('');
			$("#mergeConfFileID").css({
			background: "white",
			border: "0px"
			});
			mergeConfFile="";
			return;
		}
	} else {
		$("#mergeConfFileID").css({
			background: "yellow",
			border: "3px red solid"
		});
		update_status_message("No configuration file(.cfg) is selected.");
		mergeConfFile = "";
		alert("No configuration file(.cfg) is selected.");
	}
}


(function($) {
	update_status_message = function(mesg) 
	{
		// var time = new Date($.now()); // returns huge string
		var currentdate = new Date();
		currentdate + '';
		var datetime = currentdate.toLocaleString();
		$("#DSStatusMessage").append(datetime + ":" + mesg + "\n");
		$("#DSStatusMessage").animate(
				{
					scrollTop : $("#DSStatusMessage")[0].scrollHeight
							- $("#DSStatusMessage").height()
				}, 400, function() {
				});
	};
})(jQuery);

(function ($) {
    update_dra_status_message = function (mesg) {
        $("#DRStatusMessage").append(mesg + "\n");
        $("#DRStatusMessage").animate({
            scrollTop:$("#DRStatusMessage")[0].scrollHeight - $("#DRStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

// Reset all fields
$("#Reset").click(function() 
{
	Reset_innerHTML();
	custom_dos_portorder(gb_sku);
	
	$("#vidpidmaskrule").hide();
	$("#vidpidrule").hide();
	document.getElementById("ParseConfigureArea").value = "";
	$('#saveparse').prop('checked',false);
	$("#deviceclassrule").hide();
	$('#addminihostrule').hide();
	$('#minihostoverwriteexistingrule').hide();
	var nameofcontrol = ".minihostruletype";
	var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
	.children('.dropdown-toggle').dropdown('toggle');
	var nameofcontrol = ".minihostexistingrule";
	var nameofcontrol1 = "[data-bind=\"" + "minihostexistingrule" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Index")
	.children('.dropdown-toggle').dropdown('toggle');
	$('#minihostruleindex').hide();
	Reset_miniHostDiv();
	Reset_miniHostVariables();

	
	clearWidgetMap();
	set_changed_fields_border_default();
	$("input[type='file']").val('');
	offline_MchpUsbClose();
	var ret = offline_MchpUsbOpen("8", gb_sku);
	if (ret) 
	{
		populateDefaultValues();
	}
	iniFile = "";
	offlineConfFile = "";
	LoadConfFile = "";
	gArrConfigIndex = 0;
	RegString = "";
	document.getElementById("myForm").reset();
	changecount = 0;
	$("#Apply").attr('disabled', true);
	//document.getElementById("copyNCM").checked = false;
	reset_file_input();
	resetVariables();
	$('#showtipforport6split').hide();
	$('#showtipforport5split').hide();
	// Change border back to default color from red
	RegString = "";
	iniFile = "";
	document.getElementById("DRStatusMessage").value = "";
	document.getElementById("DRStatusMessage").innerHTML="";
});
// End of Reset all fields

// Populating the default widget values based on the SKU
function populateDefaultValues() 
{
	var skuName = gb_sku; // Get from the dropdown

	// Setting the configuration mode to offline in the backend
	setConfigMode(true, skuName);
	
	
	////Read Current Rule cont 
	var newval = getWidgetValue(HUB_FAMILY_INDEX, "minihost_vidpidindex");
	gb_vidpidrulecnt = newval.toString(16);
	gb_vidpidrulecnt = parseInt(gb_vidpidrulecnt, 16);
	gblivevidpidrulecnt = gb_vidpidrulecnt;
	
	newval = getWidgetValue(HUB_FAMILY_INDEX, "minihost_vidpidmaskindex");
	gb_vidpidmaskrulecnt = newval.toString(16);
	gb_vidpidmaskrulecnt = parseInt(gb_vidpidmaskrulecnt, 16);
	gblivevidpidmaskrulecnt = gb_vidpidmaskrulecnt;
	
	newval = getWidgetValue(HUB_FAMILY_INDEX, "minihost_deviceclassindex");
	gb_deviceclassrulecnt = newval.toString(16);
	gb_deviceclassrulecnt = parseInt(gb_deviceclassrulecnt, 16);
	gblivedeviceclassrulecnt = gb_deviceclassrulecnt;
	
	// Updating GwidgetlistHex starts
	$.each(GwidgetlistHex, function(index, value) 
	{
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);

		if (widgetValue) 
		{
			var decvalue = parseInt(widgetValue, 10);
			var hexstring;
			if (value == "usbvcd" || value == "usb3vcd") // remove the '.'
			// added before
			{
				var dot = ".";
				var hexvalue = (decvalue.toString(16));
				var position = 1;
				var hexstring = [ hexvalue.slice(0, position), dot,
						hexvalue.slice(position) ].join('');
			} 
			else 
			{
				hexstring = decvalue.toString(16); 
			}
			$(widgetid).val(hexstring);
		}
	});
	// Updating GwidgetlistHex ends

	// Updating GwidgetlistString starts
	$.each(GwidgetlistString, function(index, value) 
	{
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		if ((widgetValue === " ") || (widgetValue === "")) 
		{
			$(widgetid).val("");
			$(widgetid).attr('placeholder', stringnullvalue);
		} 
		else 
		{
			$(widgetid).val(widgetValue);
		}
	});
	// Updating GwidgetlistString ends

	// Updating GwidgetlistInt starts
	$.each(GwidgetlistInt, function(index, value) 
	{
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		if (widgetValue === "") 
		{
			$(widgetid).val("");
		} 
		else 
		{
			var decVal;
			if (value == "hub3maxpowerselfbus") 
			{
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal, 10);
				decVal = decVal * 8;
			}
			else if ((value == "hubcmaxpowerbus")
					|| (value == "hubcmaxpowerself")) 
			{
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal, 10);
			} 
			else 
			{
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal, 10);
				decVal = decVal * 2;
			}
			$(widgetid).val(decVal);
		}
	});
	// Updating GwidgetlistInt ends

	// Updating GwidgetlistCheckbox11 starts
	$.each(GwidgetlistCheckbox11, function(index, value) 
	{
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		if (widgetValue == checkbox_checked_value) 
		{
			if(value == "cdcenable")
			{
				$(widgetid).prop('checked', false);
			}
			else
			{
				$(widgetid).prop('checked', true);
			}
			// If there are corresponding fieldsets - enable them
			$(widgetid).trigger("change");
			// if (value == "flexconnect" || value == "usb3flexconnect") 
			// {
				// $("#flexportULButton").attr('disabled', false);
			// }
			// set_changed_fields_border_default();
		} 
		else 
		{
			if(value == "cdcenable")
			{
				$(widgetid).prop('checked', true);
			}
			else
			{
				$(widgetid).prop('checked', false);
			}
			// If there are corresponding fieldsets - disable them
			$(widgetid).trigger("change");
			// if ((value == "flexconnect") || (value == "usb3flexconnect")) 
			// {
				// if((value == "flexconnect"))
				// {
					// widgetValue = getWidgetValue(HUB_FAMILY_INDEX, "usb3flexconnect");
				// }
				// else
				// {
					// widgetValue = getWidgetValue(HUB_FAMILY_INDEX, "flexconnect");
				// }
				// if(widgetValue != checkbox_checked_value)
				// {
					// $("#flexportULButton").attr('disabled', true);
				// }
				// else
				// {
					// $("#flexportULButton").attr('disabled', false);
				// }
			// }
			
			
			// set_changed_fields_border_default();
		}
	});
	// Updating GwidgetlistCheckbox11 ends
	
	// Updating GwidgetlistPortType Starts
	$.each(GwidgetlistPortType, function(index, value) 
	{
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		var portid = value + "label";
		var portnumber = document.getElementById(portid).innerHTML;
		document.getElementById(portid).innerHTML = portnumber + widgetValue;
	});
	// Updating GwidgetlistPortType Ends
	
	//Updating minihost rules configured Starts
	var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, "minihostrulesconfigured");
	if(widgetValue == "") //Dont Show if no rules are programmed
	{
		$('#minihostrulesconfigured').hide();
	}
	else
	{
		$('#minihostrulesconfigured').show();
		document.getElementById("minihostrulesconfiguredarea").value = widgetValue;
	}
	//Updating minihost rules configured Ends

	// Updating GwidgetlistDropDown starts
	$.each(GwidgetlistDropDown, function(index, value) 
	{
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		var decval = parseInt(widgetValue, 10);
		var nameofcontrol = "." + value + "1";
		var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";
		var selText;

		if (value == "PHYBOOST" || value == "PHYBOOSTdownstreamport1"
				|| value == "PHYBOOSTdownstreamport2"
				|| value == "PHYBOOSTdownstreamport3"
				|| value == "PHYBOOSTdownstreamport4"
				|| value == "PHYBOOSTdownstreamport5"
				|| value == "PHYBOOSTdownstreamport6") 
		{
			selText = DropDownPHYBOOST[widgetValue];
		} 
		else if (value == "SQUELCH" || value == "SQUELCHdownstreamport1"
				|| value == "SQUELCHdownstreamport2"
				|| value == "SQUELCHdownstreamport3"
				|| value == "SQUELCHdownstreamport4"
				|| value == "SQUELCHdownstreamport5"
				|| value == "SQUELCHdownstreamport6") 
		{
			selText = DropDownSQUELCH[widgetValue];
		} 
		else if (value == "upstreamHsRiseFall"
				|| value == "downstreamport1HsRiseFall"
				|| value == "downstreamport2HsRiseFall"
				|| value == "downstreamport3HsRiseFall"
				|| value == "downstreamport4HsRiseFall"
				|| value == "downstreamport5HsRiseFall"
				|| value == "downstreamport6HsRiseFall") 
		{
			selText = DropDownHSRiseFall[widgetValue];
		} 
		// else if (value == "flexport") 
		// {
			// selText = DropDownflexport[widgetValue];
		// } 
		// Update fields based on obtained value
		$(nameofcontrol).find(nameofcontrol1).text(selText).children(
				'.dropdown-toggle').dropdown('toggle');
	});
	// Updating GwidgetlistDropDown ends

	// Updating GwidgetlistRadio
	$.each(GwidgetlistRadio,function(index, value) 
	{
		var groupname = value + "group";
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX,
				value);
		var nameofcontrol = "input[name=" + groupname
				+ "][value=" + widgetValue + "]";
		$(nameofcontrol).prop("checked", true);

		if (value === "hubpower") 
		{
			var widgetid = "#hubpowergroup";
			// If there are corresponding fieldsets - enable
			// them
			$(widgetid).trigger("change");
			if (widgetValue == "0") 
			{ // Bus power
				// Disable the fields
				$('#selfpowerfieldset').hide();
				$('#buspowerfieldset').show();
			} 
			else if (widgetValue == "1") 
			{ // Self power
				// Disable the fields
				$('#buspowerfieldset').hide();
				$('#selfpowerfieldset').show();
			}
			set_changed_fields_border_default();
		}
		if (value === "i2senable") 
		{
			if(widgetValue == "0")
			{
				document.getElementById("speakermeute").disabled=true;
				document.getElementById("bothms").disabled=true;
				document.getElementById("bothms1").disabled=true;
			}
			else if(widgetValue == "1") {
				document.getElementById("speakermeute").disabled=false;
				document.getElementById("bothms").disabled=true;
				document.getElementById("bothms1").disabled=true;
			} else if(widgetValue == "2") {
				document.getElementById("speakermeute").disabled=true;
				document.getElementById("bothms").disabled=false;
				document.getElementById("bothms1").disabled=true;
				
			} else if(widgetValue == "3") {
				document.getElementById("speakermeute").disabled=false;
				document.getElementById("bothms").disabled=false;
				document.getElementById("bothms1").disabled=false;
			}
		}
		if ((value === "downstreamBCsettingport1")
				|| (value === "downstreamBCsettingport2")
				|| (value === "downstreamBCsettingport3")
				|| (value === "downstreamBCsettingport4")
				|| (value === "downstreamBCsettingport5")
				|| (value === "downstreamBCsettingport6")) 
		{
			var BCfeild = "";
			var BCFeildLabel = "";
			if ((widgetValue != 0) && (widgetValue != 1)
					&& (widgetValue != 2)) 
			{
				BCfeild = "#" + value + "radio4";
				BCFeildLabel = value + "radio4label";
				$(BCfeild).show();
				$(BCfeild).prop("checked", true);
				var BCDesStr = "";
				BCDesStr = Determine_BCDescription(widgetValue);
				// Decode the value to display description
				// dynamically
				document.getElementById(BCFeildLabel).innerHTML = BCDesStr;

			}
			else 
			{
				$(BCfeild).hide();
			}
		}
	});
	// Updating GwidgetlistRadio ends
}

function ValidateMac(currMac) 
{
	var macflag = true;

	MacValue = currMac.split(":");

	var maclength = MacValue.length;

	if (maclength < 6 || maclength > 6) 
	{
		alert("Mac Address value entered for NCM device is invalid. Mac Address format should be 00:80:0F:10:20:01.");
		return false;
	}

	for (var i = 0; i < 6; i++) 
	{
		var isMacOKAddr = /^[0-9a-fA-F]{1,2}$/i.test(MacValue[i]);

		if (!isMacOKAddr) 
		{
			alert("The Given MAC Address is not a valid Hexa decimal");
			return false;
		}

		if ((MacValue[i] == 00) || (MacValue[i] == 255)) 
		{
			// will continue loop.Do nothing
		} 
		else 
		{
			macflag = false;
		}
		if (i == 5 && macflag == true) 
		{
			alert("Mac Address value entered for NCM device is invalid. Mac Address format should be 00:80:0F:10:20:01.");
			return false;
		}
	}
	return true;
}
(function($) {
	checkChangedWidget = function() 
	{
		var USB3StrSupportedChar = 141;
		var usb3strerror = false;
		var USB3CurrentTotalLen = 0;
		
		var error_msg = "";
		var hce_stringmodified = 0;
		var hce1_stringmodified = 0;
		var hce2_stringmodified = 0;
		var usb2_stringmodified = 0;
		var usb3_stringmodified = 0;
		var uuid_stringmodified = 0;

		var hcemanuStringLength = 0;
		var manuStringLength = 0;
		var usb3StringLength = 0;

		// TODO - Calculate maximum length and add check accordigly
		var usb2Defaultlen = 126;
		var usb3Defaultlen = 126;
		var HCEDefaultlen = 126;
		var EAPDefaultLen = 111;

		var EapStrAlert = false; //Alert for EAP1
		var EapStrAlert1 = false; //Alert for EAP2
		var EapStrLengthVerify = false;

		var hce1macmodified = 0;
		var hce2macmodified = 0;

		var bUSB2PortEnable = [ 0, 0, 0, 0, 0, 0, 0 ];
		// Find out currently how many ports are enabled
		bUSB2PortEnable[1] = $('#enableport1').is(':checked');
		bUSB2PortEnable[2] = $('#enableport2').is(':checked');
		bUSB2PortEnable[3] = $('#enableport3').is(':checked');
		bUSB2PortEnable[4] = $('#enableport4').is(':checked');
		bUSB2PortEnable[5] = $('#enableport5').is(':checked');
		bUSB2PortEnable[6] = $('#enableport6').is(':checked');

		var bTotal = false;
		
		if(gb_sku === "USB7202")
		{
			bTotal = bUSB2PortEnable[1] + bUSB2PortEnable[2]
					+ bUSB2PortEnable[3] + bUSB2PortEnable[4];		
		}
		if(gb_sku === "USB7206")
		{
			bTotal = bUSB2PortEnable[1] + bUSB2PortEnable[2]
					+ bUSB2PortEnable[3] + bUSB2PortEnable[4] 
					+ bUSB2PortEnable[5] + bUSB2PortEnable[6];		
		}
		
		var hceStatus = $('#hceenable').is(':checked') ? 1 : 0;

		// Check the hceenable and portenable validity
		if (hceStatus == 0 && bTotal == false) 
		{
			var option = confirm("Hub controller is disabled.After programming all the ports will be disabled. do you want to continue?");
			if(!option) {
				enable_nav_fields();
				update_status_message("Generation of configuration file was terminated by the user.");
				return false;
			}
		}

		
		// Checking the validity of Hex fields against null,zero and valid hex
		// digits
		$.each(GwidgetlistHex, function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval;
			var newval;
			var isValid;

			newval = $(widgetid).val();

			if (newval == "") 
			{
				error_msg = error_msg + "The value of \""
						+ Mapping[widgetName]
						+ "\" cannot be null.\n";

			} 
			else 
			{
				if (widgetName === "usbvcd"
						|| widgetName === "usb3vcd") 
				{

					var iusbvcd = parseInt(getWidgetValue(HUB_FAMILY_INDEX, widgetName), 10);
					var dot = ".";
					var xusbvcd = (iusbvcd.toString(16));

					var xusbvcd = [ xusbvcd.slice(0, 1), dot,
							xusbvcd.slice(1) ].join('');
					oldval = xusbvcd;
					newval = $(widgetid).val();

					if (widgetName === "usbvcd") 
					{
						isValid = /^2\.?[0-9]{0,2}$/i
								.test(newval);
					}
					if (widgetName === "usb3vcd") 
					{
						isValid = /^3\.?[0-9]{0,2}$/i
								.test(newval);
					}

					if (!isValid) 
					{
						error_msg = error_msg
								+ "The value entered for \""
								+ Mapping[widgetName]
								+ "\" is not valid.\n";
					}
				} 
				else if ((widgetName === "vid")
						|| (widgetName === "usb3vid")) 
				{
					var usb3VID = $("#usb3vid").val();
					var usb2VID = $("#vid").val();
					if (usb3VID == usb2VID) 
					{
						// do nothing
					} 
					else 
					{
						update_status_message("Mismatch in VID of USB2.0 and USB3.1 Gen2. Please make sure their VID is the same.");
						error_msg = "Mismatch in VID of USB2.0 and USB3.1 Gen2. Please make sure their VID is the same.";
					}
				} 
				else 
				{
					oldval = parseInt(getWidgetValue(HUB_FAMILY_INDEX, widgetName), 10);
					isValid = /^[0-9A-Fa-f]{1,4}$/i.test($(
							widgetid).val());
					newval = parseInt($(widgetid).val(), 16);

					if (!isValid) 
					{
						error_msg = error_msg
								+ "The value entered for \""
								+ Mapping[widgetName]
								+ "\" must be a 4 digit hexadecimal value and it cannot be Zero.\n";
					}
				}
			}

		});
		
		// //String length constraint check
		$.each(GwidgetlistString,function(index, widgetName) 
		{
			var widgetid = "#" + widgetName;
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, widgetName);

			var newval = $(widgetid).val();

			if (newval != oldval) 
			{
				if (widgetName === "hce_manufacturer"
						|| widgetName == "hce_product"
						|| widgetName == "hce_serial") 
				{
					var stringvalue = $(widgetid).val();

					// Check the widget length also
					if (stringvalue == "") 
					{
						// do nothing null string
					} 
					else 
					{
						hcemanuStringLength = ($(widgetid)
								.val().length);
					}
					// Checking the string length constraint

					if ((hcemanuStringLength > HCEDefaultlen)) 
					{
						error_msg = error_msg
								+ "String Descriptor of Hub Feature Controller can have a max length of"
								+ " " + HCEDefaultlen + " "
								+ "unicode characters only\n";
					}
				}

				// Validating the NCM1 and NCM2 String
				// descriptor
				if (widgetName === "hce1_macaddr" || widgetName === "hce2_macaddr") 
				{
					var newval = "";
					if(widgetName === "hce1_macaddr")
					{
						newval = $("#hce1_macaddr").val();
					}
					else
					{
						newval = $("#hce2_macaddr").val();
					}
				
					var MacValue = newval.split(":");
	
					var maclength = MacValue.length;
					
										
					if(maclength < 6 || maclength > 6)
					{
						error_msg = error_msg + "The Given MAC Address is not valid.Mac Address should be for Example = 00:80:0F:10:20:01";
					}
					MacValue[0] = parseInt(MacValue[0],16);
					if((MacValue[0] & 0x01) === 0x01)
					{
						error_msg = error_msg + "MAC Address should not be a Multicast or Broadcast address";
					}
					
					var regex = /^([0-9a-fA-F]{2}[:-]){5}([0-9A-F]{2})$/;
				  
					var isMacOKAddr = regex.test(newval);
					
					if(!isMacOKAddr)
					{
						error_msg = error_msg +"The Given MAC Address is not a valid Mac Address";
					}
		
				}

				// Validate the Maunfactuerer String
				if (widgetName === "manufacturer"
						|| widgetName == "product"
						|| widgetName == "serial") 
				{

					var stringvalue = $(widgetid).val();

					// Check the widget length also
					if (stringvalue == "") 
					{
						// do nothing null string
					} 
					else 
					{
						manuStringLength = ($(widgetid).val().length);
					}
					// Checking the string length constraint
					if ((manuStringLength > usb2Defaultlen)) 
					{
						error_msg = error_msg
								+ "String Descriptor of USB2 Hub can have a max length of"
								+ " " + usb2Defaultlen + " "
								+ "unicode characters only\n";
					}
				}

				if (widgetName === "usb3uuid") 
				{
					var uuidVal = $("#usb3uuid").val();
					var isValid = /^[0-9a-fA-F]{1,32}$/i
							.test(uuidVal);
					if (!isValid) {

						error_msg = error_msg
								+ "UUID value entered is invalid. UUID must be a 16 bytes of hexadecimal number.\n";
					}
				}

				// Validating the String Descriptor of USb3 Hub
				if (widgetName === "usb3manufacturer"
						|| widgetName == "usb3product"
						|| widgetName == "usb3serial") 
				{
					if(false === usb3strerror)
					{
						var stringvalue = $(widgetid).val();

						// Check the widget length also
						if (stringvalue == "") 
						{
							// do nothing null string
						} 
						else 
						{
							usb3StringLength = ($(widgetid).val().length);
							USB3CurrentTotalLen = ($('#usb3manufacturer').val().length) + ($('#usb3product').val().length) + ($('#usb3serial').val().length);
						}
						//Calculate maximum supported Char
						if((usb3StringLength & 0x03) === 0x03)
						{
							//Do Nothing
						}
						else{
							// USB3 start addr - BFD2_E500 (512 Bytes), End addr - BFD2_E700
							// USB3 string start addr - BFD2_E5E0
							// Total chars = (BFD2_E700 - BFD2_E5E0) = 0x120 (288) --> (288 -6)/2 = 141
							// String descriptors must start at a QWORD boundary.
							// String length multiple of 3 does not require additional Bytes
							// Example:
							// String Length		Calculated			QWORD Address		Difference in Bytes
							// 1					E5E4				E5E8				4
							// 2					E5E6				E5E8				2
							// 3					E5E8				E5E8				0
							// 4					E5EA				E5F0				6
							// 5					E5EC				E5F0				4
							// 6					E5EE				E5F0				2
							// 7					E5F0				E5F0				0
							// Cycle ( 6, 4, 2, 0) repeats ...
							// String len that does not have diffrence in bytes - 3 (0011), 7 (0111), 11 (1011), 15 (1111), 
							// 19 (0001 0011), 23 (0001 0111), 27 (0001 1011), 31 (0001 1111), 35 (0010 0011) ...
							// How below equation is obtained?
							// 6 = 6 - ((0x04 & 0x03) * 2) --> 6 - (0 * 2)
							// 4 = 6 - ((0x05 & 0x03) * 2) --> 6 - (1 * 2)
							// 2 = 6 - ((0x06 & 0x03) * 2) --> 6 - (2 * 2)
							// 0 = 6 - ((0x07 & 0x03) * 2) --> 6 - (3 * 2)
							
							var TempVal = usb3StringLength & 0x03;
							var Temp1Val = (6 - (TempVal * 2));
							USB3StrSupportedChar = USB3StrSupportedChar - (Temp1Val /2);
						}
						if(((USB3CurrentTotalLen) > (USB3StrSupportedChar)))
						{
							error_msg = error_msg
								+ "USB3.1 Gen2 Sting descriptors is greater than Maximum supported characters\n";
						}
						usb3strerror = true;
					}
				}
				// Start of EAP1 Strings Alert
				if ((widgetName === "hce1_product"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce1_eapproduct').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert === false)
						{
							var option = confirm("Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Operation Terminated by user";
								update_status_message("Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Operation Terminated by user");
							}
							EapStrAlert = true;
						}
					}
				}
				if ((widgetName === "hce1_eapproduct"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce1_product').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert === false)
						{
							var option = confirm("Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Operation Terminated by user";
								update_status_message("Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Operation Terminated by user");
							}
							EapStrAlert = true;
						}
					}
				}
				// End of EAP1 Strings alert
				
				// Start of EAP2 Strings alert
				if ((widgetName === "hce2_product"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce2_eapproduct').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert1 === false)
						{
							var option = confirm("Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Operation Terminated by user";
								update_status_message("Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Operation Terminated by user");
							}
							EapStrAlert1 = true;
						}
					}
				}
				if ((widgetName === "hce2_eapproduct"))
				{
					var stringvalue= $(widgetid).val();
					var stringvalue1 = $('#hce2_product').val();
								
					// Check the widget length also
					if ((stringvalue  === "") && (stringvalue1 === ""))
					{
					}
					else if((stringvalue  != "") && (stringvalue1 != ""))
					{
					}
					else
					{
						if(EapStrAlert1 === false)
						{
							var option = confirm("Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Do you want to continue?\n");
							if(option === false)
							{
								error_msg = error_msg + "Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Operation Terminated by user" ;
								update_status_message("Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Operation Terminated by user");
							}
							EapStrAlert1 = true;
						}
					}
				}
				// End of EAP2 Strings Alert
				
				// Check for EAP Strings Length
				if((widgetName === "hce1_eapproduct") || (widgetName === "hce2_eapproduct") || (widgetName === "hce1_eapinterface") || (widgetName === "hce1_eapinterface"))
				{
					if(EapStrLengthVerify === false)
					{
						var Eap1ProductLen = ($('#hce1_eapproduct').val().length);
						var Eap1InterfaceLen = ($('#hce1_eapinterface').val().length);
						var Eap2ProductLen = ($('#hce2_eapproduct').val().length);
						var Eap2InterfaceLen = ($('#hce2_eapinterface').val().length);
						
						if((Eap1ProductLen + Eap1InterfaceLen + Eap2ProductLen +  Eap2InterfaceLen) > EAPDefaultLen)
						{
							error_msg = error_msg + "String Descriptor of IAP/EAP Class device Strings can have a max length of"+ " "+ EAPDefaultLen+ " "+ "unicode characters only." ;
							update_status_message("Error : String Descriptor of Hub Feature Controller can have a max length of"+ EAPDefaultLen+ "unicode characters only.");
							EapStrLengthVerify = true;
						}
					}
				}
				// End of EAP string length check
			}
		});

		// Checking int fields
		$.each(GwidgetlistInt,function(index, widgetName) 
		{
			widgetid = "#" + widgetName;

			var newval = $(widgetid).val();

			if ((widgetName == "maxpowerself")
					|| (widgetName == "hubcmaxpowerself")) 
			{
				if ((newval > 100) || (newval < 0)) 
				{
					error_msg = error_msg
							+ "USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.\n";
				}
			}

			if (widgetName == "maxpowerbus") 
			{
				if ((newval > 500) || (newval < 0)) 
				{

					error_msg = error_msg
							+ "USB2.0 max power(bus) cannot be more than 500mA or negative.\n";
				}
			}

			if (widgetName == "hubcmaxpowerbus") 
			{
				if ((newval > 255) || (newval < 0)) 
				{
					error_msg = error_msg
							+ "USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.\n";
				}
			}
			if ((widgetName == "maxpowerself")
					|| (widgetName == "maxpowerbus")
					|| (widgetName == "power_ontime")) 
			{
				var newdecvalue = parseInt(newval, 10);
				newdecvalue = newdecvalue & 0xff;

				if ((newdecvalue & 0x01)) 
				{
					error_msg = error_msg
							+ "\"Hub MaxPower(Self)\" and \"Hub MaxPower(Bus)\" fields can have even numbers only";
					return;
				}
			}
			if (widgetName == "power_ontime") 
			{
				if ((newval > 510) || (newval < 0)) 
				{

					error_msg = error_msg
							+ "Power-On Time cannot be more than 510ms or negative.\n";
				}
			}
		});
		if(gb_minihostruletype === "01") //Rule type:vid pid
		{
			vidpid_idx = 0, vidpid_vid = 0, vidpid_pid =0 ,vidpid_ruleid = 0;
			if(gb_vidpidrulecnt >= 20)
			{
				error_msg = error_msg + "Maximum there can be only 20 rules for VID PID Rule type";
			}
			else if($('#minihostoverwrite').is(':checked') && (gb_existingruleidx == 0))
			{
				error_msg = error_msg + "Select Existing Mini Host Rule Index to be overwritten";
			}
			else
			{
				if($('#minihostoverwrite').is(':checked'))
				{
					vidpid_idx = gb_existingruleidx;
				}
				else
				{
					gb_vidpidrulecnt = gb_vidpidrulecnt + 1;
					vidpid_idx = gb_vidpidrulecnt;
				}
				vidpid_vid = document.getElementById("vidpidrule_vid").value;
				vidpid_pid = document.getElementById("vidpidrule_pid").value;
				vidpid_ruleid = document.getElementById("vidpidrule_ruleid").value;
				if(vidpid_vid == "" || vidpid_pid == "" || vidpid_ruleid== "" || vidpid_conn=="")
				{
					error_msg = error_msg + "Please fill all fields for Mini Host selected Rule type";
				}
			}
		}
		if(gb_minihostruletype === "11")
		{
			vidpidmask_idx = 0, vidpidmask_vid = 0, vidpidmask_pid =0 ,vidpidmask_vidpidmsk =0, vidpidmask_ruleid = 0;
			if(gb_vidpidmaskrulecnt >= 10)
			{
				error_msg = error_msg + "Maximum there can be only 10 rules for VID PID Mask Rule type";
			}
			if($('#minihostoverwrite').is(':checked') && (gb_existingruleidx == 0))
			{
				error_msg = error_msg + "Select Existing Mini Host Rule Index to be overwritten";
			}
			else
			{
				if($('#minihostoverwrite').is(':checked'))
				{
					vidpidmask_idx = gb_existingruleidx;
				}
				else
				{
					gb_vidpidmaskrulecnt = gb_vidpidmaskrulecnt + 1;
					vidpidmask_idx = gb_vidpidmaskrulecnt;
				}
				vidpidmask_vid = document.getElementById("vidpidmaskrule_vid").value;
				vidpidmask_pid = document.getElementById("vidpidmaskrule_pid").value;
				vidpidmask_vidpidmsk = document.getElementById("vidpidmaskrule_vidpidmask").value;
				vidpidmask_ruleid = document.getElementById("vidpidmaskrule_ruleid").value;
				if(vidpidmask_vid == "" || vidpidmask_pid == "" || vidpidmask_vidpidmsk== "" || vidpidmask_ruleid=="" || vidpidmask_conn=="")
				{
					error_msg = error_msg + "Please fill all fields for Mini Host selected Rule type";
				}
			}
		}
		if(gb_minihostruletype === "10")
		{
			deviceclass_idx = 0,deviceclass_ruleid = 0;
			if(gb_deviceclassrulecnt >= 5)
			{
				error_msg = error_msg +  "Maximum there can be only 5 rules for Device Class Rule type";
			}
			if($('#minihostoverwrite').is(':checked') && (gb_existingruleidx == 0))
			{
				error_msg = error_msg + "Select Existing Mini Host Rule Index to be overwritten";
			}
			else
			{
				if($('#minihostoverwrite').is(':checked'))
				{
					deviceclass_idx = gb_existingruleidx;
				}
				else
				{
					gb_deviceclassrulecnt = gb_deviceclassrulecnt + 1;
					deviceclass_idx = gb_deviceclassrulecnt;
				}
				deviceclass_ruleid = document.getElementById("deviceclassrule_ruleid").value;
				if(deviceclass_class == "" || deviceclass_conn == "" || deviceclass_ruleid == "" )
				{
					error_msg = error_msg + "Please fill all fields for Mini Host selected Rule type";
				}
			}
		}
		// if ($('#flexconnect').is(':checked')) 
		// {
			// var nameofcontrol = ".flexport1";
			// var nameofcontrol1 = "[data-bind=\"flexportlabel\"]";
			// var selText = $(nameofcontrol).find(nameofcontrol1).text();

			// var portenableid = "#enableport" + selText;

			// if (!($(portenableid).is(':checked'))) 
			// {
				// error_msg = error_msg
						// + "Downstream port "
						// + selText
						// + " is disabled. FlexConnect cannot be done. \n Enable Downstream port "
						// + selText + " and try again.\n";
			// }
		// }
		// if ($('#usb3flexconnect').is(':checked')) 
		// {
			// var nameofcontrol = ".flexport1";
			// var nameofcontrol1 = "[data-bind=\"flexportlabel\"]";
			// var selText = $(nameofcontrol).find(nameofcontrol1).text();

			// var portenableid = "#usb3enableport" + selText;

			// if (!($(portenableid).is(':checked'))) 
			// {
				// error_msg = error_msg
						// + "Downstream port "
						// + selText
						// + " is disabled. FlexConnect cannot be done. \n Enable Downstream port "
						// + selText + " and try again.\n";
			// }
		// }

		if (error_msg != "") {

			alert(error_msg);
			enable_nav_fields();
			return false;
		}

		return true;

	};
})(jQuery);

// Apply changes function
$("#Apply").click(function() 
{
	gApply = true;
	if (offlineConfFile == "") {
		update_status_message("Please select a file to save the offline Configuration.");
		alert("Please select a file to save the offline Configuration.");
		return;
	}
		
	if (false == checkChangedWidget()) 
	{
		return;
	}
	// Array to save the widgets and their values which were
	// changed.
	var deltaobj = [];
	var modifiedWidgets = [];
	var sentinel = true;
	var mismatchCheck = 0;
	var currentvalue = "NONE";
	//var enableFlex = false;
	var enableport = false;
	// flag for alert message
	var errorFlag = false;

	// language id constraint
	var stringmodified = 0;
	var udc_stringmodified = 0;
	var usb3stringmodified = 0;
	var langid = $("#languageid").val();
	var udc_langid = $("#hce_languageid").val();
	var usb3langid = $("#usb3languageid").val();
	var currentvalue = "NONE";

	var abUSB2PortEnable = [ 0, 0, 0, 0, 0, 0, 0 ];
	var abUSB3PortEnable = [ 0, 0, 0, 0, 0, 0, 0 ];

	// Find out currently how many USB2.0 ports are enabled
	abUSB2PortEnable[1] = ($('#enableport1').is(':checked')) ? 1 : 0;
	abUSB2PortEnable[2] = ($('#enableport2').is(':checked')) ? 1 : 0;
	abUSB2PortEnable[3] = ($('#enableport3').is(':checked')) ? 1 : 0;
	abUSB2PortEnable[4] = ($('#enableport4').is(':checked')) ? 1 : 0;
	abUSB2PortEnable[5] = ($('#enableport5').is(':checked')) ? 1 : 0;
	abUSB2PortEnable[6] = ($('#enableport6').is(':checked')) ? 1 : 0;

	// Find out USB3.0 ports are enabled?
	abUSB3PortEnable[1] = ($('#usb3enableport1').is(':checked')) ? 1 : 0;
	abUSB3PortEnable[2] = ($('#usb3enableport2').is(':checked')) ? 1 : 0;
	abUSB3PortEnable[3] = ($('#usb3enableport3').is(':checked')) ? 1 : 0;
	abUSB3PortEnable[4] = ($('#usb3enableport4').is(':checked')) ? 1 : 0;
	abUSB3PortEnable[5] = ($('#usb3enableport5').is(':checked')) ? 1 : 0;
	abUSB3PortEnable[6] = ($('#usb3enableport6').is(':checked')) ? 1 : 0;

	// To program it to defaults when a port is disabled.
	var enableportwidget;
	var usb3enableportwidget;
	var nrwidget;
	var usb3nrwidget;
	var usb3nrwidgetchanged = false;
	var swapwidget;
	var phyboostwidget;
	var varisensewidget;
	var hsrisefallwidget;
	var nrport;
	var dpdmSwap;
	var phyboost;
	var hsrisefall;
	var varisense;
	var NRModified = [ false, false, false, false, false,false, false ];
	var USB3NRModified = [ false, false, false, false, false,false ];

	var NROldVal = [ 0, 0, 0, 0, 0, 0, 0 ];
	var USB3NROldVal = [ 0, 0, 0, 0, 0, 0, 0 ];

	var SwapModified = [ false, false, false, false, false, false, false ];
	var PhyBoostModified = [ false, false, false, false, false, false, false ];
	var VarisenseModified = [ false, false, false, false, false, false, false ];
	var RiseFallModified = [ false, false, false, false, false, false, false ];
	var enableportOldVal = [ 0, 0, 0, 0, 0, 0, 0 ];
	var usb3enableportOldVal = [ 0, 0, 0, 0, 0, 0, 0 ];
	var usb3portmapping = [ 0, 0, 0, 0, 0, 0, 0, 0 ];
	var usb2portmapping = [ 0, 0, 0, 0, 0, 0, 0, 0 ];

	var NoofUSB2Port, NoofUSB3Port, USB2PhysicalPortMax;

	if (gb_sku === "USB7202") 
	{
		NoofUSB2Port = 4;
		NoofUSB3Port = 2;
		USB2PhysicalPortMax = 4;
	}
	if (gb_sku === "USB7250" || gb_sku === "USB7251"
			|| gb_sku === "USB7252") 
	{
		NoofUSB2Port = 4;
		NoofUSB3Port = 3;
		USB2PhysicalPortMax = 5;
	}
	if (gb_sku === "USB7216" || gb_sku === "USB7206" || gb_sku === "USB7256") 
	{
		NoofUSB2Port = 6;
		if(gb_sku === "USB7216" || gb_sku === "USB7256")
		{
			NoofUSB3Port = 4;
		}else if(gb_sku === "USB7206")
		{
			NoofUSB3Port = 5;
		}
		USB2PhysicalPortMax = 6;
	}

	// USB2 Non Removable
	var abnrcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
	abnrcurrentval[1] = $('#nrdeviceport1').is(':checked') ? "1" : "0";
	abnrcurrentval[2] = $('#nrdeviceport2').is(':checked') ? "1" : "0";
	abnrcurrentval[3] = $('#nrdeviceport3').is(':checked') ? "1" : "0";
	abnrcurrentval[4] = $('#nrdeviceport4').is(':checked') ? "1" : "0";
	abnrcurrentval[5] = $('#nrdeviceport5').is(':checked') ? "1" : "0";
	abnrcurrentval[6] = $('#nrdeviceport6').is(':checked') ? "1" : "0";

	// USB3 Non Removable
	var abusb3nrcurrentval = [ 0, 0, 0, 0, 0, 0 ];
	abusb3nrcurrentval[1] = $('#usb3nrdeviceport1').is(':checked') ? "1" : "0";
	abusb3nrcurrentval[2] = $('#usb3nrdeviceport2').is(':checked') ? "1" : "0";
	abusb3nrcurrentval[3] = $('#usb3nrdeviceport3').is(':checked') ? "1" : "0";
	abusb3nrcurrentval[4] = $('#usb3nrdeviceport4').is(':checked') ? "1" : "0";
	abusb3nrcurrentval[5] = $('#usb3nrdeviceport5').is(':checked') ? "1" : "0";

	// USB2 Swap port
	var abPortSwapcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
	abPortSwapcurrentval[1] = $('#swapport1dpdm').is(':checked') ? "1" : "0";
	abPortSwapcurrentval[2] = $('#swapport2dpdm').is(':checked') ? "1" : "0";
	abPortSwapcurrentval[3] = $('#swapport3dpdm').is(':checked') ? "1" : "0";
	abPortSwapcurrentval[4] = $('#swapport4dpdm').is(':checked') ? "1" : "0";
	abPortSwapcurrentval[5] = $('#swapport5dpdm').is(':checked') ? "1" : "0";
	abPortSwapcurrentval[6] = $('#swapport6dpdm').is(':checked') ? "1" : "0";

	// PhyBoost
	var selText;
	var abPhyboostcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
	selText = $(".PHYBOOSTdownstreamport11").find("[data-bind=\"PHYBOOSTdownstreamport1label\"]").text();
	abPhyboostcurrentval[1] = DropDownPHYBOOST.indexOf(selText);
	selText = $(".PHYBOOSTdownstreamport21").find("[data-bind=\"PHYBOOSTdownstreamport2label\"]").text();
	abPhyboostcurrentval[2] = DropDownPHYBOOST.indexOf(selText);
	selText = $(".PHYBOOSTdownstreamport31").find("[data-bind=\"PHYBOOSTdownstreamport3label\"]").text();
	abPhyboostcurrentval[3] = DropDownPHYBOOST.indexOf(selText);
	selText = $(".PHYBOOSTdownstreamport41").find("[data-bind=\"PHYBOOSTdownstreamport4label\"]").text();
	abPhyboostcurrentval[4] = DropDownPHYBOOST.indexOf(selText);
	selText = $(".PHYBOOSTdownstreamport51").find("[data-bind=\"PHYBOOSTdownstreamport5label\"]").text();
	abPhyboostcurrentval[5] = DropDownPHYBOOST.indexOf(selText);
	selText = $(".PHYBOOSTdownstreamport61").find("[data-bind=\"PHYBOOSTdownstreamport6label\"]").text();
	abPhyboostcurrentval[6] = DropDownPHYBOOST.indexOf(selText);

	// Varisense
	var abSQUELCHcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
	selText = $(".SQUELCHdownstreamport11").find("[data-bind=\"SQUELCHdownstreamport1label\"]").text();
	abSQUELCHcurrentval[1] = DropDownSQUELCH.indexOf(selText);
	selText = $(".SQUELCHdownstreamport21").find("[data-bind=\"SQUELCHdownstreamport2label\"]").text();
	abSQUELCHcurrentval[2] = DropDownSQUELCH.indexOf(selText);
	selText = $(".SQUELCHdownstreamport31").find("[data-bind=\"SQUELCHdownstreamport3label\"]").text();
	abSQUELCHcurrentval[3] = DropDownSQUELCH.indexOf(selText);
	selText = $(".SQUELCHdownstreamport41").find("[data-bind=\"SQUELCHdownstreamport4label\"]").text();
	abSQUELCHcurrentval[4] = DropDownSQUELCH.indexOf(selText);
	selText = $(".SQUELCHdownstreamport51").find("[data-bind=\"SQUELCHdownstreamport5label\"]").text();
	abSQUELCHcurrentval[5] = DropDownSQUELCH.indexOf(selText);
	selText = $(".SQUELCHdownstreamport61").find("[data-bind=\"SQUELCHdownstreamport6label\"]").text();
	abSQUELCHcurrentval[6] = DropDownSQUELCH.indexOf(selText);

	// HS RiseFall
	var abHSRiseFallcurrentval = [ 0, 0, 0, 0, 0, 0, 0 ];
	selText = $(".downstreamport1HsRiseFall1").find("[data-bind=\"downstreamport1HsRiseFalllabel\"]").text();
	abHSRiseFallcurrentval[1] = DropDownHSRiseFall.indexOf(selText);
	selText = $(".downstreamport2HsRiseFall1").find("[data-bind=\"downstreamport2HsRiseFalllabel\"]").text();
	abHSRiseFallcurrentval[2] = DropDownHSRiseFall.indexOf(selText);
	selText = $(".downstreamport3HsRiseFall1").find("[data-bind=\"downstreamport3HsRiseFalllabel\"]").text();
	abHSRiseFallcurrentval[3] = DropDownHSRiseFall.indexOf(selText);
	selText = $(".downstreamport4HsRiseFall1").find("[data-bind=\"downstreamport4HsRiseFalllabel\"]").text();
	abHSRiseFallcurrentval[4] = DropDownHSRiseFall.indexOf(selText);
	selText = $(".downstreamport5HsRiseFall1").find("[data-bind=\"downstreamport5HsRiseFalllabel\"]").text();
	abHSRiseFallcurrentval[5] = DropDownHSRiseFall.indexOf(selText);
	selText = $(".downstreamport6HsRiseFall1").find("[data-bind=\"downstreamport6HsRiseFalllabel\"]").text();
	abHSRiseFallcurrentval[6] = DropDownHSRiseFall.indexOf(selText);

	// Phy, varisense,hsrisefall all are usb2 based feilds. so
	// checking for maximum physical port
	for (var port = 1; port <= 7; port++) 
	{
		enableportwidget = "enableport" + port.toString();
		enableportOldVal[port] = getWidgetValue(dummyHubID,enableportwidget);
		if (port <= 5) 
		{
			usb3enableportwidget = "usb3enableport"+ port.toString();
			usb3enableportOldVal[port] = getWidgetValue(dummyHubID, usb3enableportwidget);
		}
		if (port <= USB2PhysicalPortMax) 
		{
			if (abUSB2PortEnable[port] == 0) 
			{
				if (abUSB3PortEnable[port] == true) 
				{
					var widgetgroupname;
					var portsplitval = 0;
					if((gb_sku === "USB7216" || gb_sku === "USB7206" || gb_sku === "USB7256"))
					{
						if(port === 3)
						{
							widgetgroupname = '#' + "port3splitting" + "group";
							portsplitval = $(widgetgroupname).find(':checked').val();
						}
						if(port === 4)
						{
							widgetgroupname = '#' + "port4splitting" + "group";
							portsplitval = $(widgetgroupname).find(':checked').val();
						}
						if(port === 5)
						{
							widgetgroupname = '#' + "port5splitting" + "group";
							portsplitval = $(widgetgroupname).find(':checked').val();
						}
					}
					else if((gb_sku === "USB7250") || (gb_sku === "USB7251") || (gb_sku === "USB7252"))
					{
						if(port === 5)
						{
							widgetgroupname = '#' + "port5splitting" + "group";
							portsplitval = $(widgetgroupname).find(':checked').val();
							
						}
					}
					
					if(portsplitval == 0)
					{
						var Customer_Port = 0;
						if(gb_sku === "USB7202")
						{
							Customer_Port = USB7202_PortMap[port] ;
						}
						else if(gb_sku === "USB7250" || gb_sku === "USB7251" || gb_sku === "USB7252")
						{
							Customer_Port = USB725x_PortMap[port];
						}
						else if(gb_sku === "USB7216" || gb_sku === "USB7256")
						{
							Customer_Port = USB7256_PortMap[port];
						}
						else if(gb_sku === "USB7206")
						{
							Customer_Port = USB7206_PortMap[port];
						}
						alert("USB2.0 port of Port"
								+ Customer_Port
								+ " cannot be disabled, when USB3.1 Gen2 port is still in enabled state");
						return;
					}
				}
			}
			if ((abUSB2PortEnable[port] == 0)&& (enableportOldVal[port] == 1)) 
			{
				// Non -removable
				nrwidget = "nrdeviceport" + port.toString();
				nrport = getWidgetValue(dummyHubID, nrwidget);
				NROldVal[port] = nrport;
				// If port is disabled, force nr to 0
				if ((nrport != 0)) 
				{
					NRModified[port] = true;
					deltaobj.push(nrwidget, 0);
				} 
				else if ((NROldVal[port] == 0)
						|| (abnrcurrentval[port] != 0)) 
				{
					// do nothing. if current val of nr is 1 but
					// port is disabled
				}

				// Port Swap
				swapwidget = "swapport" + port.toString()+ "dpdm";
				dpdmSwap = getWidgetValue(dummyHubID,swapwidget);
				if ((dpdmSwap != 0)) 
				{
					SwapModified[port] = true;
					deltaobj.push(swapwidget, 0);
				} 
				else if ((dpdmSwap == 0)
						|| (abPortSwapcurrentval[port] != 0)) 
				{
					// do nothing. if current val of nr is 1 but
					// port is disabled
				}
				// Phyboost
				phyboostwidget = "PHYBOOSTdownstreamport"+ port.toString();
				phyboost = getWidgetValue(dummyHubID,phyboostwidget);

				if (phyboost != 0) 
				{
					PhyBoostModified[port] = true;
					deltaobj.push(phyboostwidget, 0);
				} 
				else if ((phyboost == 0)
						|| (abPhyboostcurrentval[port] != 0)) 
				{
					// do nothing. if current val of phyboost is
					// not 0 but port is disabled
				}

				// Varisense
				varisensewidget = "SQUELCHdownstreamport" + port.toString();
				varisense = getWidgetValue(dummyHubID, varisensewidget);
				if (varisense != 0) 
				{
					VarisenseModified[port] = true;
					deltaobj.push(varisensewidget, 0);
				} 
				else if ((varisense == 0)
						|| (abSQUELCHcurrentval[port] != 0)) 
				{
					// do nothing. if current val of squelch is
					// not 0 but port is disabled
				}

				// risefall
				hsrisefallwidget = "downstreamport" + port.toString() + "HsRiseFall";
				hsrisefall = getWidgetValue(dummyHubID,hsrisefallwidget);
				if (hsrisefall != 0) 
				{
					RiseFallModified[port] = true;
					deltaobj.push(hsrisefall, 0);
				} 
				else if ((hsrisefall == 0)
						|| (abHSRiseFallcurrentval[port] != 0)) 
				{
					// do nothing. if current val of hsrisefall
					// is not 0 but port is disabled
				}

			} 
			else 
			{
				nrwidget = "nrdeviceport" + port.toString();
				if (abnrcurrentval[port] != getWidgetValue(dummyHubID, nrwidget)) 
				{
					if (NRModified[port] == true) 
					{
						// do nothing. since nr port for this
						// port is forced to 0 in above steps
					} else
					{
						deltaobj.push(nrwidget,abnrcurrentval[port]);
						modifiedWidgets.push(nrwidget);
					}
				}
				swapwidget = "swapport" + port.toString()+ "dpdm";
				if (abPortSwapcurrentval[port] != getWidgetValue(dummyHubID, swapwidget)) 
				{
					if (SwapModified[port] == true) 
					{
						// do nothing. since swap port for this
						// port is forced to 0 in above steps
					} 
					else 
					{
						deltaobj.push(swapwidget,abPortSwapcurrentval[port]);
						modifiedWidgets.push(swapwidget);
					}
				}
				phyboostwidget = "PHYBOOSTdownstreamport"+ port.toString();
				if (abPhyboostcurrentval[port] != getWidgetValue(dummyHubID, phyboostwidget)) 
				{
					if (PhyBoostModified[port] == true) 
					{
						// do nothing. since swap port for this
						// port is forced to 0 in above steps
					} 
					else 
					{
						deltaobj.push(phyboostwidget,abPhyboostcurrentval[port]);
						modifiedWidgets.push(phyboostwidget);
					}
				}
				varisensewidget = "SQUELCHdownstreamport"+ port.toString();
				if (abSQUELCHcurrentval[port] != getWidgetValue(dummyHubID, varisensewidget)) 
				{
					if (VarisenseModified[port] == true) {
						// do nothing. since swap port for this
						// port is forced to 0 in above steps
					} else {
						deltaobj.push(varisensewidget,
								abSQUELCHcurrentval[port]);
						modifiedWidgets.push(varisensewidget);
					}
				}
				
				hsrisefallwidget = "downstreamport"+ port.toString() + "HsRiseFall";
				if (abHSRiseFallcurrentval[port] != getWidgetValue(dummyHubID, hsrisefallwidget)) 
				{
					if (RiseFallModified[port] == true) 
					{
						// do nothing. since swap port for this
						// port is forced to 0 in above steps
					} 
					else 
					{
						deltaobj.push(hsrisefallwidget,abHSRiseFallcurrentval[port]);
						modifiedWidgets.push(hsrisefallwidget);
					}
				}
			}
			if(port <=5 ) //USB3 can be maximum at port5
			{
				if ((abUSB3PortEnable[port] == 0)&& (usb3enableportOldVal[port] == 1)) 
				{
					
					usb3nrwidget = "usb3nrdeviceport"
							+ port.toString();
					USB3NROldVal[port] = getWidgetValue(dummyHubID,usb3nrwidget);
					// If port is disabled, force nr to 0
					if ((USB3NROldVal[port] != 0)
							|| (abusb3nrcurrentval[port] != 0)) 
					{
						usb3nrwidgetchanged = true;
						USB3NRModified[port] = true;
						deltaobj.push(usb3nrwidget, 0);
					}
					
				} 
				else 
				{
					usb3nrwidget = "usb3nrdeviceport" + port.toString();
					if (abusb3nrcurrentval[port] != getWidgetValue(dummyHubID, usb3nrwidget)) 
					{
						if (USB3NRModified[port] == true) 
						{
							// do nothing. since nr port for this
							// port is forced to 0 in above steps
						} 
						else 
						{
							usb3nrwidgetchanged = true;
							deltaobj.push(usb3nrwidget,
									abusb3nrcurrentval[port]);
							modifiedWidgets.push(usb3nrwidget);
						}
					}
				}
			}
		}
	}
	// Do remapping if there is a change in port state
	if ((abUSB2PortEnable[1] != enableportOldVal[1])
			|| (abUSB2PortEnable[2] != enableportOldVal[2])
			|| (abUSB2PortEnable[3] != enableportOldVal[3])
			|| (abUSB2PortEnable[4] != enableportOldVal[4])
			|| (abUSB2PortEnable[5] != enableportOldVal[5])
			|| (abUSB2PortEnable[6] != enableportOldVal[6])
			|| (abUSB3PortEnable[1] != usb3enableportOldVal[1])
			|| (abUSB3PortEnable[2] != usb3enableportOldVal[2])
			|| (abUSB3PortEnable[3] != usb3enableportOldVal[3])
			|| (abUSB3PortEnable[4] != usb3enableportOldVal[4])
			|| (abUSB3PortEnable[5] != usb3enableportOldVal[5])) 
	{

		// Use Fw logic to do port remapping
		var byUSB2PortDis = 0;
		var byUSB3PortDis = 0;

		var BIT = [ 0x00000001, 0x00000002, 0x00000004, 0x00000008, 0x00000010, 0x00000020, 0x00000040, 0x00000080 ];
		var HUB_PORT_BIT = [0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80];
		var HUB_PORT_6 = 0x40;
		var HUB_PORT_5 = 0x20;
		var HUB_PORT_4 = 0x10;
		var HUB_PORT_3 = 0x08;
		var HUB_PORT_2 = 0x04;
		var HUB_PORT_1 = 0x02;

		// Disabled ports are calculated based on customer docs (i.e - Tool display)
		if (gb_sku == "USB7202") 
		{
			byUSB2PortDis = (BIT[5] | BIT[7]); //4 DFP
			byUSB3PortDis = (BIT[3] | BIT[4] | BIT[5] | BIT[6] | BIT[7]); // Only first 2 ports has 3.0
		}
		if (gb_sku === "USB7250" || gb_sku === "USB7251"
				|| gb_sku === "USB7252") 
		{
			byUSB2PortDis = (BIT[5] | BIT[7]); //4 DFP
			byUSB3PortDis = (BIT[4] | BIT[5] | BIT[6] | BIT[7]); // First 3 ports has 3.0
		}
		if (gb_sku === "USB7216" || gb_sku === "USB7206" || gb_sku === "USB7256") 
		{
			byUSB2PortDis = (BIT[7]); //6 DFP
			
			if(gb_sku === "USB7216" || gb_sku === "USB7256")
			{
				byUSB3PortDis = (BIT[5] | BIT[6] | BIT[7]); // First 4 ports has 3.0
			}
			else if(gb_sku === "USB7206")
			{
				byUSB3PortDis = (BIT[6] | BIT[7]); // First 5 ports has 3.0
			}
		}
		// Based on current user disabled ports, update
		// byUSB2PortDis and byUSB3PortDis
		// var ports used in for loop is as per DOS (i.e - Continuous div in UI)
		for (var ports = 1; ports <= USB2PhysicalPortMax; ports++) 
		{
			if (abUSB2PortEnable[ports] == 0) // disable
			{
				if (gb_sku == "USB7202") 
				{
					if (((ports == 5) || (ports == 7))) 
					{
						// do nothing
					} 
					else 
					{
						if(ports == 2)
						{
							byUSB2PortDis |= BIT[3];
						}
						else if(ports == 3)
						{
							byUSB2PortDis |= BIT[2];
						}
						else
						{
							byUSB2PortDis |= BIT[ports];
						}
					}
				}
				if (gb_sku == "USB7250" || gb_sku == "USB7251"
						|| gb_sku == "USB7252") 
				{
					if ((ports == 4) || (ports == 7)) 
					{
						// do nothing
					} 
					else 
					{
						if(ports == 2)
						{
							byUSB2PortDis |= BIT[4];
						}
						else if(ports == 3)
						{
							byUSB2PortDis |= BIT[2];
						}
						else if(ports == 5)
						{
							byUSB2PortDis |= BIT[3];
						}
						else
						{
							byUSB2PortDis |= BIT[ports];
						}
					}
				}
				if (gb_sku === "USB7216" || gb_sku === "USB7206" || gb_sku === "USB7256") 
				{
					if (ports == 7) 
					{
						// do nothing
					} 
					else 
					{
						if(gb_sku === "USB7216" || gb_sku === "USB7256" )
						{
							if(ports == 2)
							{
								byUSB2PortDis |= BIT[5];
							}
							else if(ports == 3)
							{
								byUSB2PortDis |= BIT[2];
							}
							else if(ports == 4)
							{
								byUSB2PortDis |= BIT[3];
							}
							else if(ports == 5)
							{
								byUSB2PortDis |= BIT[4];
							}
							else
							{
								byUSB2PortDis |= BIT[ports];
							}
						}
						else if(gb_sku === "USB7206")
						{
							byUSB2PortDis |= BIT[ports];
						}
					}
				}
			}
			if (abUSB3PortEnable[ports] == 0) // usb3 disable
			{
				if ((gb_sku == "USB7202")) 
				{
					if ( (ports ==2) || (ports == 4)
							|| (ports == 5) || (ports == 6)
							|| (ports === 7)) 
					{
						// do nothing
					} 
					else 
					{
						if(ports == 3)
						{
							byUSB3PortDis |= BIT[2];
						}
						else
						{
							byUSB3PortDis |= BIT[ports];
						}
					}
				}
				if (gb_sku == "USB7250" || gb_sku == "USB7251"
						|| gb_sku == "USB7252") 
				{
					if ((ports == 2) || (ports == 4)
							|| (ports == 6) || (ports === 7)) 
					{
						// do nothing
					} 
					else 
					{
						if(ports == 3)
						{
							byUSB3PortDis |= BIT[2];
						}
						else if(ports == 5)
						{
							byUSB3PortDis |= BIT[3];
						}
						else
						{
							byUSB3PortDis |= BIT[ports];
						}
					}
				}
				if (gb_sku === "USB7216" || gb_sku === "USB7206" || gb_sku === "USB7256") 
				{
					if (gb_sku === "USB7216" || gb_sku === "USB7256")
					{
						if ((ports == 2) || (ports == 6)
								|| (ports === 7)) 
						{
							// do nothing
						} else 
						{
							if(ports == 3)
							{
								byUSB3PortDis |= BIT[2];
							}
							else if(ports == 4)
							{
								byUSB3PortDis |= BIT[3];
							}
							else if(ports == 5)
							{
								byUSB3PortDis |= BIT[4];
							}
							else
							{
								byUSB3PortDis |= BIT[ports];
							}
						}
					}
					if (gb_sku === "USB7206")
					{
						if ((ports == 6)
								|| (ports === 7)) 
						{
							// do nothing
						} else 
						{
							byUSB3PortDis |= BIT[ports];
						}
					}
				}
			}
		}
		var byUSB2PortDisnew = byUSB2PortDis.toString(16);
		var byUSB3PortDisnew = byUSB3PortDis.toString(16);

		var byUSB3PortDishex = parseInt(byUSB3PortDisnew, 16);
		var byUSB2PortDishex = parseInt(byUSB2PortDisnew, 16);

		var byLogicalPort = 1, byusb3LogicalPort = 1;
		var USB3EnableVal = 0xFF - byUSB3PortDishex;
		var USB2EnableVal = 0xFF - byUSB2PortDishex;
			
		var USB3USB2SameEnabledPorts = USB2EnableVal & USB3EnableVal ;
		var USB3UnMappedPorts = 0;
		var USB2UnMappedPorts =0;
		if(USB3USB2SameEnabledPorts > USB3EnableVal)
		{
			USB3UnMappedPorts = USB3USB2SameEnabledPorts - USB3EnableVal;
		}
		else
		{
			USB3UnMappedPorts = USB3EnableVal - USB3USB2SameEnabledPorts;
		}
		if(USB3USB2SameEnabledPorts > USB2EnableVal)
		{
			USB2UnMappedPorts = USB3USB2SameEnabledPorts - USB2EnableVal;
		}
		else
		{
			USB2UnMappedPorts = USB2EnableVal - USB3USB2SameEnabledPorts;
		}
			
		usb2portmapping[1] = (USB3USB2SameEnabledPorts & 0x02) ? byLogicalPort++ : 0x00;
		usb3portmapping[1] = (USB3USB2SameEnabledPorts & 0x02) ? byusb3LogicalPort++ : 0x00;
		
		usb2portmapping[2] = (USB3USB2SameEnabledPorts & 0x04) ? byLogicalPort++ : 0x00;
		usb3portmapping[2] = (USB3USB2SameEnabledPorts & 0x04) ? byusb3LogicalPort++ : 0x00;
		
		usb2portmapping[3] = (USB3USB2SameEnabledPorts & 0x08) ? byLogicalPort++ : 0x00;
		usb3portmapping[3] = (USB3USB2SameEnabledPorts & 0x08) ? byusb3LogicalPort++ : 0x00;
		
		usb2portmapping[4] = (USB3USB2SameEnabledPorts & 0x10) ? byLogicalPort++ : 0x00;
		usb3portmapping[4] = (USB3USB2SameEnabledPorts & 0x10) ? byusb3LogicalPort++ : 0x00;
		
		usb2portmapping[5] = (USB3USB2SameEnabledPorts & 0x20) ? byLogicalPort++ : 0x00;
		usb3portmapping[5] = (USB3USB2SameEnabledPorts & 0x20) ? byusb3LogicalPort++ : 0x00;
		
		usb2portmapping[6] = (USB3USB2SameEnabledPorts & 0x40) ? byLogicalPort++ : 0x00;
		usb3portmapping[6] = (USB3USB2SameEnabledPorts & 0x40) ? byusb3LogicalPort++ : 0x00;

		for(var i= 1; i<=6; i++)
		{
			if(usb3portmapping[i] === 0)
			{
				usb3portmapping[i] = (USB3UnMappedPorts & HUB_PORT_BIT[i]) ? byusb3LogicalPort++ : 0x00;
			}
			if(usb2portmapping[i] === 0)
			{
				usb2portmapping[i] = (USB2UnMappedPorts & HUB_PORT_BIT[i]) ? byLogicalPort++ : 0x00;
			}
		}
		
		var hcestate = $('#hceenable').is(':checked');
		if (hcestate === true) 
		{
			usb2portmapping[7] = byLogicalPort;
		}
		
		if(gb_sku == "USB7202")
		{
			// DOS port 2 is customer Doc port 3 and DOS port 3 is customer Doc port 2
			// So swap the value here
			var temp2 = usb2portmapping[2];
			var temp3 = usb2portmapping[3];
			usb2portmapping[2] = temp3;
			usb2portmapping[3] = temp2;
			
			temp2 = usb3portmapping[2];
			temp3 = usb3portmapping[3];
			
			usb3portmapping[2] = temp3;
			usb3portmapping[3] = temp2;
		}
		if (gb_sku == "USB7250" || gb_sku == "USB7251"
						|| gb_sku == "USB7252") 
		{
			// So swap the value here
			var temp2 = usb2portmapping[2];
			var temp3 = usb2portmapping[3];
			var temp4 = usb2portmapping[4];
			
			usb2portmapping[2] = temp4
			usb2portmapping[3] = temp2;
			usb2portmapping[4] = 0x00;
			usb2portmapping[5] = temp3;
			
			temp2 = usb3portmapping[2];
			temp3 = usb3portmapping[3];
			temp4 = usb3portmapping[4];
			
			usb3portmapping[2] = temp4
			usb3portmapping[3] = temp2;
			usb3portmapping[4] = 0x00;
			usb3portmapping[5] = temp3;
		} 
		if(gb_sku === "USB7216" || gb_sku === "USB7256")
		{
			var temp2 = usb2portmapping[2];
			var temp3 = usb2portmapping[3];
			var temp4 = usb2portmapping[4];
			var temp5 = usb2portmapping[5];
			
			usb2portmapping[2] = temp5;
			usb2portmapping[3] = temp2;
			usb2portmapping[4] = temp3;
			usb2portmapping[5] = temp4;
			
			temp2 = usb3portmapping[2];
			temp3 = usb3portmapping[3];
			temp4 = usb3portmapping[4];
			temp5 = usb3portmapping[5];
			
			usb3portmapping[2] = temp5;
			usb3portmapping[3] = temp2;
			usb3portmapping[4] = temp3;
			usb3portmapping[5] = temp4;
		}
		
		var portmapping, usb3portmappingwid;
		var usb2portmappingOldVal = [ 0, 0, 0, 0, 0, 0, 0 ];

		// UDC also
		for (var ports = 1; ports <= 7; ports++) 
		{
			portmapping = "port" + ports.toString() + "mapping";

			deltaobj.push(portmapping, usb2portmapping[ports]);
			if((abUSB2PortEnable[ports] != enableportOldVal[ports]))
			{
				if(ports == 7)
				{
					//UI does not have div for port 7
				}
				else
				{
					modifiedWidgets.push(portmapping);
				}
			}
		}
		for (var ports = 1; ports <= USB2PhysicalPortMax; ports++) 
		{
			enableportwidget = "enableport" + ports.toString();
			usb3enableportwidget = "usb3enableport" + ports.toString();
			deltaobj.push(enableportwidget, abUSB2PortEnable[ports]);
			if((abUSB2PortEnable[ports] != enableportOldVal[ports]))
			{
				modifiedWidgets.push(enableportwidget);
			}
			usb3portmappingwid = "usb3port" + ports.toString() + "mapping";

			if(ports <=5) //usb3 is present maximum at port5
			{
				deltaobj.push(usb3enableportwidget,abUSB3PortEnable[ports]);
				deltaobj.push(usb3portmappingwid,usb3portmapping[ports]);
		
				if(abUSB3PortEnable[ports] != usb3enableportOldVal[ports])
				{
					modifiedWidgets.push(usb3enableportwidget);
					modifiedWidgets.push(usb3portmappingwid);
				}
			}
		}
		deltaobj.push("usb3numberofports",(byusb3LogicalPort - 1));
		//modifiedWidgets.push("usb3numberofports");
	} 
	else 
	{
		var usb3mapping = 1;
		// Port mapping of USB3 is necessary to update USB3 NR
		usb3portmapping[1] = (abUSB3PortEnable[1] == 1) ? usb3mapping++ : 0x00;
		usb3portmapping[2] = (abUSB3PortEnable[2] == 1) ? usb3mapping++ : 0x00;
		usb3portmapping[3] = (abUSB3PortEnable[3] == 1) ? usb3mapping++ : 0x00;
		usb3portmapping[4] = (abUSB3PortEnable[4] == 1) ? usb3mapping++ : 0x00;
		usb3portmapping[5] = (abUSB3PortEnable[5] == 1) ? usb3mapping++ : 0x00;
	}
	if ((usb3nrwidgetchanged === true) || (abUSB3PortEnable[1] != usb3enableportOldVal[1])
				|| (abUSB3PortEnable[2] != usb3enableportOldVal[2])
				|| (abUSB3PortEnable[3] != usb3enableportOldVal[3])
				|| (abUSB3PortEnable[5] != usb3enableportOldVal[5]))
	{
		var usb3nrdev = 0;
		usb3nrdev |= (abusb3nrcurrentval[1] == 1) ? (1 << usb3portmapping[1]) : 0x00;
		usb3nrdev |= (abusb3nrcurrentval[2] == 1) ? (1 << usb3portmapping[2]) : 0x00;
		usb3nrdev |= (abusb3nrcurrentval[3] == 1) ? (1 << usb3portmapping[3]) : 0x00;
		usb3nrdev |= (abusb3nrcurrentval[4] == 1) ? (1 << usb3portmapping[4]) : 0x00;
		usb3nrdev |= (abusb3nrcurrentval[5] == 1) ? (1 << usb3portmapping[5]) : 0x00;
		usb3nrdev = usb3nrdev.toString(16);

		deltaobj.push("usb3nrdevice", usb3nrdev);
		//modifiedWidgets.push("usb3nrdevice");
	}

	// setwidget GwidgetlistString starts
	$.each(GwidgetlistString, function(index, widgetName) 
	{
		var widgetid = "#" + widgetName;
		var oldval = getWidgetValue(dummyHubID, widgetName);
		var newval = $(widgetid).val();

		if (newval != oldval) 
		{

			if (jQuery.isEmptyObject(newval)) {
				newval = "";
			}

			deltaobj.push(widgetName, newval);
			modifiedWidgets.push(widgetName);

		}
	});
	// setwidget GwidgetlistString ends

	//setwidget GwidgetlistHex starts
	$.each(GwidgetlistHex,function(index, widgetName) 
	{
		var widgetid = "#" + widgetName;
		var oldval;
		var newval;
		var isValid;

		if (widgetName === "usbvcd"
				|| widgetName === "usb3vcd") 
		{
			// Backend Values are in Int
			// UI values are in HEX
			var oldval = parseInt(getWidgetValue(dummyHubID,widgetName), 10);
			oldval = oldval.toString(16);
			var strnewval = $(widgetid).val();
			strnewval = strnewval.replace('.','');
			newval = parseInt(strnewval, 16);
			newval = newval.toString(16);

		} 
		else 
		{
			var ioldval = parseInt(getWidgetValue(dummyHubID,widgetName), 10);
			var stroldval = ioldval.toString(16);
			oldval = "0x" + stroldval
			var strxnewval = $(widgetid).val();
			var inewval = parseInt(strxnewval,16);
			strxnewval = inewval.toString(16);
			newval = "0x" + strxnewval;
		}
		if (oldval != newval) 
		{
			if ((widgetName == "languageid"
					|| widgetName == "usb3languageid"
					|| widgetName == "hce_languageid"
					|| widgetName == "hce1_languageid" || widgetName == "hce2_languageid")) 
			{

				if (newval == "0x0") 
				{
					alert("Language ID cannot be zero. Setting it to default value (0x409)");
					newval = parseInt("0x409",16);
				}
			}

			// Adding the VID of USB2.0 and HCE
			// to Protouch2.ini, if they are
			// modified.

			if ((widgetName == "vid")
					|| (widgetName == "usb3vid")
					|| (widgetName == "hce_vid")
					|| (widgetName == "hce1_vid")
					|| (widgetName == "hce2_vid")) 
			{

				var xval = $(widgetid).val();
				var strxval = "0x" + xval;
				updateINI(strxval);

				// if pid of USB2.0 or Hub
				// controller is modified, then
				// increase the time out.
				vid_pidModified = true;
			}

			// if vid of hub or Hub controller
			// is modified, then increase the
			// time out.
			if ((widgetName == "pid")
					|| (widgetName == "usb3pid")
					|| (widgetName == "hce_pid")
					|| (widgetName == "hce1_pid")
					|| (widgetName == "hce2_pid")) 
			{
				vid_pidModified = true;
			}

			deltaobj.push(widgetName, newval);
			modifiedWidgets.push(widgetName);
		}
	});
	//setwidget GwidgetlistHex ends

	// setwidget GwidgetlistInt starts
	$.each(GwidgetlistInt,function(index, widgetName) 
	{
		var widgetid = "#" + widgetName;
		var oldval = getWidgetValue(dummyHubID,
				widgetName);
		var strxnewval;

		if (widgetName == "hub3maxpowerselfbus") 
		{
			oldval = parseInt(oldval, 10) * 8;
		} 
		else if ((widgetName == "hubcmaxpowerself")
				|| (widgetName == "hubcmaxpowerbus")) 
		{
			oldval = parseInt(oldval, 10);
		} 
		else 
		{
			oldval = parseInt(oldval, 10) * 2;
		}

		var that = $(widgetid), parent = that
				.closest('fieldset');
		var checkdisabled = $(parent).prop(
				"disabled");

		var newval = $(widgetid).val();
		var newdecvalue = parseInt(newval, 10);
		newdecvalue = newdecvalue & 0xff;

		if ((widgetName == "hub3maxpowerselfbus")
				|| (widgetName == "maxpowerself")
				|| (widgetName == "maxpowerbus")) 
		{
			if ((newdecvalue & 0x01)
					&& !checkdisabled) {
				currentvalue = "ODDNUM";
				return;
			}
		}

		if ((oldval == newval) || isNaN(newval)) 
		{
			// do nothing - no change in value
		} 
		else if (checkdisabled) 
		{
			// Change detected but field is
			// disabled - So do nothing
		} 
		else 
		{
			if ((widgetName == "maxpowerself")
					|| (widgetName == "hubcmaxpowerself")) 
			{
				if ((newval > 100)
						|| (newval < 0)) {
					alert("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
					update_status_message("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
					errorFlag = true;
					return;
				}
			}

			if (widgetName == "maxpowerbus")
			{
				if ((newval > 500)
						|| (newval < 0)) {
					alert("USB2.0 max power(bus) cannot be more than 500mA or negative.");
					update_status_message("USB2.0 max power(bus) cannot be more than 500mA or negative.");
					errorFlag = true;
					return;
				}
			}

			if (widgetName == "hubcmaxpowerbus") 
			{
				if ((newval > 255)
						|| (newval < 0)) {
					alert("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
					update_status_message("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
					errorFlag = true;
					return;
				}
			}

			if (widgetName == "hub3maxpowerselfbus") 
			{
				if ((newval > 900)
						|| (newval < 0)) {
					alert("USB3.1 Gen2 hub max power cannot be more than 900mA or negative.");
					update_status_message("USB3.1 Gen2 hub max power cannot be more than 900mA or negative.");
					errorFlag = true;
					return;
				}
			}
			var hexval;
			if (widgetName == "hub3maxpowerselfbus") 
			{
				var newdecvalue = parseInt(
						newval, 10);
				var reminder = newdecvalue % 8;
				if (reminder != 0) {
					alert("Hub Max Power 3.1 Gen2 field can have multiples of 8 only");
					var mesg = "Error : Hub Max Power 3.1 Gen2 field can have multiples of 8 only";
					update_status_message(mesg);
					errorFlag = true;
					return;
				}
				newdecvalue = newdecvalue / 8;
				var temp = Math
						.floor(newdecvalue);
				hexval = temp.toString(16);
			} 
			else if ((widgetName == "hubcmaxpowerbus")
					|| (widgetName == "hubcmaxpowerself")) 
			{
				newdecvalue = parseInt(newval,
						10);
				hexval = newdecvalue
						.toString(16);
			} 
			else 
			{
				newdecvalue = parseInt(newval,10);
				newdecvalue = newdecvalue / 2;
				hexval = newdecvalue
						.toString(16);
			}
			deltaobj.push(widgetName, hexval);
			modifiedWidgets.push(widgetName);
		}
	});
	if (currentvalue == "ODDNUM") 
	{
		$("#progID").hide();
		alert("\"Hub MaxPower(Self)\", \"Hub Circuit MaxPower(Self)\", \"HubMaxPower(Bus)\" and \"Hub Circuit MaxPower(Bus)\" fields can have even numbers only");
		var mesg = "Error : \"Hub MaxPower(Self)\", \"Hub Circuit MaxPower(Self)\", \"Hub MaxPower(Bus)\" and \"Hub Circuit MaxPower(Bus)\" fields can have even numbers only";
		update_status_message(mesg);
		currentvalue = "NONE";
		errorFlag = true;
		return;
	}
	// setwidget GwidgetlistInt ends
	
	//setwidget GwidgetlistCheckbox11 starts
	$.each(GwidgetlistCheckbox11,function(index, widgetName) 
	{
		var widgetid = "#" + widgetName;
		var oldval = getWidgetValue(dummyHubID,widgetName);
		var newval = checkbox_unchecked_value;
		var that = $(widgetid), parent = that.closest('fieldset');
		var checkdisabled = $(parent).prop("disabled");
	
		if(widgetName != "cdcenable") 
		{
			if($(widgetid).is(':checked'))
			{
				newval = checkbox_checked_value;
			}
		} 
		if(widgetName === "cdcenable") {
			if($("#cdcenable").is(':checked')) {
				newval = checkbox_unchecked_value;
			}
			else
			{
				newval = checkbox_checked_value
			}
		}
		
		// Enabled - check the previous value
		// and determine delta
		if (oldval == newval) 
		{
			// do nothing - no change in value
		} 
		else 
		{
			if (widgetName == "lpmenable") 
			{
				alert("The change in LPM Enable will cause change in the USB bcdUSB");
				deltaobj.push("lpmenable",newval);
			}
			if(widgetName == "cdcenable") 
			{
				if(newval == checkbox_checked_value) {
					deltaobj.push("cdcenable",checkbox_checked_value);
				} 
				else
				{
					alert("CDC enable is based on Strap.Disable CDC applicable only for the CDC enabled USB Device(USB72XX hub product family).");
					deltaobj.push("cdcenable",checkbox_unchecked_value);
				}
				modifiedWidgets.push(widgetName);
			}
			// if ((widgetName == "flexconnect")) 
			// {
				// if (($('#flexconnect').is(':checked'))) 
				// {

					// alert("Enabling Flexconnect will swap USB2 Downstream port  with Upstream port. Please make required changes in hub for further processing after successful programming");
				// } 
				// else 
				// {
					// alert("Disabling Flexconnect will swap USB2 Downstream port with Upstream port. Please make required changes in hub for further processing after successful programming");
				// }
			// }
			// if ((widgetName == "usb3flexconnect")) 
			// {
				// if (($('#usb3flexconnect').is(':checked'))) 
				// {

					// alert("Enabling Flexconnect will swap USB3.1 Gen2 Downstream port  with Upstream port. Please make required changes in hub for further processing after successful programming");
				// } 
				// else 
				// {
					// alert("Disabling Flexconnect will swap USB3.1 Gen2 Downstream port with Upstream port. Please make required changes in hub for further processing after successful programming");
				// }
			// }
			if (widgetName == "swapupstreamdpdm") {

				if ($('#swapupstreamdpdm').is(
						':checked')) {

					alert("Programming Upstream swap will swap D+ and D- lines of Upstream port. Please make the required changes in hub for further processing after successful programming");
				}

				gb_enable_swapupstreamdpdm = true;
			}
			//if ((widgetName != "flexconnect") && (widgetName != "usb3flexconnect")) 
			//{
				if ((widgetName === "nrdeviceport1")
						|| (widgetName === "nrdeviceport2")
						|| (widgetName === "nrdeviceport3")
						|| (widgetName === "nrdeviceport4")
						|| (widgetName === "nrdeviceport5")
						|| (widgetName === "nrdeviceport6")
						|| (widgetName === "usb3nrdeviceport1")
						|| (widgetName === "usb3nrdeviceport2")
						|| (widgetName === "usb3nrdeviceport3")
						|| (widgetName === "usb3nrdeviceport4")
						|| (widgetName === "usb3nrdeviceport5")
						|| (widgetName === "swapport1dpdm")
						|| (widgetName === "swapport2dpdm")
						|| (widgetName === "swapport3dpdm")
						|| (widgetName === "swapport4dpdm")
						|| (widgetName === "swapport5dpdm")
						|| (widgetName === "swapport6dpdm")
						|| (widgetName === "enableport1")
						|| (widgetName === "enableport2")
						|| (widgetName === "enableport3")
						|| (widgetName === "enableport4")
						|| (widgetName === "enableport5")
						|| (widgetName === "enableport6")
						|| (widgetName === "usb3enableport1")
						|| (widgetName === "usb3enableport2")
						|| (widgetName === "usb3enableport3")
						|| (widgetName === "usb3enableport4")
						|| (widgetName === "usb3enableport5")) 
				{
					// do nothing. since value
					// of these checkboxes may
					// be forced to 0 based on
					// state of port
					// handled down
				} 
				else 
				{
					if(widgetName != "cdcenable") 
					{
						deltaobj.push(widgetName,newval);
						modifiedWidgets.push(widgetName);
					}
					
				}
			//} 
			// else 
			// {
				// var nameofcontrol = "." + "flexport" + "1";
				// var nameofcontrol1 = "[data-bind=\"" + "flexport"+ "label\"]";
				// var selText = $(nameofcontrol).find(nameofcontrol1).text();
				// var flxport = DropDownflexport.indexOf(selText);
				// if((gb_sku == "USB7250" || gb_sku == "USB7251" || gb_sku == "USB7252") && (flxport == "4"))
				// {
					// flxport = "5"; //Port 4 is not available
				// }
				// if(widgetName === "flexconnect")
				// {
					// modifiedWidgets.push(widgetName);
					// deltaobj.push(widgetName,newval);
						
					// if ((!$('#flexconnect').is(':checked'))) 
					// {
						// modifiedWidgets.push("flexport");
						// deltaobj.push("flexport","0");
					// }
					// else //checked
					// {
						// deltaobj.push("flexport", flxport);
						// modifiedWidgets.push("flexport");
					// }
					
				// }	
				// if(widgetName == "usb3flexconnect")
				// {
					// modifiedWidgets.push(widgetName);
					// deltaobj.push(widgetName,newval);
						
					// if ((!$('#usb3flexconnect').is(':checked'))) 
					// {
						// modifiedWidgets.push("usb3flexport");
						// deltaobj.push("usb3flexport","0");
					// }
					// else
					// {
						// deltaobj.push("usb3flexport", flxport); //push usb3flexport also
						// modifiedWidgets.push("usb3flexport");
					// }
				// }
			// }
		}
	});
	//setwidget GwidgetlistCheckbox11 ends
	
	// setwidget GwidgetlistRadio start
	$.each(GwidgetlistRadio,function(index, widgetName) 
	{
		var widgetgroupname = '#' + widgetName + "group";
		var oldval = getWidgetValue(dummyHubID,widgetName);
		var newval = $(widgetgroupname).find(':checked').val();
		var that = $(widgetgroupname), parent = that.closest('fieldset');
		var checkdisabled = $(parent).prop("disabled");

		if (widgetName === "downstreamBCsettingport1"
				|| widgetName === "downstreamBCsettingport2"
				|| widgetName === "downstreamBCsettingport3"
				|| widgetName === "downstreamBCsettingport4"
				|| widgetName === "downstreamBCsettingport5"
				|| widgetName === "downstreamBCsettingport6") 
		{
			if (oldval != 0 && oldval != 1
					&& oldval != 2) 
			{
				oldval = "3";
			}
		}
		if ((oldval === newval)
				|| jQuery.isEmptyObject(newval)) 
		{
			// do nothing
			// If Port splitting is already
			// enabled and only GPIO needs to
			// be updated
		} 
		else if (checkdisabled) 
		{
			// Change detected but field is
			// disabled - So do nothing
			console.log("change detected but field disabled: widget:"
							+ widgetgroupname
							+ " new value:"
							+ newval);
		} 
		else 
		{
			deltaobj.push(widgetName, newval);
			modifiedWidgets.push(widgetName);
		}

	});
	// setwidget GwidgetlistRadio Ends

	// setwidget GwidgetlistDropDown Start
	$.each(GwidgetlistDropDown, function(index2, value1) 
	{
		if (value1 === "PHYBOOSTdownstreamport1"
				|| value1 === "PHYBOOSTdownstreamport2"
				|| value1 === "PHYBOOSTdownstreamport3"
				|| value1 === "PHYBOOSTdownstreamport4"
				|| value1 === "PHYBOOSTdownstreamport5"
				|| value1 === "PHYBOOSTdownstreamport6"
				|| value1 === "SQUELCHdownstreamport1"
				|| value1 === "SQUELCHdownstreamport2"
				|| value1 === "SQUELCHdownstreamport3"
				|| value1 === "SQUELCHdownstreamport4"
				|| value1 === "SQUELCHdownstreamport5"
				|| value1 === "SQUELCHdownstreamport6"
				|| value1 === "downstreamport1HsRiseFall"
				|| value1 === "downstreamport2HsRiseFall"
				|| value1 === "downstreamport3HsRiseFall"
				|| value1 === "downstreamport4HsRiseFall"
				|| value1 === "downstreamport5HsRiseFall"
				|| value1 === "downstreamport6HsRiseFall")
				//|| value1 === "flexport"
		{
			// do nothing
		} 
		else 
		{
			var nameofcontrol = "." + value1 + "1";
			var nameofcontrol1 = "[data-bind=\"" + value1+ "label\"]";
			var selText = $(nameofcontrol).find(nameofcontrol1).text();
			var newindexofdropdownlist;
			var that = $(nameofcontrol), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop("disabled");
			if (value1 == "PHYBOOST") 
			{
				newindexofdropdownlist = DropDownPHYBOOST.indexOf(selText);
			}
			if (value1 === "SQUELCH") 
			{
				newindexofdropdownlist = DropDownSQUELCH.indexOf(selText);
			}
			if (value1 === "upstreamHsRiseFall") {
				newindexofdropdownlist = DropDownHSRiseFall.indexOf(selText);
			}

			var oldval = getWidgetValue(dummyHubID, value1);

			// TODO - Dropdown forced values
			if (newindexofdropdownlist != oldval) 
			{
				deltaobj.push(value1, newindexofdropdownlist);
				modifiedWidgets.push(value1);
			}
		}
	});

	var stringToSet = "";
	var wKey;
	var wVal;
	var flag = 0;

	if (deltaobj.length != 0) 
	{
		for (var i = deltaobj.length; i >= 0; i = i - 2) 
		{
			wKey = deltaobj[i];
			wVal = deltaobj[i + 1];
			if ((typeof wKey === 'undefined')
					|| (typeof wVal === 'undefined')) 
			{
				// Do nothing
			} 
			else 
			{
				stringToSet = wKey + ",,," + wVal + ";;;"+ stringToSet;
				flag++;
			}
		}
	}

	if (iniFile) 
	{
		iniFile_fullPath = getFullPathINI();
		modifiedWidgets.push("xdataprogram");
		stringToSet = "xdataprogram,,," + iniFile_fullPath+ ";;;" + stringToSet;
		flag++;
	}

	// Initializing the values with "-1".
	var regOptionChosen = -1;
	var Regadd = -1;
	var RegVal = -1;

	// Getting the data from the respective UI fields
	regOptionChosen = $("#Regoperationgroup").find(':checked').val();
	Regadd = $("#Regaddress").val();
	RegVal = $("#Regvalue").val();

	if ((regOptionChosen) && (Regadd) && (RegVal)) 
	{ 
		if (typeof regOptionChosen === 'undefined') 
		{
			alert("Please choose an appropriate action under the Direct Register Access.");
			errorFlag = true;
			return;
		}
		if (regOptionChosen == 0) 
		{
			Regop = "XMODE_WRITE_BYTE";
		} 
		else if (regOptionChosen == 1) 
		{
			Regop = "XMODE_SET_BITS";
		} 
		else if (regOptionChosen == 2) 
		{
			Regop = "XMODE_CLEAR_BITS"
		} 
		else 
		{
			Regop = "";
			// do nothing
		}

		var isOKAddr = /^[0-9A-Fa-f]{8}$/i.test(Regadd);
		var newRegVal = RegVal.replace(/\s+/g, "");
		var isOKVal = /^[0-9A-Fa-f]+$/i.test(newRegVal);

		if ((Regadd == "") || (RegVal == "")) 
		{
			alert("Either the value of register address or the register value is not entered under the Direct Register Access.");
			errorFlag = true;
			return;
		}
		if (!isOKAddr) 
		{
			alert("The Register Address entered under the Direct Register Access must be a 8 digit hexadecimal number.");
			errorFlag = true;
		}

		if (!isOKVal) 
		{
			alert("The Register value entered under the Direct Register Access is not a valid hexadecimal number.");
			errorFlag = true;
		}

		if (isOKAddr && isOKVal) 
		{
			if (Regop.length == 0) 
			{
				alert("Please choose appropriate register operation.");
				errorFlag = true;
			} 
			else 
			{
				if (Regadd && RegVal) 
				{
					if (RegString) 
					{
						RegString = Regop + "+" + Regadd + "+" + newRegVal + "+" + RegString;
					} 
					else 
					{
						RegString = Regop + "+" + Regadd + "+" + newRegVal;
					}
				} 
				else 
				{
					alert("Either Register address or Register value is not added.");
					errorFlag = true;
				}
			}
		}
	}

	if (RegString) 
	{
		stringToSet = "xdataentry,,," + RegString + ";;;" + stringToSet;
		modifiedWidgets.push("xdataentry");
		flag++;
	}
	if((gb_minihostruletype === "01") && (vidpid_vid != "") && (vidpid_pid != "") && (vidpid_conn != "") && (vidpid_ruleid != ""))
	{
		if(gb_vidpidString != "")
		{
			gb_vidpidString = vidpid_idx + "+" + vidpid_vid + "+" + vidpid_pid + "+" + vidpid_conn + "+"+ vidpid_ruleid + "+" + gb_vidpidString;
		}
		else
		{
			gb_vidpidString = vidpid_idx + "+" + vidpid_vid + "+" + vidpid_pid + "+" + vidpid_conn + "+"+ vidpid_ruleid;
		}
		gb_newvidpidrule = true;
	}
	if((gb_minihostruletype === "11") && (vidpidmask_vid != "") && (vidpidmask_pid != "") && (vidpidmask_vidpidmsk != "") && (vidpidmask_ruleid != "") && (vidpidmask_conn != ""))
	{
		if(gb_vidpidmaskString != "")
		{
			gb_vidpidmaskString = vidpidmask_idx + "+" + vidpidmask_vid + "+" + vidpidmask_pid + "+" + vidpidmask_vidpidmsk + "+" + vidpidmask_conn + "+"+ vidpidmask_ruleid + "+" + gb_vidpidmaskString;
		}
		else
		{
			gb_vidpidmaskString = vidpidmask_idx + "+" + vidpidmask_vid + "+" + vidpidmask_pid + "+" + vidpidmask_vidpidmsk + "+" + vidpidmask_conn + "+"+ vidpidmask_ruleid;
		}
		gb_newvipidmaskrule = true;
	}
	if((gb_minihostruletype === "10") && (deviceclass_class != "") && (deviceclass_conn != "") && (deviceclass_ruleid != ""))
	{
		if(gb_deviceclassString != "")
		{
			gb_deviceclassString = deviceclass_idx + "+"  +  deviceclass_class + "+" + deviceclass_conn + "+" + deviceclass_ruleid + "+" + gb_deviceclassString;
		}
		else
		{
			gb_deviceclassString = deviceclass_idx + "+"  +  deviceclass_class + "+" + deviceclass_conn + "+" + deviceclass_ruleid;
		}
		gb_newdeviceclassrule = true;
	}
	if(gb_newvidpidrule == true)
	{
		// Use one more variable to store values even if preview changes is
		// clicked
		if(vidpidrulevalues == "")
		{
			vidpidrulevalues = vidpidrulevalues + gb_vidpidString;
		}
		else if((vidpidrulevalues != "") && (gb_vidpidString != ""))
		{
			vidpidrulevalues = vidpidrulevalues + "+" + gb_vidpidString;
		}
		stringToSet = "minihost_vidpidrule,,," + gb_vidpidrulecnt + "+" + vidpidrulevalues + ";;;" + stringToSet;
		modifiedWidgets.push("minihost_vidpidrule");
		flag++;
	}
	if(gb_newvipidmaskrule == true)
	{
		// Use one more variable to store values even if preview changes is
		// clicked
		if(vidpidmaskrulevalues == "")
		{
			vidpidmaskrulevalues = vidpidmaskrulevalues + gb_vidpidmaskString;
		}
		else if((vidpidmaskrulevalues != "") && (gb_vidpidmaskString != ""))
		{
			vidpidmaskrulevalues = vidpidmaskrulevalues + "+" + gb_vidpidmaskString;
		}
		stringToSet = "minihost_vidpidmaskrule,,," + gb_vidpidmaskrulecnt + "+" + vidpidmaskrulevalues + ";;;" + stringToSet;
		modifiedWidgets.push("minihost_vidpidmaskrule");
		flag++;
	}
	if(gb_newdeviceclassrule == true)
	{
		// Use one more variable to store values even if preview changes is
		// clicked
		if(deviceclassrulevalues == "")
		{
			deviceclassrulevalues = deviceclassrulevalues + gb_deviceclassString;
		}
		else if((deviceclassrulevalues != "") && (gb_deviceclassString != ""))
		{
			deviceclassrulevalues = deviceclassrulevalues + "+" + gb_deviceclassString;
		}
		stringToSet = "minihost_deviceclassrule,,," + gb_deviceclassrulecnt + "+" + deviceclassrulevalues + ";;;" + stringToSet;
		modifiedWidgets.push("minihost_deviceclassrule");
		flag++;
	}
	var displayChange = "";
	for (var i = 0; i < modifiedWidgets.length; i++) 
	{
		if (i % 4 == 0) 
		{
			if (displayChange) 
			{
				if(typeof Mapping[modifiedWidgets[i]] === 'undefined')
				{
					if(gb_sku === "USB7202")
					{
						displayChange = "\n"
						+ USB7202_Mapping[modifiedWidgets[i]] + ", "
						+ displayChange;
					}
					else if(gb_sku === "USB7250" || gb_sku === "USB7251" || gb_sku === "USB7252")
					{
						displayChange = "\n"
						+ USB725x_Mapping[modifiedWidgets[i]] + ", "
						+ displayChange;
					}
					else if(gb_sku === "USB7216" || gb_sku === "USB7256")
					{
						displayChange = "\n"
						+ USB7256_Mapping[modifiedWidgets[i]] + ", "
						+ displayChange;
					}
					else if(gb_sku === "USB7206")
					{
						displayChange = "\n"
						+ Mapping[modifiedWidgets[i]] + ", "
						+ displayChange;
					}
				}
				else
				{
					displayChange = "\n"
						+ Mapping[modifiedWidgets[i]] + ", "
						+ displayChange;
				}
			} 
			else 
			{
				if(typeof Mapping[modifiedWidgets[i]] === 'undefined')
				{
					if(gb_sku === "USB7202")
					{
						displayChange = USB7202_Mapping[modifiedWidgets[i]];
					}
					else if(gb_sku === "USB7250" || gb_sku === "USB7251" || gb_sku === "USB7252")
					{
						displayChange = USB725x_Mapping[modifiedWidgets[i]];
					}
					else if(gb_sku === "USB7216" || gb_sku === "USB7256")
					{
						displayChange = USB7256_Mapping[modifiedWidgets[i]];
					}
					else if(gb_sku === "USB7206")
					{
						displayChange = Mapping[modifiedWidgets[i]];
					}
				}
				else
				{
					displayChange = Mapping[modifiedWidgets[i]];
				}
			}
		} 
		else 
		{
			if (displayChange) 
			{
				if(typeof Mapping[modifiedWidgets[i]] === 'undefined')
				{
					if(gb_sku === "USB7202")
					{
						displayChange = USB7202_Mapping[modifiedWidgets[i]] + ", " + displayChange;
					}
					else if(gb_sku === "USB7250" || gb_sku === "USB7251" || gb_sku === "USB7252")
					{
						displayChange = USB725x_Mapping[modifiedWidgets[i]] + ", " + displayChange;
					}
					else if(gb_sku === "USB7216" || gb_sku === "USB7256")
					{
						displayChange = USB7256_Mapping[modifiedWidgets[i]] + ", " + displayChange;
					}
					else if(gb_sku === "USB7206")
					{
						displayChange = Mapping[modifiedWidgets[i]] + ", " + displayChange;
					}
				}
				else
				{
					displayChange = Mapping[modifiedWidgets[i]] + ", " + displayChange;
				}
			}
		}
	}

	if (flag == 0 && errorFlag == false) 
	{
		alert("No changes detected for offline configuration.");
		update_status_message("No changes detected for offline configuration.");
	} 
	else 
	{
		if (errorFlag === false) 
		{
			var option = confirm("Configuration file will be generated with the following device settings\n"
					+ displayChange);

			if (option) 
			{
				var result = setOfflineConfiguration(HUB_FAMILY_INDEX, stringToSet, "0");

				if (result) 
				{
					alert("Offline configuration was created successfully");
					update_status_message("Offline configuration was created successfully for the following widgets.\n"
							+ displayChange);
				} 
				else 
				{
					alert("Offline configuration failed.");
					update_status_message("Offline configuration failed.");
				}
			} 
			else 
			{
				update_status_message("Generation of configuration file was terminated by the user.");
			}

			//clean up
			numberofportState = false;
			enable_lpm = false;
			enable_swapupstreamdpdm = false;
			hceenablemanu = false;
			hceenableprod = false;
			hceenableser = false;

			//Variables are reverted to Zero
			resetVariables();
			//document.getElementById("copyNCM").checked = false;
			Reset_innerHTML();
			
			$("#vidpidmaskrule").hide();
			$("#vidpidrule").hide();
			$("#deviceclassrule").hide();
			$('#addminihostrule').hide();
			$('#minihostoverwriteexistingrule').hide();
			var nameofcontrol = ".minihostruletype";
			var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
			$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
			.children('.dropdown-toggle').dropdown('toggle');
			var nameofcontrol = ".minihostexistingrule";
			var nameofcontrol1 = "[data-bind=\"" + "minihostexistingrule" + "label\"]";
			$(nameofcontrol).find(nameofcontrol1).text("Select Rule Index")
			.children('.dropdown-toggle').dropdown('toggle');
			$('#minihostruleindex').hide();
			Reset_miniHostDiv();
			Reset_miniHostVariables();
			gApply = false;
		} 
		else 
		{
		}
	}
});

function resetVariables() {
		 vid_check = 0;
         usb3vid_check = 0;
         pid_check = 0;
         usb3pid_check = 0;
         did_check = 0;
         usb3did_check = 0;
         usbvcd_check = 0;
         usb3vcd_check = 0;
         hce_vid_check = 0;
         hce_pid_check = 0;
         hce_did_check = 0;
         hce_languageid_check = 0;
         hce1_vid_check = 0;
         hce1_pid_check = 0;
         hce1_did_check = 0;
         hce1_languageid_check = 0;
         hce1_macaddr_check = 0;
		 hce1_eapinterface_check = 0;
         hce2_vid_check = 0;
         hce2_pid_check = 0;
         hce2_did_check = 0;
         hce2_languageid_check = 0;
         hce2_macaddr_check = 0;
		 hce2_eapinterface_check = 0;
         languageid_check = 0;
         usb3languageid_check = 0;
         manufacturer_check = 0;
         usb3manufacturer_check = 0;
         product_check = 0;
         usb3product_check = 0;
         serial_check = 0;
         usb3serial_check = 0;
         hce_manufacturer_check = 0;
         hce_product_check = 0;
         hce_serial_check =0;
         hce1_manufacturer_check = 0;
         hce1_product_check = 0;
		 hce1_eapproduct_check = 0;
         hce1_string5_check = 0;
         hce2_manufacturer_check = 0;
         hce2_product_check = 0;
		 hce2_eapproduct_check = 0;
         hce2_string5_check = 0;
         usb3uuid_check = 0;
         i2senablegroup_check = 0;
		 i2senablehid_check = 0;
         i2senablehidgroup_check = 0;
         maxpowerself_check = 0;
         hubcmaxpowerself_check = 0;
         maxpowerbus_check = 0;
         hubcmaxpowerbus_check = 0;
         power_ontime_check = 0;
         flexconnect_check = 0;
    		 usb3flexconnect_check = 0;
         //copyNCM_check = 0;
         hsdisable_check = 0;
         hceenable_check = 0;
         lpmenable_check = 0;
		 
         swapupstreamdpdm_check = 0;
         swapport1dpdm_check = 0;
         swapport2dpdm_check = 0;
         swapport3dpdm_check = 0;
         swapport4dpdm_check = 0;
         swapport5dpdm_check = 0;
    		 swapport6dpdm_check = 0;
		 
         nrdeviceport1_check = 0;
         nrdeviceport2_check = 0;
         nrdeviceport3_check = 0;
         nrdeviceport4_check = 0;
		     nrdeviceport5_check = 0;
    		 nrdeviceport6_check = 0;
		 
         enableport1_check = 0;
         enableport2_check = 0;
         enableport3_check = 0;
         enableport4_check = 0;
         enableport5_check = 0;
		     enableport6_check = 0;
		 
  	  	 usb3nrdeviceport1_check = 0;
	  	   usb3nrdeviceport2_check = 0;
	       usb3nrdeviceport3_check = 0;
	       usb3nrdeviceport4_check = 0;
	       usb3nrdeviceport5_check = 0;
		 
  		   usb3enableport1_check = 0;
  	     usb3enableport2_check = 0;
  	     usb3enableport3_check = 0;
  	     usb3enableport4_check = 0;
  	     usb3enableport5_check = 0;
		 
         hubpowergroup_check = 0;
         cdcenable_check = 0;
         downstreamBCsettingport1group_check = 0;
         downstreamBCsettingport2group_check = 0;
         downstreamBCsettingport3group_check = 0;
         downstreamBCsettingport4group_check = 0;
    		 downstreamBCsettingport5group_check = 0;
    		 downstreamBCsettingport6group_check = 0;
		 
         PHYBOOSTUL_check = 0;
         PHYBOOSTULdownstreamport1_check = 0;
         PHYBOOSTULdownstreamport2_check = 0;
         PHYBOOSTULdownstreamport3_check = 0;
         PHYBOOSTULdownstreamport4_check = 0;
         PHYBOOSTULdownstreamport5_check = 0;
		     PHYBOOSTULdownstreamport6_check = 0;
		 
         SQUELCHUL_check = 0;
         SQUELCHULdownstreamport1_check = 0;
         SQUELCHULdownstreamport2_check = 0;
         SQUELCHULdownstreamport3_check = 0;
         SQUELCHULdownstreamport4_check = 0;
         SQUELCHULdownstreamport5_check = 0;
		     SQUELCHULdownstreamport6_check = 0;
		 
         downstreamport1HsRiseFallUL_check = 0;
         downstreamport2HsRiseFallUL_check = 0;
         downstreamport3HsRiseFallUL_check = 0;
         downstreamport4HsRiseFallUL_check = 0;
         downstreamport5HsRiseFallUL_check = 0;
		     downstreamport6HsRiseFallUL_check = 0;
		 
         upstreamHsRiseFallUL_check = 0;
    		 MiniHost_Vid_check = 0;
    		 MiniHost_Pid_check = 0;
    		 MiniHost_VidMask_check = 0;
    		 MiniHost_PidMask_check = 0;
    		 minihostconnect_check = 0;
         iniFileID_check = 0;
		 
    		 pstimeoutgroup_check = 0;
    		 port3splittinggroup_check = 0;
    		 port4splittinggroup_check = 0;
    		 port5splittinggroup_check = 0;
		 
  		 pdport1_check =0;
  		 pdport3_check =0;
  		 pdupstream_check =0;
		 
  		gb_minihostruletype = "";
  		gb_connectiontype;
  		gb_vidpidrulecnt =0;
      gblivevidpidrulecnt = 0;
  		gb_vidpidmaskrulecnt =0;
      gblivevidpidmaskrulecnt =0;
  		gb_deviceclassrulecnt =0;
      gblivedeviceclassrulecnt;
  		gb_existingruleidx=0;
  		gb_vidpidString="";
  		gb_vidpidmaskString ="";
  		gb_deviceclassString ="";
  		gb_newvidpidrule = false;
  		gb_newvipidmaskrule = false;
  		gb_newdeviceclassrule = false;
  		vidpidrulevalues ="";
  		vidpidmaskrulevalues ="";
  		deviceclassrulevalues="";
  		vidpid_idx = 0, vidpid_vid = 0, vidpid_pid =0 ,vidpid_ruleid = 0;
  		vidpidmask_idx = 0, vidpidmask_vid = 0, vidpidmask_pid =0 ,vidpidmask_vidpidmsk =0, vidpidmask_ruleid = 0;
  		deviceclass_idx = 0,deviceclass_ruleid = 0;

}
function Determine_BCDescription(BCValue) 
{
	// Remove 0x from value
	BCValue.replace("0x", "");
	// Convert string to hex
	var iBCValue = parseInt(BCValue, 16);
	var BCDesc = "";
	if (iBCValue & 0x01) 
	{
		BCDesc += "BC Enabled with ";
	} 
	else 
	{
		BCDesc += "BC Disabled with "
	}
	if (iBCValue & 0x20) // BC Mode
	{
		BCDesc = "1.2 DCP, ";
	}
	if (((iBCValue & 0x06) >> 1) == 0x03) 
	{
		BCDesc += "Omega 2.5A Mode ";
	} 
	else if (((iBCValue & 0x06) >> 1) == 0x02) 
	{
		BCDesc += "Omega 2A Mode ";
	} 
	else if (((iBCValue & 0x06) >> 1) == 0x01) 
	{
		BCDesc += "Omega 1A Mode ";
	} 
	else 
	{
		BCDesc += "Omega Mode Disabled ";
	}
	if (iBCValue & 0x10) // chine mode
	{
		BCDesc += "and China Mode Enabled ";
	}
	if (iBCValue & 0x08) 
	{
		BCDesc += "and SAMSUNG Mode Enabled";
	}
	return BCDesc;
}
function Reset_minihostvidpidRules()
{
	document.getElementById("vidpidrule_vid").value="";
	document.getElementById("vidpidrule_pid").value="";
	document.getElementById("vidpidrule_ruleid").value ="";
	var nameofcontrol = ".setvidpidruleconnectiontype";
	var nameofcontrol1 = "[data-bind=\"" + "setvidpidruleconnectiontype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select connection type")
	.children('.dropdown-toggle').dropdown('toggle');
}	
function Reset_minihostvidpidmaskRules()
{
	document.getElementById("vidpidmaskrule_vid").value="";
	document.getElementById("vidpidmaskrule_pid").value="";
	document.getElementById("vidpidmaskrule_vidpidmask").value ="";
	document.getElementById("vidpidmaskrule_ruleid").value ="";
	var nameofcontrol = ".setvidpidmaskruleconnectiontype";
	var nameofcontrol1 = "[data-bind=\"" + "setvidpidmaskruleconnectiontype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select connection type")
	.children('.dropdown-toggle').dropdown('toggle');
}
function Reset_deviceclassRules()
{
	document.getElementById("deviceclassrule_ruleid").value ="";
	var nameofcontrol = ".setdeviceclassruleconnectiontype";
	var nameofcontrol1 = "[data-bind=\"" + "setdeviceclassruleconnectiontype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select connection type")
	.children('.dropdown-toggle').dropdown('toggle');
	nameofcontrol = ".setdeviceclasstype";
	nameofcontrol1 = "[data-bind=\"" + "setdeviceclasstype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Device class")
	.children('.dropdown-toggle').dropdown('toggle');
}
function Reset_miniHostVariables()
{
	gb_minihostruletype = "";
	gb_connectiontype;
	gb_vidpidrulecnt =0;
	gblivevidpidrulecnt = 0;
	gb_vidpidmaskrulecnt =0;
	gblivevidpidmaskrulecnt =0;
	gb_deviceclassrulecnt =0;
	gblivedeviceclassrulecnt;
	gb_existingruleidx=0;
	gb_vidpidString="";
	gb_vidpidmaskString ="";
	gb_deviceclassString ="";
	gb_newvidpidrule = false;
	gb_newvipidmaskrule = false;
	gb_newdeviceclassrule = false;
	vidpidrulevalues ="";
	vidpidmaskrulevalues ="";
	deviceclassrulevalues="";
	vidpid_idx = 0, vidpid_vid = 0, vidpid_pid =0 ,vidpid_ruleid = 0;
	vidpidmask_idx = 0, vidpidmask_vid = 0, vidpidmask_pid =0 ,vidpidmask_vidpidmsk =0, vidpidmask_ruleid = 0;
	deviceclass_idx = 0,deviceclass_ruleid = 0;
}
function Reset_miniHostDiv()
{
	Reset_deviceclassRules();
	Reset_minihostvidpidmaskRules();
	Reset_minihostvidpidRules();	
	var nameofcontrol = ".minihostruletype";
	var nameofcontrol1 = "[data-bind=\"" + "minihostruletype" + "label\"]";
	$(nameofcontrol).find(nameofcontrol1).text("Select Rule Type")
	.children('.dropdown-toggle').dropdown('toggle');
	$('#minihostoverwriteexistingrule').hide();
	$("#minihostoverwrite").prop("checked", false);
	$('#minihostruleindex').hide();
}
function Reset_innerHTML()
{
	if(gApply === false)
	{
		document.getElementById('port1typelabel').innerHTML = "Port 1 ";
		document.getElementById('port2typelabel').innerHTML = "Port 2 ";
		document.getElementById('port3typelabel').innerHTML = "Port 3 ";
		document.getElementById('port4typelabel').innerHTML = "Port 4 ";
		document.getElementById('port5typelabel').innerHTML = "Port 5 ";
		document.getElementById('port6typelabel').innerHTML = "Port 6 ";
	}
	
	document.getElementById('viderr').innerText  = "";
	document.getElementById('piderr').innerText  = "";
	document.getElementById('diderr').innerText  = "";
	document.getElementById('usbvcderr').innerText  = "";
	document.getElementById('languageiderr').innerText  = "";
	
	document.getElementById('usb3viderr').innerText  = "";
	document.getElementById('usb3piderr').innerText  = "";
	document.getElementById('usb3diderr').innerText  = "";
	document.getElementById('usb3vcderr').innerText  = "";
	document.getElementById('usb3languageiderr').innerText  = "";
	document.getElementById('usb3uuiderr').innerText  = "";
	
	document.getElementById('hce_viderr').innerText  = "";
	document.getElementById('hce_piderr').innerText  = "";
	document.getElementById('hce_diderr').innerText  = "";
	document.getElementById('hce_languageiderr').innerText  = "";
	
	document.getElementById('minihostvidpiderr').innerText  = "";
	document.getElementById('minihostvidpidmaskerr').innerText  = "";
	document.getElementById('minihostdeviceclasserr').innerText  = "";
}
function custom_dos_portorder(skuname)
{
	PortMap_default();		//USB7206 ports are in correct order. No need Change
	if(skuname === "USB7202")
	{
		//Change Order of Div based on Customer DOS
		$("#BPORT3fieldset").insertAfter("#BPORT1fieldset");
		$("#BPORT2fieldset").insertAfter("#BPORT3fieldset");
		$("#BPORT4fieldset").insertAfter("#BPORT2fieldset");
		
		//Advanced
		$("#PORT3fieldset").insertAfter("#PORT1fieldset");
		$("#PORT2fieldset").insertAfter("#PORT3fieldset");
		$("#PORT4fieldset").insertAfter("#PORT2fieldset");
		
		
		//Rename ports - Advanced
		PORT3fieldsetlabel.innerHTML = "Port 2";
		PORT2fieldsetlabel.innerHTML = "Port 3";
		PORT4fieldsetlabel.innerHTML = "Port 4";
		
		// Rename ports - Basic
		port3typelabel.innerText = "Port 2 ";
		port2typelabel.innerText = "Port 3 ";
		port4typelabel.innerText = "Port 4 ";

		usb2port3typelabel.innerText = "Enable Port 2";
		usb3port3typelabel.innerText = "Enable Port 2";
		
		usb2port2typelabel.innerText = "Enable Port 3";
		//usb3port2typelabel.innerText = "Enable Port 3"; //PP2 doe not have USB3
		
		usb2port4typelabel.innerText = "Enable Port 4";
		usb3port4typelabel.innerText = "Enable Port 4";
	}
	else if ((skuname === "USB7250") || (skuname === "USB7251")
			|| (skuname === "USB7252")) 
	{
		//Change Order of Div based on Customer DOS
		$("#BPORT3fieldset").insertAfter("#BPORT1fieldset");
		$("#BPORT5fieldset").insertAfter("#BPORT3fieldset");
		$("#BPORT2fieldset").insertAfter("#BPORT5fieldset");
		
		//Advanced
		$("#PORT3fieldset").insertAfter("#PORT1fieldset");
		$("#PORT5fieldset").insertAfter("#PORT3fieldset");
		$("#PORT2fieldset").insertAfter("#PORT5fieldset");
		
		
		//Rename ports - Advanced
		PORT3fieldsetlabel.innerHTML = "Port 2";
		PORT5fieldsetlabel.innerHTML = "Port 3";
		PORT2fieldsetlabel.innerHTML = "Port 4";
		
		// Rename ports - Basic
		port3typelabel.innerText = "Port 2 ";
		port5typelabel.innerText = "Port 3 ";
		port2typelabel.innerText = "Port 4 ";

		usb2port3typelabel.innerText = "Enable Port 2";
		usb3port3typelabel.innerText = "Enable Port 2";
				
		usb2port5typelabel.innerText = "Enable Port 3";
		usb3port5typelabel.innerText = "Enable Port 3";
		
		usb2port2typelabel.innerText = "Enable Port 4";
		//usb3port2typelabel.innerText = "Enable Port 3"; //PP2 doe not have USB3
	}
	else if(skuname === "USB7216" || gb_sku === "USB7256")
	{
		//Change Order of Div based on Customer DOS
		$("#BPORT3fieldset").insertAfter("#BPORT1fieldset");
		$("#BPORT4fieldset").insertAfter("#BPORT3fieldset");
		$("#BPORT5fieldset").insertAfter("#BPORT4fieldset");
		$("#BPORT2fieldset").insertAfter("#BPORT5fieldset");
		$("#BPORT6fieldset").insertAfter("#BPORT2fieldset");
		
		//Advanced
		$("#PORT3fieldset").insertAfter("#PORT1fieldset");
		$("#PORT4fieldset").insertAfter("#PORT3fieldset");
		$("#PORT5fieldset").insertAfter("#PORT4fieldset");
		$("#PORT2fieldset").insertAfter("#PORT5fieldset");
		$("#PORT6fieldset").insertAfter("#PORT2fieldset");
		
		
		//Rename ports - Advanced
		PORT3fieldsetlabel.innerHTML = "Port 2";
		PORT4fieldsetlabel.innerHTML = "Port 3";
		PORT5fieldsetlabel.innerHTML = "Port 4";
		PORT2fieldsetlabel.innerHTML = "Port 5";
		PORT6fieldsetlabel.innerHTML = "Port 6";
		
		// Rename ports - Basic
		port3typelabel.innerText = "Port 2 ";
		port4typelabel.innerText = "Port 3 ";
		port5typelabel.innerText = "Port 4 ";
		port2typelabel.innerText = "Port 5 ";
		port6typelabel.innerText = "Port 6 ";

		usb2port3typelabel.innerText = "Enable Port 2";
		usb3port3typelabel.innerText = "Enable Port 2";
				
		usb2port4typelabel.innerText = "Enable Port 3";
		usb3port4typelabel.innerText = "Enable Port 3";
		
		usb2port5typelabel.innerText = "Enable Port 4";
		usb3port5typelabel.innerText = "Enable Port 4";
		
		usb2port2typelabel.innerText = "Enable Port 5";
		
		usb2port6typelabel.innerText = "Enable Port 6";
		//usb3port6typelabel.innerText = "Enable Port 6"; //PP6 does not have USB3
	}
}
function PortMap_default()
{
	$("#usb3nrdeviceport1").prop("checked",false);
	$("#usb3nrdeviceport3").prop("checked",false);
	$("#usb3nrdeviceport4").prop("checked",false);
	$("#usb3nrdeviceport5").prop("checked",false);
	
	$("#nrdeviceport1").prop("checked",false);
	$("#nrdeviceport2").prop("checked",false);
	$("#nrdeviceport3").prop("checked",false);
	$("#nrdeviceport4").prop("checked",false);
	$("#nrdeviceport5").prop("checked",false);
	$("#nrdeviceport6").prop("checked",false);
	
	//Change Order of Div based on Customer DOS
	$("#BPORT2fieldset").insertAfter("#BPORT1fieldset");
	$("#BPORT3fieldset").insertAfter("#BPORT2fieldset");
	$("#BPORT4fieldset").insertAfter("#BPORT3fieldset");
	$("#BPORT5fieldset").insertAfter("#BPORT4fieldset");
	$("#BPORT6fieldset").insertAfter("#BPORT5fieldset");
	
	//Advanced
	$("#PORT2fieldset").insertAfter("#PORT1fieldset");
	$("#PORT3fieldset").insertAfter("#PORT2fieldset");
	$("#PORT4fieldset").insertAfter("#PORT3fieldset");
	$("#PORT5fieldset").insertAfter("#PORT4fieldset");
	$("#PORT6fieldset").insertAfter("#PORT5fieldset");
			
	//Rename ports - Advanced
	PORT1fieldsetlabel.innerHTML = "Port 1";
	PORT2fieldsetlabel.innerHTML = "Port 2";
	PORT3fieldsetlabel.innerHTML = "Port 3";
	PORT4fieldsetlabel.innerHTML = "Port 4";
	PORT5fieldsetlabel.innerHTML = "Port 5";
	PORT6fieldsetlabel.innerHTML = "Port 6";
	
	// Rename ports - Basic
	port1typelabel.innerText = "Port 1 ";
	port2typelabel.innerText = "Port 2 ";
	port3typelabel.innerText = "Port 3 ";
	port4typelabel.innerText = "Port 4 ";
	port5typelabel.innerText = "Port 5 ";
	port6typelabel.innerText = "Port 6 ";

	
	usb2port2typelabel.innerText = "Enable Port 2";
	usb3port2typelabel.innerText = "Enable Port 2"; 
	
	usb2port3typelabel.innerText = "Enable Port 3";
	usb3port3typelabel.innerText = "Enable Port 3";
			
	usb2port4typelabel.innerText = "Enable Port 4";
	usb3port4typelabel.innerText = "Enable Port 4";
	
	usb2port5typelabel.innerText = "Enable Port 5";
	usb3port5typelabel.innerText = "Enable Port 5";

	usb2port6typelabel.innerText = "Enable Port 6";
	//usb3port6typelabel.innerText = "Enable Port 6"; //PP6 does not have USB3
}