//var LAN_FAMILY_INDEX = "0";
var changecount = 0;
var Product = getProduct();
var change = 0;

//Widget IDs of String fields in the GUI
var GwidgetlistString = [
	"macaddr"
];

//Widget IDs of Hex fields in the GUI
var GwidgetValuelistHex = [
	"subsystemvid",
	"subsystemid"
];

//Widget IDs of Checkbox fields in the GUI
var GwidgetCheckbox = [
	"LED0Enable",
	"LED1Enable",
	"LED2Enable",
	"LED3Enable"
];

var GwidgetlistDropDown = [
	"LED0Function",
	"LED1Function",
	"LED2Function",
	"LED3Function",
	"auxcurrent",
	"pmeSupport",
	"L0Latency",
	"L1Latency",
	"OBFFSupport"
];

var DropDownLEDListFunction = [
	"Link/Activity",
	"Link1000/Activity",
	"Link100/Activity",
	"Link10/Activity",
	"Link100/1000/Activity",
	"Link10/1000/Activity",
	"Link10/100/Activity",
	"Reserved",
	"Duplex/Collision",
	"Collision",
	"Activity",
	"Reserved",
	"Auto-Negotiation Fault",
	"Serial Mode",
	"Force LED Off",
	"Force LED On"
];

var auxcurrentFunction = [
	"0 mA",
	"55 mA",
	"100 mA",
	"160 mA",
	"220 mA",
    "270 mA",
	"320 mA",
	"375 mA"
];

var pmeFunction = [
    "D0",
	"D3 Hot",
	"D3 Cold"
];

var L0LatencyFunction = [
    "1 us",
	"2 us",
	"3 us",
	"4 us",
	"5 us",
	"6 us",
	"7 us"
];

var L1LatencyFunction = [
   "1 us",
	"2 us",
	"4 us",
	"8 us",
	"16 us",
	"32 us",
	"64 us"	
];

var OBFFSupportFunction = [
   "Not Supported",
	"Supported using message Signaling only",
	"Supported using WAKE# Signaling only",
	"Supported using WAKE# and message signaling"
];
//Widget IDs of Radio fields in the GUI
var GwidgetlistRadio = [
	"LED0CombineEnable",
	"LED1CombineEnable",
	"LED2CombineEnable",
	"LED3CombineEnable",
	"LED0",
	"LED1",
	"LED2",
	"LED3",
	"LED0Polarity",
	"LED1Polarity",
	"LED2Polarity",
	"LED3Polarity",
	"LEDActivity",
	"LEDRate",
	"LEDPulsing",
	"ClkPowerEnable",
	"LTRSupport",
	"ASPMControl",
	"L1PMSubstates",
	"PciPmL1",
	"PciPmL2",
	"ASPML2",
	"ASPML1",
	"macSpeedDetect",
	"macConfiguration",
	"macDuplexDetection",
	"macDuplexMode",
	"macDuplexPolarity",
	"macEEETxClkStopEnable",
	"macRgmiiTxDelayEnable",
	"macRgmiiRxEnable",
	"macClk125Enable",
	"macRefClk25Enable",
	"macEEEEnable"
];

(function ($) {
    disable_fields = function () {
		$("#MAC_Section").attr('disabled', true);
		$("#config_Section").attr('disabled', true);
		$("#DI_Hex_Section").attr('disabled', true);
		$("#devicecap2_Section").attr('disabled', true);
		$("#DeviceCap_Section").attr('disabled', true);
		$("#powerTab_Section").attr('disabled', true);
		$("#ASPM_Section").attr('disabled', true);
		$("#PM_Section").attr('disabled', true);
		$("#macconfig_Section").attr('disabled', true);
		$("#LEDBehavior_Section").attr('disabled', true);
		$("#LED0_Section").attr('disabled', true);
		$("#LED1_Section").attr('disabled', true);
		$("#LED2_Section").attr('disabled', true);
		$("#LED3_Section").attr('disabled', true);
		$('#RemoveTableSection').hide();
    };
})(jQuery);

(function ($) {
    enable_fields = function () {
		$("#MAC_Section").attr('disabled', false);
		$("#config_Section").attr('disabled', false);
		$("#DI_Hex_Section").attr('disabled', false);
		$("#devicecap2_Section").attr('disabled', false);
		$("#DeviceCap_Section").attr('disabled', false);
		$("#powerTab_Section").attr('disabled', false);
		$("#ASPM_Section").attr('disabled', false);
		$("#PM_Section").attr('disabled', false);
		$("#macconfig_Section").attr('disabled', false);
		$("#LEDBehavior_Section").attr('disabled', false);
		$("#LED0_Section").attr('disabled', false);
		$("#LED1_Section").attr('disabled', false);
		$("#LED2_Section").attr('disabled', false);
		$("#LED3_Section").attr('disabled', false);
	};
})(jQuery);

//Function to switch load and save Preference
function switchloadsave(changecount) {
	if(changecount!=0)
	{
		$('#LoadFileField').hide();
		$('#LoadFileField').attr('disabled', 'disabled');
		$('#SaveFileField').removeAttr('disabled');
		$('#SaveFileField').show();
		$("#Apply").attr('disabled', false);	
	}else{
		$('#SaveFileField').hide();
		$('#SaveFileField').attr('disabled', 'disabled');
		$('#LoadFileField').removeAttr('disabled');
		$('#LoadFileField').show();
		$("#Apply").attr('disabled', true);	
	}
}
$("#macaddr").change(function () {
	maconlyConfig = true;
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macaddr");
	var newval = $("#macaddr").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macaddr_check > 0) {
			macaddr_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (macaddr_check == 0) {
			changecount = changecount+1;
		}
		macaddr_check++;
	}
	switchloadsave(changecount);
});

$(document).on('change', 'input[id="userAddress"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	changecount = changecount+1;
	switchloadsave(changecount);
			
});

$(document).on('change', 'input[id="byteEnable1"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($(this).is(':checked')) {
		if(($(this).siblings("input[id='userValue1']").val()) == "") {
			$(this).siblings("input[id='userValue1']").val("00");
			
		}
	} else {
		$(this).siblings("input[id='userValue1']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

$(document).on('change', 'input[id="byteEnable2"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($(this).is(':checked')) {
		if(($(this).siblings("input[id='userValue2']").val()) == "") {
			$(this).siblings("input[id='userValue2']").val("00");
			
		}
	} else {
		$(this).siblings("input[id='userValue2']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

$(document).on('change', 'input[id="byteEnable3"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($(this).is(':checked')) {
		if(($(this).siblings("input[id='userValue3']").val()) == "") {
			$(this).siblings("input[id='userValue3']").val("00");
			
		}
	} else {
		$(this).siblings("input[id='userValue3']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

$(document).on('change', 'input[id="byteEnable4"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($(this).is(':checked')) {
		if(($(this).siblings("input[id='userValue4']").val()) == "") {
			$(this).siblings("input[id='userValue4']").val("00");
			
		}
	} else {
		$(this).siblings("input[id='userValue4']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

function updateFCWValue() {
	$(event.target).closest('div').parent().parent().parent().addClass("highlight");
	changecount = changecount+1;
	switchloadsave(changecount);
}

$(document).on('change', 'input[id="userValue1"]', function() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
	
	if(($(this).val()) == "") {
		$(this).siblings("input[id='byteEnable1']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable1']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
	changecount = changecount+1;
	switchloadsave(changecount);		
});
	
$(document).on('change', 'input[id="userValue2"]', function() {
	if(($(this).val()) == "") {
		$(this).siblings("input[id='byteEnable2']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable2']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
	changecount = changecount+1;
	switchloadsave(changecount);		
});

function value1Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}

function value2Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}

function value3Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}

function value4Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}

$(document).on('change', 'input[id="userValue3"]', function() {
	if(($(this).val()) == "") {
		$(this).siblings("input[id='byteEnable3']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable3']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
	changecount = changecount+1;
	switchloadsave(changecount);		
});

$(document).on('change', 'input[id="userValue4"]', function() {
	if(($('this').val()) == "") {
		$(this).siblings("input[id='byteEnable4']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable4']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
	changecount = changecount+1;
	switchloadsave(changecount);		
});


$("#subsystemvid").change(function () {
	var oldval = parseInt(getLANWidgetValue(LAN_FAMILY_INDEX, "subsystemvid"), 10);
	var newval = parseInt($("#subsystemvid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (subsystemvid_check > 0) {
			subsystemvid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (subsystemvid_check == 0) {
			changecount = changecount+1;
		}
		subsystemvid_check++;
	}
	switchloadsave(changecount);
});

$("#byteOffset").change(function () {
	var oldval = 0;
	var newval = parseInt($("#byteOffset").val(), 16);
	
	if (oldval == newval) {
		RegString = false;
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (subsystemvid_check > 0) {
			subsystemvid_check = 0;
		}
	} else {
		RegString = true;
		if (byteOffset_check == 0) {
			changecount = changecount+1;
		}
		byteOffset_check++;
	}
	switchloadsave(changecount);
});

$("#subsystemid").change(function () {
	var oldval = parseInt(getLANWidgetValue(LAN_FAMILY_INDEX, "subsystemid"), 10);
	var newval = parseInt($("#subsystemid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (subsystemid_check > 0) {
			subsystemid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (subsystemid_check == 0) {
			changecount = changecount+1;
		}
		subsystemid_check++;
	}
	switchloadsave(changecount);
});

$("#LED0Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED0Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED0Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED0Enable_check > 0) {
			LED0Enable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED0Enable_check == 0) {
			changecount = changecount+1;
		}
		LED0Enable_check++;
	}
	switchloadsave(changecount);
});

$("#LED1Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED1Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED1Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED1Enable_check > 0) {
			LED1Enable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED1Enable_check == 0) {
			changecount = changecount+1;
		}
		LED1Enable_check++;
	}
	switchloadsave(changecount);
});

$("#LED2Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED2Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED2Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED2Enable_check > 0) {
			LED2Enable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED2Enable_check == 0) {
			changecount = changecount+1;
		}
		LED2Enable_check++;
	}
	switchloadsave(changecount);
});

$("#LED3Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED3Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED3Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED3Enable_check > 0) {
			LED3Enable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED3Enable_check == 0) {
			changecount = changecount+1;
		}
		LED3Enable_check++;
	}
	switchloadsave(changecount);
});

$("#LED0CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED0CombineEnable");
	var newval = $("#LED0CombineEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED0CombineEnable_check > 0) {
			LED0CombineEnable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED0CombineEnable_check == 0) {
		changecount = changecount+1;
		}
		LED0CombineEnable_check++;
	}
	switchloadsave(changecount);
});


$("#LED1CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED1CombineEnable");
	var newval = $("#LED1CombineEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED1CombineEnable_check > 0) {
			LED1CombineEnable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED1CombineEnable_check == 0) {
		changecount = changecount+1;
		}
		LED1CombineEnable_check++;
	}
	switchloadsave(changecount);
});

$("#LED2CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED2CombineEnable");
	var newval = $("#LED2CombineEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED2CombineEnable_check > 0) {
			LED2CombineEnable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED2CombineEnable_check == 0) {
		changecount = changecount+1;
		}
		LED2CombineEnable_check++;
	}
	switchloadsave(changecount);
});

$("#LED3CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED3CombineEnable");
	var newval = $("#LED3CombineEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED3CombineEnable_check > 0) {
			LED3CombineEnable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED3CombineEnable_check == 0) {
		changecount = changecount+1;
		}
		LED3CombineEnable_check++;
	}
	switchloadsave(changecount);
});

$("#LED0Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED0");
	var newval = $("#LED0Group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED0_check > 0) {
			LED0_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED0_check == 0) {
		changecount = changecount+1;
		}
		LED0_check++;
	}
	switchloadsave(changecount);
});

$("#LED1Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED1");
	var newval = $("#LED1Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED1_check > 0) {
			LED1_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED1_check == 0) {
		changecount = changecount+1;
		}
		LED1_check++;
	}
	switchloadsave(changecount);
});

$("#LED2Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED2");;
	var newval = $("#LED2Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED2_check > 0) {
			LED2_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED2_check == 0) {
		changecount = changecount+1;
		}
		LED2_check++;
	}
	switchloadsave(changecount);
});


$("#LED3Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED3");
	var newval = $("#LED3Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED3_check > 0) {
			LED3_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LED3_check == 0) {
		changecount = changecount+1;
		}
		LED3_check++;
	}
	switchloadsave(changecount);
});

$("#LEDRateGroup").change(function () {
	
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LEDRate");
	var newval = $("#LEDRateGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LEDRate_check > 0) {
			LEDRate_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LEDRate_check == 0) {
		changecount = changecount+1;
		}
		LEDRate_check++;
	}
	switchloadsave(changecount);
});


$("#LEDPulsingGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LEDPulsing");
	var newval = $("#LEDPulsingGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LEDPulsing_check > 0) {
			LEDPulsing_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (LEDPulsing_check == 0) {
		changecount = changecount+1;
		}
		LEDPulsing_check++;
	}
	switchloadsave(changecount);
});

$("#LED0PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED0Polarity");
	var newval = $("#LED0PolarityGroup").find(':checked').val();
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED0Polarity_check > 0) {
			LED0Polarity_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (LED0Polarity_check == 0) {
			changecount = changecount+1;
		}
		LED0Polarity_check++;
	}
	switchloadsave(changecount);
});

$("#LED1PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED1Polarity");
	var newval = $("#LED1PolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED1Polarity_check > 0) {
			LED1Polarity_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (LED1Polarity_check == 0) {
			changecount = changecount+1;
		}
		LED1Polarity_check++;
	}
	switchloadsave(changecount);
});

$("#LED2PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED2Polarity");
	var newval = $("#LED2PolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED2Polarity_check > 0) {
			LED2Polarity_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (LED2Polarity_check == 0) {
			changecount = changecount+1;
		}
		LED2Polarity_check++;
	}
	switchloadsave(changecount);
});

$("#LED3PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LED3Polarity");
	var newval = $("#LED3PolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED3Polarity_check > 0) {
			LED3Polarity_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (LED3Polarity_check == 0) {
			changecount = changecount+1;
		}
		LED3Polarity_check++;
	}
	switchloadsave(changecount);
});

$("#LEDActivityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LEDActivity");
	var newval = $("#LEDActivityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LEDActivity_check > 0) {
			LEDActivity_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (LEDActivity_check == 0) {
			changecount = changecount+1;
		}
		LEDActivity_check++;
	}
	switchloadsave(changecount);
});

$("#ClkPowerEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "ClkPowerEnable");
	var newval = $("#ClkPowerEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (ClkPowerEnable_check > 0) {
			ClkPowerEnable_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (ClkPowerEnable_check == 0) {
			changecount = changecount+1;
		}
		ClkPowerEnable_check++;
	}
	switchloadsave(changecount);
});

$("#LTRSupportGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "LTRSupport");
	var newval = $("#LTRSupportGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LTRSupport_check > 0) {
			LTRSupport_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (LTRSupport_check == 0) {
			changecount = changecount+1;
		}
		LTRSupport_check++;
	}
	switchloadsave(changecount);
});

$("#ASPMControlGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "ASPMControl");
	var newval = $("#ASPMControlGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (ASPMControl_check > 0) {
			ASPMControl_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (ASPMControl_check == 0) {
			changecount = changecount+1;
		}
		ASPMControl_check++;
	}
	switchloadsave(changecount);
});

$("#L1PMSubstatesGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "L1PMSubstates");
	var newval = $("#L1PMSubstatesGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(oldval == 0)
		{
			$("#hideL1xbits").attr('disabled', true);
		}
		else
		{
			$("#hideL1xbits").attr('disabled', false);
		}
		
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (L1PMSubstates_check > 0) {
			L1PMSubstates_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if(newval == 0)
		{
			$("#hideL1xbits").attr('disabled', true);
		}
		else
		{
			$("#hideL1xbits").attr('disabled', false);
		}
		if (L1PMSubstates_check == 0) {
			changecount = changecount+1;
		}
		L1PMSubstates_check++;
	}
	switchloadsave(changecount);
});

$("#PciPmL1Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "PciPmL1");
	var newval = $("#PciPmL1Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PciPmL1_check > 0) {
			PciPmL1_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (PciPmL1_check == 0) {
			changecount = changecount+1;
		}
		PciPmL1_check++;
	}
	switchloadsave(changecount);
});

$("#PciPmL2Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "PciPmL2");
	var newval = $("#PciPmL2Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PciPmL2_check > 0) {
			PciPmL2_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (PciPmL2_check == 0) {
			changecount = changecount+1;
		}
		PciPmL2_check++;
	}
	switchloadsave(changecount);
});

$("#ASPML2Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "ASPML2");
	var newval = $("#ASPML2Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (ASPML2_check > 0) {
			ASPML2_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (ASPML2_check == 0) {
			changecount = changecount+1;
		}
		ASPML2_check++;
	}
	switchloadsave(changecount);
});

$("#ASPML1Group").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "ASPML1");
	var newval = $("#ASPML1Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (ASPML1_check > 0) {
			ASPML1_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (ASPML1_check == 0) {
			changecount = changecount+1;
		}
		ASPML1_check++;
	}
	switchloadsave(changecount);
});

$("#macConfigurationGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macConfiguration");
	var newval = $("#macConfiguration").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macConfiguration_check > 0) {
			macConfiguration_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macConfiguration_check == 0) {
			changecount = changecount+1;
		}
		macConfiguration_check++;
	}
	switchloadsave(changecount);
});

$("#macDuplexModeGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macDuplexMode");
	var newval = $("#macDuplexModeGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macDuplexMode_check > 0) {
			macDuplexMode_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macDuplexMode_check == 0) {
			changecount = changecount+1;
		}
		macDuplexMode_check++;
	}
	switchloadsave(changecount);
});

$("#macSpeedDetectGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macSpeedDetect");
	var newval = $("#macSpeedDetectGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(oldval == 1)
		{
			$("#macConfig").attr('disabled', true);
		}
		else
		{
			$("#macConfig").attr('disabled', false);
		}
		
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macSpeedDetect_check > 0) {
			macSpeedDetect_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if(newval == 1)
		{
			$("#macConfig").attr('disabled', true);
		}
		else
		{
			$("#macConfig").attr('disabled', false);
		}
		
		if (macSpeedDetect_check == 0) {
			changecount = changecount+1;
		}
		macSpeedDetect_check++;
	}
	switchloadsave(changecount);
});

$("#macDuplexDetectionGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macDuplexDetection");
	var newval = $("#macDuplexDetectionGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(oldval == 1)
		{
			$("#duplexPolarity").attr('disabled', true);
			$("#duplexMode").attr('disabled', true);
		}
		else
		{
			$("#duplexPolarity").attr('disabled', false);
			$("#duplexMode").attr('disabled', false);
		}
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macDuplexDetection_check > 0) {
			macDuplexDetection_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if(newval == 1)
		{
			$("#duplexPolarity").attr('disabled', true);
			$("#duplexMode").attr('disabled', true);
		}
		else
		{
			$("#duplexPolarity").attr('disabled', false);
			$("#duplexMode").attr('disabled', false);
		}
		if (macDuplexDetection_check == 0) {
			changecount = changecount+1;
		}
		macDuplexDetection_check++;
	}
	switchloadsave(changecount);
});

$("#macDuplexPolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macDuplexPolarity");
	var newval = $("#macDuplexPolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macDuplexPolarity_check > 0) {
			macDuplexPolarity_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macDuplexPolarity_check == 0) {
			changecount = changecount+1;
		}
		macDuplexPolarity_check++;
	}
	switchloadsave(changecount);
});

$("#macEEETxClkStopEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macEEETxClkStopEnable");
	var newval = $("#macEEETxClkStopEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macEEETxClkStopEnable_check > 0) {
			macEEETxClkStopEnable_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (MacEEETxClkStopEnable_check == 0) {
			changecount = changecount+1;
		}
		MacEEETxClkStopEnable_check++;
	}
	switchloadsave(changecount);
});

$("#macRgmiiTxDelayEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macRgmiiTxDelayEnable");
	var newval = $("#macRgmiiTxDelayEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macRgmiiTxDelayEnable_check > 0) {
			macRgmiiTxDelayEnable_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macRgmiiTxDelayEnable_check == 0) {
			changecount = changecount+1;
		}
		macRgmiiTxDelayEnable_check++;
	}
	switchloadsave(changecount);
});

$("#macRgmiiRxEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macRgmiiRxEnable");
	var newval = $("#macRgmiiRxEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macRgmiiRxEnable_check > 0) {
			macRgmiiRxEnable_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macRgmiiRxEnable_check == 0) {
			changecount = changecount+1;
		}
		macRgmiiRxEnable_check++;
	}
	switchloadsave(changecount);
});


$("#macClk125EnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macClk125Enable");
	var newval = $("#macClk125EnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macClk125Enable_check > 0) {
			macClk125Enable_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macClk125Enable_check == 0) {
			changecount = changecount+1;
		}
		macClk125Enable_check++;
	}
	switchloadsave(changecount);
});

$("#macRefClk25EnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macRefClk25Enable");
	var newval = $("#macRefClk25EnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macRefClk25Enable_check > 0) {
			macRefClk25Enable_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macRefClk25Enable_check == 0) {
			changecount = changecount+1;
		}
		macRefClk25Enable_check++;
	}
	switchloadsave(changecount);
});

$("#macEEEEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_FAMILY_INDEX, "macEEEEnable");
	var newval = $("#macEEEEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (macEEEEnable_check > 0) {
			macEEEEnable_check = 0;
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if (macEEEEnable_check == 0) {
			changecount = changecount+1;
		}
		macEEEEnable_check++;
	}
	switchloadsave(changecount);
});

///////Dropdown part/////
$('#auxcurrentUL li').on('click', function(){
	var oldval = auxcurrentFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "auxcurrent")];
	var newval =$(this).text();
	
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (auxcurrent_check > 0) {
			auxcurrent_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (auxcurrent_check == 0) {
		changecount=changecount+1;
		}
		auxcurrent_check++;
	}
	switchloadsave(changecount);
});

$('#pmeSupportUL li').on('click', function(){
	var oldval = pmeFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "pmeSupport")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (pmeSupport_check > 0) {
			pmeSupport_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (pmeSupport_check == 0) {
			changecount=changecount+1;
		}
		pmeSupport_check++;
	}
	switchloadsave(changecount);
});

$('#L0LatencyUL li').on('click', function(){
	var oldval = L0LatencyFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "L0Latency")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (L0Latency_check > 0) {
			L0Latency_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (L0Latency_check == 0) {
			changecount=changecount+1;
		}
		L0Latency_check++;
	}
	switchloadsave(changecount);
});

$('#L1LatencyUL li').on('click', function(){
	var oldval = L1LatencyFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "L1Latency")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (L1Latency_check > 0) {
			L1Latency_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (L1Latency_check == 0) {
			changecount=changecount+1;
		}
		L1Latency_check++;
	}
	switchloadsave(changecount);
});

$('#OBFFSupportUL li').on('click', function(){
	var oldval = OBFFSupportFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "OBFFSupport")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (OBFFSupport_check > 0) {
			OBFFSupport_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (OBFFSupport_check == 0) {
			changecount=changecount+1;
		}
		OBFFSupport_check++;
	}
	switchloadsave(changecount);
});

$('#LED0FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "LED0Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED0Function_check > 0) {
			LED0Function_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (LED0Function_check == 0) {
		changecount=changecount+1;
		}
		LED0Function_check++;
	}
	switchloadsave(changecount);
});

$('#LED1FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "LED1Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED1Function_check > 0) {
			LED1Function_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (LED1Function_check == 0) {
			changecount=changecount+1;
		}
		LED1Function_check++;
	}
	switchloadsave(changecount);
});

$('#LED2FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "LED2Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED2Function_check > 0) {
			LED2Function_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (LED2Function_check == 0) {
		changecount=changecount+1;
		}
		LED2Function_check++;
	}
	switchloadsave(changecount);
});

$('#LED3FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_FAMILY_INDEX, "LED3Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (LED3Function_check > 0) {
			LED3Function_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (LED3Function_check == 0) {
		changecount=changecount+1;
		}
		LED3Function_check++;
	}
	switchloadsave(changecount);
});

function changeClose() {
   changecount=changecount+1;
   switchloadsave(changecount);
}

function changeTable() {
   changecount=changecount+1;
   switchloadsave(changecount);
}

(function ($) {
   set_changed_fields_border_default = function () {
        $("input[type='text']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='number']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='checkbox']").each(function() {
            $(this).parent().removeClass("highlight");
        });

        $("input[type='radio']").each(function() {
            $(this).parent().removeClass("highlight");
        });
		
		$("#ConfigLocationGroup").parent().removeClass("highlight");
		
		//LEDCombineEnableGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "CombineEnableGroup";
			$(wid).parent().removeClass("highlight");
		}	
		
		//LEDPolarityGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "PolarityGroup";
			$(wid).parent().removeClass("highlight");
		}
		//LEDGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "Group";
			$(wid).parent().removeClass("highlight");
		}
		
		//LEDRate
		wid = "#LEDRate" + "Group";
		$(wid).parent().removeClass("highlight");
		
		//LEDRate
		wid = "#LEDPulsing" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#LEDActivity" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#LTRSupport" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ClkPowerEnable" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPMControl" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#L1PMSubstates" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#PciPmL2" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#PciPmL1" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPML2" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPML1" + "Group";
		$(wid).parent().removeClass("highlight");
		
        $(".dropdown li a").each(function () {
            var parent = $(this).closest('div');
            $(parent).css('border-color', 'transparent');
        });
		
		  $("#macConfigurationGroup").parent().removeClass("highlight");
		  $("#macDuplexModeGroup").parent().removeClass("highlight");
		  $("#macSpeedDetectGroup").parent().removeClass("highlight");
		  $("#macDuplexDetectionGroup").parent().removeClass("highlight");
		  $("#macDuplexPolarityGroup").parent().removeClass("highlight");
		  $("#macEEEEnableGroup").parent().removeClass("highlight");
		  $("#macEEETxClkStopEnableGroup").parent().removeClass("highlight");
		  $("#macRgmiiTxDelayEnableGroup").parent().removeClass("highlight");
		  $("#macRgmiiRxEnableGroup").parent().removeClass("highlight");
		  $("#macRefClk25EnableGroup").parent().removeClass("highlight");
		  $("#macClk125EnableGroup").parent().removeClass("highlight");
	};
})(jQuery);

(function ($) {
    reset_file_input = function () {
        $("input[type='file']").val('');
		$("input[type='file']").css({
						background: "white",
						border: "0px"
						});
    };
})(jQuery);

function enableSaveButton() {
	switchloadsave(changecount);
}