/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/
var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";
//Widget IDs of String fields in the GUI
var GwidgetlistString = [
	"macaddr"
];

//Widget IDs of Hex fields in the GUI
var GwidgetValuelistHex = [
	"subsystemvid",
	"subsystemid"
];

//Widget IDs of Checkbox fields in the GUI
var GwidgetCheckbox = [
	"LED0Enable",
	"LED1Enable",
	"LED2Enable",
	"LED3Enable"
];

var GwidgetlistDropDown = [
	"auxcurrent",
	"LED0Function",
	"LED1Function",
	"LED2Function",
	"LED3Function",
	"pmeSupport",
	"L0Latency",
	"L1Latency",
	"OBFFSupport"
];


var DropDownLEDListFunction = [
	"Link/Activity",
	"Link1000/Activity",
	"Link100/Activity",
	"Link10/Activity",
	"Link100/1000/Activity",
	"Link10/1000/Activity",
	"Link10/100/Activity",
	"Reserved",
	"Duplex/Collision",
	"Collision",
	"Activity",
	"Reserved",
	"Auto-Negotiation Fault",
	"Serial Mode",
	"Force LED Off",
	"Force LED On"
];

var auxcurrentFunction = [
	"0 mA",
	"55 mA",
	"100 mA",
	"160 mA",
	"220 mA",
    "270 mA",
	"320 mA",
	"375 mA"
];

var pmeFunction = [
    "D0",
	"D3 Hot",
	"D3 Cold"
];

var L0LatencyFunction = [
    "1 us",
	"2 us",
	"3 us",
	"4 us",
	"5 us",
	"6 us",
	"7 us"
];

var L1LatencyFunction = [
   "1 us",
	"2 us",
	"4 us",
	"8 us",
	"16 us",
	"32 us",
	"64 us"	
];

var OBFFSupportFunction = [
   "Not Supported",
	"Supported using message Signaling only",
	"Supported using WAKE# Signaling only",
	"Supported using WAKE# and message signaling"
];

//Widget IDs of Radio fields in the GUI
var GwidgetlistRadio = [
	"LED0CombineEnable",
	"LED1CombineEnable",
	"LED2CombineEnable",
	"LED3CombineEnable",
	"LED0",
	"LED1",
	"LED2",
	"LED3",
	"LED0Polarity",
	"LED1Polarity",
	"LED2Polarity",
	"LED3Polarity",
	"LEDActivity",
	"LEDRate",
	"LEDPulsing",
	"ClkPowerEnable",
	"LTRSupport",
	"ASPMControl",
	"L1PMSubstates",
	"PciPmL1",
	"PciPmL2",
	"ASPML2",
	"ASPML1",
	"macEEETxClkStopEnable",
	"macSpeedDetect",
	"macConfiguration",
	"macDuplexDetection",
	"macDuplexMode",
	"macDuplexPolarity",
	"macRgmiiTxDelayEnable",
	"macRgmiiRxEnable",
	"macClk125Enable",
	"macRefClk25Enable",
	"macEEEEnable"
];

(function ($) {
    set_changed_fields_border_red = function () {

        $("input[type='text']").change(function () {
            // Check input( $( this ).val() ) for validity here
            $(this).css('border-color', 'red');
        });

        $("input[type='number']").change(function () {
            // Check input( $( this ).val() ) for validity here
            $(this).css('border-color', 'red');
        });

        $("input[type='checkbox']").change(function () {
            // Check input( $( this ).val() ) for validity here
            $(this).parent().addClass("highlight");
        });

        $("input[type='radio']").change(function () {
            // Check input( $( this ).val() ) for validity here
            $(this).parent().addClass("highlight");
        });

        $('#xdataaddress').change(function () {
            // dont change color
            $(this).css('border-color', 'LightGray');
        });

        $('#xdatavalue').change(function () {
            // dont change color
            $(this).css('border-color', 'LightGray');
        });

        $(".dropdown li a").click(function () {
            var parent = $(this).closest('div');
            $(parent).css('border-color', 'red');
        });
    };
})(jQuery);

(function ($) {
    reset_fields = function () {
        $("input[type='text']").val('');
        $("input[type='number']").val('');
        $("input[type='checkbox']").removeAttr("checked");
        $("input[type='radio']").removeAttr("checked");
		$("input[type='file']").val('');
		$('textarea#xdatavalue').val(" ");
		
		
	};
})(jQuery);

(function ($) {
    reset_file_input = function () {
        $("input[type='file']").val('');
		$("input[type='file']").css({
						background: "white",
						border: "0px"
						});
		$("#eraseFW").removeAttr("checked");
    };
})(jQuery);

(function ($) {
    disable_fields = function () {
		$("#MAC_Section").attr('disabled', true);
		$("#config_Section").attr('disabled', true);
		$("#DI_Hex_Section").attr('disabled', true);
		$("#devicecap2_Section").attr('disabled', true);
		$("#DeviceCap_Section").attr('disabled', true);
		$("#powerTab_Section").attr('disabled', true);
		$("#ASPM_Section").attr('disabled', true);
		$("#PM_Section").attr('disabled', true);
		$("#macconfig_Section").attr('disabled', true);
		$("#LEDBehavior_Section").attr('disabled', true);
		$("#LED0_Section").attr('disabled', true);
		$("#LED1_Section").attr('disabled', true);
		$("#LED2_Section").attr('disabled', true);
		$("#LED3_Section").attr('disabled', true);
		$("#UI_Section").attr('disabled', true);
		$("#LU_Section").attr('disabled', true);
		$("#SFpingField").attr('disabled', true);
		$("#MemDump_Section").attr('disabled', true);
		$("#srcIpAddrDiv").attr('disabled', true);
		$('#RemoveTableSection').hide();
    };
})(jQuery);

(function ($) {
    enable_fields = function () {
		$("#MAC_Section").attr('disabled', false);
		$("#config_Section").attr('disabled', false);
		$("#DI_Hex_Section").attr('disabled', false);
		$("#devicecap2_Section").attr('disabled', false);
		$("#DeviceCap_Section").attr('disabled', false);
		$("#powerTab_Section").attr('disabled', false);
		$("#ASPM_Section").attr('disabled', false);
		$("#PM_Section").attr('disabled', false);
		$("#macconfig_Section").attr('disabled', false);
		$("#LEDBehavior_Section").attr('disabled', false);
		$("#LED0_Section").attr('disabled', false);
		$("#LED1_Section").attr('disabled', false);
		$("#LED2_Section").attr('disabled', false);
		$("#LED3_Section").attr('disabled', false);
		$("#UI_Section").attr('disabled', false);
		$("#LU_Section").attr('disabled', false);
		$("#SFpingField").attr('disabled', false);
		$("#MemDump_Section").attr('disabled', false);
		$("#srcIpAddrDiv").attr('disabled', true);
		$("#userInitializationDiv").attr('disabled', false);
		var nameofcontrol = "input[name= registerTypegroup][value=0]";
		$(nameofcontrol).prop("checked", true);
    };
})(jQuery);


var otpMem ;
var dummyoldval ;
$("#ConfigLocationGroup").change(function () {
	var oldval = get_lan_memory(LAN_ID);
	
	otpMem = oldval.split("_");
	dummyoldval = otpMem[0];
	
	var newval = $("#ConfigLocationGroup").find(':checked').val();
	
	if (dummyoldval == newval) {
		
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
		
	}
	
});

$("#eepromConfigGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "eepromConfig");
	var newval = $("#eepromConfigGroup").find(':checked').val();
	
	if(newval == "0") {
		disable_fields();
		$("#MAC_Section").attr('disabled', false);
	} else {
		enable_fields();
	}
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');    
	} else {
		$(this).css('border-color', 'red');
	}
});

$("#macaddr").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macaddr");
	var newval = $("#macaddr").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		
		
	} else {
		$(this).css('border-color', 'red');
		
	}
	
});

$(document).on('change', 'input[id="userAddress"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
});
$(document).on('change', 'input[id="userAddress"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
});

$(document).on('change', 'input[id="byteEnable1"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($(this).closest('[type=checkbox]').is(':checked')) {
		if(($('input[id="userValue1"]').val()) == "") {
			$(this).closest('[type=text]').val("00");
		}
	} else {
		$(this).siblings("input[id='userValue1']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

$(document).on('change', 'input[id="byteEnable2"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($("input[id=byteEnable2]").is(':checked')) {
		if(($('input[id="userValue2"]').val()) == "") {
			$('input[id="userValue2"]').val("00");
			
		}
	} else {
		$(this).siblings("input[id='userValue2']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

$(document).on('change', 'input[id="byteEnable3"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($("input[id=byteEnable3]").is(':checked')) {
		if(($('input[id="userValue3"]').val()) == "") {
			$('input[id="userValue3"]').val("00");
			
		}
	} else {
		$(this).siblings("input[id='userValue3']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

$(document).on('change', 'input[id="byteEnable4"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
	if($("input[id=byteEnable4]").is(':checked')) {
		if(($('input[id="userValue4"]').val()) == "") {
			$('input[id="userValue4"]').val("00");
			
		}
	} else {
		$(this).siblings("input[id='userValue4']").val("");
	}
	changecount = changecount+1;
	switchloadsave(changecount);		
});

function updateFCWValue() {
	$(event.target).closest('div').parent().parent().parent().addClass("highlight");
	changecount = changecount+1;
	switchloadsave(changecount);
}
function value1Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}
function value2Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}
function value3Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}
function value4Change() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
}
$(document).on('change', 'input[id="userValue1"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
});
$(document).on('change', 'input[id="userValue2"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
});
$(document).on('change', 'input[id="userValue3"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
});
$(document).on('change', 'input[id="userValue4"]', function() {
	$(this).parent().parent().parent().parent().addClass("highlight");
});

$(document).on('change', 'input[id="userValue1"]', function() {
	$( event.target ).closest('div').find('[type=checkbox]').prop('checked', true); 
	
	if(($(this).val()) == "") {
		$(this).siblings("input[id='byteEnable1']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable1']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
			
});
	
$(document).on('change', 'input[id="userValue2"]', function() {
	if(($(this).val()) == "") {
		$(this).siblings("input[id='byteEnable2']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable2']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
	
});

$(document).on('change', 'input[id="userValue3"]', function() {
	if(($(this).val()) == "") {
		$(this).siblings("input[id='byteEnable3']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable3']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
	
});

$(document).on('change', 'input[id="userValue4"]', function() {
	if(($('this').val()) == "") {
		$(this).siblings("input[id='byteEnable4']").prop('checked',false); ;
	} else {
		$(this).siblings("input[id='byteEnable4']").prop('checked',true); ;
	}
	$(this).parent().parent().parent().parent().addClass("highlight");
	
});

$("#subsystemvid").change(function () {
	var oldval = parseInt(getLANWidgetValue(LAN_ID, "subsystemvid"), 10);
	var newval = parseInt($("#subsystemvid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		
		
	} else {
		$(this).css('border-color', 'red');
		
	}
	
});

$("#subsystemid").change(function () {
	var oldval = parseInt(getLANWidgetValue(LAN_ID, "subsystemid"), 10);
	var newval = parseInt($("#subsystemid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		
	} else {
		$(this).css('border-color', 'red');
		
	}
	
});

///////Dropdown part/////
$('#auxcurrentUL li').on('click', function(){
	var oldval = auxcurrentFunction[getLANWidgetValue(LAN_ID, "auxcurrent")];
	var newval =$(this).text();
	
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		
	}
	
});

$('#pmeSupportUL li').on('click', function(){
	var oldval = pmeFunction[getLANWidgetValue(LAN_ID, "pmeSupport")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		
	}
	
});

$('#L0LatencyUL li').on('click', function(){
	var oldval = L0LatencyFunction[getLANWidgetValue(LAN_ID, "L0Latency")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		
	}
	
});

$('#L1LatencyUL li').on('click', function(){
	var oldval = L1LatencyFunction[getLANWidgetValue(LAN_ID, "L1Latency")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		
	}
	
});

$('#OBFFSupportUL li').on('click', function(){
	var oldval = OBFFSupportFunction[getLANWidgetValue(LAN_ID, "OBFFSupport")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		
	}
	
});

$('#LED0FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_ID, "LED0Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		
	}
	
});

$('#LED1FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_ID, "LED1Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
	}
	
});

$('#LED2FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_ID, "LED2Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
	}
	
});

$('#LED3FunctionUL li').on('click', function(){
	var oldval = DropDownLEDListFunction[getLANWidgetValue(LAN_ID, "LED3Function")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
	}
	
});

//GwidgetlistString Starts
//GwidgetlistString Ends

$("#LED0CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED0CombineEnable");
	var newval = $("#LED0CombineEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED1CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED1CombineEnable");
	var newval = $("#LED1CombineEnableGroup").find(':checked').val();
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED2CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED2CombineEnable");
	var newval = $("#LED2CombineEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED3CombineEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED3CombineEnable");
	var newval = $("#LED3CombineEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED0Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED0");
	var newval = $("#LED0Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED1Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED1");
	var newval = $("#LED1Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED2Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED2");
	var newval = $("#LED2Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED3Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED3");
	var newval = $("#LED3Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LEDRateGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LEDRate");
	var newval = $("#LEDRateGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});


$("#LEDPulsingGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LEDPulsing");
	var newval = $("#LEDPulsingGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED0PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED0Polarity");
	var newval = $("#LED0PolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED1PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED1Polarity");
	var newval = $("#LED1PolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED2PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED2Polarity");
	var newval = $("#LED2PolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LED3PolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED3Polarity");
	var newval = $("#LED3PolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LEDActivityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LEDActivity");
	var newval = $("#LEDActivityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#ClkPowerEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "ClkPowerEnable");
	var newval = $("#ClkPowerEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#LTRSupportGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LTRSupport");
	var newval = $("#LTRSupportGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#ASPMControlGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "ASPMControl");
	var newval = $("#ASPMControlGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#L1PMSubstatesGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "L1PMSubstates");
	var newval = $("#L1PMSubstatesGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(oldval == 0)
		{
			$("#hideL1xbits").attr('disabled', true);
		}
		else
		{
			$("#hideL1xbits").attr('disabled', false);
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if(newval == 0)
		{
			$("#hideL1xbits").attr('disabled', true);
		}
		else
		{
			$("#hideL1xbits").attr('disabled', false);
		}
		
	}
});

$("#PciPmL1Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "PciPmL1");
	var newval = $("#PciPmL1Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#PciPmL2Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "PciPmL2");
	var newval = $("#PciPmL2Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#ASPML2Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "ASPML2");
	var newval = $("#ASPML2Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#ASPML1Group").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "ASPML1");
	var newval = $("#ASPML1Group").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#macConfigurationGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macConfiguration");
	var newval = $("#macConfigurationGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#macDuplexModeGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macDuplexMode");
	var newval = $("#macDuplexModeGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#macSpeedDetectGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macSpeedDetect");
	var newval = $("#macSpeedDetectGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(oldval == 1)
		{
			$("#macConfig").attr('disabled', true);
		}
		else
		{
			$("#macConfig").attr('disabled', false);
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if(newval == 1)
		{
			$("#macConfig").attr('disabled', true);
		}
		else
		{
			$("#macConfig").attr('disabled', false);
		}
		
	}
});

$("#macDuplexDetectionGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macDuplexDetection");
	var newval = $("#macDuplexDetectionGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(oldval == 1)
		{
			$("#duplexPolarity").attr('disabled', true);
			$("#duplexMode").attr('disabled', true);
		}
		else
		{
			$("#duplexPolarity").attr('disabled', false);
			$("#duplexMode").attr('disabled', false);
		}
		
	} else {
		$(this).parent().addClass("highlight");
		if(newval == 1)
		{
			$("#duplexPolarity").attr('disabled', true);
			$("#duplexMode").attr('disabled', true);
		}
		else
		{
			$("#duplexPolarity").attr('disabled', false);
			$("#duplexMode").attr('disabled', false);
		}
	}
});

$("#macDuplexPolarityGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macDuplexPolarity");
	var newval = $("#macDuplexPolarityGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#MacEEETxClkStopEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "MacEEETxClkStopEnable");
	var newval = $("#MacEEETxClkStopEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#macRgmiiTxDelayEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macRgmiiTxDelayEnable");
	var newval = $("#macRgmiiTxDelayEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#macRgmiiRxEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macRgmiiRxEnable");
	var newval = $("#macRgmiiRxEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});


$("#macClk125EnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macClk125Enable");
	var newval = $("#macClk125EnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#macRefClk25EnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macRefClk25Enable");
	var newval = $("#macRefClk25EnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});

$("#macEEEEnableGroup").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "macEEEEnable");
	var newval = $("#macEEEEnableGroup").find(':checked').val();
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
});


$("#LED0Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED0Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED0Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
	
});

$("#LED1Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED1Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED1Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
	
});

$("#LED2Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED2Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED2Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		
		
	} else {
		$(this).parent().addClass("highlight");
		
	}
	
});

$("#LED3Enable").change(function () {
	var oldval = getLANWidgetValue(LAN_ID, "LED3Enable");
	var newval = checkbox_unchecked_value;
	if($("#LED3Enable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
	
});

/////////Polarity///////
//GwidgetlistCheckbox Ends

(function ($) {
    set_changed_fields_border_default = function () {
        $("input[type='text']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='number']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='checkbox']").each(function() {
            $(this).parent().removeClass("highlight");
        });

        $("input[type='radio']").each(function() {
            $(this).parent().removeClass("highlight");
        });
		
		$("#ConfigLocationGroup").parent().removeClass("highlight");
		
		//LEDCombineEnableGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "CombineEnableGroup";
			$(wid).parent().removeClass("highlight");
		}	
		
		//LEDPolarityGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "PolarityGroup";
			$(wid).parent().removeClass("highlight");
		}
		//LEDGroup
		for (var i = 0; i <= 3; i++) {
			wid = "#LED" + i + "Group";
			$(wid).parent().removeClass("highlight");
		}
		
		//LEDRate
		wid = "#LEDRate" + "Group";
		$(wid).parent().removeClass("highlight");
		
		//LEDRate
		wid = "#LEDPulsing" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#LEDActivity" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#LTRSupport" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ClkPowerEnable" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPMControl" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#L1PMSubstates" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#PciPmL2" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#PciPmL1" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPML2" + "Group";
		$(wid).parent().removeClass("highlight");
		wid = "#ASPML1" + "Group";
		$(wid).parent().removeClass("highlight");
		
        $(".dropdown li a").each(function () {
            var parent = $(this).closest('div');
            $(parent).css('border-color', 'transparent');
        });
		
		  $("#macConfigurationGroup").parent().removeClass("highlight");
		  $("#macDuplexModeGroup").parent().removeClass("highlight");
		  $("#macSpeedDetectGroup").parent().removeClass("highlight");
		  $("#macDuplexDetectionGroup").parent().removeClass("highlight");
		  $("#macDuplexPolarityGroup").parent().removeClass("highlight");
		  $("#macEEEEnableGroup").parent().removeClass("highlight");
		  $("#macEEETxClkStopEnableGroup").parent().removeClass("highlight");
		  $("#macRgmiiTxDelayEnableGroup").parent().removeClass("highlight");
		  $("#macRgmiiRxEnableGroup").parent().removeClass("highlight");
		  $("#macRefClk25EnableGroup").parent().removeClass("highlight");
		  $("#macClk125EnableGroup").parent().removeClass("highlight");
	};
})(jQuery);
(function ($) {
    reset_file_input = function () {
        $("input[type='file']").val('');
		$("input[type='file']").css({
						background: "white",
						border: "0px"
						});
    };
})(jQuery);
