var HUB_ID = "4";
var changecount = 0;


var DropDownPHYBOOST = [
"Nominal 17.78 mA",
"5% below nominal",
"10% above nominal",
"5% above nominal",
"20% above nominal",
"15% above nominal",
"30% above nominal",
"25% above nominal"
];
// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [
"Nominal 100mV",
"12.5mV below nominal",
"25mV below nominal",
"37.5mV below nominal",
"50mV below nominal",
"62.5mV below nominal",
"25mV above nominal",
"12.5mV above nominal"
];

var NCMMAP = [
"hce1_vid",
"hce1_pid",
"hce1_did",
"hce1_languageid",
"hce1_manufacturer",
"hce1_product",
"hce1_string5",
"hce2_vid",
"hce2_pid",
"hce2_did",
"hce2_languageid",
"hce2_manufacturer",
"hce2_product",
"hce2_string5"
];

var NCMMAPcopy = [
"#hce_vid",
"#hce_pid",
"#hce_did",
"#hce_languageid",
"#hce_manufacturer",
"#hce_product",
"#hce_serial",
"#hce_vid",
"#hce_pid",
"#hce_did",
"#hce_languageid",
"#hce_manufacturer",
"#hce_product",
"#hce_serial"
];

var NCMMAPhigh = [
"#hce1_vid",
"#hce1_pid",
"#hce1_did",
"#hce1_languageid",
"#hce1_manufacturer",
"#hce1_product",
"#hce1_string5",
"#hce2_vid",
"#hce2_pid",
"#hce2_did",
"#hce2_languageid",
"#hce2_manufacturer",
"#hce2_product",
"#hce2_string5"
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall =[
"Default",
"+18%",
"-18%",
"-12%"
];


// Lookup for phyboost dropdown value selection
var DropDownFlexPort = [
"0",
"1",
"2",
"3",
"4"
];

//Function to switch load and save Preference
function switchloadsave(changecount) {
	if(changecount!=0)
	{
		$('#LoadFileField').hide();
		$('#LoadFileField').attr('disabled', 'disabled');
		$('#SaveFileField').removeAttr('disabled');
		$('#SaveFileField').show();
		$("#Apply").attr('disabled', false);	
		/*$("#hcefieldset").attr("disabled", true);
		$("#hce2fieldset").attr("disabled", "");
		$('#hce1_languageid').attr("disabled", 'disabled');  	     
		$('#hce1_manufacturer').attr("disabled", 'disabled'); 
		$('#hce1_product').attr("disabled", 'disabled'); 
		$('#hce1_string5').attr("disabled", 'disabled'); 
		$('#hce2_languageid').attr("disabled", 'disabled');  	     
		$('#hce2_manufacturer').attr("disabled", 'disabled'); 
		$('#hce2_product').attr("disabled", 'disabled'); 
		$('#hce2_string5').attr("disabled", 'disabled'); */
	}else{
		$('#SaveFileField').hide();
		$('#SaveFileField').attr('disabled', 'disabled');
		$('#LoadFileField').removeAttr('disabled');
		$('#LoadFileField').show();
		$("#Apply").attr('disabled', true);	
		/*$("#hcefieldset").attr("disabled", true);
		$("#hce2fieldset").attr("disabled", "");
		$('#hce1_languageid').attr("disabled", 'disabled');  	     
		$('#hce1_manufacturer').attr("disabled", 'disabled'); 
		$('#hce1_product').attr("disabled", 'disabled'); 
		$('#hce1_string5').attr("disabled", 'disabled'); 
		$('#hce2_languageid').attr("disabled", 'disabled');  	     
		$('#hce2_manufacturer').attr("disabled", 'disabled'); 
		$('#hce2_product').attr("disabled", 'disabled'); 
		$('#hce2_string5').attr("disabled", 'disabled'); */
	}
}
$("#vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "vid"), 10);
	var newval = parseInt($("#vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (vid_check > 0) {
			vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (vid_check == 0) {
			changecount = changecount+1;
		}
		vid_check++;
	}
	switchloadsave(changecount);

});

$("#pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "pid"), 10);
	var newval = parseInt($("#pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (pid_check > 0) {
			pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (pid_check == 0) {
			changecount = changecount+1;
		}
		pid_check++;
	}
	switchloadsave(changecount);
});

$("#did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "did"), 10);
	var newval = parseInt($("#did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (did_check > 0) {
			did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (did_check == 0) {
			changecount = changecount+1;
		}
		did_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "secondary_vid"), 10);
	var newval = parseInt($("#secondary_vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_vid_check > 0) {
			secondary_vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_vid_check == 0) {
			changecount = changecount+1;	
		}
		secondary_vid_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "secondary_pid"), 10);
	var newval = parseInt($("#secondary_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_pid_check > 0) {
			secondary_pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_pid_check == 0) {
			changecount = changecount+1;
		}
		secondary_pid_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "secondary_did"), 10);
	var newval = parseInt($("#secondary_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_did_check > 0) {
			secondary_did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_did_check == 0) {
			changecount = changecount+1;	
		}
		secondary_did_check++;
	}
	switchloadsave(changecount);
});

$("#hce_vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_vid"), 10);
	var newval = parseInt($("#hce_vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_vid_check > 0) {
			hce_vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_vid_check == 0) {
			changecount = changecount+1;	
		}
		hce_vid_check++;
	}
	switchloadsave(changecount);
});

$("#hce_pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_pid"), 10);
	var newval = parseInt($("#hce_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_pid_check > 0) {
			hce_pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_pid_check == 0) {
			changecount = changecount+1;
		}
		hce_pid_check++;
	}
	switchloadsave(changecount);
});

$("#hce_did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_did"), 10);
	var newval = parseInt($("#hce_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_did_check > 0) {
			hce_did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_did_check == 0) {
			changecount = changecount+1;
		}
		hce_did_check++;
	}
	switchloadsave(changecount);
});

$("#hce1_vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce1_vid"), 10);
	var newval = parseInt($("#hce1_vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce1_vid_check > 0) {
			hce1_vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce1_vid_check == 0) {
			changecount = changecount+1;	
		}
		hce1_vid_check++;
	}
	switchloadsave(changecount);
});

$("#hce1_pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce1_pid"), 10);
	var newval = parseInt($("#hce1_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce1_pid_check > 0) {
			hce1_pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce1_pid_check == 0) {
			changecount = changecount+1;
		}
		hce1_pid_check++;
	}
	switchloadsave(changecount);
});

$("#hce1_did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce1_did"), 10);
	var newval = parseInt($("#hce1_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce1_did_check > 0) {
			hce1_did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce1_did_check == 0) {
			changecount = changecount+1;
		}
		hce1_did_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce2_vid"), 10);
	var newval = parseInt($("#hce2_vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce2_vid_check > 0) {
			hce2_vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce2_vid_check == 0) {
			changecount = changecount+1;	
		}
		hce2_vid_check++;
	}
	switchloadsave(changecount);
});


$("#hce2_pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce2_pid"), 10);
	var newval = parseInt($("#hce2_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce2_pid_check > 0) {
			hce2_pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce2_pid_check == 0) {
			changecount = changecount+1;
		}
		hce2_pid_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce2_did"), 10);
	var newval = parseInt($("#hce2_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce2_did_check > 0) {
			hce2_did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce2_did_check == 0) {
			changecount = changecount+1;
		}
		hce2_did_check++;
	}
	switchloadsave(changecount);
});

$("#usbvcd").change(function () {
	var usbvcdVal = parseInt(getWidgetValue(HUB_ID, "usbvcd"), 10);
	var dot = ".";
	var hexvalue = (usbvcdVal.toString(16));
	var position = 1;
	var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
	oldval = hexstring;
	newval = $("#usbvcd").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usbvcd_check > 0) {
			usbvcd_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usbvcd_check == 0) {
		changecount = changecount+1;
		}
		usbvcd_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_usbvcd").change(function () {
	var secondary_usbvcdVal = parseInt(getWidgetValue(HUB_ID, "secondary_usbvcd"), 10);
	var dot = ".";
	var hexvalue = (secondary_usbvcdVal.toString(16));
	var position = 1;
	var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
	oldval = hexstring;
	newval = $("#secondary_usbvcd").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_usbvcd_check > 0) {
			secondary_usbvcd_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_usbvcd_check == 0) {
		changecount = changecount+1;
		}
		secondary_usbvcd_check++;
	}
	switchloadsave(changecount);
});

$("#languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "languageid"), 10);
	var newval = parseInt($("#languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (languageid_check > 0) {
			languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (languageid_check == 0) {
			changecount = changecount+1;
		}
		languageid_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "secondary_languageid"), 10);
	var newval = parseInt($("#secondary_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_languageid_check > 0) {
			secondary_languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_languageid_check == 0) {
			changecount = changecount+1;
		}
		secondary_languageid_check++;
	}
	switchloadsave(changecount);
});

$("#hce_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_languageid"), 10);
	var newval = parseInt($("#hce_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_languageid_check > 0) {
			hce_languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_languageid_check == 0) {
			changecount = changecount+1;
		}
		hce_languageid_check++;
	}
	switchloadsave(changecount);
});

$("#hce1_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce1_languageid"), 10);
	var newval = parseInt($("#hce1_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce1_languageid_check > 0) {
			hce1_languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce1_languageid_check == 0) {
			changecount = changecount+1;
		}
		hce1_languageid_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce2_languageid"), 10);
	var newval = parseInt($("#hce2_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce2_languageid_check > 0) {
			hce2_languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce2_languageid_check == 0) {
			changecount = changecount+1;
		}
		hce2_languageid_check++;
	}
	switchloadsave(changecount);
});
//GwidgetlistHex Ends

//GwidgetlistString Starts
$("#manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "manufacturer");
	var newval = $("#manufacturer").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (manufacturer_check > 0) {
			manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (manufacturer_check == 0) {
			changecount = changecount+1;
		}
		manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "product");
	var newval = $("#product").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (product_check > 0) {
			product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (product_check == 0) {
			changecount = changecount+1;
		}
		product_check++;
	}
	switchloadsave(changecount);
});

$("#serial").change(function () {
	var oldval = getWidgetValue(HUB_ID, "serial");
	var newval = $("#serial").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (serial_check > 0) {
			serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (serial_check == 0) {
			changecount = changecount+1;
		}	
		serial_check++;
	}
	switchloadsave(changecount);
});

$("#hce_manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce_manufacturer");
	var newval = $("#hce_manufacturer").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_manufacturer_check > 0) {
			hce_manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_manufacturer_check == 0) {
			changecount = changecount+1;
		}
		hce_manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#hce_product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce_product");
	var newval = $("#hce_product").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_product_check > 0) {
			hce_product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_product_check == 0) {
			changecount = changecount+1;	
		}
		hce_product_check++;
	}
	switchloadsave(changecount);
});

$("#hce_serial").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce_serial");
	var newval = $("#hce_serial").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_serial_check > 0) {
			hce_serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_serial_check == 0) {
			changecount = changecount+1;	
		}
		hce_serial_check++;
	}
	switchloadsave(changecount);
});


$("#hce1_manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce1_manufacturer");
	var newval = $("#hce1_manufacturer").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_manufacturer_check > 0) {
			hce_manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_manufacturer_check == 0) {
			changecount = changecount+1;
		}
		hce_manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#hce1_product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce1_product");
	var newval = $("#hce1_product").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_product_check > 0) {
			hce_product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_product_check == 0) {
			changecount = changecount+1;	
		}
		hce_product_check++;
	}
	switchloadsave(changecount);
});

$("#hce1_string5").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce1_string5");
	var newval = $("#hce1_string5").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_serial_check > 0) {
			hce_serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_serial_check == 0) {
			changecount = changecount+1;	
		}
		hce_serial_check++;
	}
	switchloadsave(changecount);
});


$("#hce1_macaddr").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce1_macaddr");
	var newval = $("#hce1_macaddr").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce1_macaddr_check > 0) {
			hce1_macaddr_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce1_macaddr_check == 0) {
			changecount = changecount+1;	
		}
		hce1_macaddr_check++;
	}
	switchloadsave(changecount);
});

$("#hce1_eapproduct").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce1_eapproduct");
	var newval = $("#hce1_eapproduct").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce1_eapproduct_check > 0) {
			hce1_eapproduct_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce1_eapproduct_check == 0) {
			changecount = changecount+1;	
		}
		hce1_eapproduct_check++;
	}
	switchloadsave(changecount);
});
$("#hce1_eapinterface").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce1_eapinterface");
	var newval = $("#hce1_eapinterface").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce1_eapinterface_check > 0) {
			hce1_eapinterface_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce1_eapinterface_check == 0) {
			changecount = changecount+1;	
		}
		hce1_eapinterface_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce2_manufacturer");
	var newval = $("#hce2_manufacturer").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_manufacturer_check > 0) {
			hce_manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_manufacturer_check == 0) {
			changecount = changecount+1;
		}
		hce_manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce2_product");
	var newval = $("#hce2_product").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_product_check > 0) {
			hce_product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_product_check == 0) {
			changecount = changecount+1;	
		}
		hce_product_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_string5").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce2_string5");
	var newval = $("#hce2_string5").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_serial_check > 0) {
			hce_serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_serial_check == 0) {
			changecount = changecount+1;	
		}
		hce_serial_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_macaddr").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce2_macaddr");
	var newval = $("#hce2_macaddr").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce2_macaddr_check > 0) {
			hce2_macaddr_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce2_macaddr_check == 0) {
			changecount = changecount+1;	
		}
		hce2_macaddr_check++;
	}
	switchloadsave(changecount);
});

$("#hce2_eapproduct").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce2_eapproduct");
	var newval = $("#hce2_eapproduct").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce2_eapproduct_check > 0) {
			hce2_eapproduct_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce2_eapproduct_check == 0) {
			changecount = changecount+1;	
		}
		hce2_eapproduct_check++;
	}
	switchloadsave(changecount);
});
$("#hce2_eapinterface").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce2_eapinterface");
	var newval = $("#hce2_eapinterface").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce2_eapinterface_check > 0) {
			hce2_eapinterface_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce2_eapinterface_check == 0) {
			changecount = changecount+1;	
		}
		hce2_eapinterface_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "secondary_manufacturer");
	var newval = $("#secondary_manufacturer").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_manufacturer_check > 0) {
			secondary_manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_manufacturer_check == 0) {
			changecount = changecount+1;	
		}
		secondary_manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "secondary_product");
	var newval = $("#secondary_product").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_product_check > 0) {
			secondary_product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_product_check == 0) {
			changecount = changecount+1;	
		}
		secondary_product_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_serial").change(function () {
	var oldval = getWidgetValue(HUB_ID, "secondary_serial");
	var newval = $("#secondary_serial").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_serial_check > 0) {
			secondary_serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_serial_check == 0) {
			changecount = changecount+1;
		}
		secondary_serial_check++;
	}
	switchloadsave(changecount);
});

$("#usb2uuid").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb2uuid");
	var newval = $("#usb2uuid").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb2uuid_check > 0) {
			usb2uuid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb2uuid_check == 0) {
			changecount = changecount+1;	
		}
		usb2uuid_check++;
	}
	switchloadsave(changecount);
});

$("#secondary_usb2uuid").change(function () {
	var oldval = getWidgetValue(HUB_ID, "secondary_usb2uuid");
	var newval = $("#secondary_usb2uuid").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondary_usb2uuid_check > 0) {
			secondary_usb2uuid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (secondary_usb2uuid_check == 0) {
			changecount = changecount+1;	
		}
		secondary_usb2uuid_check++;
	}
	switchloadsave(changecount);
});
//GwidgetlistString Ends

//GwidgetlistInt Starts
$("#maxpowerself").change(function () {
	var oldval = getWidgetValue(HUB_ID, "maxpowerself");
	oldval = parseInt(oldval,10) * 2;
	var newval = parseInt($("#maxpowerself").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (maxpowerself_check > 0) {
			maxpowerself_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (maxpowerself_check == 0) {
			changecount = changecount+1;	
		}
		maxpowerself_check++;
	}
	switchloadsave(changecount);
});

$("#hubcmaxpowerself").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hubcmaxpowerself");
	oldval = parseInt(oldval,10);
	var newval = parseInt($("#hubcmaxpowerself").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hubcmaxpowerself_check > 0) {
			hubcmaxpowerself_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hubcmaxpowerself_check == 0) {
			changecount = changecount+1;
		}
		hubcmaxpowerself_check++;
	}
	switchloadsave(changecount);
});

$("#maxpowerbus").change(function () {
	var oldval = getWidgetValue(HUB_ID, "maxpowerbus");
	oldval = parseInt(oldval,10) * 2;
	var newval = parseInt($("#maxpowerbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (maxpowerbus_check > 0) {
			maxpowerbus_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (maxpowerbus_check == 0) {
			changecount = changecount+1;
		}
		maxpowerbus_check++;
	}
	switchloadsave(changecount);
});

$("#power_ontime").change(function () {
	var oldval = getWidgetValue(HUB_ID, "power_ontime");
	oldval = parseInt(oldval,10) * 2;
	var newval = parseInt($("#power_ontime").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (power_ontime_check > 0) {
			power_ontime_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (power_ontime_check == 0) {
			changecount = changecount+1;	
		}
		power_ontime_check++;
	}
	switchloadsave(changecount);
});

$("#hubcmaxpowerbus").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hubcmaxpowerbus");
	oldval = parseInt(oldval,10);
	var newval = parseInt($("#hubcmaxpowerbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hubcmaxpowerbus_check > 0) {
			hubcmaxpowerbus_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hubcmaxpowerbus_check == 0) {
			changecount = changecount+1;
		}
		hubcmaxpowerbus_check++;
	}
	switchloadsave(changecount);
});

$("#hub3maxpowerselfbus").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hub3maxpowerselfbus");
	oldval = parseInt(oldval,10) * 8;
	var newval = parseInt($("#hub3maxpowerselfbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hub3maxpowerselfbus_check > 0) {
			hub3maxpowerselfbus_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hub3maxpowerselfbus_check == 0) {
			changecount = changecount+1;	
		}
		hub3maxpowerselfbus_check++;
	}
	switchloadsave(changecount);
});
//GwidgetlistInt Ends

$("#copyNCM").change(function () {
	
	for (var i = 0;i<= 13;i++) {
		var widgetname = i;
		var oldval;
		var newval ;
		
		if(NCMMAP[widgetname] == "hce1_did" || NCMMAP[widgetname] == "hce1_pid" || NCMMAP[widgetname] == "hce1_vid" || NCMMAP[widgetname] == "hce1_languageid" || NCMMAP[widgetname] == "hce2_languageid" ||
		NCMMAP[widgetname] == "hce2_did" || NCMMAP[widgetname] == "hce2_pid" || NCMMAP[widgetname] == "hce2_vid") {
			oldval = parseInt(getWidgetValue(HUB_ID, NCMMAP[widgetname]),10);
		} else {
			oldval = getWidgetValue(HUB_ID, NCMMAP[widgetname]);
		}
		
		if(NCMMAP[widgetname] == "hce1_did" || NCMMAP[widgetname] == "hce1_pid" || NCMMAP[widgetname] == "hce1_vid" || NCMMAP[widgetname] == "hce1_languageid" || NCMMAP[widgetname] == "hce2_languageid" ||
		NCMMAP[widgetname] == "hce2_did" || NCMMAP[widgetname] == "hce2_pid" || NCMMAP[widgetname] == "hce2_vid") {
			
			newval = parseInt($(NCMMAPcopy[widgetname]).val(),16);
		} else {
			newval = $(NCMMAPcopy[widgetname]).val();
		}
		
		if (oldval == newval) {
			$(NCMMAPhigh[widgetname]).css('border-color', 'LightGray');
			if(changecount!=0)
			{
				changecount = changecount-1;
			}
			if (copyNCM_check > 0) {
				copyNCM_check = 0;
			}
		} else {
			$(NCMMAPhigh[widgetname]).css('border-color', 'red');
			if (copyNCM_check == 0) {
				changecount = changecount+1;	
			}
			copyNCM_check++;
		}
		switchloadsave(changecount);
	}
	
});

//GwidgetlistCheckbox Starts
$("#flexconnect").change(function () {
	var oldval = getWidgetValue(HUB_ID, "flexconnect");
	var temp = oldval;
	
	var newval = checkbox_unchecked_value;
	if($("#flexconnect").is(':checked'))
	{
		newval = checkbox_checked_value;
	}

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		$("#flexportULButton").attr('disabled', true);
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (flexconnect_check > 0) {
			flexconnect_check = 0;
		}
	} else {
		$("#flexportULButton").attr('disabled', false);
		$(this).parent().addClass("highlight");
		if (flexconnect_check == 0) {
			changecount = changecount+1;
		}
		flexconnect_check++;
	}
	switchloadsave(changecount);
});

$("#hsdisable").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hsdisable");
	var newval = checkbox_unchecked_value;
	if($("#hsdisable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hsdisable_check > 0) {
			hsdisable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (hsdisable_check == 0) {
			changecount = changecount+1;
		}
		hsdisable_check++;
	}
	switchloadsave(changecount);
});

$("#hceenable").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hceenable");
	var newval = checkbox_unchecked_value;
	if($("#hceenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hceenable_check > 0) {
			hceenable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (hceenable_check == 0) {
			changecount = changecount+1;
		}
		hceenable_check++;
	}
	switchloadsave(changecount);
});

$("#cdcenable").change(function () {
	var oldval = getWidgetValue(HUB_ID, "cdcenable");
	var newval = checkbox_unchecked_value;
	if($("#cdcenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (cdcenable_check > 0) {
			cdcenable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (cdcenable_check == 0) {
			changecount = changecount+1;
		}
		cdcenable_check++;
	}
	switchloadsave(changecount);
});


$("#lpmenable").change(function () {
	var oldval = getWidgetValue(HUB_ID, "lpmenable");
	var newval = checkbox_unchecked_value;
	if($("#lpmenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (lpmenable_check > 0) {
			lpmenable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (lpmenable_check == 0) {
			changecount = changecount+1;
		}
		lpmenable_check++;
	}
	switchloadsave(changecount);
});

$("#swapupstreamdpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapupstreamdpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapupstreamdpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapupstreamdpdm_check > 0) {
			swapupstreamdpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapupstreamdpdm_check == 0) {
			changecount = changecount+1;
		}
		swapupstreamdpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapsecondaryportdpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapsecondaryportdpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapsecondaryportdpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapsecondaryportdpdm_check > 0) {
			swapsecondaryportdpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapsecondaryportdpdm_check == 0) {
			changecount = changecount+1;
		}
		swapsecondaryportdpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport1dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport1dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport1dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport1dpdm_check > 0) {
			swapport1dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport1dpdm_check == 0) {
			changecount = changecount+1;
		}
		swapport1dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport2dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport2dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport2dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport2dpdm_check > 0) {
			swapport2dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport2dpdm_check == 0) {
		changecount = changecount+1;
		}
		swapport2dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport3dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport3dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport3dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport3dpdm_check > 0) {
			swapport3dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport3dpdm_check == 0) {
		changecount = changecount+1;
		}
		swapport3dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport4dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport4dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport4dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport4dpdm_check > 0) {
			swapport4dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport4dpdm_check == 0) {
			changecount = changecount+1;
		}
		swapport4dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport5dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport5dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport5dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport5dpdm_check > 0) {
			swapport5dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport5dpdm_check == 0) {
		changecount = changecount+1;
		}
		swapport5dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport1").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport1");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr1UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport1_check > 0) {
			nrdeviceport1_check = 0;
		}
	} else {
		nr1UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport1_check == 0) {
			changecount = changecount+1;
		}
		nrdeviceport1_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport2").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport2");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr2UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport2_check > 0) {
			nrdeviceport2_check = 0;
		}
	} else {
		nr2UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport2_check == 0) {
			changecount = changecount+1;
		}
		nrdeviceport2_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport3").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport3");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr3UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport3_check > 0) {
			nrdeviceport3_check = 0;
		}
	} else {
		nr3UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport3_check == 0) {
		changecount = changecount+1;
		}
		nrdeviceport3_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport4").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport4");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr4UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport4_check > 0) {
			nrdeviceport4_check = 0;
		}
	} else {
		nr4UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport4_check == 0) {
		changecount = changecount+1;
		}
		nrdeviceport4_check++;
	}
	switchloadsave(changecount);
});

$("#enableport1").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport1");
	var newval = checkbox_unchecked_value;
	if($("#enableport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport1_check > 0) {
			enableport1_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport1_check == 0) {
		changecount = changecount+1;
		}
		enableport1_check++;
	}
	switchloadsave(changecount);
});

$("#enableport2").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport2");
	var newval = checkbox_unchecked_value;
	if($("#enableport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport2_check > 0) {
			enableport2_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport2_check == 0) {
		changecount = changecount+1;
		}
		enableport2_check++;
	}
	switchloadsave(changecount);
});

$("#enableport3").change(function () {
	
	var oldval;
	
	if(sku == "USB4914" || sku == "USB4925" ) {
		
		oldval = getWidgetValue(HUB_ID, "enableport5");
	} else {
		oldval = getWidgetValue(HUB_ID, "enableport3");
	}
	var newval = checkbox_unchecked_value;
	if($("#enableport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport3_check > 0) {
			enableport3_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport3_check == 0) {
		changecount = changecount+1;
		}
		enableport3_check++;
	}
	switchloadsave(changecount);
});

$("#enableport4").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport4");
	var newval = checkbox_unchecked_value;
	if($("#enableport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport4_check > 0) {
			enableport4_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport4_check == 0) {
		changecount = changecount+1;
		}
		enableport4_check++;
	}
	switchloadsave(changecount);
});

$("#enableport5").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport5");
	var newval = checkbox_unchecked_value;
	if($("#enableport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport5_check > 0) {
			enableport5_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport5_check == 0) {
		changecount = changecount+1;
		}
		enableport5_check++;
	}
	switchloadsave(changecount);
});


$("#hubpowergroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hubpower");
	var newval = $("#hubpowergroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hubpowergroup_check > 0) {
			hubpowergroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (hubpowergroup_check == 0) {
		changecount = changecount+1;
		}
		hubpowergroup_check++;
	}
	switchloadsave(changecount);
});

$("#i2senablegroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "i2senable");
	var newval = $("#i2senablegroup").find(':checked').val();
	
	if(newval == "1") 
	{
		document.getElementById("speakermeute").disabled=false;
		document.getElementById("bothms").disabled=true;
		document.getElementById("bothms1").disabled=true;
	} else if(newval == "2") {
		document.getElementById("speakermeute").disabled=true;
		document.getElementById("bothms1").disabled=true;
		document.getElementById("bothms").disabled=false;
		
	} else if(newval == "3") {
		document.getElementById("speakermeute").disabled=false;
		document.getElementById("bothms1").disabled=false;
		document.getElementById("bothms").disabled=false;
	} else if(newval == "0") {
		
		document.getElementById("speakermeute").disabled=true;
		document.getElementById("bothms1").disabled=true;
		document.getElementById("bothms").disabled=true;
	}
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (i2senablegroup_check > 0) {
			i2senablegroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (i2senablegroup_check == 0) {
		changecount = changecount+1;
		}
		i2senablegroup_check++;
	}
	switchloadsave(changecount);
});

$("#i2senablehidgroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "i2senable");
	var newval = $("#i2senablehidgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (i2senablehidgroup_check > 0) {
			i2senablehidgroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (i2senablehidgroup_check == 0) {
		changecount = changecount+1;
		}
		i2senablehidgroup_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport1group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport1");
	var newval = $("#downstreamBCsettingport1group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport1group_check > 0) {
			downstreamBCsettingport1group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport1group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport1group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport2group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport2");
	var newval = $("#downstreamBCsettingport2group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport2group_check > 0) {
			downstreamBCsettingport2group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport2group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport2group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport3group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport3");
	var newval = $("#downstreamBCsettingport3group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport3group_check > 0) {
			downstreamBCsettingport3group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport3group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport3group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport4group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport4");
	var newval = $("#downstreamBCsettingport4group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport4group_check > 0) {
			downstreamBCsettingport4group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport4group_check == 0) {
		changecount = changecount + 1;
		}
		downstreamBCsettingport4group_check++;
	}
	switchloadsave(changecount);
});

$('#flexportUL li').on('click', function(){
	//var oldval = DropDownFlexPort[getWidgetValue(HUB_ID, "flexport")];
	var oldval = getWidgetValue(HUB_ID, "flexport");

	var newval =$(this).text();
	
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (flexportUL_check > 0) {
			flexportUL_check = 0;
		}
	}
	else{
		
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		
		if (flexportUL_check == 0) {
		changecount=changecount+1;
		}
		flexportUL_check++;
	}
	switchloadsave(changecount);
});

$('#PHYBOOSTUL li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOST")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTUL_check > 0) {
			PHYBOOSTUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTUL_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTUL_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamsecondaryport li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamsecondaryport")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamsecondaryport_check > 0) {
			PHYBOOSTULdownstreamsecondaryport_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamsecondaryport_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamsecondaryport_check++;
	}
	switchloadsave(changecount);
});

$('#PHYBOOSTULdownstreamport1 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport1")];
	var newval =$(this).text();
	if (oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport1_check > 0) {
			PHYBOOSTULdownstreamport1_check = 0;
		}
	}
	else {
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport1_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport1_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport2 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport2")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport2_check > 0) {
			PHYBOOSTULdownstreamport2_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport2_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport2_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport3 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport3")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport3_check > 0) {
			PHYBOOSTULdownstreamport3_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport3_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport3_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport4 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport4")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport4_check > 0) {
			PHYBOOSTULdownstreamport4_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport4_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport4_check++;
	}
	switchloadsave(changecount);
});

$('#PHYBOOSTULdownstreamport5 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport5")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport5_check > 0) {
			PHYBOOSTULdownstreamport5_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport5_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport5_check++;
	}
	switchloadsave(changecount);
});

// USB2.0 port mapping
$('#SQUELCHUL li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCH")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHUL_check > 0) {
			SQUELCHUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHUL_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHUL_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamsecondaryport li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamsecondaryport")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamsecondaryport_check > 0) {
			SQUELCHULdownstreamsecondaryport_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamsecondaryport_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamsecondaryport_check++;
	}
	switchloadsave(changecount);
});

$('#SQUELCHULdownstreamport1 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport1")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport1_check > 0) {
			SQUELCHULdownstreamport1_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport1_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport1_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport2 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport2")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport2_check > 0) {
			SQUELCHULdownstreamport2_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport2_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport2_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport3 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport3")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport3_check > 0) {
			SQUELCHULdownstreamport3_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport3_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport3_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport4 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport4")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport4_check > 0) {
			SQUELCHULdownstreamport4_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport4_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport4_check++;
	}
	switchloadsave(changecount);
});

$('#SQUELCHULdownstreamport5 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport5")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport5_check > 0) {
			SQUELCHULdownstreamport5_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport5_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport5_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport1HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport1HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport1HsRiseFallUL_check > 0) {
			downstreamport1HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport1HsRiseFallUL_check == 0) {
		changecount=changecount+1;
		}
		downstreamport1HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

$('#secondaryportHsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "secondaryportHsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (secondaryportHsRiseFallUL_check > 0) {
			secondaryportHsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (secondaryportHsRiseFallUL_check == 0) {
		changecount=changecount+1;
		}
		secondaryportHsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

$('#downstreamport2HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport2HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport2HsRiseFallUL_check > 0) {
			downstreamport2HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport2HsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		downstreamport2HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport3HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport3HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport3HsRiseFallUL_check > 0) {
			downstreamport3HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport3HsRiseFallUL_check == 0) {
		changecount=changecount+1;	
		}
		downstreamport3HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport4HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport4HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport4HsRiseFallUL_check > 0) {
			downstreamport4HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport4HsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		downstreamport4HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

$('#downstreamport5HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport5HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport5HsRiseFallUL_check > 0) {
			downstreamport5HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport5HsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		downstreamport5HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

$('#upstreamHsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "upstreamHsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (upstreamHsRiseFallUL_check > 0) {
			upstreamHsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (upstreamHsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		upstreamHsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

//Direct Register Access: ini file
$("#iniid").change(function () {
		if (iniFileID_check == 0) {
			changecount = changecount+1;
		}
		iniFileID_check++;
		if (iniFileID_check > 0) {
			iniFileID_check = 0;
		}
	switchloadsave(changecount);
});

(function ($) {
    set_changed_fields_border_default = function () {
        $("input[type='text']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='number']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='checkbox']").each(function() {
            $(this).parent().removeClass("highlight");
        });

        $("input[type='radio']").each(function() {
            $(this).parent().removeClass("highlight");
        });
		
	
		$("#i2senablegroup").parent().removeClass("highlight");
		$("#i2senablehidgroup").parent().removeClass("highlight");
		$("#cdcenablegroup").parent().removeClass("highlight");
		$("#downstreamBCsettingport1group").parent().removeClass("highlight");
		$("#downstreamBCsettingport2group").parent().removeClass("highlight");
		$("#downstreamBCsettingport3group").parent().removeClass("highlight");
		$("#downstreamBCsettingport4group").parent().removeClass("highlight");
		$("#port5splittinggroup").parent().removeClass("highlight");
		$("#port6splittinggroup").parent().removeClass("highlight");
		
		$("#prtpwr5usb3splitgroup").parent().removeClass("highlight");
		$("#prtpwr6usb3splitgroup").parent().removeClass("highlight");
		$("#portpower5").hide();
		$("#portpower6").hide();
		$("#pstimeoutgroup").parent().removeClass("highlight");
        $(".dropdown li a").each(function () {
            var parent = $(this).closest('div');
            $(parent).css('border-color', 'transparent');
        });
    };
})(jQuery);
(function ($) {
    reset_file_input = function () {
        $("input[type='file']").val('');
		$("input[type='file']").css({
						background: "white",
						border: "0px"
						});
    };
})(jQuery);

// To detect changes in the Direct Access Register, if direct input is given
var RegOperation = -1;
var RegisterAddr = -1;
var RegisterVal = -1; 

$("#Regoperationgroup").change(function () {
	RegOperation = $("#Regoperationgroup").find(':checked').val();
	
	if (RegOperation != -1) {
		enableSaveButton();
	}
});

$("#Regaddress").change(function () {
	RegisterAddr = $("#Regaddress").val();
	
	if (RegisterAddr != -1) {
		enableSaveButton();
	}
});

$("#Regvalue").change(function () {
	RegisterVal = $("#Regvalue").val();
	
	if (RegisterVal != -1) {
		enableSaveButton();
	}
});

function enableSaveButton() {
	if ((RegOperation != -1) && (RegisterAddr != -1) && (RegisterVal != -1)) {
		changecount = changecount+1;
	}
	switchloadsave(changecount);
}