var HUB_ID = "0";
var changecount = 0;
var Product = getProduct();

var DropDownPHYBOOST = [
"Nominal 17.78 mA",
"5% below nominal",
"10% above nominal",
"5% above nominal",
"20% above nominal",
"15% above nominal",
"30% above nominal",
"25% above nominal"
];
// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [
"Nominal 100mV",
"12.5mV below nominal",
"25mV below nominal",
"37.5mV below nominal",
"50mV below nominal",
"62.5mV below nominal",
"25mV above nominal",
"12.5mV above nominal"
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall =[
"Default",
"+18%",
"-18%",
"-12%"
];

// Lookup for port mapping selection
var DropDownPORTMAPPING = [
"Disabled", // Just to cover up Index 0 as the actual port mapping start with 1
"Map to Logical Port1",
"Map to Logical Port2",
"Map to Logical Port3",
"Map to Logical Port4",
"Map to Logical Port5",
"Map to Logical Port6",
"Map to Logical Port7"
];
//GwidgetlistHex starts

//Function to switch load and save Preference
function switchloadsave(changecount) {
	if(changecount!=0)
	{
		$('#LoadFileField').hide();
		$('#LoadFileField').attr('disabled', 'disabled');
		$('#SaveFileField').removeAttr('disabled');
		$('#SaveFileField').show();
		$("#Apply").attr('disabled', false);	
	}else{
		$('#SaveFileField').hide();
		$('#SaveFileField').attr('disabled', 'disabled');
		$('#LoadFileField').removeAttr('disabled');
		$('#LoadFileField').show();
		$("#Apply").attr('disabled', true);	
	}
}
$("#vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "vid"), 10);
	var newval = parseInt($("#vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (vid_check > 0) {
			vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (vid_check == 0) {
			changecount = changecount+1;
		}
		vid_check++;
	}
	switchloadsave(changecount);

});

$("#pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "pid"), 10);
	var newval = parseInt($("#pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (pid_check > 0) {
			pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (pid_check == 0) {
			changecount = changecount+1;
		}
		pid_check++;
	}
	switchloadsave(changecount);
});

$("#did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "did"), 10);
	var newval = parseInt($("#did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (did_check > 0) {
			did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (did_check == 0) {
			changecount = changecount+1;
		}
		did_check++;
	}
	switchloadsave(changecount);
});

$("#usb3vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "usb3vid"), 10);
	var newval = parseInt($("#usb3vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3vid_check > 0) {
			usb3vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3vid_check == 0) {
			changecount = changecount+1;	
		}
		usb3vid_check++;
	}
	switchloadsave(changecount);
});

$("#usb3pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "usb3pid"), 10);
	var newval = parseInt($("#usb3pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3pid_check > 0) {
			usb3pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3pid_check == 0) {
			changecount = changecount+1;
		}
		usb3pid_check++;
	}
	switchloadsave(changecount);
});

$("#usb3did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "usb3did"), 10);
	var newval = parseInt($("#usb3did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3did_check > 0) {
			usb3did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3did_check == 0) {
			changecount = changecount+1;	
		}
		usb3did_check++;
	}
	switchloadsave(changecount);
});

$("#hce_vid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_vid"), 10);
	var newval = parseInt($("#hce_vid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_vid_check > 0) {
			hce_vid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_vid_check == 0) {
			changecount = changecount+1;	
		}
		hce_vid_check++;
	}
	switchloadsave(changecount);
});

$("#hce_pid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_pid"), 10);
	var newval = parseInt($("#hce_pid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_pid_check > 0) {
			hce_pid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_pid_check == 0) {
			changecount = changecount+1;
		}
		hce_pid_check++;
	}
	switchloadsave(changecount);
});

$("#hce_did").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_did"), 10);
	var newval = parseInt($("#hce_did").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_did_check > 0) {
			hce_did_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_did_check == 0) {
			changecount = changecount+1;
		}
		hce_did_check++;
	}
	switchloadsave(changecount);
});

$("#usbvcd").change(function () {
	var usbvcdVal = parseInt(getWidgetValue(HUB_ID, "usbvcd"), 10);
	var dot = ".";
	var hexvalue = (usbvcdVal.toString(16));
	var position = 1;
	var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
	oldval = hexstring;
	newval = $("#usbvcd").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usbvcd_check > 0) {
			usbvcd_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usbvcd_check == 0) {
		changecount = changecount+1;
		}
		usbvcd_check++;
	}
	switchloadsave(changecount);
});

$("#usb3vcd").change(function () {
	var usb3vcdVal = parseInt(getWidgetValue(HUB_ID, "usb3vcd"), 10);
	var dot = ".";
	var hexvalue = (usb3vcdVal.toString(16));
	var position = 1;
	var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
	oldval = hexstring;
	newval = $("#usb3vcd").val();
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3vcd_check > 0) {
			usb3vcd_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3vcd_check == 0) {
		changecount = changecount+1;
		}
		usb3vcd_check++;
	}
	switchloadsave(changecount);
});

$("#languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "languageid"), 10);
	var newval = parseInt($("#languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (languageid_check > 0) {
			languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (languageid_check == 0) {
			changecount = changecount+1;
		}
		languageid_check++;
	}
	switchloadsave(changecount);
});

$("#usb3languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "usb3languageid"), 10);
	var newval = parseInt($("#usb3languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3languageid_check > 0) {
			usb3languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3languageid_check == 0) {
			changecount = changecount+1;
		}
		usb3languageid_check++;
	}
	switchloadsave(changecount);
});

$("#hce_languageid").change(function () {
	var oldval = parseInt(getWidgetValue(HUB_ID, "hce_languageid"), 10);
	var newval = parseInt($("#hce_languageid").val(), 16);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_languageid_check > 0) {
			hce_languageid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_languageid_check == 0) {
			changecount = changecount+1;
		}
		hce_languageid_check++;
	}
	switchloadsave(changecount);
});
//GwidgetlistHex Ends

//GwidgetlistString Starts
$("#manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "manufacturer");
	var newval = $("#manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (manufacturer_check > 0) {
			manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (manufacturer_check == 0) {
			changecount = changecount+1;
		}
		manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "product");
	var newval = $("#product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (product_check > 0) {
			product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (product_check == 0) {
			changecount = changecount+1;
		}
		product_check++;
	}
	switchloadsave(changecount);
});

$("#serial").change(function () {
	var oldval = getWidgetValue(HUB_ID, "serial");
	var newval = $("#serial").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (serial_check > 0) {
			serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (serial_check == 0) {
			changecount = changecount+1;
		}	
		serial_check++;
	}
	switchloadsave(changecount);
});

$("#hce_manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce_manufacturer");
	var newval = $("#hce_manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_manufacturer_check > 0) {
			hce_manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_manufacturer_check == 0) {
			changecount = changecount+1;
		}
		hce_manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#hce_product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce_product");
	var newval = $("#hce_product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_product_check > 0) {
			hce_product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_product_check == 0) {
			changecount = changecount+1;	
		}
		hce_product_check++;
	}
	switchloadsave(changecount);
});

$("#hce_serial").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hce_serial");
	var newval = $("#hce_serial").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hce_serial_check > 0) {
			hce_serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hce_serial_check == 0) {
			changecount = changecount+1;	
		}
		hce_serial_check++;
	}
	switchloadsave(changecount);
});

$("#usb3manufacturer").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3manufacturer");
	var newval = $("#usb3manufacturer").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3manufacturer_check > 0) {
			usb3manufacturer_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3manufacturer_check == 0) {
			changecount = changecount+1;	
		}
		usb3manufacturer_check++;
	}
	switchloadsave(changecount);
});

$("#usb3product").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3product");
	var newval = $("#usb3product").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3product_check > 0) {
			usb3product_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3product_check == 0) {
			changecount = changecount+1;	
		}
		usb3product_check++;
	}
	switchloadsave(changecount);
});

$("#usb3serial").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3serial");
	var newval = $("#usb3serial").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3serial_check > 0) {
			usb3serial_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3serial_check == 0) {
			changecount = changecount+1;
		}
		usb3serial_check++;
	}
	switchloadsave(changecount);
});

$("#usb3uuid").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3uuid");
	var newval = $("#usb3uuid").val();
	
	if (oldval == "") {
		//oldval = stringnullvalue;
	}

	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3uuid_check > 0) {
			usb3uuid_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (usb3uuid_check == 0) {
			changecount = changecount+1;	
		}
		usb3uuid_check++;
	}
	switchloadsave(changecount);
});
//GwidgetlistString Ends

//GwidgetlistInt Starts
$("#maxpowerself").change(function () {
	var oldval = getWidgetValue(HUB_ID, "maxpowerself");
	oldval = parseInt(oldval,10) * 2;
	var newval = parseInt($("#maxpowerself").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (maxpowerself_check > 0) {
			maxpowerself_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (maxpowerself_check == 0) {
			changecount = changecount+1;	
		}
		maxpowerself_check++;
	}
	switchloadsave(changecount);
});

$("#hubcmaxpowerself").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hubcmaxpowerself");
	oldval = parseInt(oldval,10);
	var newval = parseInt($("#hubcmaxpowerself").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hubcmaxpowerself_check > 0) {
			hubcmaxpowerself_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hubcmaxpowerself_check == 0) {
			changecount = changecount+1;
		}
		hubcmaxpowerself_check++;
	}
	switchloadsave(changecount);
});

$("#maxpowerbus").change(function () {
	var oldval = getWidgetValue(HUB_ID, "maxpowerbus");
	oldval = parseInt(oldval,10) * 2;
	var newval = parseInt($("#maxpowerbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (maxpowerbus_check > 0) {
			maxpowerbus_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (maxpowerbus_check == 0) {
			changecount = changecount+1;
		}
		maxpowerbus_check++;
	}
	switchloadsave(changecount);
});

$("#hubcmaxpowerbus").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hubcmaxpowerbus");
	oldval = parseInt(oldval,10);
	var newval = parseInt($("#hubcmaxpowerbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hubcmaxpowerbus_check > 0) {
			hubcmaxpowerbus_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hubcmaxpowerbus_check == 0) {
			changecount = changecount+1;
		}
		hubcmaxpowerbus_check++;
	}
	switchloadsave(changecount);
});

$("#hub3maxpowerselfbus").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hub3maxpowerselfbus");
	oldval = parseInt(oldval,10) * 8;
	var newval = parseInt($("#hub3maxpowerselfbus").val(), 10);
	
	if (oldval == newval) {
		$(this).css('border-color', 'LightGray');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hub3maxpowerselfbus_check > 0) {
			hub3maxpowerselfbus_check = 0;
		}
	} else {
		$(this).css('border-color', 'red');
		if (hub3maxpowerselfbus_check == 0) {
			changecount = changecount+1;	
		}
		hub3maxpowerselfbus_check++;
	}
	switchloadsave(changecount);
});
//GwidgetlistInt Ends

//GwidgetlistCheckbox Starts
$("#flexconnect").change(function () {
	var oldval = getWidgetValue(HUB_ID, "flexconnect");
	var temp = oldval;
	
	if (Product == "USB2.0") {
		temp = temp & 3;
		if (temp == 0) {
			oldval = "0";
		} else if (temp == 3) {
			oldval = "1";
		}
	}
	var newval = checkbox_unchecked_value;
	if($("#flexconnect").is(':checked'))
	{
		newval = checkbox_checked_value;
	}

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (flexconnect_check > 0) {
			flexconnect_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (flexconnect_check == 0) {
			changecount = changecount+1;
		}
		flexconnect_check++;
	}
	switchloadsave(changecount);
});

/*$("#compound").change(function () {
	var oldval = getWidgetValue(HUB_ID, "compound");
	var newval = checkbox_unchecked_value;
	if($("#compound").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
	} else {
		$(this).parent().addClass("highlight");
	}
});*/

$("#hsdisable").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hsdisable");
	var newval = checkbox_unchecked_value;
	if($("#hsdisable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hsdisable_check > 0) {
			hsdisable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (hsdisable_check == 0) {
			changecount = changecount+1;
		}
		hsdisable_check++;
	}
	switchloadsave(changecount);
});

$("#hceenable").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hceenable");
	var newval = checkbox_unchecked_value;
	if($("#hceenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hceenable_check > 0) {
			hceenable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (hceenable_check == 0) {
			changecount = changecount+1;
		}
		hceenable_check++;
	}
	switchloadsave(changecount);
});


$("#lpmenable").change(function () {
	var oldval = getWidgetValue(HUB_ID, "lpmenable");
	var newval = checkbox_unchecked_value;
	if($("#lpmenable").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (lpmenable_check > 0) {
			lpmenable_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (lpmenable_check == 0) {
			changecount = changecount+1;
		}
		lpmenable_check++;
	}
	switchloadsave(changecount);
});

$("#swapupstreamdpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapupstreamdpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapupstreamdpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapupstreamdpdm_check > 0) {
			swapupstreamdpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapupstreamdpdm_check == 0) {
			changecount = changecount+1;
		}
		swapupstreamdpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapupstreamhsic").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapupstreamhsic");
	var newval = checkbox_unchecked_value;
	if($("#swapupstreamhsic").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapupstreamhsic_check > 0) {
			swapupstreamhsic_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapupstreamhsic_check == 0) {
			changecount = changecount+1;
		}
		swapupstreamhsic_check++;
	}
	switchloadsave(changecount);
});

$("#swapport1dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport1dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport1dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport1dpdm_check > 0) {
			swapport1dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport1dpdm_check == 0) {
			changecount = changecount+1;
		}
		swapport1dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport2dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport2dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport2dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport2dpdm_check > 0) {
			swapport2dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport2dpdm_check == 0) {
		changecount = changecount+1;
		}
		swapport2dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport3dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport3dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport3dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport3dpdm_check > 0) {
			swapport3dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport3dpdm_check == 0) {
		changecount = changecount+1;
		}
		swapport3dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport4dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport4dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport4dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport4dpdm_check > 0) {
			swapport4dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport4dpdm_check == 0) {
			changecount = changecount+1;
		}
		swapport4dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport5dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport5dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport5dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport5dpdm_check > 0) {
			swapport5dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport5dpdm_check == 0) {
		changecount = changecount+1;
		}
		swapport5dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport6dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport6dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport6dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport6dpdm_check > 0) {
			swapport6dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport6dpdm_check == 0) {
		changecount = changecount+1;
		}
		swapport6dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#swapport7dpdm").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swapport7dpdm");
	var newval = checkbox_unchecked_value;
	if($("#swapport7dpdm").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swapport7dpdm_check > 0) {
			swapport7dpdm_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swapport7dpdm_check == 0) {
			changecount = changecount+1;
		}
		swapport7dpdm_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport1").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport1");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr1UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport1_check > 0) {
			nrdeviceport1_check = 0;
		}
	} else {
		nr1UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport1_check == 0) {
			changecount = changecount+1;
		}
		nrdeviceport1_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport2").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport2");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr2UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport2_check > 0) {
			nrdeviceport2_check = 0;
		}
	} else {
		nr2UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport2_check == 0) {
			changecount = changecount+1;
		}
		nrdeviceport2_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport3").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport3");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr3UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport3_check > 0) {
			nrdeviceport3_check = 0;
		}
	} else {
		nr3UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport3_check == 0) {
		changecount = changecount+1;
		}
		nrdeviceport3_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport4").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport4");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr4UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport4_check > 0) {
			nrdeviceport4_check = 0;
		}
	} else {
		nr4UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport4_check == 0) {
		changecount = changecount+1;
		}
		nrdeviceport4_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport5").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport5");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr5UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport5_check > 0) {
			nrdeviceport5_check = 0;
		}
	} else {
		nr5UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport5_check == 0) {
			changecount = changecount+1;
		}
		nrdeviceport5_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport6").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport6");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr6UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport6_check > 0) {
			nrdeviceport6_check = 0;
		}
	} else {
		nr6UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport6_check == 0) {
		changecount = changecount+1;
		}
		nrdeviceport6_check++;
	}
	switchloadsave(changecount);
});

$("#nrdeviceport7").change(function () {
	var oldval = getWidgetValue(HUB_ID, "nrdeviceport7");
	var newval = checkbox_unchecked_value;
	if($("#nrdeviceport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		nr7UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (nrdeviceport7_check > 0) {
			nrdeviceport7_check = 0;
		}
	} else {
		nr7UserModified = true;
		$(this).parent().addClass("highlight");
		if (nrdeviceport7_check == 0) {
		changecount = changecount+1;
		}
		nrdeviceport7_check++;
	}
	switchloadsave(changecount);
});

$("#usb3nrdeviceport1").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3nrdeviceport1");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr1UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3nrdeviceport1_check > 0) {
			usb3nrdeviceport1_check = 0;
		}
	} else {
		usb3nr1UserModified = true;
		$(this).parent().addClass("highlight");
		if (usb3nrdeviceport1_check == 0) {
			changecount = changecount+1;
		}
		usb3nrdeviceport1_check++;
	}
	switchloadsave(changecount);
});

$("#usb3nrdeviceport2").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3nrdeviceport2");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr2UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3nrdeviceport2_check > 0) {
			usb3nrdeviceport2_check = 0;
		}
	} else {
		usb3nr2UserModified = true;
		$(this).parent().addClass("highlight");
		if (usb3nrdeviceport2_check == 0) {
			changecount = changecount+1;
		}
		usb3nrdeviceport2_check++;
	}
	switchloadsave(changecount);
});

$("#usb3nrdeviceport3").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3nrdeviceport3");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr3UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3nrdeviceport3_check > 0) {
			usb3nrdeviceport3_check = 0;
		}
	} else {
		usb3nr3UserModified = true;
		$(this).parent().addClass("highlight");
		if (usb3nrdeviceport3_check == 0) {
		changecount = changecount+1;
		}
		usb3nrdeviceport3_check++;
	}
	switchloadsave(changecount);
});

$("#usb3nrdeviceport4").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3nrdeviceport4");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr4UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3nrdeviceport4_check > 0) {
			usb3nrdeviceport4_check = 0;
		}
	} else {
		usb3nr4UserModified = true;
		$(this).parent().addClass("highlight");
		if (usb3nrdeviceport4_check == 0) {
		changecount = changecount+1;
		}
		usb3nrdeviceport4_check++;
	}
	switchloadsave(changecount);
});

$("#usb3nrdeviceport5").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3nrdeviceport5");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr5UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3nrdeviceport5_check > 0) {
			usb3nrdeviceport5_check = 0;
		}
	} else {
		usb3nr5UserModified = true;
		$(this).parent().addClass("highlight");
		if (usb3nrdeviceport5_check == 0) {
			changecount = changecount+1;
		}
		usb3nrdeviceport5_check++;
	}
	switchloadsave(changecount);
});

$("#usb3nrdeviceport6").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3nrdeviceport6");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr6UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3nrdeviceport6_check > 0) {
			usb3nrdeviceport6_check = 0;
		}
	} else {
		usb3nr6UserModified = true;
		$(this).parent().addClass("highlight");
		if (usb3nrdeviceport6_check == 0) {
		changecount = changecount+1;
		}
		usb3nrdeviceport6_check++;
	}
	switchloadsave(changecount);
});

$("#usb3nrdeviceport7").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3nrdeviceport7");
	var newval = checkbox_unchecked_value;
	if($("#usb3nrdeviceport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		usb3nr7UserModified = false;
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3nrdeviceport7_check > 0) {
			usb3nrdeviceport7_check = 0;
		}
	} else {
		usb3nr7UserModified = true;
		$(this).parent().addClass("highlight");
		if (usb3nrdeviceport7_check == 0) {
		changecount = changecount+1;
		}
		usb3nrdeviceport7_check++;
	}
	switchloadsave(changecount);
});

$("#swappin1").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swappin1");
	var newval = checkbox_unchecked_value;
	if($("#swappin1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swappin1_check > 0) {
			swappin1_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swappin1_check == 0) {
		changecount = changecount+1;
		}
		swappin1_check++;
	}
	switchloadsave(changecount);
});

$("#swappin2").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swappin2");
	var newval = checkbox_unchecked_value;
	if($("#swappin2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swappin2_check > 0) {
			swappin2_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swappin2_check == 0) {
		changecount = changecount+1;
		}
		swappin2_check++;
	}
	switchloadsave(changecount);
});

$("#swappin3").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swappin3");
	var newval = checkbox_unchecked_value;
	if($("#swappin3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swappin3_check > 0) {
			swappin3_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swappin3_check == 0) {
		changecount = changecount+1;
		}
		swappin3_check++;
	}
	switchloadsave(changecount);
});

$("#swappin4").change(function () {
	var oldval = getWidgetValue(HUB_ID, "swappin4");
	var newval = checkbox_unchecked_value;
	if($("#swappin4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (swappin4_check > 0) {
			swappin4_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (swappin4_check == 0) {
		changecount = changecount+1;
		}
		swappin4_check++;
	}
	switchloadsave(changecount);
});

$("#enableport1").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport1");
	var newval = checkbox_unchecked_value;
	if($("#enableport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport1_check > 0) {
			enableport1_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport1_check == 0) {
		changecount = changecount+1;
		}
		enableport1_check++;
	}
	switchloadsave(changecount);
});

$("#enableport2").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport2");
	var newval = checkbox_unchecked_value;
	if($("#enableport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport2_check > 0) {
			enableport2_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport2_check == 0) {
		changecount = changecount+1;
		}
		enableport2_check++;
	}
	switchloadsave(changecount);
});

$("#enableport3").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport3");
	var newval = checkbox_unchecked_value;
	if($("#enableport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport3_check > 0) {
			enableport3_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport3_check == 0) {
		changecount = changecount+1;
		}
		enableport3_check++;
	}
	switchloadsave(changecount);
});

$("#enableport4").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport4");
	var newval = checkbox_unchecked_value;
	if($("#enableport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport4_check > 0) {
			enableport4_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport4_check == 0) {
		changecount = changecount+1;
		}
		enableport4_check++;
	}
	switchloadsave(changecount);
});

$("#enableport5").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport5");
	var newval = checkbox_unchecked_value;
	if($("#enableport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport5_check > 0) {
			enableport5_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport5_check == 0) {
		changecount = changecount+1;
		}
		enableport5_check++;
	}
	switchloadsave(changecount);
});

$("#enableport6").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport6");
	var newval = checkbox_unchecked_value;
	if($("#enableport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport6_check > 0) {
			enableport6_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport6_check == 0) {
		changecount = changecount+1;
		}
		enableport6_check++;
	}
	switchloadsave(changecount);
});

$("#enableport7").change(function () {
	var oldval = getWidgetValue(HUB_ID, "enableport7");
	var newval = checkbox_unchecked_value;
	if($("#enableport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (enableport7_check > 0) {
			enableport7_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (enableport7_check == 0) {
		changecount = changecount+1;
		}
		enableport7_check++;
	}
	switchloadsave(changecount);
});

$("#usb3enableport1").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3enableport1");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport1").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3enableport1_check > 0) {
			usb3enableport1_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (usb3enableport1_check == 0) {
		changecount = changecount+1;
		}
		usb3enableport1_check++;
	}
	switchloadsave(changecount);
});

$("#usb3enableport2").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3enableport2");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport2").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3enableport2_check > 0) {
			usb3enableport2_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (usb3enableport2_check == 0) {
		changecount = changecount+1;
		}
		usb3enableport2_check++;
	}
	switchloadsave(changecount);
});

$("#usb3enableport3").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3enableport3");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport3").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3enableport3_check > 0) {
			usb3enableport3_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (usb3enableport3_check == 0) {
		changecount = changecount+1;
		}
		usb3enableport3_check++;
	}
	switchloadsave(changecount);
});

$("#usb3enableport4").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3enableport4");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport4").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3enableport4_check > 0) {
			usb3enableport4_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (usb3enableport4_check == 0) {
		changecount = changecount+1;
		}
		usb3enableport4_check++;
	}
	switchloadsave(changecount);
});

$("#usb3enableport5").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3enableport5");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport5").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3enableport5_check > 0) {
			usb3enableport5_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (usb3enableport5_check == 0) {
		changecount = changecount+1;
		}
		usb3enableport5_check++;
	}
	switchloadsave(changecount);
});

$("#usb3enableport6").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3enableport6");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport6").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3enableport6_check > 0) {
			usb3enableport6_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (usb3enableport6_check == 0) {
		changecount = changecount+1;
		}
		usb3enableport6_check++;
	}
	switchloadsave(changecount);
});

$("#usb3enableport7").change(function () {
	var oldval = getWidgetValue(HUB_ID, "usb3enableport7");
	var newval = checkbox_unchecked_value;
	if($("#usb3enableport7").is(':checked'))
	{
		newval = checkbox_checked_value;
	}
	
	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3enableport7_check > 0) {
			usb3enableport7_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (usb3enableport7_check == 0) {
		changecount = changecount+1;
		}
		usb3enableport7_check++;
	}
	switchloadsave(changecount);
});
//GwidgetlistCheckbox Ends

//GwidgetlistRadio Starts
$("#port5splittinggroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "port5splitting");
	var newval = $("#port5splittinggroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port5splittinggroup_check > 0) {
			port5splittinggroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (port5splittinggroup_check == 0) {
		changecount = changecount+1;
		}
		port5splittinggroup_check++;
	}
	switchloadsave(changecount);
});

$("#port6splittinggroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "port6splitting");
	var newval = $("#port6splittinggroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port6splittinggroup_check > 0) {
			port6splittinggroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (port6splittinggroup_check == 0) {
		changecount = changecount+1;
		}
		port6splittinggroup_check++;
	}
	switchloadsave(changecount);
});

$("#prtpwr5usb3splitgroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "prtpwr5usb3split");
	var newval = $("#prtpwr5usb3splitgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (prtpwr5usb3splitgroup_check > 0) {
			prtpwr5usb3splitgroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (prtpwr5usb3splitgroup_check == 0) {
		changecount = changecount+1;
		}
		prtpwr5usb3splitgroup_check++;
	}
	switchloadsave(changecount);
});

$("#prtpwr6usb3splitgroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "prtpwr6usb3split");
	var newval = $("#prtpwr6usb3splitgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (prtpwr6usb3splitgroup_check > 0) {
			prtpwr6usb3splitgroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (prtpwr6usb3splitgroup_check == 0) {
		changecount = changecount+1;
		}
		prtpwr6usb3splitgroup_check++;
	}
	switchloadsave(changecount);
});

$("#pstimeoutgroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "pstimeout");
	var newval = $("#pstimeoutgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (pstimeoutgroup_check > 0) {
			pstimeoutgroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (pstimeoutgroup_check == 0) {
		changecount = changecount+1;
		}
		pstimeoutgroup_check++;
	}
	switchloadsave(changecount);
});

$("#hubpowergroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "hubpower");
	var newval = $("#hubpowergroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (hubpowergroup_check > 0) {
			hubpowergroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (hubpowergroup_check == 0) {
		changecount = changecount+1;
		}
		hubpowergroup_check++;
	}
	switchloadsave(changecount);
});

$("#upstreambatterysettingsgroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "upstreambatterysettings");
	var newval = $("#upstreambatterysettingsgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (upstreambatterysettingsgroup_check > 0) {
			upstreambatterysettingsgroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (upstreambatterysettingsgroup_check == 0) {
		changecount = changecount+1;
		}
		upstreambatterysettingsgroup_check++;
	}
	switchloadsave(changecount);
});

$("#suspendindicationgroup").change(function () {
	var oldval = getWidgetValue(HUB_ID, "suspendindication");
	var newval = $("#suspendindicationgroup").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (suspendindicationgroup_check > 0) {
			suspendindicationgroup_check = 0;
		}
	} else {
		$(this).parent().addClass("highlight");
		if (suspendindicationgroup_check == 0) {
		changecount = changecount+1;
		}
		suspendindicationgroup_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport1group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport1");
	var newval = $("#downstreamBCsettingport1group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport1group_check > 0) {
			downstreamBCsettingport1group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport1group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport1group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport2group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport2");
	var newval = $("#downstreamBCsettingport2group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport2group_check > 0) {
			downstreamBCsettingport2group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport2group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport2group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport3group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport3");
	var newval = $("#downstreamBCsettingport3group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport3group_check > 0) {
			downstreamBCsettingport3group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport3group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport3group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport4group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport4");
	var newval = $("#downstreamBCsettingport4group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport4group_check > 0) {
			downstreamBCsettingport4group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport4group_check == 0) {
		changecount = changecount + 1;
		}
		downstreamBCsettingport4group_check++;
	}
	switchloadsave(changecount);
});
$("#downstreamBCsettingport5group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport5");
	var newval = $("#downstreamBCsettingport5group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport5group_check > 0) {
			downstreamBCsettingport5group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport5group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport5group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport6group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport6");
	var newval = $("#downstreamBCsettingport6group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport6group_check > 0) {
			downstreamBCsettingport6group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport6group_check == 0) {
		changecount = changecount+1;
		}
		downstreamBCsettingport6group_check++;
	}
	switchloadsave(changecount);
});

$("#downstreamBCsettingport7group").change(function () {
	var oldval = getWidgetValue(HUB_ID, "downstreamBCsettingport7");
	var newval = $("#downstreamBCsettingport7group").find(':checked').val();

	if (oldval == newval) {
		$(this).parent().removeClass("highlight");
		if(changecount!=0)
		{
			changecount = changecount - 1;
		}
		if (downstreamBCsettingport7group_check > 0) {
			downstreamBCsettingport7group_check = 0;
		}
	} else {
		var parent = $(this).closest('div');
        $(this).parent().css('border-color', 'red');
		$(this).parent().addClass("highlight");
		if (downstreamBCsettingport7group_check == 0) {
		changecount = changecount + 1;
		}
		downstreamBCsettingport7group_check++;
	}
	switchloadsave(changecount);
});

$('#PHYBOOSTUL li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOST")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTUL_check > 0) {
			PHYBOOSTUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTUL_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTUL_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport1 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport1")];
	var newval =$(this).text();
	if (oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport1_check > 0) {
			PHYBOOSTULdownstreamport1_check = 0;
		}
	}
	else {
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport1_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport1_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport2 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport2")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport2_check > 0) {
			PHYBOOSTULdownstreamport2_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport2_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport2_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport3 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport3")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport3_check > 0) {
			PHYBOOSTULdownstreamport3_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport3_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport3_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport4 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport4")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport4_check > 0) {
			PHYBOOSTULdownstreamport4_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport4_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport4_check++;
	}
	switchloadsave(changecount);
});

$('#PHYBOOSTULdownstreamport5 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport5")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport5_check > 0) {
			PHYBOOSTULdownstreamport5_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport5_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport5_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport6 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport6")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport6_check > 0) {
			PHYBOOSTULdownstreamport6_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport6_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport6_check++;
	}
	switchloadsave(changecount);
});
$('#PHYBOOSTULdownstreamport7 li').on('click', function(){
	var oldval = DropDownPHYBOOST[getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport7")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (PHYBOOSTULdownstreamport7_check > 0) {
			PHYBOOSTULdownstreamport7_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (PHYBOOSTULdownstreamport7_check == 0) {
		changecount=changecount+1;
		}
		PHYBOOSTULdownstreamport7_check++;
	}
	switchloadsave(changecount);
});

//USB2.0 Port mapping
$('#USB2Port1MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "port1mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port1mapping_check > 0) {
			port1mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (port1mapping_check == 0) {
		changecount=changecount+1;
		}
		port1mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB2Port2MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "port2mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port2mapping_check > 0) {
			port2mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (port2mapping_check == 0) {
		changecount=changecount+1;
		}
		port2mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB2Port3MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "port3mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port3mapping_check > 0) {
			port3mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (port3mapping_check == 0) {
		changecount=changecount+1;
		}
		port3mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB2Port4MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "port4mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port4mapping_check > 0) {
			port4mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (port4mapping_check == 0) {
		changecount=changecount+1;
		}
		port4mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB2Port5MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "port5mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port5mapping_check > 0) {
			port5mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (port5mapping_check == 0) {
		changecount=changecount+1;
		}
		port5mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB2Port6MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "port6mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port6mapping_check > 0) {
			port6mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (port6mapping_check == 0) {
		changecount=changecount+1;
		}
		port6mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB2Port7MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "port7mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (port7mapping_check > 0) {
			port7mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (port7mapping_check == 0) {
		changecount=changecount+1;
		}
		port7mapping_check++;
	}
	switchloadsave(changecount);
});
// USB2.0 port mapping

//USB3.1 Gen1 Port mapping
$('#USB3Port1MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "usb3port1mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3port1mapping_check > 0) {
			usb3port1mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (usb3port1mapping_check == 0) {
		changecount=changecount+1;
		}
		usb3port1mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB3Port2MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "usb3port2mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3port2mapping_check > 0) {
			usb3port2mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (usb3port2mapping_check == 0) {
		changecount=changecount+1;
		}
		usb3port2mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB3Port3MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "usb3port3mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3port3mapping_check > 0) {
			usb3port3mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (usb3port3mapping_check == 0) {
		changecount=changecount+1;
		}
		usb3port3mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB3Port4MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "usb3port4mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3port4mapping_check > 0) {
			usb3port4mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (usb3port4mapping_check == 0) {
		changecount=changecount+1;
		}
		usb3port4mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB3Port5MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "usb3port5mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3port5mapping_check > 0) {
			usb3port5mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (usb3port5mapping_check == 0) {
		changecount=changecount+1;
		}
		usb3port5mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB3Port6MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "usb3port6mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3port6mapping_check > 0) {
			usb3port6mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (usb3port6mapping_check == 0) {
		changecount=changecount+1;
		}
		usb3port6mapping_check++;
	}
	switchloadsave(changecount);
});

$('#USB3Port7MappingUL li').on('click', function(){
	var oldval = DropDownPORTMAPPING[getWidgetValue(HUB_ID, "usb3port7mapping")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (usb3port7mapping_check > 0) {
			usb3port7mapping_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (usb3port7mapping_check == 0) {
		changecount=changecount+1;
		}
		usb3port7mapping_check++;
	}
	switchloadsave(changecount);
});
// USB2.0 port mapping
$('#SQUELCHUL li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCH")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHUL_check > 0) {
			SQUELCHUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHUL_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHUL_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport1 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport1")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport1_check > 0) {
			SQUELCHULdownstreamport1_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport1_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport1_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport2 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport2")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport2_check > 0) {
			SQUELCHULdownstreamport2_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport2_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport2_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport3 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport3")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport3_check > 0) {
			SQUELCHULdownstreamport3_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport3_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport3_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport4 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport4")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport4_check > 0) {
			SQUELCHULdownstreamport4_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport4_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport4_check++;
	}
	switchloadsave(changecount);
});

$('#SQUELCHULdownstreamport5 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport5")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport5_check > 0) {
			SQUELCHULdownstreamport5_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport5_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport5_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport6 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport6")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport6_check > 0) {
			SQUELCHULdownstreamport6_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport6_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport6_check++;
	}
	switchloadsave(changecount);
});
$('#SQUELCHULdownstreamport7 li').on('click', function(){
	var oldval = DropDownSQUELCH[getWidgetValue(HUB_ID, "SQUELCHdownstreamport7")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (SQUELCHULdownstreamport7_check > 0) {
			SQUELCHULdownstreamport7_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (SQUELCHULdownstreamport7_check == 0) {
		changecount=changecount+1;
		}
		SQUELCHULdownstreamport7_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport1HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport1HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport1HsRiseFallUL_check > 0) {
			downstreamport1HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport1HsRiseFallUL_check == 0) {
		changecount=changecount+1;
		}
		downstreamport1HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport2HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport2HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport2HsRiseFallUL_check > 0) {
			downstreamport2HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport2HsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		downstreamport2HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport3HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport3HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport3HsRiseFallUL_check > 0) {
			downstreamport3HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport3HsRiseFallUL_check == 0) {
		changecount=changecount+1;	
		}
		downstreamport3HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport4HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport4HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport4HsRiseFallUL_check > 0) {
			downstreamport4HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport4HsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		downstreamport4HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

$('#downstreamport5HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport5HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport5HsRiseFallUL_check > 0) {
			downstreamport5HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport5HsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		downstreamport5HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport6HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport6HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport6HsRiseFallUL_check > 0) {
			downstreamport6HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport6HsRiseFallUL_check == 0) {
		changecount=changecount+1;	
		}
		downstreamport6HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});
$('#downstreamport7HsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "downstreamport7HsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (downstreamport7HsRiseFallUL_check > 0) {
			downstreamport7HsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (downstreamport7HsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		downstreamport7HsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

$('#upstreamHsRiseFallUL li').on('click', function(){
	var oldval = DropDownHSRiseFall[getWidgetValue(HUB_ID, "upstreamHsRiseFall")];
	var newval =$(this).text();
	if(oldval == newval)
	{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'transparent');
		if(changecount!=0)
		{
			changecount = changecount-1;
		}
		if (upstreamHsRiseFallUL_check > 0) {
			upstreamHsRiseFallUL_check = 0;
		}
	}
	else{
		var parent = $(this).closest('div');
        $(parent).css('border-color', 'red');
		if (upstreamHsRiseFallUL_check == 0) {
		changecount=changecount+1;		
		}
		upstreamHsRiseFallUL_check++;
	}
	switchloadsave(changecount);
});

//Direct Register Access: ini file
$("#iniid").change(function () {
		if (iniFileID_check == 0) {
			changecount = changecount+1;
		}
		iniFileID_check++;
		if (iniFileID_check > 0) {
			iniFileID_check = 0;
		}
	switchloadsave(changecount);
});

(function ($) {
    set_changed_fields_border_default = function () {
        $("input[type='text']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='number']").each(function() {
            $(this).css('border-color', 'LightGray');
        });

        $("input[type='checkbox']").each(function() {
            $(this).parent().removeClass("highlight");
        });

        $("input[type='radio']").each(function() {
            $(this).parent().removeClass("highlight");
        });
		
		$("#suspendindicationgroup").parent().removeClass("highlight");
		$("#upstreambatterysettingsgroup").parent().removeClass("highlight");
		$("#cdcenablegroup").parent().removeClass("highlight");
		$("#downstreamBCsettingport1group").parent().removeClass("highlight");
		$("#downstreamBCsettingport2group").parent().removeClass("highlight");
		$("#downstreamBCsettingport3group").parent().removeClass("highlight");
		$("#downstreamBCsettingport4group").parent().removeClass("highlight");
		$("#port5splittinggroup").parent().removeClass("highlight");
		$("#port6splittinggroup").parent().removeClass("highlight");
		
		$("#prtpwr5usb3splitgroup").parent().removeClass("highlight");
		$("#prtpwr6usb3splitgroup").parent().removeClass("highlight");
		$("#portpower5").hide();
		$("#portpower6").hide();
		$("#pstimeoutgroup").parent().removeClass("highlight");
        $(".dropdown li a").each(function () {
            var parent = $(this).closest('div');
            $(parent).css('border-color', 'transparent');
        });
    };
})(jQuery);
(function ($) {
    reset_file_input = function () {
        $("input[type='file']").val('');
		$("input[type='file']").css({
						background: "white",
						border: "0px"
						});
    };
})(jQuery);

// To detect changes in the Direct Access Register, if direct input is given
var RegOperation = -1;
var RegisterAddr = -1;
var RegisterVal = -1; 

$("#Regoperationgroup").change(function () {
	RegOperation = $("#Regoperationgroup").find(':checked').val();
	
	if (RegOperation != -1) {
		enableSaveButton();
	}
});

$("#Regaddress").change(function () {
	RegisterAddr = $("#Regaddress").val();
	
	if (RegisterAddr != -1) {
		enableSaveButton();
	}
});

$("#Regvalue").change(function () {
	RegisterVal = $("#Regvalue").val();
	
	if (RegisterVal != -1) {
		enableSaveButton();
	}
});

function enableSaveButton() {
	if ((RegOperation != -1) && (RegisterAddr != -1) && (RegisterVal != -1)) {
		changecount = changecount+1;
	}
	switchloadsave(changecount);
}