/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/

//Global variables
var gbProductfun = getFlextype();
var RegString = "";
var iniFile = "";
var offlineConfFile = "";
var LoadConfigFile = "";
var HUB_FAMILY_INDEX = "4";
var dummyHubID = "4";
var primaryCFlag = true;
var enableport = false;
var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";


var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";

var gINIFileSelected = false;
var FirstMergecfgFile = "";
var SecondMergecfgFile = "";
var mergeConfFile = "";
var ParseCfgFileExt = "";
var parseConfigFile = "";
var parseSaveFile = "";

// Widget ID of hex fields in the GUI
var GwidgetlistHex = [
"vid",
"pid",
"did",
"usbvcd",
"languageid",
"secondary_vid",
"secondary_pid",
"secondary_did",
"secondary_usbvcd",
"secondary_languageid",
"hce_vid",
"hce_pid",
"hce_did",
"hce_languageid",
"hce1_vid",
"hce1_pid",
"hce1_did",
"hce1_languageid",
"hce2_vid",
"hce2_pid",
"hce2_did",
"hce2_languageid"
];

// Widget ID of string fields in the GUI
var GwidgetlistString = [
"manufacturer", 
"secondary_manufacturer", 
"product",
"secondary_product",
"serial",
"secondary_serial",
"hce_manufacturer",
"hce_product",
"hce_serial",
"hce1_manufacturer",
"hce1_product",
"hce1_eapproduct",
"hce1_eapinterface",
"hce1_string5",
"hce2_manufacturer",
"hce2_product",
"hce2_eapproduct",
"hce2_eapinterface",
"hce2_string5",
"usb2uuid",
"secondary_usb2uuid",
"hce1_macaddr",
"hce2_macaddr"
];

// Widget ID of decimal fields in the GUI
var GwidgetlistInt = [
"maxpowerself",
"hubcmaxpowerself",
"maxpowerbus",
"hubcmaxpowerbus",
"hub3maxpowerselfbus",
"power_ontime"
];


// Widgets that are checkboxes in GUI
var GwidgetlistCheckbox = [
"flexconnect",
"hsdisable",
"hceenable",
"cdcenable",
"lpmenable",
"enableport1",
"enableport2",
"enableport3",
"enableport4",
"enableport5",
"nrdeviceport1",
"nrdeviceport2",
"nrdeviceport3",
"nrdeviceport4",
"nrdeviceport5",
"swapsecondaryportdpdm",
"swapupstreamdpdm",
"swapport1dpdm",
"swapport2dpdm",
"swapport3dpdm",
"swapport4dpdm",
"swapport5dpdm"
];

/*
	Hard straps related variables
*/
var StrapHashMapDefault = [];
var StrapHashMapAfterChange = [];
/*
	Hard straps list
*/
var straplistinOTP = [
"enableport1",
"enableport2",
"enableport3",
"enableport4",
"enableport5",
"nrdeviceport1",
"nrdeviceport2",
"nrdeviceport3",
"nrdeviceport4",
"downstreamBCsettingport1",
"downstreamBCsettingport2",
"downstreamBCsettingport3",
"downstreamBCsettingport4"
];

// Widgets that are radio buttons in GUI
var GwidgetlistRadio = [
"hubpower",
"i2senable",
"i2senablehid",
"downstreamBCsettingport1",
"downstreamBCsettingport2",
"downstreamBCsettingport3",
"downstreamBCsettingport4"
];

// Widgets that are Drop Down in GUI
var GwidgetlistDropDown = [
"flexport",
"PHYBOOST",
"SQUELCH",
"PHYBOOSTdownstreamsecondaryport",
"SQUELCHdownstreamsecondaryport",
"secondaryportHsRiseFall",
"upstreamHsRiseFall",
"PHYBOOSTdownstreamport1",
"SQUELCHdownstreamport1",
"downstreamport1HsRiseFall",
"PHYBOOSTdownstreamport2",
"SQUELCHdownstreamport2",
"downstreamport2HsRiseFall",
"PHYBOOSTdownstreamport3",
"SQUELCHdownstreamport3",
"downstreamport3HsRiseFall",
"PHYBOOSTdownstreamport4",
"SQUELCHdownstreamport4",
"downstreamport4HsRiseFall",
"PHYBOOSTdownstreamport5",
"SQUELCHdownstreamport5",
"downstreamport5HsRiseFall"
];

//Document START
$(document).ready(function () {
	//Display widgets with respect to the type of Microchip product selected.
	
	if (gbProductfun == "NonFlex") {
		
		$('#progID').show();
		$("#USB49_List").show();
		$("#USB47_List").hide();
		$("#secondaryHubDiv").show();
		$("#NCMdiv").show();
		$("#BPort5fieldset").show();
		$("#PORT5fieldset").show();
		$("#USB49Title").show();
		$("#USB47Title").hide();
		$("#otpflex").hide();
		$("#SecondaryPort").show();
	} else if (gbProductfun == "Flex") {
		$("#USB49_List").hide();
		$("#USB47_List").show();
		$("#secondaryHubDiv").hide();
		$("#NCMdiv").hide();
		$("#BPort5fieldset").hide();
		$("#PORT5fieldset").hide();
		$("#USB49Title").hide();
		$("#USB47Title").show();
		$("#otpflex").show();
		$("#primaryDiv").detach();
		$("#collapse_DI_PH").show();
		$("#uuidDiv").detach();
		$("#collapse_DI_UUID").show();
		$("#hceDiv").detach();
		$("#collapseSubHubcontroller0").show();
		$("#SecondaryPort").hide();
		
	} else {
	}
	
	$("#Apply").attr('disabled', true);
	$("#Reset").attr('disabled', true);
	
	$('#SaveFileField').hide();
	$('#SaveFileField').attr('disabled', 'disabled');
	$('#LoadFileField').removeAttr('disabled');
	$("#LoadFileField").attr('disabled', true);
	$('#LoadFileField').show();
	$("#LoadFileField").attr('disabled', true);

	update_status_message("Offline Configuration");
	clearWidgetMap();

	$("#devicedescriptortab").attr('disabled', true);
	$("#stringdescriptortab").attr('disabled', true);
	$("#Secondarydevicedescriptortab").attr('disabled', true);
	$("#Secondarystringdescriptortab").attr('disabled', true);
	$("#USB3otherdescriptortab").attr('disabled', true);
	$("#upstreamtab").attr('disabled', true);
	$("#downstreamtab").attr('disabled', true);
	$("#Bdownstreamtab").attr('disabled', true);
	$("#USB3_Bdownstreamtab").attr('disabled', true);
	$("#uch0tab").attr('disabled', true);
	$("#advancedtab").attr('disabled', true);
	$("#specialtab").attr('disabled', true);
	$("#registerVal").attr('disabled', true);
	$("#registerFile").attr('disabled', true);
	$("#cdctab").attr('disabled', true);
	
	
	
});
//Document END
var sku, FwMode="";
//var update = false;
$('#selectsku_usb49 li').on('click', function() {
	sku = $(this).text();
	update_status_message("Selected SKU is :" + sku);
	if(FwMode==="")
	{
		$('#overlaymode').show();
	}
	else
	{
		CheckSKUandPopulateDefaultValues();
	}
});

$('#select_mode li').on('click', function() {
	$('#nav').show();
	$('#close').hide();
	$('#closemode').hide();
	$('#sfield').hide();
	$('#sfieldFwMem').hide();
	document.getElementById("overlay").setAttribute("class","col-xs-2");
	document.getElementById("overlaymode").setAttribute("class","col-xs-2");
	FwMode = $(this).text();
	update_status_message("Selected Memory is :" + FwMode);
	
	if(FwMode === "ROM")	// ROM does not support EAP Strings
	{
		$('#hce1EAP_Div').hide();
		$('#hce2EAP_Div').hide();
		NCM_EAPlabel.innerText = "NCM/IAP Class Device";
		NCM_EAPlabel1.innerText = "NCM/IAP Class Device 1";
		NCM_EAPlabel2.innerText = "NCM/IAP Class Device 2";
	}
	else
	{
		$('#hce1EAP_Div').show();
		$('#hce2EAP_Div').show();
		NCM_EAPlabel.innerText = "NCM/IAP and IAP/EAP Class Device";
		NCM_EAPlabel1.innerText = "NCM/IAP and IAP/EAP Class Device 1";
		NCM_EAPlabel2.innerText = "NCM/IAP and IAP/EAP Class Device 2";
	}
	CheckSKUandPopulateDefaultValues();
});

function CheckSKUandPopulateDefaultValues() {
	//Enable, show all supports. Based on SKU Selection change 
	//Basic Features Tab
	$('#BPort1fieldset').show(); 
	$('#BPort2fieldset').show(); 
	$('#BPort3fieldset').show();
	$('#BPort4fieldset').show();
	$('#BPort5fieldset').show();
	
	// Battery charging
	$('#BdownstreamUSBPort1').show();
	$('#BdownstreamUSBport2').show();
	$('#BdownstreamUSBPort3').show();
	$('#BdownstreamUSBPort4').show();
	
	// Ports
	$('#enableport1').attr('disabled', false);
	$('#enableport2').attr('disabled', false);
	$('#enableport3').attr('disabled', false);
	$('#enableport4').attr('disabled', false);
	
	//Non-Removable
	$('#nrdeviceport1').attr('disabled', false);
	$('#nrdeviceport2').attr('disabled', false);
	$('#nrdeviceport3').attr('disabled', false);
	$('#nrdeviceport4').attr('disabled', false);
	
	//Advance features
	$('#PORT1fieldset').show();
	$('#PORT2fieldset').show();
	$('#PORT3fieldset').show();
	$('#PORT4fieldset').show();
	$('#PORT5fieldset').show();

	$("#port2advance").find('input, button').attr('disabled',false);
	$("#port3advance").find('input, button').attr('disabled',false);
	
	
	//CDC
	$("#CDC_Div").show();
			
	if(sku == "USB4914" || sku == "USB4916" || sku == "USB4912")
	{
		if(sku == "USB4914") {
			$('#BPort4fieldset').hide();
			$('#BPort5fieldset').hide();
			
			$('#enableport3').attr('disabled', true);
			$('#nrdeviceport3').attr('disabled', true);
			
			$("#port3advance").find('input, button').attr('disabled','disabled');
			
			$("#CDC_Div").hide();
			
		} else if (sku == "USB4916"){
			// Do Nothing
		}
		else if(sku == "USB4912") //1 Carplay port + 1 Standard port
		{
			$('#BPort3fieldset').hide();
			$('#BPort4fieldset').hide();
			$('#BPort5fieldset').hide();
						
			// Standard port does not support BC
			$('#BdownstreamUSBPort2').hide();
			
			$('#enableport2').attr('disabled', true);
			$('#nrdeviceport2').attr('disabled', true);

			$("#port2advance").find('input, button').attr('disabled','disabled');
			
			$("#CDC_Div").hide();
		}

		if(primaryCFlag == true) {
			$('#collapse_DI_PH').collapse('toggle');
		}
		$('#NCMdiv').show();
		//$("#copyNcmSection").show();
		$('#primaryDiv').hide();
		$("#SecondaryPort").hide();
		primaryCFlag = false;
		$('#collapse_DI_PH').show();
		$('#secondaryHubDiv').hide();
	} else if (sku == "USB4925" || sku == "USB4927") {
		
		$('#NCMdiv').hide();
		//$("#copyNcmSection").hide();
		$("#SecondaryPort").show();
		$('#primaryDiv').show();
		$('#secondaryHubDiv').show();
		
		if(primaryCFlag == true) {
			$('#collapse_DI_PH').collapse('toggle');
			
		}
		
		if(sku == "USB4925" ) {
			$('#BPort4fieldset').hide();
			$('#BPort5fieldset').hide();
			
			$('#enableport3').attr('disabled', true);
			$('#nrdeviceport3').attr('disabled', true);
			
			$("#port3advance").find('input, button').attr('disabled','disabled');
			
			$("#CDC_Div").hide();
		} else {
			$('#BPort4fieldset').show();
			$('#BPort5fieldset').show();
		}
		primaryCFlag = false;
	} else {
		
	}
	$('#SaveFileField').hide();
	$('#LoadFileField').show();
	clearWidgetMap();
	gArrConfigIndex = 0;
	LoadConfFile = "";
	changecount = 0;
	RegString="";
	document.getElementById("myForm").reset();
	$("#Reset").attr('disabled', false);
	reset_file_input();
	iniFile ="";
	offlineConfFile="";
	enable_all_fields();
	set_changed_fields_border_default();
	offline_MchpUsbClose();
	var ret = offline_MchpUsbOpen(dummyHubID,sku);
	OfflineSelectDeviceMemory(dummyHubID,FwMode);
	if(ret)
	{
		populateDefaultValues();
	}
	
}

$('#selectsku_usb47 li').on('click', function() {
	$('#nav').show();
	$('#close').hide();
	//$("#copyNcmSection").hide();
	document.getElementById("overlay").setAttribute("class","col-xs-2");
	$('#sfield').hide();
	sku = $(this).text();
	update_status_message("Selected SKU is :" + sku);
	if(sku == "USB4715")
	{
		$('#BPort2fieldset').show();
		$('#BPort3fieldset').show();
		$('#BPort4fieldset').show();
		$('#BPort5fieldset').hide();
		
		$('#PORT2fieldset').show();
		$('#PORT3fieldset').show();
		$('#PORT4fieldset').show();
		$('#PORT5fieldset').hide();
		
		$('#ConfigFlex2').show();
		$('#ConfigFlex3').show();
		$('#ConfigFlex4').show();
	}
	else if(sku == "USB4712")
	{
		$('#BPort2fieldset').hide();
		$('#BPort3fieldset').hide();
		$('#BPort4fieldset').hide();
		$('#BPort5fieldset').hide();
		
		$('#PORT2fieldset').hide();
		$('#PORT3fieldset').hide();
		$('#PORT4fieldset').hide();
		$('#PORT5fieldset').hide();
		
		$('#ConfigFlex2').hide();
		$('#ConfigFlex3').hide();
		$('#ConfigFlex4').hide();
	}
	$('#SaveFileField').hide();
	$('#LoadFileField').show();
	clearWidgetMap();
	gArrConfigIndex = 0;
	LoadConfFile = "";
	changecount = 0;
	RegString="";
	document.getElementById("myForm").reset();
	$("#Reset").attr('disabled', false);
	reset_file_input();
	iniFile ="";
	offlineConfFile="";
	enable_all_fields();
	set_changed_fields_border_default();
	offline_MchpUsbClose();
	var ret = offline_MchpUsbOpen(dummyHubID,sku);
	if(ret)
	{
		populateDefaultValues();
	}
	
});

$("#RegEntry").click(function () {
	var regOptionChosen = $("#Regoperationgroup").find(':checked').val();
	var Regop = "";
	var Regadd = "";
	var RegVal = "";
	var toDisplay = "";
	
	if (typeof regOptionChosen === 'undefined') {
		alert("Please choose an appropriate register operation under the Direct Register Access.");
		return;
	}

	if(regOptionChosen == 0)
	{
		Regop = "XMODE_WRITE_BYTE";
		toDisplay = "WRE";
	}
	else if(regOptionChosen == 1)
	{
		Regop = "XMODE_SET_BITS";
		toDisplay = "SET ";
	}
	else if(regOptionChosen == 2)
	{
		Regop = "XMODE_CLEAR_BITS"
		toDisplay = "CLR ";
	}
	else
	{
		Regop = "";
		//do nothing
	}
	Regadd = $("#Regaddress").val();
	var isOKAddr = /^[0-9A-Fa-f]{8}$/i.test(Regadd);
	RegVal = "" + $("#Regvalue").val();
	var newRegVal = RegVal.replace(/\s+/g, "");
	var RegValOkay = /^[0-9A-Fa-f]+$/i.test(newRegVal);
	
	if ((Regadd == "") || (RegVal == "")) {
		alert("Either the value of register address or the register value is not entered under the Direct Register Access.");
		return;
	}
	
	if (!isOKAddr) {
		alert("The Register Address entered under the Direct Register Access must be a 8 digit hexadecimal number.");
	}
	
	if (!RegValOkay) {
		alert("The Register value entered under the Direct Register Access is not a valid hexadecimal number.");
	}
	
	if (RegValOkay && isOKAddr) {
		if (Regop.length == 0) {
			alert("Please choose appropriate register operation.");
		} else {
			if (Regadd && RegVal) {
				if (RegString) {
					RegString = Regop + "+" + Regadd + "+" + newRegVal + "+" + RegString;
				} else {
					RegString = Regop + "+" + Regadd + "+" + newRegVal;
				}
				changecount = changecount+1;
				switchloadsave(changecount);
				
				update_status_message("Register Address: " + Regadd + " Register Value: " + RegVal + " for operation: " + Regop + " will be added in an ini file and programmed into the hub.");
				update_dra_status_message(toDisplay+"_"+ Regadd + "=" + RegVal);
			} else {
				alert("Either Register address or Register value is not added.");
			}
		}
		document.getElementById("myForm").reset();
	}
});

function setiniType() {
	setFileType("ini", 0);
}

function startRead() {
	iniFile = "";

	var file = document.getElementById("iniid").files[0];
	if (typeof file === 'undefined') {
		update_status_message("No configuration file(.ini) is selected.");
		iniFile = "";
		if (gINIFileSelected == true)
		{
			changecount = changecount-1;
			switchloadsave(changecount);
			gINIFileSelected = false;
		}
		alert("No configuration file(.ini) is selected.");
	} else {
		iniFile = file.name;
		extension = iniFile.substr(iniFile.lastIndexOf('.') + 1);
		
		if(extension != "ini")
		{
			alert("Selected File type is not supported. Please Select File type : ini");
			var mesg = ("Selected File type is not supported.Supported File type is .ini");
			update_status_message(mesg);
			iniFile ="";
			
			$("#iniid").val('');
			$("#iniid").css({
				background: "white",
				border: "0px"
			});
			errorFlag = true;
			return;
		} else {
			var mesg = ("Selected .ini file to program is :" + iniFile);
			update_status_message(mesg);
			var fileSizeInKb = file.size/1024;
			update_status_message("The size of the .ini file selected is " + fileSizeInKb.toFixed(2) + " KB");
				$("#iniid").css({
				background: "white",
				border: "0px"
				});
			update_status_message(mesg);
			changecount = changecount+1;
			
			switchloadsave(changecount);
			gINIFileSelected = true;
		}
	}
}
//Direct Register Access blocks End

//Onclick event for dropdown STARTS
$(document).on('click', '.dropdown li a', function (event) {
	// this code is for making the current selection appear with caret
	var $target = $(event.currentTarget);

	$target.closest('.btn-group')
	.find('[data-bind]').text($target.text())
	.end()
	.children('.dropdown-toggle').dropdown('toggle');
	var selop = $(this).text();
	console.log("Selected Option - All dropdowns:" + selop);
});
//Onclick event for dropdown ENDS


// Lookup for phyboost dropdown value selection
var DropDownPHYBOOST = [
"Nominal 17.78 mA",
"5% below nominal",
"10% above nominal",
"5% above nominal",
"20% above nominal",
"15% above nominal",
"30% above nominal",
"25% above nominal",
];

// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [
"Nominal 100mV",
"12.5mV below nominal",
"25mV below nominal",
"37.5mV below nominal",
"50mV below nominal",
"62.5mV below nominal",
"25mV above nominal",
"12.5mV above nominal",
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall =[
"Default",
"+18%",
"-18%",
"-12%"
];

// Lookup for Flexport selection
var DropDownflexport = [
"0",
"1",
"2",
"3",
"4"
];

//Mapping Hex widgets to the meaningful elaborations to print while in error
var Mapping = {
//Hex
"vid": "Primary Hub Vendor ID",
"pid": "Primary Hub Product ID",
"did": "Primary Hub Device ID",
"usbvcd": "USB2.0 Version",
"languageid": "Primary Hub Language ID",
"manufacturer": "Primary Hub Manufacturer",
"product" : "Primary Hub Product",
"serial": "Primary Hub SerialNumber",
"usb2uuid":"Primary Hub Universal unique ID",

"secondary_vid": "Secondary Hub Vendor ID",
"secondary_pid": "Secondary Hub Product ID",
"secondary_did": "Secondary Hub Device ID",
"secondary_usbvcd": "Secondary Hub USB2.0 Specification number",
"secondary_languageid": "Secondary Hub Language ID",
"secondary_manufacturer": "Secondary Hub Manufacturer",
"secondary_product" : "Secondary Hub Product",
"secondary_serial": "Secondary Hub SerialNumber",
"secondary_usb2uuid":"Secondary Hub Universal unique ID",

"enableport1":"Port1 Enable/Disable State",
"enableport2":"Port2 Enable/Disable State",
"enableport3":"Port3 Enable/Disable State",
"enableport4":"Port4 Enable/Disable State",
"enableport5":"Port5 Enable/Disable State",

"port1mapping":"Port1 Logical mapping",
"port2mapping":"Port2 Logical mapping",
"port3mapping":"Port3 Logical mapping",
"port4mapping":"Port4 Logical mapping",
"port5mapping":"Port5 Logical mapping",
"port6mapping":"Port6 Logical mapping",
"port7mapping":"Port7 Logical mapping",

"nrdeviceport1":"Port1 Non-removable State",
"nrdeviceport2":"Port2 Non-removable State",
"nrdeviceport3":"Port3 Non-removable State",
"nrdeviceport4":"Port4 Non-removable State",
"nrdeviceport5":"Port5 Non-removable State",
"nrdeviceport6":"Port6 Non-removable State",
"nrdeviceport7":"Port7 Non-removable State",


"downstreamBCsettingport1":"Port1 Battery charging State",
"downstreamBCsettingport2":"Port2 Battery charging State",
"downstreamBCsettingport3":"Port3 Battery charging State",
"downstreamBCsettingport4":"Port4 Battery charging State",

"swapport1dpdm":"Port1:Swap D+/D-",
"swapport2dpdm":"Port2:Swap D+/D-",
"swapport3dpdm":"Port3:Swap D+/D-",
"swapport4dpdm":"Port4:Swap D+/D-",
"swapport5dpdm":"Port5:Swap D+/D-",
"swapupstreamdpdm":"Upstream Port:Swap D+/D-",
"swapsecondaryportdpdm":"Secondary Port:Swap D+/D-",

"PHYBOOSTdownstreamport1":"Port1:PHYBOOST",
"PHYBOOSTdownstreamport2":"Port2:PHYBOOST",
"PHYBOOSTdownstreamport3":"Port3:PHYBOOST",
"PHYBOOSTdownstreamport4":"Port4:PHYBOOST",
"PHYBOOSTdownstreamport5":"Port5:PHYBOOST",
"PHYBOOST":"Upstream Port:PHYBOOST",
"PHYBOOSTdownstreamsecondaryport":"Secondary Port:PHYBOOST",

"SQUELCHdownstreamport1":"Port1:Varisense",
"SQUELCHdownstreamport2":"Port2:Varisense",
"SQUELCHdownstreamport3":"Port3:Varisense",
"SQUELCHdownstreamport4":"Port4:Varisense",
"SQUELCHdownstreamport5":"Port5:Varisense",
"SQUELCH":"Upstream Port:Varisense",
"SQUELCHdownstreamsecondaryport":"Secondary Port:Varisense",

"upstreamHsRiseFall":"Upstream High Speed rise/fall adjust",
"secondaryportHsRiseFall":"Secondary port: High Speed rise/fall adjust",
"downstreamport1HsRiseFall":"Port1:High Speed rise/fall adjust",
"downstreamport2HsRiseFall":"Port2:High Speed rise/fall adjust",
"downstreamport3HsRiseFall":"Port3:High Speed rise/fall adjust",
"downstreamport4HsRiseFall":"Port4:High Speed rise/fall adjust",
"downstreamport5HsRiseFall":"Port5:High Speed rise/fall adjust",

"flexport": "Flex Port",
"flexconnect":"Flexconnect",
"hceenable":"Hub Feature Controller State",
"hce_vid": "Hub Feature Controller Vendor ID",
"hce_pid": "Hub Feature Controller Product ID",
"hce_did": "Hub Feature Controller Device ID",
"hce_languageid": "Hub Feature Controller Language ID",
"hce_manufacturer":"Hub Feature Controller Manufacturer",
"hce_product":"Hub Feature Controller Product",
"hce_serial":"Hub Feature Controller SerialNumber",

"hce1_vid" : "NCM/IAP and IAP/EAP Class Device 1 Vendor ID",
"hce1_pid" : "NCM/IAP and IAP/EAP Class Device 1 Product ID",
"hce1_did" : "NCM/IAP and IAP/EAP Class Device 1 Device ID",
"hce1_languageid" : "NCM/IAP and IAP/EAP Class Device 1 Language ID",
"hce1_manufacturer" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer",
"hce1_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 1 Manufacturer String Length",
"hce1_product" : "NCM/IAP Class Device 1 Product",
"hce1_string5" : "NCM/IAP and IAP/EAP Class Device 1 Serial Number",
"hce1_productlen" : "NCM/IAP Class Device 1 Product String Length",
"hce1_macaddr" : "NCM/IAP Class Device 1 MAC address",
"hce1_eapproduct" : "IAP/EAP Class Device 1 Product String",
"hce1_eapinterface" : "IAP/EAP Class Device 1 Interface String",


"hce2_vid" : "NCM/IAP and IAP/EAP Class Device 2 Vendor ID",
"hce2_pid" : "NCM/IAP and IAP/EAP Class Device 2 Product ID",
"hce2_did" : "NCM/IAP and IAP/EAP Class Device 2 Device ID",
"hce2_languageid" : "NCM/IAP and IAP/EAP Class Device 2 Language ID",
"hce2_manufacturer" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer",
"hce2_manufacturerlen" : "NCM/IAP and IAP/EAP Class Device 2 Manufacturer String Length",
"hce2_product" : "NCM/IAP Class Device 2 Product",
"hce2_productlen" : "NCM/IAP Class Device 2 Product String Length",
"hce2_string5" : "NCM/IAP and IAP/EAP Class Device 2 Serial Number",
"hce2_macaddr" : "NCM/IAP Class Device 2 MAC address",
"hce2_eapproduct" : "IAP/EAP Class Device 2 Product String",
"hce2_eapinterface" : "IAP/EAP Class Device 2 Interface String",


"i2senable":"I2S Feature Select",
"i2senablehid":"HID Feature Select",
"power_ontime":"Power-on time",
"cdcenable":"CDC State",
"hubpower":"Hub Power",
"maxpowerself":"Hub MaxPower(Self)",
"hubcmaxpowerself":"Hub Circuit MaxCurrent (Self)",
"maxpowerbus":"Hub MaxPower (Bus)",
"hubcmaxpowerbus":"Hub Circuit MaxCurrent (Bus)",
"hsdisable":"Hub Full Speed Mode",
"lpmenable":"LPM State",
"xdataentry":"Direct Register Access",
"xdataprogram":"ini File"
};

(function ($) {
    enable_all_fields = function () {
		$("#registerVal").attr('disabled',false);
		$("#registerFile").attr('disabled',false);
        $("#devicedescriptortab").attr('disabled', false);
        $("#stringdescriptortab").attr('disabled', false);
        $("#Secondarydevicedescriptortab").attr('disabled', false);
        $("#Secondarystringdescriptortab").attr('disabled', false);
        $("#USB3otherdescriptortab").attr('disabled', false);
        $("#upstreamtab").attr('disabled', false);
        $("#downstreamtab").attr('disabled', false);
        $("#Bdownstreamtab").attr('disabled', false);
        $("#USB3_Bdownstreamtab").attr('disabled', false);
        $("#uch0tab").attr('disabled', false);
        $("#advancedtab").attr('disabled', false);
        $("#specialtab").attr('disabled', false);
        $('#BPort1fieldset').attr('disabled', false);
        $('#BPort2fieldset').attr('disabled', false);
        $('#BPort3fieldset').attr('disabled', false);
        $('#BPort4fieldset').attr('disabled', false);
	$('#BPort5fieldset').attr('disabled', false);
        $('#PORT1fieldset').attr('disabled', false);
        $('#PORT2fieldset').attr('disabled', false);
        $('#PORT3fieldset').attr('disabled', false);
        $('#PORT4fieldset').attr('disabled',false);
     	$('#cdctab').attr('disabled', false);
		
    };
})(jQuery);

// Parse Configuration - Start
function getParseConftype() {
	setFileType("cfg_parse", 0);
}
function setParseSavetype() {
	setFileType("txt",1);
}

function ParseConfigFile(){
	var file = document.getElementById("Parsefileid").files[0];

	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		parseConfigFile = "";
		alert("No configuration file(.cfg) is selected.");

	}else{
		parseConfigFile = file.name;
		extension = parseConfigFile.substr(parseConfigFile.lastIndexOf('.') + 1);
		if((extension != "cfg" && extension != "dump") && extension != "bin")
		{
			alert("Selected File type is not supported. Supported File type : .cfg/.dump/.bin");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			parseConfigFile = "";
			$("#Parsefileid").val('');
			$("#Parsefileid").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}
		else{
			var mesg = ("Selected files to parse is :" + parseConfigFile);
			update_status_message(mesg);
			ParseCfgFileExt = parseConfigFile.replace(/(.*)\.[^.]+$/, "cfg_parse")
			var ParseFileSizeInKb = file.size/1024;
			if(ParseFileSizeInKb > (1024 * 8))
			{
				alert("File size not supported. Maximum File size can be 2KB");
				var mesg = ("File size not supported. Maximum File size can be 2KB");
				update_status_message(mesg);
				parseConfigFile = "";
				$("#Parsefileid").val('');
				$("#Parsefileid").css({
				background: "white",
				border: "0px"
				});
				errorFlag = true;
				return;
			}
			update_status_message("The size of the selected file selected is " + ParseFileSizeInKb.toFixed(2) + " KB");
				$("#Parsefileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}
function ParseSaveFile(){
	parseSaveFile = "";
	var file = document.getElementById("ParseSavefileid").files[0];
	if(file)
	{
		$("#ParseSavefileid").css({
			background: "white",
			border: "0px"
		});
		parseSaveFile = file.name;
		var saveextension = parseSaveFile.substr(parseSaveFile.lastIndexOf('.') + 1);
		if(saveextension === parseSaveFile )
		{
			parseSaveFile = parseSaveFile + ".txt";
		}
		else if(saveextension === "txt")
		{
			var mesg = ("Selected .txt file to save Configuration file parse output is :" + parseSaveFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .txt");
			update_status_message("Selected File Type is not supported.Supported File type is .txt");
			$("#ParseSavefileid").val('');
			$("#ParseSavefileid").css({
			background: "white",
			border: "0px"
			});
			parseSaveFile="";
			return;
		}
	}
	else
	{
		parseSaveFile = "";
	}
}

function Parsefiles(){
	var data = "";
	//Dont allow user to parse when file name is not present
	if($('#saveparse').is(':checked')){
		if(parseSaveFile == "") {
			alert("Please provide file name to proceed");
			return -1;
		}
	}
	data = UsbParseCfgFile(parseSaveFile);
	if(typeof data === 'undefined')
	{
		alert("Failed to parse selected file");
		update_status_message("Failed to parse selected file");
	}
	else
	{
		document.getElementById("ParseConfigureArea").value = data;
		alert("Parse Configuration file Success");
		update_status_message("Parse Configuration file Success");
	}
}
// Parse Configuration file - End

function MergerReadFirstFile() {
	var file = document.getElementById("Mergerfileid").files[0];
	
	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		FirstMergecfgFile = "";
		alert("No configuration file(.cfg) is selected.");

	} else {
		FirstMergecfgFile = file.name;
		extension = FirstMergecfgFile.substr(FirstMergecfgFile.lastIndexOf('.') + 1);
		if((extension != "cfg"))
		{
			alert("Selected File type is not supported. Select File type : cfg");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			FirstMergecfgFile ="";
			$("#Mergerfileid").val('');
			$("#Mergerfileid").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}else{
			var mesg = ("Selected .cfg files to program are :" + FirstMergecfgFile);
			update_status_message(mesg);
			var firstFileSizeInKb = file.size/1024;
			update_status_message("The size of the .cfg files selected are " + firstFileSizeInKb.toFixed(2) + " KB");
				$("#Mergerfileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}

function MergerReadSecondFile() {
	var file = document.getElementById("Mergerfileid1").files[0];
	
	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		SecondMergecfgFile = "";
		alert("No configuration file(.cfg) is selected.");

	} else {
		SecondMergecfgFile = file.name;
		extension = SecondMergecfgFile.substr(SecondMergecfgFile.lastIndexOf('.') + 1);
		if((extension != "cfg"))
		{
			alert("Selected File type is not supported. Select File type : cfg");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			SecondMergecfgFile ="";
			$("#Mergerfileid1").val('');
			$("#Mergerfileid1").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}else{
			var mesg = ("Selected .cfg files to program are :" + SecondMergecfgFile);
			update_status_message(mesg);
			SecondMergecfgFile = SecondMergecfgFile.replace(/(.*)\.[^.]+$/, "cfg_merge");
			var firstFileSizeInKb = file.size/1024;
			update_status_message("The size of the .cfg files selected are " + firstFileSizeInKb.toFixed(2) + " KB");
				$("#Mergerfileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}

function getmergeConftype() {
	setFileType("cfg", 0);
}

function getmergeSecondConftype() {
	setFileType("cfg_merge", 0);
}

function setmergeConftype() {
	setFileType("cfg_out", 1);
}

function mergefiles() {
	
	var bRet = false;
	
	if(FirstMergecfgFile != "")
	{
		if(SecondMergecfgFile != "") {
			bRet = UsbMergeCfgFile(mergeConfFile);
		} else {
			alert("Please Select File to merge configuration");
			update_status_message("Please Select File to merge configuration");
			return;
		}
	}
	else {
		alert("Please Select File to merge configuration");
		update_status_message("Please Select File to merge configuration");
		return;
	}
	
	if(bRet)
	{
		mergeConfFile = "";
		FirstMergecfgFile = "";
		SecondMergecfgFile = "";
		alert("Merged file was created successfully");
		update_status_message("Merged file was created successfully");
		
	} else {
		alert("Failed to merge two configuration files");
		update_status_message("Failed to merge two configuration files");
	}
}

function getmergeConfFile() {
	mergeConfFile = "";
	var file = document.getElementById("mergeConfFileID").files[0];
	var fileSizeInKb = file.size/1024;
	update_status_message("The size of the Configuration file selected is " + fileSizeInKb + " KB");
	if (file) {
		$("#mergeConfFileID").css({
			background: "white",
			border: "0px"
		});
		mergeConfFile = file.name;
		var saveextension = mergeConfFile.substr(mergeConfFile.lastIndexOf('.') + 1);
		if(saveextension === mergeConfFile)
		{
			mergeConfFile = mergeConfFile + ".cfg";
		}
		else if(saveextension === "cfg")
		{
			var mesg = ("Selected .cfg file to save is :" + mergeConfFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .cfg");
			update_status_message("Selected File Type is not supported.Supported File type is .cfg");
			$("#mergeConfFileID").val('');
			$("#mergeConfFileID").css({
			background: "white",
			border: "0px"
			});
			mergeConfFile="";
			return;
		}
	} else {
		$("#mergeConfFileID").css({
			background: "yellow",
			border: "3px red solid"
		});
		update_status_message("No configuration file(.cfg) is selected.");
		mergeConfFile = "";
		alert("No configuration file(.cfg) is selected.");
	}
}

function getOfflineConf() {
	offlineConfFile = "";
	var file = document.getElementById("offlineConfFileID").files[0];
	var fileSizeInKb = file.size/1024;
	update_status_message("The size of the Configuration file selected is " + fileSizeInKb + " KB");
	if (file) {
		$("#offlineConfFileID").css({
			background: "white",
			border: "0px"
		});
		offlineConfFile = file.name;
		var saveextension = offlineConfFile.substr(offlineConfFile.lastIndexOf('.') + 1);
		if(saveextension === offlineConfFile)
		{
			offlineConfFile = offlineConfFile + ".cfg";
		}
		else if(saveextension === "cfg")
		{
			var mesg = ("Selected .cfg file to save is :" + offlineConfFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .cfg");
			update_status_message("Selected File Type is not supported.Supported File type is .cfg");
			$("#offlineConfFileID").val('');
			$("#offlineConfFileID").css({
			background: "white",
			border: "0px"
			});
			offlineConfFile="";
			return;
		}
	} else {
		$("#offlineConfFileID").css({
			background: "yellow",
			border: "3px red solid"
		});
		update_status_message("No configuration file(.cfg) is selected.");
		offlineConfFile = "";
		alert("No configuration file(.cfg) is selected.");
	}
}
var gArrConfigFilelist = [];
var gArrConfigIndex = 0;
function startReadcfg() {
	LoadConfFile = "";
	var fileextension;
	var file = document.getElementById("offlineConfload").files[0];
	var fileSizeInKb = file.size/1024;
	var Filelist = "";
	var canAllow = false;
	var fileSize = file.size;
	LoadConfFile = file.name;
	fileextension = LoadConfFile.substr(LoadConfFile.lastIndexOf('.') + 1);
	if(fileextension == "cfg" || fileextension == "dump")
	{
		update_status_message("The size of the Configuration file selected is " + fileSizeInKb.toFixed(2) + " KB");
	} else {
		alert("Selected File Type is not supported. Please Select File type : .cfg/.dump");
		//reset_file_input();
		$("#offlineConfload").val('');
		$("#offlineConfload").css({
			background: "white",
			border: "0px"
			});
		LoadConfFile ="";
		return;
	}

	if (file) {
		
		if (fileextension == "dump") {
			if (fileSize == 8192) {
				canAllow = true;
			} else {
				update_status_message("The size of configuration file \"" + file.name + "\" should be 8KB for USB57X4 hub.");
				LoadConfFile = "";
				alert("The size of configuration file \"" + file.name + "\" should be 8KB for USB57X4 hub.");
				return;
			}
		} else if (fileextension == "cfg") {
			if (fileSize <= 8192) {
				canAllow = true;
			} else {
				update_status_message("The size of configuration file \"" + file.name + "\" cannot exceed 8KB for USB57X4 hub.");
				LoadConfFile = "";
				alert("The size of configuration file \"" + file.name + "\" cannot exceed 8KB for USB57X4 hub.");
				return;
			}
		} else {
			//Do nothing	
		}
	}
	
	if (canAllow) {
		$("#offlineConfload").css({
			background: "white",
			border: "0px"
		});
	}
	
	if (gArrConfigIndex > 15)
	{
		alert("Max configuration file count is 15");
		return;
	}
	gArrConfigFilelist[gArrConfigIndex++] = LoadConfFile;
	var Texttodisplay = "Loaded Configuration files are ";
	for(var i = 0; i < gArrConfigIndex; i++)
	{
		Filelist = Filelist + gArrConfigFilelist[i] + ",";
	}
	update_status_message(Texttodisplay + Filelist);
	//overrideDefaultOfflineConfig function will return strap values in LoadConfFile
	//Return string format is "widget:value###widget:value.."
	
	var StrapValues = overrideDefaultOfflineConfig(dummyHubID,LoadConfFile);
	
	if(StrapValues == null)
	{
		alert("Not a valid file");
	}
	var Straps = StrapValues.split("###");
	$.each(Straps, function (idx, value) {
		var widgetvalpairs = value.split(":");
		//After load configuration file , there may be new values for straps.
		//Update to StrapHashMapAfterChange hashmap for later comparison
		StrapHashMapAfterChange[widgetvalpairs[0]] = widgetvalpairs[1];
	});
	//offline_MchpUsbClose();
	populateDefaultValues();
	
}

function setOfflineConf() {
	setFileType("cfg", 1);
}
function getOfflineConftype() {
	setFileType("cfg_dump", 0);
}

(function ($) {
    update_status_message = function (mesg) {
        //var time = new Date($.now()); // returns huge string
        var currentdate = new Date(); 
        currentdate+''; 
        var datetime = currentdate.toLocaleString();
        $("#DSStatusMessage").append( datetime +":"+ mesg + "\n");
        $("#DSStatusMessage").animate({
            scrollTop:$("#DSStatusMessage")[0].scrollHeight - $("#DSStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

(function ($) {
    update_dra_status_message = function (mesg) {
        $("#DRStatusMessage").append(mesg + "\n");
        $("#DRStatusMessage").animate({
            scrollTop:$("#DRStatusMessage")[0].scrollHeight - $("#DRStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

// Reset all fields
$("#Reset").click(function() {
	clearWidgetMap();
	set_changed_fields_border_default();
	$("input[type='file']").val('');
	offline_MchpUsbClose();
	var ret = offline_MchpUsbOpen(dummyHubID,sku);
	if(ret)
	{
		populateDefaultValues();
	}
	
	document.getElementById("ParseConfigureArea").value = "";
	$('#saveparse').prop('checked',false);
	iniFile ="";
	offlineConfFile="";
	LoadConfFile = "";
	gArrConfigIndex = 0;
	RegString="";
	document.getElementById("myForm").reset();
	changecount =0;
	$('#memoryChoice').hide();
	$("#Apply").attr('disabled',true);
	reset_file_input();
	resetVariables();
	RegString = "";
	iniFile = "";
	document.getElementById("DRStatusMessage").value = "";
	document.getElementById("DRStatusMessage").innerHTML="";
});
// End of Reset all fields


//Populating the default widget values based on the SKU
function populateDefaultValues() {
	
var skuName = sku; //Get from the dropdown
	
	//Setting the configuration mode to offline in the backend
	setConfigMode(true, skuName);

	//gArrConfigIndex is 0 means none of config files are loaded.
	//Hashmap map should have default values.
	if (gArrConfigIndex == 0) {
	    $.each(straplistinOTP, function (index, value) {
	        StrapHashMapDefault[value] = "DEFAULT";
	        StrapHashMapAfterChange[value] = "DEFAULT"
	    });
	}
	
	// Updating GwidgetlistHex
	$.each(GwidgetlistHex, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(dummyHubID, value);
		
		if (widgetValue) {
			var decvalue = parseInt(widgetValue,10);
			var hexstring;
			if (value == "usbvcd" || value == "secondary_usbvcd") // remove the '.' added before
			{
				var dot = ".";
				var hexvalue = (decvalue.toString(16));
				var position = 1;
				var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
			} else {
				hexstring = decvalue.toString(16); //"0x" +  (decvalue.toString(16) );
			}
			$(widgetid).val(hexstring);
		}
	});

	// Updating GwidgetlistString
	$.each(GwidgetlistString, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(dummyHubID, value);
		
		if((widgetValue === " ") || (widgetValue === "")) {
			$(widgetid).val("");
			$(widgetid).attr('placeholder', stringnullvalue);
			//$(widgetid).attr('placeholder',stringnullvalue);
		} else {
			$(widgetid).val(widgetValue);
		}
	});

	// Updating GwidgetlistInt
	$.each(GwidgetlistInt, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(dummyHubID, value);
		
		if(widgetValue === "") {
			$(widgetid).val("");
		} else {
			var decVal;
			if (value == "hub3maxpowerselfbus") {
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal,10);
				decVal = decVal * 8;
			} else if((value == "hubcmaxpowerbus") || (value == "hubcmaxpowerself")) {
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal,10);
			} else {
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal,10);
				decVal = decVal * 2;
			}
			$(widgetid).val(decVal);
		}
	});

	// Updating GwidgetlistCheckbox
	$.each(GwidgetlistCheckbox, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(dummyHubID, value);
		
		if(sku == "USB4912" || sku == "USB4712")
		{
			if(sku == "USB4912")
			{
				if(value == "enableport2" || value == "nrdeviceport2") {
					widgetValue = getWidgetValue(dummyHubID,"nrdeviceport5");
					widgetValue = getWidgetValue(dummyHubID,"enableport5");
					$("#BdownstreamUSBport2").hide();
					$("#PORT3fieldset").hide();
					$("#PORT4fieldset").hide();
					$("#PORT5fieldset").hide();
				}
			}
			else if(sku == "USB4712")
			{
				$("#PORT2fieldset").hide();
				$("#PORT3fieldset").hide();
				$("#PORT4fieldset").hide();
				$("#PORT5fieldset").hide();
			}
		}
		else if(sku == "USB4925" || sku == "USB4914") {
			if(value == "enableport3" || value == "nrdeviceport3") {
				widgetValue = getWidgetValue(dummyHubID,"nrdeviceport5");
				widgetValue = getWidgetValue(dummyHubID,"enableport5");
				$("#usbnr3div").attr('disabled', true);
				$("#BdownstreamUSBPort3").hide();
				$("#PORT4fieldset").hide();
				$("#PORT5fieldset").hide();
			}
			
		} else {
			
			if(value == "nrdeviceport5") {
				widgetValue = getWidgetValue(dummyHubID,"nrdeviceport5");
				
				$("#usbnr5div").attr('disabled', true);
			}
			if(sku != "USB4715") {
				$("#PORT5fieldset").show();
			}
			$("#BdownstreamUSBPort3").show();
			$("#PORT4fieldset").show();
			
		}
			if ( widgetValue == checkbox_checked_value )
			{
				$(widgetid).prop('checked',true);     
				// If there are corresponding fieldsets - enable them 
				$(widgetid).trigger("change"); 
				if(value == "flexconnect") {
					$("#flexportULButton").attr('disabled', false);
				}
				//set_changed_fields_border_default();
			}
			else {
				$(widgetid).prop('checked',false);
				// If there are corresponding fieldsets - disable them 
				$(widgetid).trigger("change"); 
				if(value == "flexconnect") {
					$("#flexportULButton").attr('disabled', true);
				}
				//set_changed_fields_border_default();
			}
		//}
	});
	
	// Updating GwidgetlistDropDown
	$.each(GwidgetlistDropDown, function( index, value ) {
		
		var widgetValue = getWidgetValue(dummyHubID, value);
		
		var decval = parseInt(widgetValue,10);
		var nameofcontrol = "." + value + "1";
		var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";
		var selText;
		
		if ( value == "flexport")
		{
			$.each(DropDownFlexPort, function( index, valuelist ) {
				if ( index == decval)
				{   
					selText = valuelist;
				}
			});
		
		}
		
		if ( value == "PHYBOOST" || value=="PHYBOOSTdownstreamport1" || value == "PHYBOOSTdownstreamsecondaryport"
		|| value=="PHYBOOSTdownstreamport2" || value=="PHYBOOSTdownstreamport3"
		|| value=="PHYBOOSTdownstreamport4" || value == "PHYBOOSTdownstreamport5")
		{
			$.each(DropDownPHYBOOST, function( index, valuelist ) {
				if (index == decval)
				{   
					selText = valuelist;
				}
			});
		
		}
		
		if ( value == "SQUELCH" || value=="SQUELCHdownstreamport1" || value == "SQUELCHdownstreamsecondaryport"
		|| value=="SQUELCHdownstreamport2" || value=="SQUELCHdownstreamport3"
		|| value=="SQUELCHdownstreamport4" || value=="SQUELCHdownstreamport5")
		{
			$.each(DropDownSQUELCH, function( index, valuelist ) {
				if ( index == decval)
				{   
					selText = valuelist;
				}
			});
		}
		if(value == "upstreamHsRiseFall" || value=="downstreamport1HsRiseFall" || value == "secondaryportHsRiseFall"
		|| value=="downstreamport2HsRiseFall" || value =="downstreamport3HsRiseFall"
		|| value=="downstreamport4HsRiseFall" || value=="downstreamport5HsRiseFall")
		{
			$.each(DropDownHSRiseFall, function( index, valuelist ) {
				if ( index == decval)
				{   
					selText = valuelist;
				}
			});
		}
		// Update fields based on obtained value
		$(nameofcontrol)
	   .find(nameofcontrol1).text(selText)
		.children('.dropdown-toggle').dropdown('toggle');
	});

	// Updating GwidgetlistRadio
	$.each(GwidgetlistRadio, function( index, value ) {
		
		var groupname = value +"group";
		
		var widgetValue = getWidgetValue(dummyHubID, value);
		
		var nameofcontrol = "input[name=" + groupname + "][value=" + widgetValue + "]";
			$(nameofcontrol).prop("checked", true);
			
		if ( value === "hubpower")
		{
			var widgetid = "#hubpowergroup";
			// If there are corresponding fieldsets - enable them 
			$(widgetid).trigger("change"); 
			if (widgetValue == "0") { // Bus power
				// Disable the fields
				
				$('#selfpowerfieldset').hide();
				$('#buspowerfieldset').show();
			} else if (widgetValue == "1") { // Self power
				// Disable the fields
				
				$('#buspowerfieldset').hide();
				$('#selfpowerfieldset').show();
			}
			set_changed_fields_border_default();
		}
		if(value === "i2senable") {
			
			if(widgetValue == "1") 
			{
				document.getElementById("speakermeute").disabled=false;
				document.getElementById("bothms").disabled=true;
				document.getElementById("bothms1").disabled=true;
			} else if(widgetValue == "2") {
				document.getElementById("speakermeute").disabled=true;
				document.getElementById("bothms1").disabled=true;
				document.getElementById("bothms").disabled=false;
				
			} else if(widgetValue == "3") {
				document.getElementById("speakermeute").disabled=false;
				document.getElementById("bothms1").disabled=false;
				document.getElementById("bothms").disabled=false;
			} else if(widgetValue == "0") {
				
				document.getElementById("speakermeute").disabled=true;
				document.getElementById("bothms1").disabled=true;
				document.getElementById("bothms").disabled=true;
			}
			
		}
	});
		
				if ($('#enableport1').is(':checked')) {
					// Enable the fieldset                    
					$('#downstreamport1Fieldset').removeAttr('disabled');
					
					$('#nr1div').removeAttr('disabled');
					$('#BdownstreamUSBport1').removeAttr('disabled');
				}
				if ($('#enableport2').is(':checked')) {
					// Enable the fieldset                    
					$('#downstreamport2Fieldset').removeAttr('disabled');
					
					$('#nr2div').removeAttr('disabled');
					$('#BdownstreamUSBport2').removeAttr('disabled');
				}
				if ($('#enableport3').is(':checked')) {
					// Enable the fieldset                    
					$('#downstreamport3Fieldset').removeAttr('disabled');
					
					$('#nr3div').removeAttr('disabled');
					$('#BdownstreamUSBport3').removeAttr('disabled');
				}
				if ($('#enableport4').is(':checked')) {
					// Enable the fieldset                    
					$('#downstreamport4Fieldset').removeAttr('disabled');
					
					$('#nr4div').removeAttr('disabled');
					$('#BdownstreamUSBport4').removeAttr('disabled');
					
				} 
				
				if ($('#enableport5').is(':checked')) {
					// Enable the fieldset                    
					$('#downstreamport5Fieldset').removeAttr('disabled');
					
					
				}//BdownstreamUSBport1*/
				
			
}

 function ValidateMac(currMac) {
	
	var MacValue = currMac.split(":");
	
	var maclength = MacValue.length;
	
	if(maclength < 6 || maclength > 6)
	{
		alert("The Given MAC Address is not valid.Mac Address should be for Example = 00:80:0F:10:20:01");
		return false;
	}
	MacValue[0] = parseInt(MacValue[0],16);
	if((MacValue[0] & 0x01) === 0x01)
	{
		alert("MAC Address should not be a Multicast or Broadcast address.");
		return false;
	}
	
	var regex = /^([0-9a-fA-F]{2}[:-]){5}([0-9A-F]{2})$/;
  
	var isMacOKAddr = regex.test(currMac);
	
	if(!isMacOKAddr)
	{
		alert("The Given MAC Address is not a valid Mac Address.");
		return false;
	}

	return true;
}

//Apply changes function
$("#Apply").click(function() {
	//Array to save the widgets and their values which were changed.
	
		var deltaobj = [];
		var modifiedWidgets = [];
		var sentinel = true;
		var mismatchCheck = 0;
		var currentvalue="NONE";
		var enableFlex = false;
		var enableport = false;
		// Check length of strings constraint
		var usb2StringLength = 0;
		var secondaryhubStringLength = 0;
		var hcemanuStringLength = 0;
		var hceprodStringLength = 0;
		var hce1prodStringLength = 0;
		var hce2prodStringLength = 0;
		
		var primaryDefaultlen = 126;
		var SecondaryDefaultlen = 126;
		var HCEDefaultlen = 126;
		var EAPDefaultLen = 111;
		
		var usb2StringFlag = true;
		var secondaryhubStringFlag = true;
		var hce2StringFlag = true;
		var hce1StringFlag = true;
		var hceStringFlag = true;
		
		var port1dontchange=0;
		var port2dontchange=0;
		var port3dontchange=0;
		var port4dontchange=0;
		var port5dontchange=0;
		var port6dontchange=0;
		var port7dontchange=0;
		
		//Set this variable when Non-removable parameter of a hub is modified
		var nrModified = false;
		var nr1Modified = false;
		var nr2Modified = false;
		var nr3Modified = false;
		var nr4Modified = false;
		
		// Find out currently how many ports are enabled
		var bEnable1 = $(enableport1).is(':checked');
		var bEnable2 = $(enableport2).is(':checked');
		var bEnable3 = $(enableport3).is(':checked');
		var bEnable4 = $(enableport4).is(':checked');
		var bEnable5 = $(enableport5).is(':checked');
		
		var bTotal = bEnable1+bEnable2+bEnable3+bEnable4 + bEnable5;
		
		if((sku == "USB4912") || (sku == "USB4712")) {
			bTotal = bEnable1+bEnable2; 
		} else if ((sku == "USB4914") || (sku == "USB4925")) {
			bTotal = bEnable1+bEnable2+bEnable3; 
		} else if((sku == "USB4916") || (sku == "USB4927") || (sku == "USB4715")) {
			bTotal = bEnable1+bEnable2+bEnable3+bEnable4 + bEnable5;
		}
		
		var hceStatus = $('#hceenable').is(':checked')?1:0;
		
		var EapStrAlert = false; //Alert for EAP1
		var EapStrAlert1 = false; //Alert for EAP2
		var EapStrLengthVerify = false;
    	
    	
		// Check the hceenable and portenable validity
		if (hceStatus == 0 && bTotal==false) {
				
			var option = confirm("Hub controller is disabled.After programming all the ports will be disabled. do you want to continue?");
			if(!option) {
				update_status_message("Programming of the device was terminated by the user.");
				return -1;
			}
		}
		
		// Check Port Disable condition
		var port1Status = $('#enableport1').is(':checked')?1:0;
		var port2Status = $('#enableport2').is(':checked')?1:0;
		var port3Status = $('#enableport3').is(':checked')?1:0;
		var port4Status = $('#enableport4').is(':checked')?1:0;
		var port5Status = $('#enableport5').is(':checked')?1:0;
		
		//flag for alert message
		var errorFlag = false;
		
		if (offlineConfFile == "") {
			update_status_message("Please select a file to save the offline Configuration.");
			alert("Please select a file to save the offline Configuration.");
			return;
		}
		
		//Hex Descriptors
		$.each(GwidgetlistHex, function( index1, value1 ) {
			var widgetid = "#" + value1;
			var oldval;
			var newval;
			var isOk;
			
			if(value1 === "usbvcd" || value1 === "secondary_usbvcd") {
				var usbvcdVal = parseInt(getWidgetValue(dummyHubID, value1), 10);
				var dot = ".";
				var hexvalue = (usbvcdVal.toString(16));
				var position = 1;
				var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
				oldval = hexstring;
				newval = $(widgetid).val();
								
				if (value1 == "usbvcd" || value1 === "secondary_usbvcd") {
					isOk = /^2\.?[0-9]{0,2}$/i.test($(widgetid).val());
				}
				
				if (typeof isOk == 'undefined') {
					return;
				}
				if (!isOk) {
					update_status_message("The value entered for \"" + Mapping[value1] + "\" is not valid.");
					alert("The value entered for \"" + Mapping[value1] + "\" is not valid");
					errorFlag = true;
				}
			} else {
				
				oldval = parseInt(getWidgetValue(dummyHubID, value1), 10);
				isOk = /^[0-9A-Fa-f]{1,4}$/i.test($(widgetid).val());
				newval = parseInt($(widgetid).val(), 16);
				
				if ((value1 == "vid") || (value1 == "hce_vid")) {
					var widID = "#" + value1;
					var widVal = $(widID).val();
					if (widVal == 0) {
						isOk = false;
					}
				}
				
				if (!isOk) {
					
					update_status_message("The value entered for \"" + Mapping[value1] + "\" must be a 4 digit hexadecimal value and it cannot be Zero.");
					alert("The value entered for \"" + Mapping[value1] + "\" must be a 4 digit hexadecimal value and it cannot be Zero.");
					errorFlag = true;
					
				}
			}
			
			if (!isOk) {
				// Do nothing. The value entered does not meet the expected pattern.
			} else {
				
				if ((oldval === newval) || isNaN(newval)) {
					//Do nothing
						
				} else {
					//Check for language ID
					
					if ((value1 == "languageid") || (value1 == "hce_languageid")) {
						if (newval == 0) {
							alert("Language ID cannot be zero. Setting it to default value (0x409)");
							newval = parseInt("0x409", 16);
						}
					}
					// Adding the VID of USB2.0 and HCE to Protouch2.ini, if they are modified.
					if ((value1 == "vid") || (value1 == "hce_vid")) {
						var valueEntered = $(widgetid).val();
						var hexEntered = "0x" + valueEntered;
						updateINI(hexEntered);
						vidModified = true;
					}

					// convert string to number                                        
					var decvalue = parseInt(newval,10);
					// convert number to string and then string to hex
					var valueToSet;
					if (value1 =="usbvcd" || value1 =="secondary_usbvcd") // remove the '.' added before
					{
						newval = newval.replace('.', '');
						decvalue = parseInt(newval,10);
						valueToSet = decvalue;
					
					}
					else {
						valueToSet = "0x" +  (decvalue.toString(16) ); 
					}
					
					var that = $( widgetid ), parent = that.closest('fieldset');
					var  checkdisabled = $(parent).prop( "disabled" );
					if ( checkdisabled )
					{
						// Change detected but field is disabled - So do nothing
						console.log("change detected but field disabled: widget:" + value1 + " new value:" + hexstring);
						if(value1 == "hce1_did" || value1 == "hce1_pid" || value1 == "hce1_vid" || value1 == "hce1_languageid" || value1 == "hce2_languageid" ||
							value1 == "hce2_did" || value1 == "hce2_pid" || value1 == "hce2_vid") {
							deltaobj.push(value1,valueToSet);
						}
					}
					else {
						deltaobj.push(value1,valueToSet);
					}
				}
			}
		});

		
		$.each(GwidgetlistRadio, function(index1, value1) {
			var widgetgroupname = '#' + value1 +"group";
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			var newval = $(widgetgroupname).find(':checked').val();
			var that = $( widgetgroupname ), parent = that.closest('fieldset');
			var  checkdisabled = $(parent).prop( "disabled" );
			
			if ((oldval === newval) || jQuery.isEmptyObject(newval))
			{// do nothing
				//If Port splitting is already enabled and only GPIO needs to be updated
				//Port 5
			}	
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
				console.log("change detected but field disabled: widget:" + widgetgroupname + " new value:" + newval);// + " current value:" + val1 + " new value:" + newval1);
			}
			else
			{
				if(value1 === "i2senable") {
					
					if(newval == "1") 
					{
						document.getElementById("speakermeute").disabled=false;
						document.getElementById("bothms").disabled=true;
						document.getElementById("bothms1").disabled=true;
					} else if(newval == "2") {
						document.getElementById("speakermeute").disabled=true;
						document.getElementById("bothms1").disabled=true;
						document.getElementById("bothms").disabled=false;
						
					} else if(newval == "3") {
						document.getElementById("speakermeute").disabled=false;
						document.getElementById("bothms1").disabled=false;
						document.getElementById("bothms").disabled=false;
					} else if(newval == "0") {
						
						document.getElementById("speakermeute").disabled=true;
						document.getElementById("bothms1").disabled=true;
						document.getElementById("bothms").disabled=true;
					}
					
				}
				deltaobj.push(value1, newval);
				
			}
		});
		
		$.each(GwidgetlistCheckbox, function( index1, value1 ) {
			var widgetid = "#" + value1;
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			var newval = checkbox_unchecked_value;
			var that = $( widgetid ), parent = that.closest('fieldset');
			var  checkdisabled = $(parent).prop( "disabled" );
			
			if(value1 != "cdcenable") {
				if($(widgetid).is(':checked'))
				{
					newval = checkbox_checked_value;
				}
			} 	
			 
			if(value1 == "cdcenable") {
				if(oldval == "1") {
					oldval = "0";
				}
				if($("#cdcenable").is(':checked')) {
					newval = checkbox_checked_value;
				}
			}
			
			if(value1 == "enableport3") {
				if(sku == "USB4914" || sku == "USB4925" ) {
					oldval = getWidgetValue(HUB_ID, "enableport5");
				} else {
					oldval = getWidgetValue(HUB_ID, "enableport3");
				}
			}
			// Enabled - check the previous value and determine delta                              
			if (oldval === newval) {
				// do nothing - no change in value
			}
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
			}
			else {
				
				if(value1 == "lpmenable") {
					alert("The change in LPM Enable will cause change in the USB bcdUSB");
				   
				}
				if(value1 == "cdcenable") {
					
					if(newval == checkbox_checked_value) {
						deltaobj.push("cdcenable",checkbox_unchecked_value);
						alert("CDC enable is based on Strap.Disable CDC applicable only for the CDC enabled USB Device(USB49XX hub product family).")
					} 
				}
				if(sku == "USB4916" || sku == "USB4927" || sku == "USB4715") {
					var portCountTomap = 1;
					if( value1 == "enableport1")
					{
						if (oldval == newval) {
							//do nothing
						}
						else if (!port1dontchange)
						{
							//portCountTomap = 1; //Start port number
							if ( newval ==  0)
							{
								deltaobj.push("port1mapping",0);
								
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable2)
								{
									if (!port2dontchange)
									{
										deltaobj.push("port2mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port2dontchange = 1;
										
									}
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									if (!port3dontchange)
									{
										deltaobj.push("port3mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port3dontchange = 1;
										
									}
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable4)
								{
									if (!port4dontchange)
									{
										deltaobj.push("port4mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port4dontchange = 1;
									}
								}
								
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
								}
							}
							else
							{
								deltaobj.push("port1mapping",portCountTomap++);
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable2)
								{
									deltaobj.push("port2mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port2dontchange = 1;
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									deltaobj.push("port3mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port3dontchange = 1;
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable4)
								{
									deltaobj.push("port4mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port4dontchange = 1;
								}
								
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
								}
								
							}
						} else { // do nothing 
						}
					}
					if( value1 == "enableport2")
					{
						portCountTomap = bEnable1 + 1;  //Start port number
						if (oldval == newval) {
							//do nothing
						}
						else if (!port2dontchange)
						{
							if ( newval ==  0)
							{
								deltaobj.push("port2mapping",0);
									//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									if (!port3dontchange)
									{
										deltaobj.push("port3mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port3dontchange = 1;
									}
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable4)
								{
									if (!port4dontchange)
									{
										deltaobj.push("port4mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port4dontchange = 1;
									}
								}
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
								}
								
								
							}
							else
							{
								deltaobj.push("port2mapping",portCountTomap++);
									
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									deltaobj.push("port3mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port3dontchange = 1;
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable4)
								{
									deltaobj.push("port4mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port4dontchange = 1;
								}
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
									
								}
								
							}
						} else { // do nothing
						}
					}
					if( value1 == "enableport3")
					{
						
						portCountTomap = bEnable1 + bEnable2 + 1;  //Start port number
						
						if (oldval == newval) {
							//do nothing
							
							
						}
						else if (!port3dontchange)
						{		
							
							if ( newval ==  0)
							{
								deltaobj.push("port3mapping",0);
									
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable4)
								{
									if (!port4dontchange)
									{
										deltaobj.push("port4mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port4dontchange = 1;
									}
								}
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
								}
								
								
							}
							else
							{
								deltaobj.push("port3mapping",portCountTomap++);
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable4)
								{
									deltaobj.push("port4mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port4dontchange = 1;
								}
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
								}
								
							}
						} else { // Do nothing
						}
					}
					
					if( value1 == "enableport4")
					{
						portCountTomap = bEnable1 + bEnable2 + bEnable3 + 1;  //Start port number
						console.log("enableport4n" + newval);
						if (oldval == newval) {
							//do nothing
						}
						else if (!port4dontchange)
						{
							if ( newval ==  0)
							{
								//There is no next port for tyler to remap, change directly
								// No need to check for the port whether it is enabled
								// Will get into this only this port is enabled
								deltaobj.push("port4mapping",0);
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
								}
								
							}
							else
							{
								// No need to check for the port whether it is enabled
								// Will get into this only this port is enabled
								deltaobj.push("port4mapping",portCountTomap++);
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
								}
								
							}
						} else { // Do nothing
						}
					}
					
					if(sku != "USB4715")
					{
						if( value1 == "enableport5")
						{
							portCountTomap = bEnable1 + bEnable2 + bEnable3 + bEnable4 + 1;  //Start port number
							console.log("enableport5n" + newval);
							if (oldval == newval) {
								//do nothing
							}
							else if (!port5dontchange)
							{
								if ( newval ==  0)
								{
									//There is no next port for tyler to remap, change directly
									// No need to check for the port whether it is enabled
									// Will get into this only this port is enabled
									deltaobj.push("port5mapping",0);
									if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
								}
								
								
							}
							else
							{
								// No need to check for the port whether it is enabled
								// Will get into this only this port is enabled
								deltaobj.push("port5mapping",portCountTomap++);
								if(sku != "USB4715") {
									if(bEnable5)
									{
										if (!port5dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port5dontchange = 1;
										}
									}
									
									if(sku == "USB4916") {
										if (!port7dontchange)
										{
											deltaobj.push("port7mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port7dontchange = 1;
										}
									}
									if (!port6dontchange)
									{
										deltaobj.push("port6mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port6dontchange = 1;
									}
									
									
								}
								
							}
						} else { // Do nothing
					}
				}
			}	
					
					if(value1 == "enableport1" || value1 == "enableport2" || value1 == "enableport3"  || value1 == "enableport4"  || value1 == "enableport5" )
					{
					
						if(sku != "USB4715") {
							if(sku == "USB4916") {
							
								deltaobj.push("nrdeviceport7",1);
							} 
							deltaobj.push("nrdeviceport5",1);	
							deltaobj.push("nrdeviceport6",1);
						}
					}
				
		}
		if(sku == "USB4912" || sku == "USB4712")
		{
			var portCountTomap = 1;
			if( value1 == "enableport1")
			{	
				if (oldval == newval) {
					//do nothing
				}
				else if (!port1dontchange)
				{
					//portCountTomap = 1; //Start port number
					if ( newval ==  0)
					{
						deltaobj.push("port1mapping",0);
					}
					if(sku == "USB4912")
					{
						if(bEnable2)
						{
							if (!port2dontchange)
							{
								deltaobj.push("port5mapping",portCountTomap++);
								//Here setting is done, dont change it again anywhere
								port2dontchange = 1;
							}
						}
						if (!port7dontchange)
						{
							deltaobj.push("port7mapping",portCountTomap++);
							//Here setting is done, dont change it again anywhere
							port7dontchange = 1;
						}
						if (!port6dontchange)
						{
							deltaobj.push("port6mapping",portCountTomap++);
							//Here setting is done, dont change it again anywhere
							port6dontchange = 1;
							
						}
					}
					else
					{
						//To Do
					}	

					if(newval == oldval) {
					} else {
						if(value1 == "enableport1" || value1 == "enableport2")
						{
							if(value1 == "enableport2" && (newval != oldval)) {
								deltaobj.push("enableport5",newval);
							}
							if(sku == "USB4912") {
								deltaobj.push("nrdeviceport5",1);	
								deltaobj.push("nrdeviceport6",1);	
							} 
						}
					}
				}
			}
		}
				
			if(sku == "USB4914" || sku == "USB4925") {
				var portCountTomap = 1;
					if( value1 == "enableport1")
					{
						if (oldval == newval) {
							//do nothing
						}
						else if (!port1dontchange)
						{
							//portCountTomap = 1; //Start port number
							if ( newval ==  0)
							{
								deltaobj.push("port1mapping",0);
								
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable2)
								{
									if (!port2dontchange)
									{
										deltaobj.push("port2mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port2dontchange = 1;
										
									}
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									if (!port3dontchange)
									{
										deltaobj.push("port5mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port3dontchange = 1;
										
									}
								}
								
								if(sku == "USB4914") {
									if (!port7dontchange)
									{
										deltaobj.push("port7mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port7dontchange = 1;
										
									}
								}
								if (!port6dontchange)
								{
									deltaobj.push("port6mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port6dontchange = 1;
									
								}
								
							}
							else
							{
								deltaobj.push("port1mapping",portCountTomap++);
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable2)
								{
									deltaobj.push("port2mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port2dontchange = 1;
								}
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									if (!port3dontchange)
									{
										deltaobj.push("port5mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port3dontchange = 1;
										
									}
								}
								if(sku == "USB4914") {
									if (!port7dontchange)
									{
										deltaobj.push("port7mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port7dontchange = 1;
										
									}
								}
								if (!port6dontchange)
								{
									deltaobj.push("port6mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port6dontchange = 1;
									
								}
								

								
							}
						} else { // do nothing 
						}
					}
					if( value1 == "enableport2")
					{
						portCountTomap = bEnable1 + 1;  //Start port number
						
						if (oldval == newval) {
							//do nothing
						}
						else if (!port2dontchange)
						{
							
							if ( newval ==  0)
							{
								deltaobj.push("port2mapping",0);
									//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									if(bEnable3)
									{
										if (!port3dontchange)
										{
											deltaobj.push("port5mapping",portCountTomap++);
											//Here setting is done, dont change it again anywhere
											port3dontchange = 1;
											
										}
									}
								}
								if(sku == "USB4914") {
									if (!port7dontchange)
									{
										deltaobj.push("port7mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port7dontchange = 1;
										
									}
								}
								if (!port6dontchange)
								{
									deltaobj.push("port6mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port6dontchange = 1;
									
								}
								
								
								
							}
							else
							{
								deltaobj.push("port2mapping",portCountTomap++);
									
								//If next port is available for remap then remap otherwise goto next available port
								if(bEnable3)
								{
									if (!port3dontchange)
									{
										deltaobj.push("port5mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port3dontchange = 1;
										
									}
								}
								if(sku == "USB4914") {
									if (!port7dontchange)
									{
										deltaobj.push("port7mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port7dontchange = 1;
										
									}
								}
								
								if (!port6dontchange)
								{
									deltaobj.push("port6mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port6dontchange = 1;
									
								}
								
							}
						} else { // do nothing
						}
					}
					if( value1 == "enableport3")
					{
						
						oldval = getWidgetValue(dummyHubID,"enableport5");
						
						portCountTomap = bEnable1 + bEnable2 + 1;  //Start port number
						
						if (oldval == newval) {
							//do nothing
						
						}
						else if (!port3dontchange)
						{		
							
							if ( newval ==  0)
							{
								deltaobj.push("port5mapping",0);
								if(sku == "USB4914") {
									if (!port7dontchange)
									{
										deltaobj.push("port7mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port7dontchange = 1;
										
									}
								}
								
								if (!port6dontchange)
								{
									deltaobj.push("port6mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port6dontchange = 1;
									
								}
								
							}
							else
							{
								deltaobj.push("port5mapping",portCountTomap++);
								if(sku == "USB4914") {
									if (!port7dontchange)
									{
										deltaobj.push("port7mapping",portCountTomap++);
										//Here setting is done, dont change it again anywhere
										port7dontchange = 1;
										
									}
								}
								if (!port6dontchange)
								{
									deltaobj.push("port6mapping",portCountTomap++);
									//Here setting is done, dont change it again anywhere
									port6dontchange = 1;
									
								}
								
							}
						} else { // Do nothing
						}
					}
					
					if(newval == oldval) {
					} else {
						if(value1 == "enableport1" || value1 == "enableport2" || value1 == "enableport3")
					{
						if(value1 == "enableport3" && (newval != oldval)) {
							deltaobj.push("enableport5",newval);
						}
						if(sku == "USB4925") {
							deltaobj.push("nrdeviceport5",1);	
							deltaobj.push("nrdeviceport6",1);	
							
						} else if(sku == "USB4914"){
							deltaobj.push("nrdeviceport5",1);	
							deltaobj.push("nrdeviceport6",1);	
							deltaobj.push("nrdeviceport7",1);	
							
						}
					}
					}
					
					
				}	
				
				//To program it to defaults when a port is disabled.
				if (bEnable1 == false) {
					var nrport1 = getWidgetValue(dummyHubID, "nrdeviceport1");
					var dpdmSwap1 = getWidgetValue(dummyHubID, "swapport1dpdm");
					var phyboost1 = getWidgetValue(dummyHubID, "PHYBOOSTdownstreamport1");
					var varisense1 = getWidgetValue(dummyHubID, "SQUELCHdownstreamport1");
					var hsrisefall1 = getWidgetValue(dummyHubID, "downstreamport1HsRiseFall");
			
					if (nrport1 != 0) {
						//deltaobj.push("nrdeviceport1", 0);
						nrModified = true;
					}
					
					if (dpdmSwap1 != 0) {
						deltaobj.push("swapport1dpdm", 0);
					}
					
					if (phyboost1 != 0) {
						deltaobj.push("PHYBOOSTdownstreamport1", 0);
					}
					
					if (varisense1 != 0) {
						deltaobj.push("SQUELCHdownstreamport1", 0);
					}
					if(hsrisefall1 !=0)
					{
						deltaobj.push("downstreamport1HsRiseFall", 0);
					}
				}
				
				if (bEnable2 == false) {
					var nrport2 = getWidgetValue(dummyHubID, "nrdeviceport2");
					var dpdmSwap2 = getWidgetValue(dummyHubID, "swapport2dpdm");
					var phyboost2 = getWidgetValue(dummyHubID, "PHYBOOSTdownstreamport2");
					var varisense2 = getWidgetValue(dummyHubID, "SQUELCHdownstreamport2");
					var hsrisefall2 = getWidgetValue(dummyHubID, "downstreamport2HsRiseFall");
					if (nrport2 != 0) {
						//deltaobj.push("nrdeviceport2", 0);
						nrModified = true;
						
					}
					
					if (dpdmSwap2 != 0) {
						deltaobj.push("swapport2dpdm", 0);
					}
					
					if (phyboost2 != 0) {
						deltaobj.push("PHYBOOSTdownstreamport2", 0);
					}
					
					if (varisense2 != 0) {
						deltaobj.push("SQUELCHdownstreamport2", 0);
					}
					if(hsrisefall2 !=0)
					{
						deltaobj.push("downstreamport2HsRiseFall", 0);
					}
				}
				
				if((sku != "USB4914") && (sku != "USB4925") && (sku != "USB4912")) {
					
					if (bEnable3 == false) {
					var nrport3 = getWidgetValue(dummyHubID, "nrdeviceport3");
					var dpdmSwap3 = getWidgetValue(dummyHubID, "swapport3dpdm");
					var phyboost3 = getWidgetValue(dummyHubID, "PHYBOOSTdownstreamport3");
					var varisense3 = getWidgetValue(dummyHubID, "SQUELCHdownstreamport3");
					var hsrisefall3 = getWidgetValue(dummyHubID, "downstreamport2HsRiseFall");
					if (nrport3 != 0) {
						//deltaobj.push("nrdeviceport3", 0);
						nrModified = true;
						
					}
					
					if (dpdmSwap3 != 0) {
						deltaobj.push("swapport3dpdm", 0);
					}
					
					if (phyboost3 != 0) {
						deltaobj.push("PHYBOOSTdownstreamport3", 0);
					}
					
					if (varisense3 != 0) {
						deltaobj.push("SQUELCHdownstreamport3", 0);
					}
					if(hsrisefall3 !=0)
					{
						deltaobj.push("downstreamport3HsRiseFall", 0);
					}
				}

				if (bEnable4 == false) {
					var nrport4 = getWidgetValue(dummyHubID, "nrdeviceport4");
					var dpdmSwap4 = getWidgetValue(dummyHubID, "swapport4dpdm");
					var phyboost4 = getWidgetValue(dummyHubID, "PHYBOOSTdownstreamport4");
					var varisense4 = getWidgetValue(dummyHubID, "SQUELCHdownstreamport4");
					var hsrisefall4 = getWidgetValue(HUB_ID, "downstreamport4HsRiseFall");
					if (nrport4 != 0) {
						//deltaobj.push("nrdeviceport4", 0);
						nrModified = true;
						
					}
					
					if (dpdmSwap4 != 0) {
						deltaobj.push("swapport4dpdm", 0);
					}
					
					if (phyboost4 != 0) {
						deltaobj.push("PHYBOOSTdownstreamport4", 0);
					}
					
					if (varisense4 != 0) {
						deltaobj.push("SQUELCHdownstreamport4", 0);
					}
					if(hsrisefall4 !=0)
					{
						deltaobj.push("downstreamport4HsRiseFall", 0);
					}
				}
		
				}
				
				if(sku == "USB4727" || sku == "USB4916") {
					if (bEnable5 == false) {
						
						var dpdmSwap5 = getWidgetValue(dummyHubID, "swapport5dpdm");
						var phyboost5 = getWidgetValue(dummyHubID, "PHYBOOSTdownstreamport5");
						var varisense5 = getWidgetValue(dummyHubID, "SQUELCHdownstreamport5");
						var hsrisefall5 = getWidgetValue(HUB_ID, "downstreamport5HsRiseFall");
						
						if (dpdmSwap5 != 0) {
							deltaobj.push("swapport5dpdm", 0);
						}
						
						if (phyboost5 != 0) {
							deltaobj.push("PHYBOOSTdownstreamport5", 0);
						}
						
						if (varisense5 != 0) {
							deltaobj.push("SQUELCHdownstreamport5", 0);
						}
						if(hsrisefall5 !=0)
						{
							deltaobj.push("downstreamport5HsRiseFall", 0);
						}
					}
				}
				
				if (value1 == "nrdeviceport1") {
					nr1Modified = true;
				} 
				if(value1 == "nrdeviceport2") {
					nr2Modified = true;
				} 
				if(sku == "USB4927" || sku == "USB4916" || sku == "USB4715") {
					if(value1 == "nrdeviceport3") {
						nr3Modified = true;
					}
					if(value1 == "nrdeviceport4") {
					nr4Modified = true;
					}
				}
					 
				//Check for Flexconnect enable or disable
				if ((value1 == "flexconnect") && (newval == checkbox_checked_value)) {
					enableFlex = true;
					
				} else if ((value1 == "flexconnect") && (newval == checkbox_unchecked_value)) {
					enableFlex = false;
				} else {
					enableFlex = false;
					
				}

				//Check swap condition
				if (value1 == "swapupstreamdpdm") {
					if ($('#swapupstreamdpdm').is(':checked')) {
						alert("Programming Upstream swap will swap D+ and D- lines of Upstream port. Please make require changes in hub for further processing after successful programming");
					}
					deltaobj.push("swapupstreamdpdm", newval);
					//modifiedWidgets.push("swapupstreamdpdm");
				} else {
					
					if(value1 == "enableport3" || value1 == "nrdeviceport3" || value1 == "nrdeviceport4") {
						if(sku == "USB4914" || sku == "USB4925") {
							
						} else {
							deltaobj.push(value1, newval);
						}
					} else {
						if(value1 != "cdcenable") {
							if(sku == "USB4912" ) {
								if(value1 == "enableport2")
								{
									oldval = getWidgetValue(dummyHubID, "enableport5");
								}
								if(oldval != newval) {
									deltaobj.push(value1, newval);
								}
							}
							else
							{
								deltaobj.push(value1, newval);
							}
						}
					}
					
					//modifiedWidgets.push(value1);
				}
			}
		});
		
		$.each(GwidgetlistDropDown, function(index1, value1) {
			var nameofcontrol = "." + value1 + "1";
			var nameofcontrol1 = "[data-bind=\"" + value1 + "label\"]";
			var selText = $(nameofcontrol).find(nameofcontrol1).text();
			var newindexofdropdownlist;
			var that = $( nameofcontrol ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );

			if ( value1 == "flexport")
			{
				
				$.each(DropDownFlexPort, function( index, valuelist ) {
					
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
						
					}
				});
			
			}
		
			if (value1 === "PHYBOOST" || value1 === "PHYBOOSTdownstreamport1" || value1 == "PHYBOOSTdownstreamsecondaryport" ||
				value1 === "PHYBOOSTdownstreamport2" || value1 === "PHYBOOSTdownstreamport3" ||
				value1 === "PHYBOOSTdownstreamport4" || value1 === "PHYBOOSTdownstreamport5")
				
			{
				$.each(DropDownPHYBOOST, function(index, valuelist) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			
			if (value1 === "SQUELCH" || value1 === "SQUELCHdownstreamport1" || value1 == "SQUELCHdownstreamsecondaryport" || 
				value1 === "SQUELCHdownstreamport2" || value1 === "SQUELCHdownstreamport3" ||
				value1 === "SQUELCHdownstreamport4" || value1 === "SQUELCHdownstreamport5")
			{
				$.each(DropDownSQUELCH, function(index, valuelist) {
					if ( selText === valuelist)
					{   
						newindexofdropdownlist = index;
					}
				});
			}
			if(value1 === "upstreamHsRiseFall" || value1 === "downstreamport1HsRiseFall" || value1 == "secondaryportHsRiseFall" ||
				value1 === "downstreamport2HsRiseFall" || value1 === "downstreamport3HsRiseFall" ||
				value1 === "downstreamport4HsRiseFall" || value1 === "downstreamport5HsRiseFall")
			{
				$.each(DropDownHSRiseFall, function(index, valuelist) {
					if (selText == valuelist)
					{   
						newindexofdropdownlist = index;
					}
				});
			}
			
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);

			if (newindexofdropdownlist || newindexofdropdownlist == 0) {
				if ((newindexofdropdownlist == oldval))
				{
					// no change
				} else if (checkdisabled) {
					// Change detected but field is disabled - So do nothing
					console.log("change detected but field disabled: widget:" + value1); // + " current value:" + val1 + " new value:" + newindexofdropdownlist);
				} else {
					if(value1 == "flexport") {
						enableport = true;
						if(enableFlex == true) {
							deltaobj.push(value1, newindexofdropdownlist);
							
						} 
					}
					else 
					{
						deltaobj.push(value1, newindexofdropdownlist);
						
					}
				}
			}
		});
	
		if(enableport == false && enableFlex == true) {
			alert("Flexconnect cannot be done without Flex Port.Please select Flex Port.");
			update_status_message("Flexconnect cannot be done without Flex Port.Please select Flex Port.");
			errorFlag = true;
			return;
		}
		
		//Int Descriptors
		$.each(GwidgetlistInt, function(index1, value1) {
			var widgetid = "#" + value1;
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			if((value1 == "hubcmaxpowerbus") || (value1 == "hubcmaxpowerself")){
				oldval = parseInt(oldval,10);
			}else{
				oldval = parseInt(oldval,10) *2;
			}
			var that = $(widgetid), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop("disabled");
			
			var newval = $(widgetid).val();
			var newdecvalue = parseInt(newval,10);
			newdecvalue = newdecvalue & 0xff;
			if((value1 == "maxpowerself") || (value1 == "maxpowerbus") || (value1 == "power_ontime"))
			{
				if ((newdecvalue & 0x01) && !checkdisabled)
				{
					currentvalue = "ODDNUM";
					return;
				}
			}
			
			if ((oldval == newval) || isNaN(newval)) {
				// do nothing - no change in value
				//console.log("nochange:widget:" + widget1 + " value:" + val1 + " new value:" + newval);
			} 
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
				console.log("change detected but field disabled: widget:" + value1 + " new value:" + newdecvalue); //+ " current value:" + val1 + " new value:" + newval);
			}
			else {
				
				if ((value1 == "maxpowerself") || (value1 == "hubcmaxpowerself")) {
					if ((newval > 100) || (newval < 0)) {
						alert ("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
						update_status_message("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (value1 == "maxpowerbus") {
					if ((newval > 500) || (newval < 0)) {
						alert ("USB2.0 max power(bus) cannot be more than 500mA or negative.");
						update_status_message("USB2.0 max power(bus) cannot be more than 500mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (value1 == "hubcmaxpowerbus") {
					if ((newval > 255) || (newval < 0)) {
						alert ("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
						update_status_message("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
						errorFlag = true;
						return;
					}
				}
				
				if (value1 == "power_ontime") {
					
					if ((newval > 510) || (newval < 0)) {
						
						alert("Power-On Time cannot be more than 510ms or negative.\n");
						update_status_message("Power-On Time cannot be more than 510ms or negative.\n");
						return;
					}
				}

				var hexval;
				if ((value1 == "hubcmaxpowerbus") || (value1 == "hubcmaxpowerself")) {
					newdecvalue = parseInt(newval,10);
					hexval = newdecvalue.toString(16);
				} else {
					newdecvalue = parseInt(newval,10);
					newdecvalue = newdecvalue/2;
					hexval = newdecvalue.toString(16);
				}
				deltaobj.push(value1, hexval);
				
			}
		});
		if (currentvalue == "ODDNUM") {
			$("#progID").hide();
			alert("\"Hub MaxPower(Self)\" , \"HubMaxPower(Bus)\" and \"Power-On Time\" fields can have even numbers only");
			var mesg = "Error : \"Hub MaxPower(Self)\" , \"HubMaxPower(Bus)\" and \"Power-On Time\" fields can have even numbers only";
			update_status_message(mesg);
			currentvalue= "NONE";
			errorFlag = true;
			return;
		}
		
		var len = readStringfromINI();
		if (len) {
				
			var Defaultlen = len.split("###");
			PrimaryDefaultlen = Defaultlen[0];
			SecondaryDefaultlen = Defaultlen[1];
			HCEDefaultlen = Defaultlen[2];
		}
			
			
		//TO DO: String length constraint check and coding
		//String Descriptors
		$.each(GwidgetlistString, function( index1, value1 ) {
			var widgetid = "#" + value1;
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			var newval = $(widgetid).val();
			
			if(newval === stringnullvalue)
			{
				newval ="";
			}
			
			//Maximum string length from INI file
			
			if (value1 === "secondary_manufacturer" || value1 === "secondary_product"|| value1 === "secondary_serial")
			{
				var stringvalue = $(widgetid).val();
				// Check the widget length also
				if (stringvalue  == "" )
				{
					// do nothing null string
				} else {
					secondaryhubStringLength = $(widgetid).val().length;
				}
				//Checking the string length constraint
				if ((secondaryhubStringLength > SecondaryDefaultlen) && secondaryhubStringFlag)
				{
					window.alert("String Descriptor of Secondary Hub can have a max length of"+ " "+ SecondaryDefaultlen+ " "+ "unicode characters only.");
					update_status_message("Error : String Descriptor of Secondary Hub can have a max length of"+ SecondaryDefaultlen+ "unicode characters only.");
					secondaryhubStringFlag = false;
					errorFlag = true;
					return;
				}
			}
			
			if (value1 === "manufacturer" || value1 === "product"|| value1 === "serial")
			{
				var stringvalue = $(widgetid).val();

				// Check the widget length also
				if (stringvalue  == "")
				{
					// do nothing null string
				} else {
					usb2StringLength = $(widgetid).val().length;
				}
				//Checking the string length constraint
				if ((usb2StringLength > PrimaryDefaultlen) && usb2StringFlag)
				{
					window.alert("String Descriptor of Primary Hub can have a max length of"+ " " + PrimaryDefaultlen + " "+"unicode characters only.");
					update_status_message("Error : String Descriptor of Primary Hub can have a max length of"+ PrimaryDefaultlen + "unicode characters only.");
					usb2StringFlag = false;
					errorFlag = true;
					return;
				}
			}
			
			//add for hce,hce1 and hce2
			if (value1 === "hce_manufacturer" || value1 == "hce_product" || value1 == "hce_serial")
			{
				var stringvalue = $(widgetid).val();

				// Check the widget length also
				if (stringvalue  == "")
				{
					// do nothing null string
				} else {
					hcemanuStringLength = ($(widgetid).val().length);
				}
				//Checking the string length constraint
			
				if ((hcemanuStringLength > HCEDefaultlen) && hceStringFlag)
				{
					window.alert("String Descriptor of Hub Feature Controller can have a max length of"+ " "+ HCEDefaultlen+ " "+ "unicode characters only.");
					update_status_message("Error : String Descriptor of Hub Feature Controller can have a max length of"+ HCEDefaultlen+ "unicode characters only.");
					hceStringFlag = false;
					errorFlag = true;
					return;
				}
			}
			
			// Start of EAP1 Strings Alert
			if ((value1 === "hce1_product"))
			{
				var stringvalue= $(widgetid).val();
				var stringvalue1 = $('#hce1_eapproduct').val();
							
				// Check the widget length also
				if ((stringvalue  === "") && (stringvalue1 === ""))
				{
				}
				else if((stringvalue  != "") && (stringvalue1 != ""))
				{
				}
				else
				{
					if(EapStrAlert === false)
					{
						var option = confirm("Disabling will NCM/IAP 1 Product will also disable IAP/EAP 1 Product. Do you want to continue?\n");
						if(option === false)
						{
							errorFlag = true;
							return;
						}
						EapStrAlert = true;
					}
				}
			}
			if ((value1 === "hce1_eapproduct"))
			{
				var stringvalue= $(widgetid).val();
				var stringvalue1 = $('#hce1_product').val();
							
				// Check the widget length also
				if ((stringvalue  === "") && (stringvalue1 === ""))
				{
				}
				else if((stringvalue  != "") && (stringvalue1 != ""))
				{
				}
				else
				{
					if(EapStrAlert === false)
					{
						var option = confirm("Disabling will IAP/EAP 1 Product will also disable NCM/IAP 1 Product. Do you want to continue?\n");
						if(option === false)
						{
							errorFlag = true;
							return;
						}
						EapStrAlert = true;
					}
				}
			}
			// End of EAP1 Strings alert
			
			// Start of EAP2 Strings alert
			if ((value1 === "hce2_product"))
			{
				var stringvalue= $(widgetid).val();
				var stringvalue1 = $('#hce2_eapproduct').val();
							
				// Check the widget length also
				if ((stringvalue  === "") && (stringvalue1 === ""))
				{
				}
				else if((stringvalue  != "") && (stringvalue1 != ""))
				{
				}
				else
				{
					if(EapStrAlert1 === false)
					{
						var option = confirm("Disabling will NCM/IAP 2 Product will also disable IAP/EAP 2 Product. Do you want to continue?\n");
						if(option === false)
						{
							errorFlag = true;
							return;
						}
						EapStrAlert1 = true;
					}
				}
			}
			if ((value1 === "hce2_eapproduct"))
			{
				var stringvalue= $(widgetid).val();
				var stringvalue1 = $('#hce2_product').val();
							
				// Check the widget length also
				if ((stringvalue  === "") && (stringvalue1 === ""))
				{
				}
				else if((stringvalue  != "") && (stringvalue1 != ""))
				{
				}
				else
				{
					if(EapStrAlert1 === false)
					{
						var option = confirm("Disabling will IAP/EAP 2 Product will also disable NCM/IAP 2 Product. Do you want to continue?\n");
						if(option === false)
						{
							errorFlag = true;
							return;
						}
						EapStrAlert1 = true;
					}
				}
			}
			// End of EAP2 Strings Alert
			
			// Check for EAP Strings Length
			if((value1 === "hce1_eapproduct") || (value1 === "hce2_eapproduct") || (value1 === "hce1_eapinterface") || (value1 === "hce1_eapinterface"))
			{
				if(EapStrLengthVerify === false)
				{
					var Eap1ProductLen = ($('#hce1_eapproduct').val().length);
					var Eap1InterfaceLen = ($('#hce1_eapinterface').val().length);
					var Eap2ProductLen = ($('#hce2_eapproduct').val().length);
					var Eap2InterfaceLen = ($('#hce2_eapinterface').val().length);
					
					if((Eap1ProductLen + Eap1InterfaceLen + Eap2ProductLen +  Eap2InterfaceLen) > EAPDefaultLen)
					{
						window.alert("String Descriptor of IAP/EAP Class device Strings can have a max length of"+ " "+ EAPDefaultLen+ " "+ "unicode characters only.");
						update_status_message("Error : String Descriptor of Hub Feature Controller can have a max length of"+ EAPDefaultLen+ "unicode characters only.");
						errorFlag = true;
						EapStrLengthVerify = true;
						return;
					}
				}
			}
			// End of EAP string length check
						
			
			if (value1 === "usb2uuid" || value1 === "secondary_usb2uuid") {
				var uuidVal = $(widgetid).val();
				var isOkay = /^[0-9a-f]{1,32}$/i.test(uuidVal);

				if (uuidVal == "") {
					alert("Please enter a value for USB3.1 Gen1 UUID.");
					return;
				} else if (!isOkay) {
					alert("UUID value entered is invalid. UUID must be a 16 bytes of hexadecimal number.");
					update_status_message("UUID value entered is invalid. UUID must be a 16 bytes of hexadecimal number.");
					errorFlag = true;
					return;
				}
			}
			
			var that = $( widgetid ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );
			
			if ((newval === oldval)) 
			{
				// do nothing no change detected.
			}
			else if ( checkdisabled )
			{
				// Change detected but field is disabled - So do nothing
				 console.log("change detected but field disabled: widget:" + value1 );
			}
			else {
				
				//console.log("change detected : widget:" + value1); // + " current value:" + val1 + " new value:" + newval);
				
				if (value1 == "hce1_macaddr" || value1 == "hce2_macaddr") {
					//Ignore as this is not part of the string descriptor
					
					//Validate the new MAC address entered
					var isMACok = ValidateMac(newval);

					if (!isMACok) {
						//update_status_message("Please enter a valid MAC address.");
						//alert("Please enter a valid MAC address.");
						errorFlag = true;
						return;
					}
				} 
				
				if (jQuery.isEmptyObject(newval)) {
						newval = "";
				}
				
				deltaobj.push(value1, newval);
				
			}
		}); //End of $.each(GwidgetlistString, function( index1, value1 )
		
		//Adding non-removable state of all downstream ports depending on the state of "nrModified"
		if (nrModified) {
			var nr1 = ($("#nrdeviceport1").is(':checked'))?"1":"0";
			var nr2 = ($("#nrdeviceport2").is(':checked'))?"1":"0";
			var nr3 = ($("#nrdeviceport3").is(':checked'))?"1":"0";
			var nr4 = ($("#nrdeviceport4").is(':checked'))?"1":"0";
			
			
			if(bEnable1 === true )
			{
				if(nr1Modified === false)
				{
					deltaobj.push("nrdeviceport1", nr1);
				}else{
				}
			}else {
				if(nr1Modified === false)
				{
					deltaobj.push("nrdeviceport1", 0);
				}else{
				}
			}
			if(bEnable2 === true)
			{
				if(nr2Modified === false)
				{
					deltaobj.push("nrdeviceport2", nr2);
				}else{
				}
			}else {
				if(nr2Modified === false)
				{
					deltaobj.push("nrdeviceport2", 0);
				}else{
				}
			}
			if(sku == "USB4927" || sku == "USB4916" || sku == "USB4715") {
				if(bEnable3 === true )
				{
					if(nr3Modified === false)
					{
						deltaobj.push("nrdeviceport3", nr3);
					}else{
					}
				}else {
					//if((sku != "USB4914") || (sku != "USB4925")) {
						if(nr3Modified === false)
						{
							deltaobj.push("nrdeviceport3", 0);
						}else{
						}
					//}
					
				}
			}
			
			if(sku == "USB4927" || sku == "USB4916" || sku == "USB4715") {
				if(bEnable4 === true )
				{
					if(nr4Modified === false)
					{
						deltaobj.push("nrdeviceport4", nr4);
					}else{
					}
				}else {
					
						if(nr4Modified === false)
						{
							deltaobj.push("nrdeviceport4", 0);
						}else{
						}
					
				}
			}
			nrModified = false;
			nr1Modified = false;
			nr2Modified = false;
			nr3Modified = false;
			nr4Modified = false;
		}
		
		
		var stringToSet = "";
		var wKey;
		var wVal;
		var flag = 0;
	

		if (deltaobj.length != 0) {
			for (var i = deltaobj.length; i >= 0; i = i - 2) {
				wKey = deltaobj[i];
				wVal = deltaobj[i+1];
			
				if ((typeof wKey === 'undefined') || (typeof wVal === 'undefined')) {
					// Do nothing
				} else {
					stringToSet = wKey + ",,," + wVal + ";;;" + stringToSet;
					modifiedWidgets.push(wKey);
					flag++;
				}
			}
		}
		
		if (iniFile) {
			iniFile_fullPath = getFullPathINI();
			modifiedWidgets.push("xdataprogram");
			stringToSet = "xdataprogram,,," + iniFile_fullPath + ";;;" + stringToSet;
			flag++;
		}
		
		//Initializing the values with "-1".
		var regOptionChosen = -1;
		var Regadd = -1;
		var RegVal = -1;
		
		//Getting the data from the respective UI fields
		regOptionChosen = $("#Regoperationgroup").find(':checked').val();
		Regadd = $("#Regaddress").val();
		RegVal = $("#Regvalue").val();
		
		if ((regOptionChosen ) && (Regadd) && (RegVal)) { //|| (regOptionChosen == 0)
			
			if (typeof regOptionChosen === 'undefined') {
				alert("Please choose an appropriate action under the Direct Register Access.");
				errorFlag = true;
				return;
			}
		
			if(regOptionChosen == 0)
			{
				Regop = "XMODE_WRITE_BYTE";
			}
			else if(regOptionChosen == 1)
			{
				Regop = "XMODE_SET_BITS";
			}
			else if(regOptionChosen == 2)
			{
				Regop = "XMODE_CLEAR_BITS"
			}
			else
			{
				Regop = "";
				//do nothing
			}
			
			var isOKAddr = /^[0-9A-Fa-f]{8}$/i.test(Regadd);
			var newRegVal = RegVal.replace(/\s+/g, "");
			var isOKVal = /^[0-9A-Fa-f]+$/i.test(newRegVal);
			
			if ((Regadd == "") || (RegVal == "")) {
				alert("Either the value of register address or the register value is not entered under the Direct Register Access.");
				errorFlag = true;
				return;
			}
			
			if (!isOKAddr) {
				alert("The Register Address entered under the Direct Register Access must be a 8 digit hexadecimal number.");
				errorFlag = true;
			}
			
			if (!isOKVal) {
				alert("The Register value entered under the Direct Register Access is not a valid hexadecimal number.");
				errorFlag = true;
			}
			
			if (isOKAddr && isOKVal) {
				if (Regop.length == 0) {
					alert("Please choose appropriate register operation.");
					errorFlag = true;
				} else {
					if (Regadd && RegVal) {
						if (RegString) {
							RegString = Regop + "+" + Regadd + "+" + newRegVal + "+" + RegString;
						} else {
							RegString = Regop + "+" + Regadd + "+" + newRegVal;
						}
					} else {
						alert("Either Register address or Register value is not added.");
						errorFlag = true;
					}
				}
			}
		}
		
		if (RegString) {
			stringToSet = "xdataentry,,," + RegString + ";;;" + stringToSet;
			modifiedWidgets.push("xdataentry");
			flag++;
		}
		
		var displayChange = "";
		for (var i = 0; i < modifiedWidgets.length; i++) {
			
			var tempdisplay = Mapping[modifiedWidgets[i]];
						
			if(sku == "USB4914" || sku == "USB4916"  ){
				
				if(tempdisplay.indexOf("Primary ") !== -1){
					
					tempdisplay = tempdisplay.replace("Primary ", "");
				}
					
			}
			if(i%4 == 0)
			{
				if (displayChange) {
					
					displayChange = "\n" + tempdisplay + ", " + displayChange;
					
				} else {
					
					displayChange = tempdisplay;
				}
				
			} else {
				
				if (displayChange) {
					
					displayChange = tempdisplay + ", " + displayChange;
				}
			}
		}
		
		
		if (flag == 0 && errorFlag == false) {
			alert("No changes detected for offline configuration.");
			update_status_message("No changes detected for offline configuration.");
		} else {
			if(errorFlag === false)
			{
				var option = confirm("Configuration file will be generated with the following device settings\n" + displayChange);
					
					
				if (option) {
					
					var result = setOfflineConfiguration(HUB_FAMILY_INDEX, stringToSet,"0");
					var checksum = CalculateChecksum(false);
					

					if (result) {
						alert("Offline configuration was created successfully");
						update_status_message("Offline configuration was created successfully for the following widgets.\n" + displayChange);
						update_status_message("Checksum for the generated cfg file is "+ "0x"+checksum);
					} else {
						alert("Offline configuration failed.");
						update_status_message("Offline configuration failed.");		
					}
				} else {
					update_status_message("Generation of configuration file was terminated by the user.");
				}
				
				//clean up
				
				numberofportState = false;
				enableport = false;
				//Variables are reverted to Zero
				resetVariables();
			}else{
			}
		}
});

function resetVariables () {
	  vid_check = 0;
	  secondary_vid_check = 0;
	  pid_check = 0;
	  secondary_pid_check = 0;
	  did_check = 0;
	  secondary_did_check = 0;
	  usbvcd_check = 0;
	  secondary_usbvcd_check = 0;
	  hce_vid_check = 0;
	  hce_pid_check = 0;
	  hce_did_check = 0;
	  hce_languageid_check = 0;
	  hce1_vid_check = 0;
	  hce1_pid_check = 0;
	  hce1_did_check = 0;
	  hce1_languageid_check = 0;
	  hce1_macaddr_check = 0;
	  hce2_vid_check = 0;
	  hce2_pid_check = 0;
	  hce2_did_check = 0;
	  hce2_languageid_check = 0;
	  hce2_macaddr_check = 0;
	  languageid_check = 0;
	  secondary_languageid_check = 0;
	  manufacturer_check = 0;
	  secondary_manufacturer_check = 0;
	  product_check = 0;
	  secondary_product_check = 0;
	  serial_check = 0;
	  secondary_serial_check = 0;
	  hce_manufacturer_check = 0;
	  hce_product_check = 0;
	  hce_serial_check =0;
	  hce1_manufacturer_check = 0;
	  hce1_product_check = 0;
	  hce1_string5_check = 0;
	  hce1_eapproduct_check=0
	  hce1_eapinterface_check=0;
	  hce2_manufacturer_check = 0;
	  hce2_product_check = 0;
	  hce2_string5_check = 0;
	  hce2_eapproduct_check=0
	  hce2_eapinterface_check=0;
	  usb2uuid_check = 0;
	  secondary_usb2uuid_check = 0;
	  i2senablegroup_check = 0;
	  i2senablehidgroup_check = 0;
	  maxpowerself_check = 0;
	  hubcmaxpowerself_check = 0;
	  maxpowerbus_check = 0;
	  hubcmaxpowerbus_check = 0;
	  power_ontime_check = 0;
	  flexconnect_check = 0;
	  copyNCM_check = 0;
	  hsdisable_check = 0;
	  hceenable_check = 0;
	  lpmenable_check = 0;
	  swapupstreamdpdm_check = 0;
	  swapsecondaryportdpdm_check = 0;
	  PHYBOOSTULdownstreamsecondaryport_check = 0;
	  SQUELCHULdownstreamsecondaryport_check = 0;
	  secondaryportHsRiseFallUL_check = 0;
	  swapupstreamhsic_check = 0;
	  swapport1dpdm_check = 0;
	  swapport2dpdm_check = 0;
	  swapport3dpdm_check = 0;
	  swapport4dpdm_check = 0;
	  swapport5dpdm_check = 0;
	  nrdeviceport1_check = 0;
	  nrdeviceport2_check = 0;
	  nrdeviceport3_check = 0;
	  nrdeviceport4_check = 0;
	  enableport1_check = 0;
	  enableport2_check = 0;
	  enableport3_check = 0;
	  enableport4_check = 0;
	  enableport5_check = 0;
	  hubpowergroup_check = 0;
	  cdcenable_check = 0;
	  downstreamBCsettingport1group_check = 0;
	  downstreamBCsettingport2group_check = 0;
	  downstreamBCsettingport3group_check = 0;
	  downstreamBCsettingport4group_check = 0;
	  PHYBOOSTUL_check = 0;
	  PHYBOOSTULdownstreamport1_check = 0;
	  PHYBOOSTULdownstreamport2_check = 0;
	  PHYBOOSTULdownstreamport3_check = 0;
	  PHYBOOSTULdownstreamport4_check = 0;
	  PHYBOOSTULdownstreamport5_check = 0;
	  SQUELCHUL_check = 0;
	  SQUELCHULdownstreamport1_check = 0;
	  SQUELCHULdownstreamport2_check = 0;
	  SQUELCHULdownstreamport3_check = 0;
	  SQUELCHULdownstreamport4_check = 0;
	  SQUELCHULdownstreamport5_check = 0;
	  downstreamport1HsRiseFallUL_check = 0;
	  downstreamport2HsRiseFallUL_check = 0;
	  downstreamport3HsRiseFallUL_check = 0;
	  downstreamport4HsRiseFallUL_check = 0;
	  downstreamport5HsRiseFallUL_check = 0;
	  upstreamHsRiseFallUL_check = 0;
	  iniFileID_check = 0;
}