/*! jQuery v1.10.2 | (c) 2005, 2013 jQuery Foundation, Inc. | jquery.org/license
*/

//Global variables
var RegString = "";
var iniFile = "";
var offlineConfFile = "";
var LoadConfigFile = "";
var HUB_FAMILY_INDEX = "3";
var numberofportState = false;
var usb3numberofportState = false;
var noselect = false;
var portsAvailable;
var stringnullvalue = "NULL STRING - NOT PROGRAMMED YET";

var checkbox_checked_value = "1";
var checkbox_unchecked_value = "0";

var enable_lpm = false;
var enable_swapupstreamdpdm = false;

var hceenablemanu = false;
var hceenableprod = false;
var hceenableser = false;
var enablealertmanu = false;
var enablealertprod = false;
var enablealertser = false;

//Set this variable when Non-removable parameter of a hub is modified
var nrModified = false;
var nr1Modified = false;
var nr2Modified = false;
var nr3Modified = false;
var nr4Modified = false;
var nr5Modified = false;
var nr6Modified = false;
var nr7Modified = false;

var usb3nrModified = false;
var usb3nr1Modified = false;
var usb3nr2Modified = false;
var usb3nr3Modified = false;
var usb3nr4Modified = false;
var usb3nr5Modified = false;
var usb3nr6Modified = false;
var usb3nr7Modified = false;

//Set these flags if they are modified by user
var nr1UserModified = false;
var nr2UserModified = false;
var nr3UserModified = false;
var nr4UserModified = false;
var nr5UserModified = false;
var nr6UserModified = false;
var nr7UserModified = false;

//Set these flags if they are modified by user
var usb3nr1UserModified = false;
var usb3nr2UserModified = false;
var usb3nr3UserModified = false;
var usb3nr4UserModified = false;
var usb3nr5UserModified = false;
var usb3nr6UserModified = false;
var usb3nr7UserModified = false;

var gINIFileSelected = false;
var gArrConfigFilelist = [];
var gArrConfigIndex = 0;
var FirstMergecfgFile = "";
var SecondMergecfgFile = "";
var mergeConfFile = "";
var ParseCfgFileExt = "";
var parseConfigFile = "";
var parseSaveFile = "";


/*
	Hard straps related variables
*/
/*var StrapHashMapDefault = [];
var StrapHashMapAfterChange = [];*/

// Widget ID of hex fields in the GUI
var GwidgetlistHex = [
"vid",
"pid",
"did",
"usbvcd",
"languageid",
"hce_vid",
"hce_pid",
"hce_did",
//"udc_usbvcd",
"hce_languageid",
// USB3 related
"usb3vid",
"usb3pid",
"usb3did",
"usb3vcd",
"usb3languageid"
];

// Widget ID of string fields in the GUI
var GwidgetlistString = [
"manufacturer", 
"product",
"serial",
"hce_manufacturer",
"hce_product",
"hce_serial",
// USB3 related
"usb3manufacturer",
"usb3product",
"usb3serial",
"usb3uuid"
];

// Widget ID of decimal fields in the GUI
var GwidgetlistInt = [
"maxpowerself",
"hubcmaxpowerself",
"maxpowerbus",
"hubcmaxpowerbus",
"hub3maxpowerselfbus"
];

// Widgets that are checkboxes in GUI
var GwidgetlistCheckbox = [
"flexconnect",
"hsdisable",
"hceenable",
"lpmenable",
"swapupstreamdpdm",
"swapport1dpdm",
"swapport2dpdm",
"swapport3dpdm",
"swapport4dpdm",
"swapport5dpdm",
"swapport6dpdm",
"swapport7dpdm",
"enableport1",
"enableport2",
"enableport3",
"enableport4",
"enableport5",
"enableport6",
"enableport7",
"nrdeviceport1",
"nrdeviceport2",
"nrdeviceport3",
"nrdeviceport4",
"nrdeviceport5",
"nrdeviceport6",
"nrdeviceport7",
"usb3enableport1",
"usb3enableport2",
"usb3enableport3",
"usb3enableport4",
"usb3enableport5",
"usb3enableport6",
"usb3enableport7",
"usb3nrdeviceport7",
"usb3nrdeviceport6",
"usb3nrdeviceport5",
"usb3nrdeviceport4",
"usb3nrdeviceport3",
"usb3nrdeviceport2",
"usb3nrdeviceport1"
];

// Widgets that are radio buttons in GUI
var GwidgetlistRadio = [
"hubpower",
"suspendindication",
"downstreamBCsettingport1",
"downstreamBCsettingport2",
"downstreamBCsettingport3",
"downstreamBCsettingport4",
"downstreamBCsettingport5",
"downstreamBCsettingport6",
"downstreamBCsettingport7",
"port5splitting",
"port6splitting",
"pstimeout"
];

// Widgets that are Drop Down in GUI
var GwidgetlistDropDown = [
"PHYBOOST",
"SQUELCH",
"upstreamHsRiseFall",
"PHYBOOSTdownstreamport1",
"SQUELCHdownstreamport1",
"downstreamport1HsRiseFall",
"PHYBOOSTdownstreamport2",
"SQUELCHdownstreamport2",
"downstreamport2HsRiseFall",
"PHYBOOSTdownstreamport3",
"SQUELCHdownstreamport3",
"downstreamport3HsRiseFall",
"PHYBOOSTdownstreamport4",
"SQUELCHdownstreamport4",
"downstreamport4HsRiseFall",
"PHYBOOSTdownstreamport5",
"SQUELCHdownstreamport5",
"downstreamport5HsRiseFall",
"PHYBOOSTdownstreamport6",
"SQUELCHdownstreamport6",
"downstreamport6HsRiseFall",
"PHYBOOSTdownstreamport7",
"SQUELCHdownstreamport7",
"downstreamport7HsRiseFall"

];

//Document START
$(document).ready(function () {
	//Display widgets with respect to the type of Microchip product selected.
	$("#Apply").attr('disabled', true);
	$("#Reset").attr('disabled', true);
	
	$('#SaveFileField').hide();
	$('#SaveFileField').attr('disabled', 'disabled');
	$('#LoadFileField').removeAttr('disabled');
	$("#LoadFileField").attr('disabled', true);
	$('#LoadFileField').show();
	$("#LoadFileField").attr('disabled', true);

	update_status_message("Offline Configuration");
	clearWidgetMap();

	$("#devicedescriptortab").attr('disabled', true);
	$("#stringdescriptortab").attr('disabled', true);
	$("#USB3devicedescriptortab").attr('disabled', true);
	$('#showtipforport6split').hide();
	$("#USB3stringdescriptortab").attr('disabled', true);
	$("#USB3otherdescriptortab").attr('disabled', true);
	$("#upstreamtab").attr('disabled', true);
	$("#downstreamtab").attr('disabled', true);
	$("#Bdownstreamtab").attr('disabled', true);
	$("#USB3_Bdownstreamtab").attr('disabled', true);
	$("#uchtab").attr('disabled', true);
	$('#showtipforport5split').hide();
	$("#advancedtab").attr('disabled', true);
	$("#specialtab").attr('disabled', true);
	$("#registerVal").attr('disabled', true);
	$("#registerFile").attr('disabled', true);
	$('#PORTSplittingfieldset').hide();
	// Enable all port BC fields
	$('#BdownstreamUSBport1').removeAttr('disabled');
	$('#BdownstreamUSBport2').removeAttr('disabled');
	$('#BdownstreamUSBport3').removeAttr('disabled');
	$('#BdownstreamUSBport4').removeAttr('disabled');
	$('#BdownstreamUSBport5').removeAttr('disabled');
	$('#BdownstreamUSBport6').removeAttr('disabled');
	$('#BdownstreamUSBport7').removeAttr('disabled');

	$('#BdownstreamUSBport1').show();
	$('#BdownstreamUSBport2').show();
	$('#BdownstreamUSBport3').show();
	$('#BdownstreamUSBport4').show();
	$('#BdownstreamUSBport5').show();
	$('#BdownstreamUSBport6').show();
	$('#BdownstreamUSBport7').show();
});
//Document END
var sku;

$('#selectsku_usb3 li').on('click', function() {
	$('#nav').show();
	$('#close').hide();
	$('#sfield').hide();
	document.getElementById("overlay").setAttribute("class","col-xs-2");
	sku = $(this).text();
	update_status_message("Selected SKU is :" + sku);
	clearWidgetMap();
	gArrConfigIndex = 0;
	LoadConfFile = "";
	changecount = 0;
	RegString="";
	document.getElementById("myForm").reset();
	$("#Reset").attr('disabled', false);
	reset_file_input();

	iniFile ="";
	offlineConfFile="";
	enable_all_fields();
	set_changed_fields_border_default();
	offline_MchpUsbClose();
	var ret = offline_MchpUsbOpen(HUB_FAMILY_INDEX,sku);
	if(ret)
	{
		populateDefaultValues();
	}
	
	/* Get the last digit of the SKU Name. It decides the number of downstream ports that
	   are currently available.
	*/
	 portsAvailable = sku.substring(6);
	
	if (portsAvailable == 7) {
		
		$("#HubControllerSectionwithConfig").attr('disabled', true);
		$("#SpecialFeatures_Flex").attr('disabled', true);
		$("#spiField").attr('disabled', true);
		$("#upstreamFlex").attr('disabled', true);
		$("#Flex_FlexFeature").attr('disabled', true);
		$("#flexlive").attr('disabled', true);
		
		$("#PORT7fieldset").show();
		$("#usb2port77map").show();
		$("#usb3port77map").show();
		$("#usb2port76map").show();
		$("#usb3port76map").show();
		$("#usb2port75map").show();
		$("#usb3port75map").show();
		$("#usb2port74map").show();
		$("#usb3port74map").show();
		$("#usb2port73map").show();
		$("#usb3port73map").show();
		$("#usb2port72map").show();
		$("#usb3port72map").show();
		$("#usb2port71map").show();
		$("#usb3port71map").show();
				
		//Show all 7 downstream ports
		$("#BPORT1fieldset").show();
		$("#BPORT2fieldset").show();
		$("#BPORT3fieldset").show();
		$("#BPORT4fieldset").show();
		$("#BPORT5fieldset").show();
		$("#BPORT6fieldset").show();
		$("#BPORT7fieldset").show();
	} 
	if (portsAvailable == 6) {
		$("#BPORT7fieldset").hide();
		$("#upstreamFlex").attr('disabled', false);
		$("#BPORT1fieldset").show();
		$("#BPORT2fieldset").show();
		$("#BPORT3fieldset").show();
		$("#BPORT4fieldset").show();
		$("#BPORT5fieldset").show();
		$("#BPORT6fieldset").show();

		//Advanced
		$("#PORT7fieldset").hide();
		
		$("#usb2port77map").hide();
		$("#usb3port77map").hide();
		$("#usb2port76map").hide();
		$("#usb3port76map").hide();
		$("#usb2port75map").hide();
		$("#usb3port75map").hide();
		$("#usb2port74map").hide();
		$("#usb3port74map").hide();
		$("#usb2port73map").hide();
		$("#usb3port73map").hide();
		$("#usb2port72map").hide();
		$("#usb3port72map").hide();
		$("#usb2port71map").hide();
		$("#usb3port71map").hide();
		
		$("#HubControllerSectionwithConfig").removeAttr('disabled');
		$("#SpecialFeatures_Flex").attr('disabled', false);
		$("#spiField").attr('disabled', false);
		$("#Flex_FlexFeature").attr('disabled', false);
		$("#flexlive").attr('disabled', false);

	} 
});

$("#RegEntry").click(function () {
	var regOptionChosen = $("#Regoperationgroup").find(':checked').val();
	var Regop = "";
	var Regadd = "";
	var RegVal = "";
	var toDisplay = "";
	
	if (typeof regOptionChosen === 'undefined') {
		alert("Please choose an appropriate register operation under the Direct Register Access.");
		return;
	}

	if(regOptionChosen == 0)
	{
		Regop = "XMODE_WRITE_BYTE";
		toDisplay = "WRE";
	}
	else if(regOptionChosen == 1)
	{
		Regop = "XMODE_SET_BITS";
		toDisplay = "SET ";
	}
	else if(regOptionChosen == 2)
	{
		Regop = "XMODE_CLEAR_BITS"
		toDisplay = "CLR ";
	}
	else
	{
		Regop = "";
		//do nothing
	}
	Regadd = $("#Regaddress").val();
	var isOKAddr = /^[0-9A-Fa-f]{4}$/i.test(Regadd);
	RegVal = "" + $("#Regvalue").val();
	var newRegVal = RegVal.replace(/\s+/g, "");
	var RegValOkay = /^[0-9A-Fa-f]+$/i.test(newRegVal);
	
	if ((Regadd == "") || (RegVal == "")) {
		alert("Either the value of register address or the register value is not entered under the Direct Register Access.");
		return;
	}
	
	if (!isOKAddr) {
		alert("The Register Address entered under the Direct Register Access must be a 4 digit hexadecimal number.");
	}
	
	if (!RegValOkay) {
		alert("The Register value entered under the Direct Register Access is not a valid hexadecimal number.");
	}
	
	if (RegValOkay && isOKAddr) {
		if (Regop.length == 0) {
			alert("Please choose appropriate register operation.");
		} else {
			if (Regadd && RegVal) {
				if (RegString) {
					RegString = Regop + "+" + Regadd + "+" + newRegVal + "+" + RegString;
				} else {
					RegString = Regop + "+" + Regadd + "+" + newRegVal;
				}
				changecount = changecount+1;
				switchloadsave(changecount);
				
				update_status_message("Register Address: " + Regadd + " Register Value: " + RegVal + " for operation: " + Regop + " will be added in an ini file and programmed into the hub.");
				update_dra_status_message(toDisplay+"_"+ Regadd + "=" + RegVal);
			} else {
				alert("Either Register address or Register value is not added.");
			}
		}
		document.getElementById("myForm").reset();
	}
});

function setiniType() {
	setFileType("ini", 0);
}

function startRead() {
	iniFile = "";

	var file = document.getElementById("iniid").files[0];
	if (typeof file === 'undefined') {
		update_status_message("No configuration file(.ini) is selected.");
		iniFile = "";
		if (gINIFileSelected == true)
		{
			changecount = changecount-1;
			switchloadsave(changecount);
			gINIFileSelected = false;
		}
		alert("No configuration file(.ini) is selected.");
	} else {
		iniFile = file.name;
		extension = iniFile.substr(iniFile.lastIndexOf('.') + 1);
		
		if(extension != "ini")
		{
			alert("Selected File type is not supported. Please Select File type : ini");
			var mesg = ("Selected File type is not supported.Supported File type is .ini");
			update_status_message(mesg);
			iniFile ="";
			//reset_file_input();
			$("#iniid").val('');
			$("#iniid").css({
				background: "white",
				border: "0px"
			});
			errorFlag = true;
			return;
		} else {
			var mesg = ("Selected .ini file to program is :" + iniFile);
			update_status_message(mesg);
			var fileSizeInKb = file.size/1024;
			update_status_message("The size of the .ini file selected is " + fileSizeInKb.toFixed(2) + " KB");
				$("#iniid").css({
				background: "white",
				border: "0px"
				});
			update_status_message(mesg);
			changecount = changecount+1;
			
			switchloadsave(changecount);
			gINIFileSelected = true;
		}
	}
}
//Direct Register Access blocks End

//Onclick event for dropdown STARTS
$(document).on('click', '.dropdown li a', function (event) {
	// this code is for making the current selection appear with caret
	var $target = $(event.currentTarget);

	$target.closest('.btn-group')
	.find('[data-bind]').text($target.text())
	.end()
	.children('.dropdown-toggle').dropdown('toggle');
	var selop = $(this).text();
	console.log("Selected Option - All dropdowns:" + selop);
});
//Onclick event for dropdown ENDS

// Lookup for phyboost dropdown value selection
var DropDownPHYBOOST = [
"Nominal 17.78 mA",
"5% below nominal",
"10% above nominal",
"5% above nominal",
"20% above nominal",
"15% above nominal",
"30% above nominal",
"25% above nominal"
];

// Lookup for squelch dropdown value selection
var DropDownSQUELCH = [
"Nominal 100mV",
"12.5mV below nominal",
"25mV below nominal",
"37.5mV below nominal",
"50mV below nominal",
"62.5mV below nominal",
"25mV above nominal",
"12.5mV above nominal"
];

// Lookup for High Speed rise/fall adjust selection
var DropDownHSRiseFall =[
"Default",
"+18%",
"-18%",
"-12%"
];
//Dropdown END

//Mapping widgets to the meaningful elaborations to print while in error
var Mapping = {
//Hex
"vid": "USB2.0 Vendor ID",
"pid": "USB2.0 Product ID",
"did": "USB2.0 Device ID",
"usbvcd": "USB2.0 Version",
"languageid": "USB2.0 Language ID",
"manufacturer": "USB2.0 Manufacturer",
"manufacturerlen" :"USB2.0 Manufacturer Length",
"product" : "USB2.0 Product",
"productlen" : "USB2.0 Product Length",
"serial": "USB2.0 Serial",
"seriallen" : "USB2.0 Serial Length",
"usb3vid": "USB3.1 Gen1 Vendor ID",
"usb3pid": "USB3.1 Gen1 Product ID",
"usb3did": "USB3.1 Gen1 Device ID",
"usb3vcd": "USB3.1 Gen1 Version",
"usb3languageid": "USB3.1 Gen1 Language ID",
"usb3manufacturer": "USB3.1 Gen1 Manufacturer",
"usb3product":"USB3.1 Gen1 Product",
"usb3serial":"USB3.1 Gen1 Serial",
"usb3uuid":"Universal unique ID",
"numberofports":"Number of Enabled USB2.0 ports",
"usb3numberofports":"Number of Enabled USB3.1 Gen1 ports",
"port5splitting":"Port 5 Port Splitting",
"port6splitting":"Port 6 Port Splitting",
"prtpwr5usb3split":"USB3 Port Power for Port 5",
"prtpwr6usb3split":"USB3 Port Power for Port 6",
"pstimeout":"USB3 Port Split Link TimeOut",
"enableport1":"USB2.0 Port1 Enable/Disable State",
"enableport2":"USB2.0 Port2 Enable/Disable State",
"enableport3":"USB2.0 Port3 Enable/Disable State",
"enableport4":"USB2.0 Port4 Enable/Disable State",
"enableport5":"USB2.0 Port5 Enable/Disable State",
"enableport6":"USB2.0 Port6 Enable/Disable State",
"enableport7":"USB2.0 Port7 Enable/Disable State",
"port1mapping":"USB2.0 Port1 Logical mapping",
"port2mapping":"USB2.0 Port2 Logical mapping",
"port3mapping":"USB2.0 Port3 Logical mapping",
"port4mapping":"USB2.0 Port4 Logical mapping",
"port5mapping":"USB2.0 Port5 Logical mapping",
"port6mapping":"USB2.0 Port6 Logical mapping",
"port7mapping":"USB2.0 Port7 Logical mapping",
"nrdeviceport1":"USB2.0 Port1 Non-removable State",
"nrdeviceport2":"USB2.0 Port2 Non-removable State",
"nrdeviceport3":"USB2.0 Port3 Non-removable State",
"nrdeviceport4":"USB2.0 Port4 Non-removable State",
"nrdeviceport5":"USB2.0 Port5 Non-removable State",
"nrdeviceport6":"USB2.0 Port6 Non-removable State",
"nrdeviceport7":"USB2.0 Port7 Non-removable State",
"usb3enableport1":"USB3.1 Gen 1 Port1 Enable/Disable State",
"usb3enableport2":"USB3.1 Gen 1 Port2 Enable/Disable State",
"usb3enableport3":"USB3.1 Gen 1 Port3 Enable/Disable State",
"usb3enableport4":"USB3.1 Gen 1 Port4 Enable/Disable State",
"usb3enableport5":"USB3.1 Gen 1 Port5 Enable/Disable State",
"usb3enableport6":"USB3.1 Gen 1 Port6 Enable/Disable State",
"usb3enableport7":"USB3.1 Gen 1 Port7 Enable/Disable State",
"usb3port1mapping":"USB3.1 Gen 1 Port1 Logical mapping",
"usb3port2mapping":"USB3.1 Gen 1 Port2 Logical mapping",
"usb3port3mapping":"USB3.1 Gen 1 Port3 Logical mapping",
"usb3port4mapping":"USB3.1 Gen 1 Port4 Logical mapping",
"usb3port5mapping":"USB3.1 Gen 1 Port5 Logical mapping",
"usb3port6mapping":"USB3.1 Gen 1 Port6 Logical mapping",
"usb3port7mapping":"USB3.1 Gen 1 Port7 Logical mapping",
"usb3nrdeviceport1":"USB3.1 Gen 1 Port1 Non-removable State",
"usb3nrdeviceport2":"USB3.1 Gen 1 Port2 Non-removable State",
"usb3nrdeviceport3":"USB3.1 Gen 1 Port3 Non-removable State",
"usb3nrdeviceport4":"USB3.1 Gen 1 Port4 Non-removable State",
"usb3nrdeviceport5":"USB3.1 Gen 1 Port5 Non-removable State",
"usb3nrdeviceport6":"USB3.1 Gen 1 Port6 Non-removable State",
"usb3nrdeviceport7":"USB3.1 Gen 1 Port7 Non-removable State",
"downstreamBCsettingport1":"Port1 Battery charging State",
"downstreamBCsettingport2":"Port2 Battery charging State",
"downstreamBCsettingport3":"Port3 Battery charging State",
"downstreamBCsettingport4":"Port4 Battery charging State",
"downstreamBCsettingport5":"Port5 Battery charging State",
"downstreamBCsettingport6":"Port6 Battery charging State",
"downstreamBCsettingport7":"Port7 Battery charging State",
"swapport1dpdm":"Port1:Swap D+/D-",
"swapport2dpdm":"Port2:Swap D+/D-",
"swapport3dpdm":"Port3:Swap D+/D-",
"swapport4dpdm":"Port4:Swap D+/D-",
"swapport5dpdm":"Port5:Swap D+/D-",
"swapport6dpdm":"Port6:Swap D+/D-",
"swapport7dpdm":"Port7:Swap D+/D-",
"swapupstreamdpdm":"Upstream Port:Swap D+/D-",
"PHYBOOSTdownstreamport1":"Port1:PHYBOOST",
"PHYBOOSTdownstreamport2":"Port2:PHYBOOST",
"PHYBOOSTdownstreamport3":"Port3:PHYBOOST",
"PHYBOOSTdownstreamport4":"Port4:PHYBOOST",
"PHYBOOSTdownstreamport5":"Port5:PHYBOOST",
"PHYBOOSTdownstreamport6":"Port6:PHYBOOST",
"PHYBOOSTdownstreamport7":"Port7:PHYBOOST",
"PHYBOOST":"Upstream Port:PHYBOOST",
"SQUELCHdownstreamport1":"Port1:Varisense",
"SQUELCHdownstreamport2":"Port2:Varisense",
"SQUELCHdownstreamport3":"Port3:Varisense",
"SQUELCHdownstreamport4":"Port4:Varisense",
"SQUELCHdownstreamport5":"Port5:Varisense",
"SQUELCHdownstreamport6":"Port6:Varisense",
"SQUELCHdownstreamport7":"Port7:Varisense",
"SQUELCH":"Upstream Port:Varisense",
"upstreamHsRiseFall":"Upstream High Speed rise/fall adjust",
"downstreamport1HsRiseFall":"Port1:High Speed rise/fall adjust",
"downstreamport2HsRiseFall":"Port2:High Speed rise/fall adjust",
"downstreamport3HsRiseFall":"Port3:High Speed rise/fall adjust",
"downstreamport4HsRiseFall":"Port4:High Speed rise/fall adjust",
"downstreamport5HsRiseFall":"Port5:High Speed rise/fall adjust",
"downstreamport6HsRiseFall":"Port6:High Speed rise/fall adjust",
"downstreamport7HsRiseFall":"Port7:High Speed rise/fall adjust",
"flexconnect":"Flexconnect",
"hceenable":"Hub Controller State",
"hce_vid": "HCE Vendor ID",
"hce_pid": "HCE Product ID",
"hce_did": "HCE Device ID",
"hce_languageid": "HCE Language ID",
"hce_manufacturer":"HCE Manufacturer",
"hce_manufacturerlen":"HCE Manufacturer Length",
"hce_product":"HCE Product",
"hce_productlen":"HCE Product Length",
"hce_serial":"HCE Serial",
"hce_seriallen":"HCE Serial Length",
"hubpower":"Hub Power",
"maxpowerself":"USB2.0 Hub Max Power(Self)",
"hubcmaxpowerself":"Hub Circuit Max Power (Self)",
"maxpowerbus":"USB2.0 Hub Max Power (Bus)",
"hubcmaxpowerbus":"Hub Circuit Max Power (Bus)",
"hub3maxpowerselfbus":"USB3.1 Gen1 Max Power",
"suspendindication":"Suspendindication",
"hsdisable":"Hub Full Speed Mode",
"lpmenable":"LPM State",
"xdataentry":"Direct Register Access",
"xdataprogram":"ini File"
};

(function ($) {
    enable_all_fields = function () {
		$("#registerVal").attr('disabled',false);
		$("#registerFile").attr('disabled',false);
        $("#devicedescriptortab").attr('disabled', false);
        $("#stringdescriptortab").attr('disabled', false);
        $("#USB3devicedescriptortab").attr('disabled', false);
        $("#USB3stringdescriptortab").attr('disabled', false);
        $("#USB3otherdescriptortab").attr('disabled', false);
        $("#upstreamtab").attr('disabled', false);
        $("#downstreamtab").attr('disabled', false);
        $("#Bdownstreamtab").attr('disabled', false);
        $("#USB3_Bdownstreamtab").attr('disabled', false);
        $("#uchtab").attr('disabled', false);
        $("#advancedtab").attr('disabled', false);
        $("#specialtab").attr('disabled', false);
        $('#BPORT1fieldset').attr('disabled', false);
        $('#BPORT2fieldset').attr('disabled', false);
        $('#BPORT3fieldset').attr('disabled', false);
        $('#BPORT4fieldset').attr('disabled', false);
		$('#BPORT5fieldset').attr('disabled', false);
        $('#BPORT6fieldset').attr('disabled', false);
        $('#BPORT7fieldset').attr('disabled', false);
        $('#PORT1fieldset').attr('disabled', false);
        $('#PORT2fieldset').attr('disabled', false);
        $('#PORT3fieldset').attr('disabled', false);
        $('#PORT4fieldset').attr('disabled',false);
		$('#PORT5fieldset').attr('disabled', false);
        $('#PORT6fieldset').attr('disabled', false);
        $('#PORT7fieldset').attr('disabled',false);
    };
})(jQuery);

function getOfflineConf() {
	offlineConfFile = "";
	var file = document.getElementById("offlineConfFileID").files[0];
	var fileSizeInKb = file.size/1024;
	update_status_message("The size of the Configuration file selected is " + fileSizeInKb + " KB");
	if (file) {
		$("#offlineConfFileID").css({
			background: "white",
			border: "0px"
		});
		offlineConfFile = file.name;
		var saveextension = offlineConfFile.substr(offlineConfFile.lastIndexOf('.') + 1);
		if(saveextension === offlineConfFile)
		{
			offlineConfFile = offlineConfFile + ".cfg";
		}
		else if(saveextension === "cfg")
		{
			var mesg = ("Selected .cfg file to save is :" + offlineConfFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .cfg");
			update_status_message("Selected File Type is not supported.Supported File type is .cfg");
			$("#offlineConfFileID").val('');
			$("#offlineConfFileID").css({
			background: "white",
			border: "0px"
			});
			offlineConfFile="";
			return;
		}
	} else {
		$("#offlineConfFileID").css({
			background: "yellow",
			border: "3px red solid"
		});
		update_status_message("No configuration file(.cfg) is selected.");
		offlineConfFile = "";
		alert("No configuration file(.cfg) is selected.");
	}
}

function startReadcfg() {
	LoadConfFile = "";
	var fileextension;
	var file = document.getElementById("offlineConfload").files[0];
	var fileSizeInKb = file.size/1024;
	var Filelist = "";
	var canAllow = false;
	var fileSize = file.size;
	LoadConfFile = file.name;
	fileextension = LoadConfFile.substr(LoadConfFile.lastIndexOf('.') + 1);
	if(fileextension == "cfg" || fileextension == "dump")
	{
		update_status_message("The size of the Configuration file selected is " + fileSizeInKb.toFixed(2) + " KB");
	} else {
		alert("Selected File Type is not supported. Please Select File type : .cfg/.dump");
		//reset_file_input();
		$("#offlineConfload").val('');
		$("#offlineConfload").css({
			background: "white",
			border: "0px"
			});
		LoadConfFile ="";
		return;
	}

	if (file) {
			if (fileextension == "dump") {
				if (fileSize == 8192) {
					canAllow = true;
				} else {
					update_status_message("The size of configuration file \"" + file.name + "\" should be 8KB for USB58XX/USB59XX hub.");
					LoadConfFile = "";
					alert("The size of configuration file \"" + file.name + "\" should be 8KB for USB58XX/USB59XX hub.");
					return;
				}
			} else if (fileextension == "cfg") {
				if (fileSize <= 8192) {
					canAllow = true;
				} else {
					update_status_message("The size of configuration file \"" + file.name + "\" cannot exceed 8KB for USB58XX/USB59XX hub.");
					LoadConfFile = "";
					alert("The size of configuration file \"" + file.name + "\" cannot exceed 8KB for USB58XX/USB59XX hub.");
					return;
				}
			} else {
				//Do nothing	
			}
		//}	
	}
	
	if (canAllow) {
		$("#offlineConfload").css({
			background: "white",
			border: "0px"
		});
	}

	if (gArrConfigIndex > 15)
	{
		alert("Max configuration file count is 15");
		return;
	}
	gArrConfigFilelist[gArrConfigIndex++] = LoadConfFile;
	var Texttodisplay = "Loaded Configuration files are ";
	for(var i = 0; i < gArrConfigIndex; i++)
	{
		Filelist = Filelist + gArrConfigFilelist[i] + ",";
	}
	update_status_message(Texttodisplay + Filelist);
	//overrideDefaultOfflineConfig function will return strap values in LoadConfFile
	//Return string format is "widget:value###widget:value.."

	var StrapValues = overrideDefaultOfflineConfig(HUB_FAMILY_INDEX,LoadConfFile);
	
	if(StrapValues == null)
	{
		alert("Not a valid file");
	}
	populateDefaultValues();
}

function setOfflineConf() {
	setFileType("cfg", 1);
}
function getOfflineConftype() {
	setFileType("cfg_dump", 0);
}

(function ($) {
    update_status_message = function (mesg) {
        //var time = new Date($.now()); // returns huge string
        var currentdate = new Date(); 
        currentdate+''; 
        var datetime = currentdate.toLocaleString();
        $("#DSStatusMessage").append( datetime +":"+ mesg + "\n");
        $("#DSStatusMessage").animate({
            scrollTop:$("#DSStatusMessage")[0].scrollHeight - $("#DSStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

function formatinput(inputName) {

	//remove space from the argument
	inputName= inputName.trim();
	
	//add spaces after every 2 digits
	var RegVal = $('#'+inputName).val().replace(/(\d{2})/g, '$1 ').replace(/(^\s+|\s+$)/,'');
	//Remove extra spaces
	RegVal = RegVal.replace(/  +/g, ' ');
	//update into text box
	$('#'+inputName).val(RegVal);
}

(function ($) {
    update_dra_status_message = function (mesg) {
        $("#DRStatusMessage").append(mesg + "\n");
        $("#DRStatusMessage").animate({
            scrollTop:$("#DRStatusMessage")[0].scrollHeight - $("#DRStatusMessage").height()
            },400,function(){
          })
        };
})(jQuery);

// Reset all fields
$("#Reset").click(function() {
	clearWidgetMap();
	offline_MchpUsbClose();
	var ret = offline_MchpUsbOpen(HUB_FAMILY_INDEX,sku);
	if(ret)
	{
		populateDefaultValues();
	}
	
	document.getElementById("ParseConfigureArea").value = "";
	$('#saveparse').prop('checked',false);
	iniFile ="";
	offlineConfFile="";
	LoadConfFile = "";
	gArrConfigIndex = 0;
	RegString="";
	document.getElementById("myForm").reset();
	changecount =0;
	$("input[type='file']").val('');
	$("#Apply").attr('disabled',true);
	reset_file_input();
	$('#showtipforport6split').hide();
	$('#showtipforport5split').hide();
	// Change border back to default color from red
	set_changed_fields_border_default();
	resetVariables();
	RegString = "";
	iniFile = "";
	document.getElementById("DRStatusMessage").value = "";
	document.getElementById("DRStatusMessage").innerHTML="";
});
// End of Reset all fields

// Parse Configuration - Start
function getParseConftype() {
	setFileType("cfg_parse", 0);
}
function setParseSavetype() {
	setFileType("txt",1);
}
function ParseConfigFile(){
	var file = document.getElementById("Parsefileid").files[0];

	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		parseConfigFile = "";
		alert("No configuration file(.cfg) is selected.");

	}else{
		parseConfigFile = file.name;
		extension = parseConfigFile.substr(parseConfigFile.lastIndexOf('.') + 1);
		if((extension != "cfg" && extension != "dump") && extension != "bin")
		{
			alert("Selected File type is not supported. Supported File type : .cfg/.dump/.bin");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			parseConfigFile = "";
			$("#Parsefileid").val('');
			$("#Parsefileid").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}
		else{
			var mesg = ("Selected files to parse is :" + parseConfigFile);
			update_status_message(mesg);
			ParseCfgFileExt = parseConfigFile.replace(/(.*)\.[^.]+$/, "cfg_parse")
			var ParseFileSizeInKb = file.size/1024;
			if(ParseFileSizeInKb > (1024 * 8))
			{
				alert("File size not supported. Maximum File size can be 2KB");
				var mesg = ("File size not supported. Maximum File size can be 2KB");
				update_status_message(mesg);
				parseConfigFile = "";
				$("#Parsefileid").val('');
				$("#Parsefileid").css({
				background: "white",
				border: "0px"
				});
				errorFlag = true;
				return;
			}
			update_status_message("The size of the selected file selected is " + ParseFileSizeInKb.toFixed(2) + " KB");
				$("#Parsefileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}
function ParseSaveFile(){
	parseSaveFile = "";
	var file = document.getElementById("ParseSavefileid").files[0];
	if(file)
	{
		$("#ParseSavefileid").css({
			background: "white",
			border: "0px"
		});
		parseSaveFile = file.name;
		var saveextension = parseSaveFile.substr(parseSaveFile.lastIndexOf('.') + 1);
		if(saveextension === parseSaveFile )
		{
			parseSaveFile = parseSaveFile + ".txt";
		}
		else if(saveextension === "txt")
		{
			var mesg = ("Selected .txt file to save Configuration file parse output is :" + parseSaveFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .txt");
			update_status_message("Selected File Type is not supported.Supported File type is .txt");
			$("#ParseSavefileid").val('');
			$("#ParseSavefileid").css({
			background: "white",
			border: "0px"
			});
			parseSaveFile="";
			return;
		}
	}
	else
	{
		parseSaveFile = "";
	}
}

function Parsefiles(){
	var data = "";
	//Dont allow user to parse when file name is not present
	if($('#saveparse').is(':checked')){
		if(parseSaveFile == "") {
			alert("Please provide file name to proceed");
			return -1;
		}
	}
	data = UsbParseCfgFile(parseSaveFile);
	if(typeof data === 'undefined')
	{
		alert("Failed to parse selected file");
		update_status_message("Failed to parse selected file");
	}
	else
	{
		document.getElementById("ParseConfigureArea").value = data;
		alert("Parse Configuration file Success");
		update_status_message("Parse Configuration file Success");
	}
}
// Parse Configuration - End

function MergerReadFirstFile() {
	var file = document.getElementById("Mergerfileid").files[0];
	
	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		FirstMergecfgFile = "";
		alert("No configuration file(.cfg) is selected.");

	} else {
		FirstMergecfgFile = file.name;
		extension = FirstMergecfgFile.substr(FirstMergecfgFile.lastIndexOf('.') + 1);
		if((extension != "cfg"))
		{
			alert("Selected File type is not supported. Select File type : cfg");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			FirstMergecfgFile ="";
			$("#Mergerfileid").val('');
			$("#Mergerfileid").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}else{
			var mesg = ("Selected .cfg files to program are :" + FirstMergecfgFile);
			update_status_message(mesg);
			var firstFileSizeInKb = file.size/1024;
			update_status_message("The size of the .cfg files selected are " + firstFileSizeInKb.toFixed(2) + " KB");
				$("#Mergerfileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}

function MergerReadSecondFile() {
	var file = document.getElementById("Mergerfileid1").files[0];
	
	if (typeof file === 'undefined') {

		update_status_message("No configuration file(.cfg) is selected.");
		SecondMergecfgFile = "";
		alert("No configuration file(.cfg) is selected.");

	} else {
		SecondMergecfgFile = file.name;
		extension = SecondMergecfgFile.substr(SecondMergecfgFile.lastIndexOf('.') + 1);
		if((extension != "cfg"))
		{
			alert("Selected File type is not supported. Select File type : cfg");
			var mesg = ("Selected File type is not supported.Supported File type is .cfg");
			update_status_message(mesg);
			SecondMergecfgFile ="";
			$("#Mergerfileid1").val('');
			$("#Mergerfileid1").css({
			background: "white",
			border: "0px"
			});
			errorFlag = true;
			return;
		}else{
			var mesg = ("Selected .cfg files to program are :" + SecondMergecfgFile);
			update_status_message(mesg);
			SecondMergecfgFile = SecondMergecfgFile.replace(/(.*)\.[^.]+$/, "cfg_merge");
			var firstFileSizeInKb = file.size/1024;
			update_status_message("The size of the .cfg files selected are " + firstFileSizeInKb.toFixed(2) + " KB");
				$("#Mergerfileid").css({
				background: "white",
				border: "0px"
			});
			
		}
	}
}

function getmergeConftype() {
	setFileType("cfg", 0);
}

function getmergeSecondConftype() {
	setFileType("cfg_merge", 0);
}

function setmergeConftype() {
	setFileType("cfg_out", 1);
}

function mergefiles() {
	
	var bRet = false;
	
	if(FirstMergecfgFile != "")
	{
		if(SecondMergecfgFile != "") {
			bRet = UsbMergeCfgFile(mergeConfFile);
		} else {
			alert("Please Select File to merge configuration");
			update_status_message("Please Select File to merge configuration");
			return;
		}
	}
	else {
		alert("Please Select File to merge configuration");
		update_status_message("Please Select File to merge configuration");
		return;
	}
	
	if(bRet)
	{
		mergeConfFile = "";
		FirstMergecfgFile = "";
		SecondMergecfgFile = "";
		alert("Merged file was created successfully");
		update_status_message("Merged file was created successfully");
		
	} else {
		alert("Failed to merge two configuration files");
		update_status_message("Failed to merge two configuration files");
	}
}

function getmergeConfFile() {
	mergeConfFile = "";
	var file = document.getElementById("mergeConfFileID").files[0];
	var fileSizeInKb = file.size/1024;
	update_status_message("The size of the Configuration file selected is " + fileSizeInKb + " KB");
	if (file) {
		$("#mergeConfFileID").css({
			background: "white",
			border: "0px"
		});
		mergeConfFile = file.name;
		var saveextension = mergeConfFile.substr(mergeConfFile.lastIndexOf('.') + 1);
		if(saveextension === mergeConfFile)
		{
			mergeConfFile = mergeConfFile + ".cfg";
		}
		else if(saveextension === "cfg")
		{
			var mesg = ("Selected .cfg file to save is :" + mergeConfFile);
			update_status_message(mesg);
		}else{
			alert("Selected File Type is not supported. Please Select File type : .cfg");
			update_status_message("Selected File Type is not supported.Supported File type is .cfg");
			$("#mergeConfFileID").val('');
			$("#mergeConfFileID").css({
			background: "white",
			border: "0px"
			});
			mergeConfFile="";
			return;
		}
	} else {
		$("#mergeConfFileID").css({
			background: "yellow",
			border: "3px red solid"
		});
		update_status_message("No configuration file(.cfg) is selected.");
		mergeConfFile = "";
		alert("No configuration file(.cfg) is selected.");
	}
}


//Populating the default widget values based on the SKU
function populateDefaultValues() {
	
	var skuName = sku; //Get from the dropdown
	
	//Setting the configuration mode to offline in the backend
	setConfigMode(true, skuName);

	// Updating GwidgetlistHex
	$.each(GwidgetlistHex, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);

		if (widgetValue) {
			var decvalue = parseInt(widgetValue,10);
			var hexstring;
			if (value == "usbvcd" || value == "udc_usbvcd" || value == "usb3vcd") // remove the '.' added before
			{
				var dot = ".";
				var hexvalue = (decvalue.toString(16));
				var position = 1;
				var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
			} else {
				hexstring = decvalue.toString(16); //"0x" +  (decvalue.toString(16) );
			}
			$(widgetid).val(hexstring);
		}
	});

	// Updating GwidgetlistString
	$.each(GwidgetlistString, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		if((widgetValue === " ") || (widgetValue === "")) {
			$(widgetid).val("");
			$(widgetid).attr('placeholder', stringnullvalue);
		} else {
			$(widgetid).val(widgetValue);
		}
	});

	// Updating GwidgetlistInt
	$.each(GwidgetlistInt, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		if(widgetValue === "") {
			$(widgetid).val("");
		} else {
			var decVal;
			if (value == "hub3maxpowerselfbus") {
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal,10);
				decVal = decVal * 8;
			} else if((value == "hubcmaxpowerbus") || (value == "hubcmaxpowerself")) {
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal,10);
			} else {
				decVal = widgetValue & 0xff;
				decVal = parseInt(decVal,10);
				decVal = decVal * 2;
			}
			$(widgetid).val(decVal);
		}
	});

	// Updating GwidgetlistCheckbox
	$.each(GwidgetlistCheckbox, function( index, value ) {
		var widgetid = "#" + value;
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		

		if ( widgetValue == checkbox_checked_value )
		{
			$(widgetid).prop('checked',true);     
			// If there are corresponding fieldsets - enable them 
			$(widgetid).trigger("change"); 
			//set_changed_fields_border_default();
		}
		else {
			$(widgetid).prop('checked',false);
			// If there are corresponding fieldsets - disable them 
			$(widgetid).trigger("change"); 
			//set_changed_fields_border_default();
		}
	});

	// Updating GwidgetlistRadio
	$.each(GwidgetlistRadio, function( index, value ) {
		var groupname = value +"group";
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		var nameofcontrol = "input[name=" + groupname + "][value=" + widgetValue + "]";
		$(nameofcontrol).prop("checked", true);
		if ( value === "hubpower")
		{
			var widgetid = "#hubpowergroup";
			// If there are corresponding fieldsets - enable them 
			$(widgetid).trigger("change"); 
			if (widgetValue == "0") { // Bus power
				// Disable the fields
				//$('#selfpowerfieldset').attr('disabled', 'disabled');
				//$('#buspowerfieldset').removeAttr('disabled');
				$('#selfpowerfieldset').hide();
				$('#buspowerfieldset').show();
			} else if (widgetValue == "1") { // Self power
				// Disable the fields
				//$('#buspowerfieldset').attr('disabled', 'disabled');
				//$('#selfpowerfieldset').removeAttr('disabled');
				$('#buspowerfieldset').hide();
				$('#selfpowerfieldset').show();
			}
			//set_changed_fields_border_default();
		}
		
		var pstemp;
		if ( value == "port5splitting")
		{	
			if(widgetValue == 1)
			{
				$('#portpower5').show();
				$('#PORTSplittingfieldset').show();
				widgetValue = getWidgetValue(HUB_ID, "prtpwr5usb3split");
				nameofcontrol = "input[name= prtpwr5usb3splitgroup][value=" + widgetValue + "]";
				$(nameofcontrol).prop("checked", true);
																
			}
			else {
				$('#portpower5').hide();
				widgetValue = getWidgetValue(HUB_ID, "prtpwr5usb3split");
				if(widgetValue == 0) {
					$('#PORTSplittingfieldset').hide();
				}
			}
		}
		
		if ( value == "port6splitting")
		{	
			if(widgetValue == 1)
			{
				$('#portpower6').show();
				$('#PORTSplittingfieldset').show();
				widgetValue = getWidgetValue(HUB_ID, "prtpwr6usb3split");
				pstemp = Number(widgetValue);
				nameofcontrol = "input[name= prtpwr6usb3splitgroup][value=" + (pstemp.toString(16)) + "]";
				$(nameofcontrol).prop("checked", true);
																						
			} else {
				$('#portpower6').hide();
				widgetValue = getWidgetValue(HUB_ID, "prtpwr5usb3split");
				if(widgetValue == 0) {
					$('#PORTSplittingfieldset').hide();
				}
			}
		}
	});
	
	// Updating GwidgetlistDropDown
	$.each(GwidgetlistDropDown, function( index, value ) {
		var widgetValue = getWidgetValue(HUB_FAMILY_INDEX, value);
		var decval = parseInt(widgetValue,10);
		var nameofcontrol = "." + value + "1";
		var nameofcontrol1 = "[data-bind=\"" + value + "label\"]";
		var selText;
				
		if ( value == "PHYBOOST" || value=="PHYBOOSTdownstreamport1" 
		|| value=="PHYBOOSTdownstreamport2" || value=="PHYBOOSTdownstreamport3"
		|| value=="PHYBOOSTdownstreamport4" || value=="PHYBOOSTdownstreamport5"
		|| value=="PHYBOOSTdownstreamport6" || value=="PHYBOOSTdownstreamport7")
		{
			$.each(DropDownPHYBOOST, function( index, valuelist ) {
				if ( index == decval)
				{   
					selText = valuelist;
				}
			});
		
		}
		if ( value == "SQUELCH" || value=="SQUELCHdownstreamport1" 
		|| value=="SQUELCHdownstreamport2" || value=="SQUELCHdownstreamport3"
		|| value=="SQUELCHdownstreamport4" || value=="SQUELCHdownstreamport5"
		|| value=="SQUELCHdownstreamport6" || value=="SQUELCHdownstreamport7")
		{
			$.each(DropDownSQUELCH, function( index, valuelist ) {
				if ( index == decval)
				{   
					selText = valuelist;
				}
			});
		}
		if (value == "upstreamHsRiseFall" || value=="downstreamport1HsRiseFall"
		|| value=="downstreamport2HsRiseFall" || value =="downstreamport3HsRiseFall"
		|| value=="downstreamport4HsRiseFall" || value=="downstreamport5HsRiseFall"
		|| value=="downstreamport6HsRiseFall" || value=="downstreamport7HsRiseFall")
		{
			$.each(DropDownHSRiseFall, function(index, valuelist) {
				if (index == decval)
				{   
					selText = valuelist;
				}
			});
		}
	
		// Update fields based on obtained value
		$(nameofcontrol)
	   .find(nameofcontrol1).text(selText)
		.children('.dropdown-toggle').dropdown('toggle');
	});
	
	if ($('#enableport1').is(':checked')) {
		// Enable the fieldset                    
		$('#downstreamport1Fieldset').removeAttr('disabled');
		$('#nr1div').removeAttr('disabled');
		$('#BdownstreamUSBport1').removeAttr('disabled');
	}
	if ($('#enableport2').is(':checked')) {
		// Enable the fieldset                    
		$('#downstreamport2Fieldset').removeAttr('disabled');
		$('#nr2div').removeAttr('disabled');
		$('#BdownstreamUSBport2').removeAttr('disabled');
	}
	if ($('#enableport3').is(':checked')) {
		// Enable the fieldset                    
		$('#downstreamport3Fieldset').removeAttr('disabled');
		$('#nr3div').removeAttr('disabled');
		$('#BdownstreamUSBport3').removeAttr('disabled');
	}
	if ($('#enableport4').is(':checked')) {
		// Enable the fieldset                    
		$('#downstreamport4Fieldset').removeAttr('disabled');
		$('#nr4div').removeAttr('disabled');
		$('#BdownstreamUSBport4').removeAttr('disabled');
	} 
	if ($('#enableport5').is(':checked')) {
		// Enable the fieldset                    
		$('#downstreamport5Fieldset').removeAttr('disabled');
		$('#nr5div').removeAttr('disabled');
		$('#BdownstreamUSBport5').removeAttr('disabled');
	} 
	if ($('#enableport6').is(':checked')) {
		// Enable the fieldset                    
		$('#downstreamport6Fieldset').removeAttr('disabled');
		$('#nr6div').removeAttr('disabled');
		$('#BdownstreamUSBport6').removeAttr('disabled');
	} 
	if ($('#enableport7').is(':checked')) {
		// Enable the fieldset                    
		$('#downstreamport7Fieldset').removeAttr('disabled');
		$('#nr7div').removeAttr('disabled');
		$('#BdownstreamUSBport7').removeAttr('disabled');
	}
}

//Apply changes function
$("#Apply").click(function() {
		//Array to save the widgets and their values which were changed.
		var deltaobj = [];
		var modifiedWidgets = [];
		var sentinel = true;
		var mismatchCheck = 0;
		
		// language id constraint
		var stringmodified = 0;
		var udc_stringmodified = 0;
		var usb3stringmodified = 0;
		var langid = $("#languageid").val();
		var udc_langid = $("#hce_languageid").val();
		var usb3langid = $("#usb3languageid").val();
		var currentvalue="NONE";
		
		// Check length of strings constraint
		var usb2StringLength = 0;
		var usb3StringLength = 0;
		var hceStringLength = 0;
		
		//Alert flags for string lengths
		var enableMapping = false;
		
		var usb2StringFlag = true;
		var usb3StringFlag = true;
		var hceStringFlag = true;
		
		//flag for alert message
		var errorFlag = false;

		var port1dontchange=0;
		var port2dontchange=0;
		var port3dontchange=0;
		var port4dontchange=0;
		var port5dontchange=0;
		var port6dontchange=0;
		var port7dontchange=0;
		
		//usb3
		var usb3port1dontchange=0;
		var usb3port2dontchange=0;
		var usb3port3dontchange=0;
		var usb3port4dontchange=0;
		var usb3port5dontchange=0;
		var usb3port6dontchange=0;
		var usb3port7dontchange=0;
		
		var usb2map = 1;
		var usb3port1disable = 0;
		var usb3port2disable = 0;
		var usb3port3disable = 0;
		var usb3port4disable = 0;
		var usb3port5disable = 0;
		var usb3port6disable = 0;
		var usb3port7disable = 0;
		
		// Find out currently how many ports are enabled
		var bEnable1 = $('#enableport1').is(':checked');
		var bEnable2 = $('#enableport2').is(':checked');
		var bEnable3 = $('#enableport3').is(':checked');
		var bEnable4 = $('#enableport4').is(':checked');
		var bEnable5 = $('#enableport5').is(':checked');
		var bEnable6 = $('#enableport6').is(':checked');
		var bEnable7 = 0;
		if (portsAvailable == 7) {
			bEnable7 = $('#enableport7').is(':checked');
		}
		var SendNoofPorts = 0;
		//Total ports enabled 
		var bTotal = bEnable1 + bEnable2 + bEnable3 + bEnable4 + bEnable5 + bEnable6 + bEnable7;
		
		// Find out currently how many USB2.0 ports are enabled
		var usb3bEnable1 = $('#usb3enableport1').is(':checked');
		var usb3bEnable2 = $('#usb3enableport2').is(':checked');
		var usb3bEnable3 = $('#usb3enableport3').is(':checked');
		var usb3bEnable4 = $('#usb3enableport4').is(':checked');
		var usb3bEnable5 = $('#usb3enableport5').is(':checked');
		var usb3bEnable6 = $('#usb3enableport6').is(':checked');
		var usb3bEnable7 = 0;
		if (portsAvailable == 7) {
			usb3bEnable7 = $('#usb3enableport7').is(':checked');
		}
		var usb3SendNoofPorts = 0;
		//Total ports enabled 
		var usb3bTotal = usb3bEnable1 + usb3bEnable2 + usb3bEnable3 + usb3bEnable4 + 
		usb3bEnable5 + usb3bEnable6 + usb3bEnable7;

		if (offlineConfFile == "") {
			update_status_message("Please select a file to save the offline Configuration.");
			alert("Please select a file to save the offline Configuration.");
			return;
		}
		
		// Check Port Disable condition
		var port1Status = $('#enableport1').is(':checked')?1:0;
		var port2Status = $('#enableport2').is(':checked')?1:0;
		var port3Status = $('#enableport3').is(':checked')?1:0;
		var port4Status = $('#enableport4').is(':checked')?1:0;
		var port5Status = $('#enableport5').is(':checked')?1:0;
		var port6Status = $('#enableport6').is(':checked')?1:0;
		var port7Status = $('#enableport7').is(':checked')?1:0;
		
		var usb3port1Status = $('#usb3enableport1').is(':checked')?1:0;
		var usb3port2Status = $('#usb3enableport2').is(':checked')?1:0;
		var usb3port3Status = $('#usb3enableport3').is(':checked')?1:0;
		var usb3port4Status = $('#usb3enableport4').is(':checked')?1:0;
		var usb3port5Status = $('#usb3enableport5').is(':checked')?1:0;
		var usb3port6Status = $('#usb3enableport6').is(':checked')?1:0;
		var usb3port7Status = $('#usb3enableport7').is(':checked')?1:0;
		

		var hceStatus = $('#hceenable').is(':checked')?1:0;

		if (hceStatus == 0) {
			if ((port1Status == 0) && (port2Status == 0) && (port3Status == 0) && (port4Status == 0)
				&& (port5Status == 0) && (port6Status == 0)) {
				if(portsAvailable == 7) {
					if((port7Status == 0)) {
						var option = confirm("Hub controller is disabled.After programming all the ports will be disabled. do you want to continue?");
						if(!option) {
							update_status_message("Generation of configuration file was terminated by the user.");
							return;
						}
					}
				} else {
					var option = confirm("Hub controller is disabled.After programming all the ports will be disabled. do you want to continue?");
					if(!option) {
						update_status_message("Generation of configuration file was terminated by the user.");
						return;
					}
				}
			}
		}

		//To program it to defaults when a port is disabled.
		if (bEnable1 == false) {
			var nrport1 = getWidgetValue(HUB_FAMILY_INDEX, "nrdeviceport1");
			var dpdmSwap1 = getWidgetValue(HUB_FAMILY_INDEX, "swapport1dpdm");
			var phyboost1 = getWidgetValue(HUB_FAMILY_INDEX, "PHYBOOSTdownstreamport1");
			var varisense1 = getWidgetValue(HUB_FAMILY_INDEX, "SQUELCHdownstreamport1");
			var hsrisefall1 = getWidgetValue(HUB_FAMILY_INDEX, "downstreamport1HsRiseFall");
			if (nrport1 != 0) {
				//deltaobj.push("nrdeviceport1", 0);
				nrModified = true;
				
			}
			
			if (dpdmSwap1 != 0) {
				deltaobj.push("swapport1dpdm", 0);
			}
			
			if (phyboost1 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport1", 0);
			}
			
			if (varisense1 != 0) {
				deltaobj.push("SQUELCHdownstreamport1", 0);
			}
			if(hsrisefall1 !=0)
			{
				deltaobj.push("downstreamport1HsRiseFall", 0);
			}
		}

		if (bEnable2 == false) {
			var nrport2 = getWidgetValue(HUB_FAMILY_INDEX, "nrdeviceport2");
			var dpdmSwap2 = getWidgetValue(HUB_FAMILY_INDEX, "swapport2dpdm");
			var phyboost2 = getWidgetValue(HUB_FAMILY_INDEX, "PHYBOOSTdownstreamport2");
			var varisense2 = getWidgetValue(HUB_FAMILY_INDEX, "SQUELCHdownstreamport2");
			var hsrisefall2 = getWidgetValue(HUB_FAMILY_INDEX, "downstreamport2HsRiseFall");
			if (nrport2 != 0) {
				//deltaobj.push("nrdeviceport2", 0);
				nrModified = true;
				
			}
			
			if (dpdmSwap2 != 0) {
				deltaobj.push("swapport2dpdm", 0);
			}
			
			if (phyboost2 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport2", 0);
			}
			
			if (varisense2 != 0) {
				deltaobj.push("SQUELCHdownstreamport2", 0);
			}
			if(hsrisefall2 !=0)
			{
				deltaobj.push("downstreamport2HsRiseFall", 0);
			}
		}

		if (bEnable3 == false) {
			var nrport3 = getWidgetValue(HUB_FAMILY_INDEX, "nrdeviceport3");
			var dpdmSwap3 = getWidgetValue(HUB_FAMILY_INDEX, "swapport3dpdm");
			var phyboost3 = getWidgetValue(HUB_FAMILY_INDEX, "PHYBOOSTdownstreamport3");
			var varisense3 = getWidgetValue(HUB_FAMILY_INDEX, "SQUELCHdownstreamport3");
			var hsrisefall3 = getWidgetValue(HUB_FAMILY_INDEX, "downstreamport2HsRiseFall");
			if (nrport3 != 0) {
				//deltaobj.push("nrdeviceport3", 0);
				nrModified = true;
				
			}
			
			if (dpdmSwap3 != 0) {
				deltaobj.push("swapport3dpdm", 0);
			}
			
			if (phyboost3 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport3", 0);
			}
			
			if (varisense3 != 0) {
				deltaobj.push("SQUELCHdownstreamport3", 0);
			}
			if(hsrisefall3 !=0)
			{
				deltaobj.push("downstreamport3HsRiseFall", 0);
			}
		}

		if (bEnable4 == false) {
			var nrport4 = getWidgetValue(HUB_FAMILY_INDEX, "nrdeviceport4");
			var dpdmSwap4 = getWidgetValue(HUB_FAMILY_INDEX, "swapport4dpdm");
			var phyboost4 = getWidgetValue(HUB_FAMILY_INDEX, "PHYBOOSTdownstreamport4");
			var varisense4 = getWidgetValue(HUB_FAMILY_INDEX, "SQUELCHdownstreamport4");
			var hsrisefall4 = getWidgetValue(HUB_ID, "downstreamport4HsRiseFall");
			if (nrport4 != 0) {
				//deltaobj.push("nrdeviceport4", 0);
				nrModified = true;
				
			}
			
			if (dpdmSwap4 != 0) {
				deltaobj.push("swapport4dpdm", 0);
			}
			
			if (phyboost4 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport4", 0);
			}
			
			if (varisense4 != 0) {
				deltaobj.push("SQUELCHdownstreamport4", 0);
			}
			if(hsrisefall4 !=0)
			{
				deltaobj.push("downstreamport4HsRiseFall", 0);
			}
		}

		if (bEnable5 == false) {
			var nrport5 = getWidgetValue(HUB_ID, "nrdeviceport5");
			var dpdmSwap5 = getWidgetValue(HUB_ID, "swapport5dpdm");
			var phyboost5 = getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport5");
			var varisense5 = getWidgetValue(HUB_ID, "SQUELCHdownstreamport5");
			var hsrisefall5 = getWidgetValue(HUB_ID, "downstreamport5HsRiseFall");
			if (nrport5 != 0) {
				nrModified = true;
				
			}
			
			if (dpdmSwap5 != 0) {
				deltaobj.push("swapport5dpdm", 0);
			}
			
			if (phyboost5 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport5", 0);
			}
			
			if (varisense5 != 0) {
				deltaobj.push("SQUELCHdownstreamport5", 0);
			}
			if(hsrisefall5 !=0)
			{
				deltaobj.push("downstreamport5HsRiseFall", 0);
			}
		}
		
		if (bEnable6 == false) {
			var nrport6 = getWidgetValue(HUB_ID, "nrdeviceport6");
			var dpdmSwap6 = getWidgetValue(HUB_ID, "swapport6dpdm");
			var phyboost6 = getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport6");
			var varisense6 = getWidgetValue(HUB_ID, "SQUELCHdownstreamport6");
			var hsrisefall6 = getWidgetValue(HUB_ID, "downstreamport6HsRiseFall");
			if (nrport6 != 0) {
				nrModified = true;
			}
			
			if (dpdmSwap6 != 0) {
				deltaobj.push("swapport6dpdm", 0);
			}
			
			if (phyboost6 != 0) {
				deltaobj.push("PHYBOOSTdownstreamport6", 0);
			}
			
			if (varisense6 != 0) {
				deltaobj.push("SQUELCHdownstreamport6", 0);
			}
			if(hsrisefall6 !=0)
			{
				deltaobj.push("downstreamport6HsRiseFall", 0);
			}
		}
		
		if (portsAvailable == 7) {
			if (bEnable7 == false) {
				var nrport7 = getWidgetValue(HUB_ID, "nrdeviceport7");
				var dpdmSwap7 = getWidgetValue(HUB_ID, "swapport7dpdm");
				var phyboost7 = getWidgetValue(HUB_ID, "PHYBOOSTdownstreamport7");
				var varisense7 = getWidgetValue(HUB_ID, "SQUELCHdownstreamport7");
				var hsrisefall7 = getWidgetValue(HUB_ID, "downstreamport7HsRiseFall");
				if (nrport7 != 0) {
					nrModified = true;
					
				}
				
				if (dpdmSwap7 != 0) {
					deltaobj.push("swapport7dpdm", 0);
				}
				
				if (phyboost7 != 0) {
					deltaobj.push("PHYBOOSTdownstreamport7", 0);
				}
				
				if (varisense7 != 0) {
					deltaobj.push("SQUELCHdownstreamport7", 0);
				}
				if(hsrisefall7 !=0)
				{
					deltaobj.push("downstreamport7HsRiseFall", 0);
				}
			}
		}
		
		if (usb3bEnable1 == false) {
			var usb3nrport1 = getWidgetValue(HUB_ID, "usb3nrdeviceport1");

			if (usb3nrport1 != 0) {
				usb3nrModified = true;
			}
		}
		
		if (usb3bEnable2 == false) {
			var usb3nrport2 = getWidgetValue(HUB_ID, "usb3nrdeviceport2");

			if (usb3nrport2 != 0) {
				usb3nrModified = true;
			}
		}
		
		if (usb3bEnable3 == false) {
			var usb3nrport3 = getWidgetValue(HUB_ID, "usb3nrdeviceport3");

			if (usb3nrport3 != 0) {
				usb3nrModified = true;
			}
		}
		
		if (usb3bEnable4 == false) {
			var usb3nrport4 = getWidgetValue(HUB_ID, "usb3nrdeviceport4");

			if (usb3nrport4 != 0) {
				usb3nrModified = true;
			}
		}
		
		if (usb3bEnable5 == false) {
			var usb3nrport5 = getWidgetValue(HUB_ID, "usb3nrdeviceport5");

			if (usb3nrport5 != 0) {
				usb3nrModified = true;
			}
		}
		
		if (usb3bEnable6 == false) {
			var usb3nrport6 = getWidgetValue(HUB_ID, "usb3nrdeviceport6");

			if (usb3nrport6 != 0) {
				usb3nrModified = true;
			}
		}
		
		if (portsAvailable == 7) {
			if (usb3bEnable7 == false) {
				var usb3nrport7 = getWidgetValue(HUB_ID, "usb3nrdeviceport7");

				if (usb3nrport7 != 0) {
					usb3nrModified = true;
				}
			}
		}

		//TO DO: String length constraint check and coding
		//String Descriptors
		$.each(GwidgetlistString, function( index1, value1 ) {
			var widgetid = "#" + value1;
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			var newval = $(widgetid).val();

			if (value1 === "usb3manufacturer" || value1 === "usb3product"|| value1 === "usb3serial")
			{
				var stringvalue = $(widgetid).val();
				// Check the widget length also
				if (stringvalue  == stringnullvalue )
				{
					// do nothing null string
				} else {
					usb3StringLength = usb3StringLength + $(widgetid).val().length;
				}
				//Checking the string length constraint
				if ((usb3StringLength > 90) && usb3StringFlag)
				{
					window.alert("String Descriptors(Sum of string lengths of Manufacturer name,Product name and Serial Number) of USB3.1 Gen1 can have a max length of 90 unicode characters only");
					update_status_message("Error : String Descriptors(Sum of string lengths of Manufacturer name,Product name and Serial Number) of USB3.1 Gen1 can have a max length of 90 unicode characters only");
					deltaobj = [];
					modifiedWidgets = [];
					usb3StringFlag = false;
					errorFlag = true;
					return;
				}
			}
			
			if (value1 === "manufacturer" || value1 === "product"|| value1 === "serial")
			{
				var stringvalue = $(widgetid).val();

				// Check the widget length also
				if (stringvalue  == stringnullvalue)
				{
					// do nothing null string
				} else {
					usb2StringLength = usb2StringLength + $(widgetid).val().length;
				}
				//Checking the string length constraint
				if ((usb2StringLength > 90) && usb2StringFlag)
				{
					window.alert("String Descriptors(Sum of string lengths of Manufacturer name,Product name and Serial Number) of USB2.0 can have a max length of 90 unicode characters only");
					update_status_message("Error : String Descriptors(Sum of string lengths of Manufacturer name,Product name and Serial Number) of USB2.0 can have a max length of 90 unicode characters only");
					deltaobj = [];
					modifiedWidgets = [];
					usb2StringFlag = false;
					errorFlag = true;
					return;
				}
			}
			
			if(value1 === "hce_manufacturer") {
				enablealertmanu = true;
			} else if(value1 === "hce_product") {
				enablealertprod = true;
			} else if(value1 === "hce_serial") {
				enablealertser = true;
			}
			
			if (value1 === "hce_manufacturer" || value1 === "hce_product" || value1 === "hce_serial")
			{
				var stringvalue = $(widgetid).val();

				// Check the widget length also
				if (stringvalue  == stringnullvalue)
				{
					// do nothing null string
				} else {
					hceStringLength = hceStringLength + $(widgetid).val().length;
				}
				//Checking the string length constraint
			
				if ((hceStringLength > 60) && hceStringFlag)
				{
					window.alert("String Descriptors(Sum of string lengths of Manufacturer name and Product name) of Hub Feature Controller can have a max length of 60 unicode characters only");
					update_status_message("Error : String Descriptors(Sum of string lengths of Manufacturer name and Product name) of Hub Feature Controller can have a max length of 60 unicode characters only");
					deltaobj = [];
					modifiedWidgets = [];
					hceStringFlag = false;
					errorFlag = true;
					return;
				}
			}

			
				if (value1 === "usb3uuid") {
					var uuidVal = $(widgetid).val();
					var isOkay = /^[0-9a-f]{1,32}$/i.test(uuidVal);

					if (uuidVal == "") {
						alert("Please enter a value for USB3.1 Gen1 UUID.");
						return;
					} else if (!isOkay) {
						alert("UUID value entered is invalid. UUID of USB3.1 Gen1 must be a 16 bytes of hexadecimal number.");
						update_status_message("UUID value entered is invalid. UUID of USB3.1 Gen1 must be a 16 bytes of hexadecimal number.");
						errorFlag = true;
						return;
					}
				}
			

			var that = $( widgetid ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );
			if ((newval === stringnullvalue) || (newval === oldval))
			{
				// do nothing no change detected.
			}
			else if ( checkdisabled )
			{
				// Change detected but field is disabled - So do nothing
				 console.log("change detected but field disabled: widget:" + value1 );
			}
			else {
				//console.log("change detected : widget:" + value1); // + " current value:" + val1 + " new value:" + newval);
			
				if (value1 === "usb3manufacturer" || 
					value1 === "usb3product"||
					value1 === "usb3serial")
				{
					usb3stringmodified = 1;
				}
			

				if (value1 === "hce_manufacturer" || 
					value1 === "hce_product" || value1 === "hce_serial")
				{
					udc_stringmodified = 1;
				}
				
				if (value1 === "manufacturer" || 
					value1 === "product"||
					value1 === "serial")
				{
					stringmodified = 1;
				}

				if (jQuery.isEmptyObject(newval)) {
					newval = "";
				}

				if (value1 === "manufacturer" || value1 === "product"|| 
					value1 === "serial")
				{
					deltaobj.push(value1, newval);
					modifiedWidgets.push(value1);
					
					// Set the widget length also
					var len = $(widgetid).val().length;
					// Now check if length constraint is met or not.
					var lenwidget = value1 + "len";
					//console.log("Also updating :" + lenwidget + " new value:" + len);
					deltaobj.push(lenwidget,len);
				}  
				
				
				if (value1 === "usb3manufacturer" || value1 === "usb3product"|| 
					value1 === "usb3serial")
				{
					deltaobj.push(value1, newval);
					modifiedWidgets.push(value1);
				} 
				
				
				if (value1 === "hce_manufacturer") {
					hceenablemanu = true;
					
				} else if (value1 === "hce_product") {
					hceenableprod = true;
				}  else if(value1 === "hce_serial") {
					hceenableser = true;
				}  
				
								
				
				if (value1 == "usb3uuid") {
					deltaobj.push(value1, newval);
					modifiedWidgets.push(value1);
				}
			}
		}); //End of $.each(GwidgetlistString, function( index1, value1 )*/

		//Hex Descriptors
		$.each(GwidgetlistHex, function( index1, value1 ) {
			var widgetid = "#" + value1;
			var oldval;
			var newval;
			var isOk;
			
			if(value1 === "usbvcd" || value1 === "udc_usbvcd" || value1 === "usb3vcd") {
				var usbvcdVal = parseInt(getWidgetValue(HUB_FAMILY_INDEX, value1), 10);
				var dot = ".";
				var hexvalue = (usbvcdVal.toString(16));
				var position = 1;
				var hexstring = [hexvalue.slice(0, position), dot, hexvalue.slice(position)].join('');
				oldval = hexstring;
				newval = $(widgetid).val();
				if (value1 == "usbvcd") {
					isOk = /^2\.?[0-9]{0,2}$/i.test($(widgetid).val());
				}
				
				
				if (value1 == "usb3vcd") {
					isOk = /^3\.?[0-9]{0,2}$/i.test($(widgetid).val());
				}
				
				
				if (typeof isOk == 'undefined') {
					return;
				}
				if (!isOk) {
					update_status_message("The value entered for \"" + Mapping[value1] + "\" is not valid.");
					alert("The value entered for \"" + Mapping[value1] + "\" is not valid");
					errorFlag = true;
				}
			} else {
				oldval = parseInt(getWidgetValue(HUB_FAMILY_INDEX, value1), 10);
				isOk = /^[0-9A-Fa-f]{1,4}$/i.test($(widgetid).val());
				newval = parseInt($(widgetid).val(), 16);
				
				if ((value1 == "vid") || (value1 == "hce_vid") || (value1 == "usb3vid")) {
					var widID = "#" + value1;
					var widVal = $(widID).val();
					if (widVal == 0) {
						isOk = false;
					}
				}
				
				if (!isOk) {
					if (value1 == "usb3pid" || value1 == "usb3did" || value1 == "usb3vid" || value1 == "usb3languageid") {
						
							update_status_message("The value entered for \"" + Mapping[value1] + "\" must be a 4 digit hexadecimal value and it cannot be Zero.");
							alert("The value entered for \"" + Mapping[value1] + "\" must be a 4 digit hexadecimal value and it cannot be Zero.");
							errorFlag = true;
						
					} else {
						update_status_message("The value entered for \"" + Mapping[value1] + "\" must be a 4 digit hexadecimal value and it cannot be Zero.");
						alert("The value entered for \"" + Mapping[value1] + "\" must be a 4 digit hexadecimal value and it cannot be Zero.");
						errorFlag = true;
					}
				}
			}
			
			if (!isOk) {
				// Do nothing. The value entered does not meet the expected pattern.
			} else {
				if ((oldval === newval) || isNaN(newval)) {
					//Do nothing
				} else {
					//Check for language ID
					if ((value1 == "languageid") || (value1 == "hce_languageid") || (value1 == "usb3languageid")) {
						if (newval == 0) {
							alert("Language ID cannot be zero. Setting it to default value (0x409)");
							newval = parseInt("0x409", 16);
						}
					}
					// Adding the VID of USB2.0 and HCE to Protouch2.ini, if they are modified.
					if ((value1 == "vid") || (value1 == "hce_vid")) {
						var valueEntered = $(widgetid).val();
						var hexEntered = "0x" + valueEntered;
						updateINI(hexEntered);
						vidModified = true;
					}

					// convert string to number                                        
					var decvalue = parseInt(newval,10);
					// convert number to string and then string to hex
					var valueToSet;
					if (value1 =="usbvcd" || value1 =="udc_usbvcd" || value1 == "usb3vcd") // remove the '.' added before
					{
						newval = newval.replace('.', '');
						decvalue = parseInt(newval,10);
						valueToSet = decvalue;
					}
					else {
						valueToSet = "0x" +  (decvalue.toString(16) ); 
					}
					var that = $( widgetid ), parent = that.closest('fieldset');
					var  checkdisabled = $(parent).prop( "disabled" );
					if ( checkdisabled )
					{
						// Change detected but field is disabled - So do nothing
						console.log("change detected but field disabled: widget:" + value1 + " new value:" + hexstring);
					}
					else {
						if (((value1 === "vid") || (value1 === "usb3vid"))) {
							if (sentinel) {
								var usb3VID = $("#usb3vid").val();
								var usb2VID = $("#vid").val();
								if (usb3VID == usb2VID) {
									sentinel = false;
									deltaobj.push("vid", valueToSet);
									deltaobj.push("usb3vid", valueToSet);
								} else {
									update_status_message("Mismatch in VID of USB2.0 and USB3.1 Gen1. Please make sure their VID is the same.");
									mismatchCheck++;
									if (mismatchCheck == 1) {
										alert("Mismatch in VID of USB2.0 and USB3.1 Gen1. Please make sure their VID is the same.");
										errorFlag = true;
										return;
									}
								}
							}
						} else {
				
							deltaobj.push(value1,valueToSet);
							modifiedWidgets.push(value1);
						}
					}
				}
			}
		});
		
		//Int Descriptors
		$.each(GwidgetlistInt, function(index1, value1) {
			var widgetid = "#" + value1;
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			if (value1 == "hub3maxpowerselfbus") {
				//if (Product == "USB3.1 Gen1") {
					oldval = parseInt(oldval,10) * 8;
				//}
			} else if((value1 == "hubcmaxpowerbus") || (value1 == "hubcmaxpowerself")){
				oldval = parseInt(oldval,10);
			}else{
				oldval = parseInt(oldval,10) *2;
			}
			var that = $(widgetid), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop("disabled");
			
			var newval = $(widgetid).val();
			var newdecvalue = parseInt(newval,10);
			newdecvalue = newdecvalue & 0xff;
			if(((value1 == "hub3maxpowerselfbus")) || (value1 == "maxpowerself") || (value1 == "maxpowerbus") )
			{
				if ((newdecvalue & 0x01) && !checkdisabled)
				{
					currentvalue = "ODDNUM";
					return;
				}
			}
			
			if ((oldval == newval) || isNaN(newval)) {
				// do nothing - no change in value
				//console.log("nochange:widget:" + widget1 + " value:" + val1 + " new value:" + newval);
			} 
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
				console.log("change detected but field disabled: widget:" + value1 + " new value:" + newdecvalue); //+ " current value:" + val1 + " new value:" + newval);
			}
			else {
				if ((value1 == "maxpowerself") || (value1 == "hubcmaxpowerself")) {
					if ((newval > 100) || (newval < 0)) {
						alert ("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
						update_status_message("USB2.0 max power(self) or USB2.0 hub circuit max power(self) cannot be more than 100mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (value1 == "maxpowerbus") {
					if ((newval > 500) || (newval < 0)) {
						alert ("USB2.0 max power(bus) cannot be more than 500mA or negative.");
						update_status_message("USB2.0 max power(bus) cannot be more than 500mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (value1 == "hubcmaxpowerbus") {
					if ((newval > 255) || (newval < 0)) {
						alert ("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
						update_status_message("USB2.0 hub circuit max power(bus) cannot be more than 255mA or negative.");
						errorFlag = true;
						return;
					}
				}

				if (value1 == "hub3maxpowerselfbus") {
					if ((newval > 900) || (newval < 0)) {
						alert ("USB3.1 Gen1 hub max power cannot be more than 900mA or negative.");
						update_status_message("USB3.1 Gen1 hub max power cannot be more than 900mA or negative.");
						errorFlag = true;
						return;
					}
				}
				var hexval;
				if (value1 == "hub3maxpowerselfbus") {
					var newdecvalue = parseInt(newval,10);
					var reminder = newdecvalue%8;
					if(reminder != 0)
					{
						alert ("Hub Max Power 3.1 Gen1 field can have multiples of 8 only");
						var mesg = "Error : Hub Max Power 3.1 Gen1 field can have multiples of 8 only";
						update_status_message(mesg);
						errorFlag = true;
						return;
					}
					newdecvalue = newdecvalue/8;
					var temp = Math.floor(newdecvalue);
					hexval = temp.toString(16);
				} else if ((value1 == "hubcmaxpowerbus") || (value1 == "hubcmaxpowerself")) {
					newdecvalue = parseInt(newval,10);
					hexval = newdecvalue.toString(16);
				} else {
					newdecvalue = parseInt(newval,10);
					newdecvalue = newdecvalue/2;
					hexval = newdecvalue.toString(16);
				}
				deltaobj.push(value1, hexval);
			}
		});
		if (currentvalue == "ODDNUM") {
			$("#progID").hide();
			alert("\"Hub MaxPower(Self)\", \"Hub Circuit MaxPower(Self)\", \"HubMaxPower(Bus)\" and \"Hub Circuit MaxPower(Bus)\" fields can have even numbers only");
			var mesg = "Error : \"Hub MaxPower(Self)\", \"Hub Circuit MaxPower(Self)\", \"Hub MaxPower(Bus)\" and \"Hub Circuit MaxPower(Bus)\" fields can have even numbers only";
			update_status_message(mesg);
			currentvalue= "NONE";
			errorFlag = true;
			return;
		}

		//Radio buttons
		var portSplit5include = false;
		var portSplit6include = false;
		var portSplittimeoutinclude = false;
		
		
		$.each(GwidgetlistRadio, function(index2, value1) {
			var widgetgroupname = '#' + value1 +"group";
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			var newval = $(widgetgroupname).find(':checked').val();
			var that = $( widgetgroupname ), parent = that.closest('fieldset');
			var  checkdisabled = $(parent).prop( "disabled" );
			if ((oldval === newval) || jQuery.isEmptyObject(newval))
			{// do nothing
				//If Port splitting is already enabled and only GPIO needs to be updated
				//Port 5
				if ((value1 == "port5splitting")) {
					if(newval == 1) {
						var portpower5radio = $("#prtpwr5usb3splitgroup").find(':checked').val();
						var portpower5radio_old = getWidgetValue(HUB_ID, "prtpwr5usb3split");
						var pstemp = Number(portpower5radio_old);
						var ps5oldVal = pstemp.toString(16);
						
						if ((portpower5radio == portpower5radio_old) ) {
							//Old value and new value are the same; do nothing
						} else {
							var opt = confirm("Enabling port splitting on port 5 will disable the default function of GPIO " + portpower5radio
											+ ".\n Do you wish to continue?");
							
							if (opt) {
								var dummyportpower5radio = parseInt(portpower5radio,10);
								var hexportpower5radio = dummyportpower5radio.toString(16);
								deltaobj.push("prtpwr5usb3split", hexportpower5radio);
								modifiedWidgets.push("prtpwr5usb3split");
								portSplit5include = true;
								portSplittimeoutinclude = true;
							} else {
								portSplit5include = false;
								
								//User has chosen not to program; Do nothing
							}
						}
					}
				}
				
				//Port 6
				if ((value1 == "port6splitting")) {
					if(newval == 1) {
						var portpower6radio = $("#prtpwr6usb3splitgroup").find(':checked').val();
						var portpower6radio_old = getWidgetValue(HUB_ID, "prtpwr6usb3split");
						
						if ((portpower6radio === portpower6radio_old)) {
							//Old value and new value are the same; do nothing
							
						} else {
							var opt = confirm("Enabling port splitting on port 6 will disable the default function of GPIO " + portpower6radio
											+ ".\n Do you wish to continue?");
							
							
							if (opt) {
								deltaobj.push("prtpwr6usb3split", portpower6radio);
								modifiedWidgets.push("prtpwr6usb3split");
								portSplit6include = true;
								portSplittimeoutinclude = true;
								
							} else {
								portSplit6include = false;
								
								
								//User has chosen not to program; Do nothing
							}
						}
					}
				}
			
			}
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
				console.log("change detected but field disabled: widget:" + widgetgroupname + " new value:" + newval);// + " current value:" + val1 + " new value:" + newval1);
			}
			else
			{
				if ((value1 == "port5splitting")) {
					if(newval == 1) {
						var portpower5radio = $("#prtpwr5usb3splitgroup").find(':checked').val();
						var pstimeout = $("#pstimeoutgroup").find(':checked').val();
						
						if (typeof portpower5radio == 'undefined') {
							alert("Please choose a GPIO to support Port Power control in Port5");
							update_status_message("Please choose a GPIO to support Port Power control in Port5");
							errorFlag = true;
							return;
						}
						
						var opt = confirm("Enabling port splitting on port 5 will disable the default function of GPIO " + portpower5radio
											+ ".\n Do you wish to continue?");
						
						if (opt) {
							var dummyportpower5radio = parseInt(portpower5radio,10);
							var hexportpower5radio = dummyportpower5radio.toString(16);
							deltaobj.push("prtpwr5usb3split", hexportpower5radio);
							modifiedWidgets.push("prtpwr5usb3split");
						
							portSplit5include = true;
							portSplittimeoutinclude = true;
						} else {
							portSplit5include = false;
							
							//User has chosen not to program; Do nothing
						}
					}
					else
					{
						deltaobj.push("prtpwr5usb3split", 0);
						modifiedWidgets.push("prtpwr5usb3split");
						portSplit5include = true;
						portSplit5timeoutinclude = true;
					}
				}
				
				if ((value1 == "port6splitting")) {
					if(newval == 1) {
						var portpower6radio = $("#prtpwr6usb3splitgroup").find(':checked').val();
						var pstimeout = $("#pstimeoutgroup").find(':checked').val();
						if (typeof portpower6radio == 'undefined') {
							alert("Please choose a GPIO to support Port Power control in Port6");
							update_status_message("Please choose a GPIO to support Port Power control in Port6");
							errorFlag = true;
							return;
						}
						
						var opt = confirm("Enabling port splitting on port 6 will disable the default function of GPIO " + portpower6radio
											+ ".\n Do you wish to continue?");
						
						
						if (opt) {
							deltaobj.push("prtpwr6usb3split", portpower6radio);
							modifiedWidgets.push("prtpwr6usb3split");
							portSplittimeoutinclude = true;
							portSplit6include = true;
							
						} else {
							portSplit6include = false;
							
							
							//User has chosen not to program; Do nothing
						}
					}
					else
					{
						deltaobj.push("prtpwr6usb3split", 0);
						modifiedWidgets.push("prtpwr6usb3split");
						portSplit6include = true;
						portSplittimeoutinclude = true;
					}
				}
				if (value1 == "port5splitting") {
					if (portSplit5include) {
						deltaobj.push(value1, newval);
						modifiedWidgets.push(value1);
					}
					
				} else if (value1 == "port6splitting") {
					if (portSplit6include) {
						deltaobj.push(value1, newval);
						modifiedWidgets.push(value1);
					}
					
				} else {
					deltaobj.push(value1, newval);
					modifiedWidgets.push(value1);
				}
				
				if (value1 == "pstimeout") {
					if (portSplittimeoutinclude) {
						deltaobj.push(value1, newval);
						modifiedWidgets.push(value1);
						portSplittimeoutinclude = false;
					}
					
				}			
			}
		});
		
		//DropDown
		
		$.each(GwidgetlistDropDown, function(index2, value1) {
			var nameofcontrol = "." + value1 + "1";
			var nameofcontrol1 = "[data-bind=\"" + value1 + "label\"]";
			var selText = $(nameofcontrol).find(nameofcontrol1).text();
			var newindexofdropdownlist;
			var that = $( nameofcontrol ), parent = that.closest('fieldset');
			var checkdisabled = $(parent).prop( "disabled" );

			if (value1 === "PHYBOOST" || value1 === "PHYBOOSTdownstreamport1" ||
				value1 === "PHYBOOSTdownstreamport2" || value1 === "PHYBOOSTdownstreamport3" ||
				value1 === "PHYBOOSTdownstreamport4" || value1 === "PHYBOOSTdownstreamport5" ||
				value1 === "PHYBOOSTdownstreamport6" || value1 === "PHYBOOSTdownstreamport7")
			{
				$.each(DropDownPHYBOOST, function(index, valuelist) {
					if ( selText === valuelist)
					{
						newindexofdropdownlist = index;
					}
				});
			}
			if (value1 === "SQUELCH" || value1 === "SQUELCHdownstreamport1" ||
				value1 === "SQUELCHdownstreamport2" || value1 === "SQUELCHdownstreamport3" ||
				value1 === "SQUELCHdownstreamport4" || value1 === "SQUELCHdownstreamport5" ||
				value1 === "SQUELCHdownstreamport6" || value1 === "SQUELCHdownstreamport7")
			{
				$.each(DropDownSQUELCH, function(index, valuelist) {
					if ( selText === valuelist)
					{   
						newindexofdropdownlist = index;
					}
				});
			}
			if(value1 === "upstreamHsRiseFall" || value1 === "downstreamport1HsRiseFall" ||
				value1 === "downstreamport2HsRiseFall" || value1 === "downstreamport3HsRiseFall" ||
				value1 === "downstreamport4HsRiseFall" || value1 === "downstreamport5HsRiseFall" ||
				value1 === "downstreamport6HsRiseFall" || value1 === "downstreamport7HsRiseFall")
			{
				$.each(DropDownHSRiseFall, function(index, valuelist) {
					if (selText == valuelist)
					{   
						newindexofdropdownlist = index;
					}
				});
			}
			
			var oldval = getWidgetValue(HUB_ID, value1);

			if (newindexofdropdownlist || newindexofdropdownlist == 0) {
				if ((newindexofdropdownlist == oldval))
				{
					// no change
				} else if (checkdisabled) {
					// Change detected but field is disabled - So do nothing
					console.log("change detected but field disabled: widget:" + value1); // + " current value:" + val1 + " new value:" + newindexofdropdownlist);
				} else {
					deltaobj.push(value1, newindexofdropdownlist);
					modifiedWidgets.push(value1);
				}
			}
		});

		//Checkbox
		$.each(GwidgetlistCheckbox, function( index2, value1 ) {
			var widgetid = "#" + value1;
			var oldval = getWidgetValue(HUB_FAMILY_INDEX, value1);
			var newval = checkbox_unchecked_value;
			var that = $( widgetid ), parent = that.closest('fieldset');
			var  checkdisabled = $(parent).prop( "disabled" );
			if($(widgetid).is(':checked'))
			{
				newval = checkbox_checked_value;
			}

			// Enabled - check the previous value and determine delta                              
			if (oldval === newval) {
				// do nothing - no change in value
			}
			else if (checkdisabled)
			{
				// Change detected but field is disabled - So do nothing
			}
			else {
				//checking condition for USB2.0 enable
				
				if ((value1 == "enableport1") && (!($('#enableport1').is(':checked')))) {
					if ($('#usb3enableport1').is(':checked')) {
						alert("Usb2.0 port of Port1 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						update_status_message("Usb2.0 port of Port1 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						errorFlag = true;
						return;
					}
				}
				
				if ((value1 == "enableport2") && (!($('#enableport2').is(':checked')))) {
					if ($('#usb3enableport2').is(':checked')) {
						alert("Usb2.0 port of Port2 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						update_status_message("Usb2.0 port of Port2 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						errorFlag = true;
						return;
					}
				}
				
				if ((value1 == "enableport3") && (!($('#enableport3').is(':checked')))) {
					if ($('#usb3enableport3').is(':checked')) {
						alert("Usb2.0 port of Port3 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						update_status_message("Usb2.0 port of Port3 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						errorFlag = true;
						return;
					}
				}
				
				if ((value1 == "enableport4") && (!($('#enableport4').is(':checked')))) {
					if ($('#usb3enableport4').is(':checked')) {
						alert("Usb2.0 port of Port4 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						update_status_message("Usb2.0 port of Port4 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
						errorFlag = true;
						return;
					}
				}
				
				if (value1 == "enableport5") {
					var portSplitState = $('#port5splittinggroup').find(':checked').val();
					if (portSplitState == 1) {
						// No need to check for USB3 enable port.
					} else {
						if (!($('#enableport5').is(':checked'))) {
							if ($('#usb3enableport5').is(':checked')) {
								alert("Port splitting is disabled for Port5. So USB2.0 port of Port5 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
								update_status_message("Port splitting is disabled for Port5. So USB2.0 port of Port5 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
								errorFlag = true;
								return;
							}
						}
					}
				}
				
				if (value1 == "enableport6") {
					var portSplitState = $('#port6splittinggroup').find(':checked').val();
					if (portSplitState == 1) {
						// No need to check for USB3 enable port.
					} else {
						if (!($('#enableport6').is(':checked'))) {
							if ($('#usb3enableport6').is(':checked')) {
								alert("Port splitting is disabled for Port6. So USB2.0 port of Port6 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
								update_status_message("Port splitting is disabled for Port6. So USB2.0 port of Port6 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
								errorFlag = true;
								return;
							}
						}
					}
				}

				if (portsAvailable == 7) {
					if ((value1 == "enableport7") && (!($('#enableport7').is(':checked')))) {
						if ($('#usb3enableport7').is(':checked')) {
							alert("Usb2.0 port of Port7 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
							update_status_message("Usb2.0 port of Port7 cannot be disabled, when USB3.1 Gen1 port is still in enabled state.");
							errorFlag = true;
							return;
						}
					}
				}
				
				if (value1 == "enableport1") {
					//deltaobj.push("port1mapping", portMapValues["port1mapping"]);
					nrModified = true;
					
				}
				
				if (value1 == "enableport2") {
					//deltaobj.push("port2mapping", portMapValues["port2mapping"]);
					nrModified = true;
					
				}
				
				if (value1 == "enableport3") {
					//deltaobj.push("port3mapping", portMapValues["port3mapping"]);
					nrModified = true;
					
				}
				
				if (value1 == "enableport4") {
					//deltaobj.push("port4mapping", portMapValues["port4mapping"]);
					nrModified = true;
					
				}
				
				if (value1 == "enableport5") {
					//deltaobj.push("port5mapping", portMapValues["port5mapping"]);
					nrModified = true;
					
				}
				
				if (value1 == "enableport6") {
					//deltaobj.push("port6mapping", portMapValues["port6mapping"]);
					nrModified = true;
					
				}
				
				if (portsAvailable == 7) {
					if (value1 == "enableport7") {
						//deltaobj.push("port7mapping", portMapValues["port7mapping"]);
						nrModified = true;
						
					}
				}
				
				//Check for Non-removable parameter changes for all downstream port
				if (value1 == "nrdeviceport1") {
					nr1Modified = true;
					nrModified = true;
					
				} 
				if(value1 == "nrdeviceport2") {
					nr2Modified = true;
					nrModified = true;
					
				} 
				if(value1 == "nrdeviceport3") {
					nr3Modified = true;
					nrModified = true;
					
				} 
				if(value1 == "nrdeviceport4") {
					nr4Modified = true;
					nrModified = true;
					
				}
				if(value1 == "nrdeviceport5") {
					nr5Modified = true;
					nrModified = true;
					
				} 
				if(value1 == "nrdeviceport6") {
					nr6Modified = true;
					nrModified = true;
					
				} 
				
				if (portsAvailable == 7) {
					if(value1 == "nrdeviceport7") {
						nr7Modified = true;
						nrModified = true;
						
					}
				}
				
				if (value1 == "usb3nrdeviceport1") {
					usb3nr1Modified = true;
					usb3nrModified = true;
				} 
				if(value1 == "usb3nrdeviceport2") {
					usb3nr2Modified = true;
					usb3nrModified = true;
				} 
				if(value1 == "usb3nrdeviceport3") {
					usb3nr3Modified = true;
					usb3nrModified = true;
				} 
				if(value1 == "usb3nrdeviceport4") {
					usb3nr4Modified = true;
					usb3nrModified = true;
				}
				if(value1 == "usb3nrdeviceport5") {
					usb3nr5Modified = true;
					usb3nrModified = true;
				} 
				if(value1 == "usb3nrdeviceport6") {
					usb3nr6Modified = true;
					usb3nrModified = true;
				} 
				
				if (portsAvailable == 7) {
					if(value1 == "usb3nrdeviceport7") {
						usb3nr7Modified = true;
						usb3nrModified = true;
					}
				}
				
				
				//Check for Flexconnect enable or disable
				if ((value1 == "flexconnect") && (newval == checkbox_checked_value)) {
					enableFlex = true;
					disableFlex = false;
				} else if ((value1 == "flexconnect") && (newval == checkbox_unchecked_value)) {
					enableFlex = false;
					disableFlex = true;
				} else {
					enableFlex = false;
					disableFlex = false;
				}
				
				//Check for Upstream D+/D- swap
				if ((value1 == "swapupstreamdpdm") && (newval == checkbox_checked_value)) {
					enable_swapupstreamdpdm = true;
				} else {
					enable_swapupstreamdpdm = false;
				}
				
				if ((value1 == "lpmenable") && (newval == checkbox_checked_value)) {
					
					enable_lpm = true;
				} else {
					enable_lpm = false;
				}
			
				if( (value1 == "enableport1") || (value1 == "enableport2") 
				|| (value1 == "enableport3")  || (value1 == "enableport4") 
				|| (value1 == "enableport5")  || (value1 == "enableport6")
				|| (value1 == "enableport7"))
				{
					if (!SendNoofPorts && !numberofportState)
					{
						if(($('#nrdeviceport1').is(':checked')) || ($('#nrdeviceport2').is(':checked')) || 
						($('#nrdeviceport3').is(':checked')) || ($('#nrdeviceport4').is(':checked')) ||
						($('#nrdeviceport5').is(':checked')) || ($('#nrdeviceport6').is(':checked')) ||
						($('#nrdeviceport7').is(':checked')))
						{
							nrModified = true;
							
						}
						deltaobj.push("numberofports",bTotal);
						enableMapping = true;
						SendNoofPorts = 1; // Sent no.of ports enabled one time if there is any change.So no need to send again.
					}
				}
				
				// Specific to USB 3.1 Gen 1
				if( (value1 == "usb3enableport1") || (value1 == "usb3enableport2") 
				|| (value1 == "usb3enableport3")  || (value1 == "usb3enableport4") 
				|| (value1 == "usb3enableport5")  || (value1 == "usb3enableport6")
				|| (value1 == "usb3enableport7"))
				{
					if (!usb3SendNoofPorts && !usb3numberofportState)
					{
						if(($('#usb3nrdeviceport1').is(':checked')) || ($('#usb3nrdeviceport2').is(':checked')) || 
						($('#usb3nrdeviceport3').is(':checked')) || ($('#usb3nrdeviceport4').is(':checked')) ||
						($('#usb3nrdeviceport5').is(':checked')) || ($('#usb3nrdeviceport6').is(':checked')) ||
						($('#usb3nrdeviceport7').is(':checked')))
						{
							usb3nrModified = true;
						}
						deltaobj.push("usb3numberofports", usb3bTotal);
						enableMapping = true;
						usb3SendNoofPorts = 1; // Sent no.of ports enabled one time if there is any change.So no need to send again.
					}
				}
				
				//Check flexconnect condition
				if (value1 == "flexconnect") {
					if ($('#enableport1').is(':checked')) {
						deltaobj.push("flexconnect", newval);
					} else {
						alert("Downstream port 1 is disabled. Flex connect cannot be done. \n Enable Downstream port 1 and try again.");
						errorFlag = true;
					}
				} else if (value1 == "swapupstreamdpdm") {
					if ($('#swapupstreamdpdm').is(':checked')) {
						alert("Programming Upstream swap will swap D+ and D- lines of Upstream port. Please make require changes in hub for further processing after successful programming");
					}
					deltaobj.push("swapupstreamdpdm", newval);
					modifiedWidgets.push("swapupstreamdpdm");
				} else {
					deltaobj.push(value1, newval);
					modifiedWidgets.push(value1);
				}
			}
		});
		
		
		if(enablealertmanu && enablealertmanu && enablealertmanu) {
			var manuval = $("#hce_manufacturer").val();
			var prodval = $("#hce_product").val();
			var serval = $("#hce_serial").val();
			
			if((manuval != "") && (prodval != "") && (serval != "")) {
				window.alert("Only two strings can be enabled at a time for Hub Feature Controller.");
				update_status_message("Error : Only two strings can be enabled at a time for Hub Feature Controller.");
				deltaobj = [];
				modifiedWidgets = [];
				hceStringFlag = false;
				errorFlag = true;
				return;
			}
				
		}
		
		if(hceenablemanu || hceenableprod || hceenableser) {
			var manuval = $("#hce_manufacturer").val();
			var prodval = $("#hce_product").val();
			var serval = $("#hce_serial").val();
			var manlen = manuval.length;
			var prodlen = prodval.length;
			var serlen = serval.length;
			
			
			if(manuval == stringnullvalue) {
				manuval = "";
				manlen = 0;
			} else if(prodval == stringnullvalue) {
				prodval = "";
				prodlen = 0;
			} else if(serval == stringnullvalue) {
				serval = "";
				serlen = 0;
			}
			
			deltaobj.push("hce_manufacturerlen",manlen);
			deltaobj.push("hce_productlen",prodlen);
			deltaobj.push("hce_seriallen",serlen);
			deltaobj.push("hce_manufacturer", manuval);
			modifiedWidgets.push("hce_manufacturer");
			deltaobj.push("hce_product", prodval);
			modifiedWidgets.push("hce_product");
			deltaobj.push("hce_serial", serval);
			modifiedWidgets.push("hce_serial");
			
		}
		
		
		if (enableMapping == true) {
		
		var usb3portmapcount = 1;
		var usb2portmapcount = 1;
		var usb2port1MapLaterFlag = false;
		var usb2port2MapLaterFlag = false;
		var usb2port3MapLaterFlag = false;
		var usb2port4MapLaterFlag = false;
		var usb2port5MapLaterFlag = false;
		var usb2port6MapLaterFlag = false;
		var usb2port7MapLaterFlag = false;
		var currentStartPoint = 0;

		if(!bEnable1 && !usb3bEnable1)
		{
			deltaobj.push("usb3port1mapping", 0);
			deltaobj.push("port1mapping", 0);
			
			//Handling port2
			if(bEnable2 && usb3bEnable2) {
				deltaobj.push("usb3port2mapping", usb3portmapcount++);
				deltaobj.push("port2mapping", usb2portmapcount++);
				currentStartPoint = 2;
			}else if(usb3bEnable2) {
				deltaobj.push("usb3port2mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable2){
				deltaobj.push("usb3port2mapping", 0);
				if(bEnable2) {
					//deltaobj.push("port2mapping", usb2portmapcount++); Must map later
					usb2port2MapLaterFlag = true;
				} else {
					deltaobj.push("port2mapping", 0);
				}
			} else {
				//Do nothing
			}

			//handling port3
			if(bEnable3 && usb3bEnable3) {
				deltaobj.push("usb3port3mapping", usb3portmapcount++);
				deltaobj.push("port3mapping", usb2portmapcount++);
				currentStartPoint = 3;
			}else if(usb3bEnable3) {
				deltaobj.push("usb3port3mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable3){
				deltaobj.push("usb3port3mapping", 0);
				if(bEnable3) {
					usb2port3MapLaterFlag = true;
					//deltaobj.push("port3mapping", usb2portmapcount++); Must map later
				} else {
					deltaobj.push("port3mapping", 0);
				}
			} else {
				//Do nothing
			}

			//handling port4
			if(bEnable4 && usb3bEnable4) {
				deltaobj.push("usb3port4mapping", usb3portmapcount++);
				deltaobj.push("port4mapping", usb2portmapcount++);
				currentStartPoint = 4;
			}else if(usb3bEnable4) {
				deltaobj.push("usb3port4mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable4){
				deltaobj.push("usb3port4mapping", 0);
				if(bEnable4) {
					usb2port4MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port4mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port5
			if(bEnable5 && usb3bEnable5) {
				deltaobj.push("usb3port5mapping", usb3portmapcount++);
				deltaobj.push("port5mapping", usb2portmapcount++);
				currentStartPoint = 5;
			} else if(usb3bEnable5) {
				deltaobj.push("usb3port5mapping", usb3portmapcount++);
				var portSplitState = $('#port5splittinggroup').find(':checked').val();
				if (!bEnable5) {
					if (portSplitState == 1) {
						deltaobj.push("port5mapping", 0);
					}
				} else {
					if (portSplitState == 1) {
						deltaobj.push("port5mapping", (usb3portmapcount - 1));
					}
				}
				
			} else if (!usb3bEnable5){
				deltaobj.push("usb3port5mapping", 0);
				if(bEnable5) {
					usb2port5MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port5mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port6
			if(bEnable6 && usb3bEnable6) {
				deltaobj.push("usb3port6mapping", usb3portmapcount++);
				deltaobj.push("port6mapping", usb2portmapcount++);
				currentStartPoint = 6;
			} else if(usb3bEnable6) {
				deltaobj.push("usb3port6mapping", usb3portmapcount++);
				var portSplitState = $('#port6splittinggroup').find(':checked').val();
				if (!bEnable6) {
					if (portSplitState == 1) {
						deltaobj.push("port6mapping", 0);
					}
				} else {
					if (portSplitState == 1) {
						deltaobj.push("port6mapping", (usb3portmapcount - 1));
					}
				}
				
			} else if (!usb3bEnable6){
				deltaobj.push("usb3port6mapping", 0);
				if(bEnable6) {
					usb2port6MapLaterFlag = true;
				} else {
					deltaobj.push("port6mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port7
			if(bEnable7 && usb3bEnable7) {
				deltaobj.push("usb3port7mapping", usb3portmapcount++);
				deltaobj.push("port7mapping", usb2portmapcount++);
				currentStartPoint = 7;
			}else if(usb3bEnable7) {
				deltaobj.push("usb3port7mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable7){
				deltaobj.push("usb3port7mapping", 0);
				if(bEnable7) {
					usb2port7MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port7mapping", 0);
				}
			} else {
				//Do nothing
			}
			// USB2.0 Port mapping
			
			
			if (currentStartPoint == 7) {
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}
				
				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 6) {
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 5) {
				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 4) {
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 3) {
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 2) {
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}

				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
			}
			
		} else if (bEnable1 && !usb3bEnable1) {
			deltaobj.push("usb3port1mapping", 0);
			usb2port1MapLaterFlag = true;
			
			//Handling port2
			if(bEnable2 && usb3bEnable2) {
				deltaobj.push("usb3port2mapping", usb3portmapcount++);
				deltaobj.push("port2mapping", usb2portmapcount++);
				currentStartPoint = 2;
			}else if(usb3bEnable2) {
				deltaobj.push("usb3port2mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable2){
				deltaobj.push("usb3port2mapping", 0);
				if(bEnable2) {
					//deltaobj.push("port2mapping", usb2portmapcount++); Must map later
					usb2port2MapLaterFlag = true;
				} else {
					deltaobj.push("port2mapping", 0);
				}
			} else {
				//Do nothing
			}

			//handling port3
			if(bEnable3 && usb3bEnable3) {
				deltaobj.push("usb3port3mapping", usb3portmapcount++);
				deltaobj.push("port3mapping", usb2portmapcount++);
				currentStartPoint = 3;
			}else if(usb3bEnable3) {
				deltaobj.push("usb3port3mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable3){
				deltaobj.push("usb3port3mapping", 0);
				if(bEnable3) {
					usb2port3MapLaterFlag = true;
					//deltaobj.push("port3mapping", usb2portmapcount++); Must map later
				} else {
					deltaobj.push("port3mapping", 0);
				}
			} else {
				//Do nothing
			}

			//handling port4
			if(bEnable4 && usb3bEnable4) {
				deltaobj.push("usb3port4mapping", usb3portmapcount++);
				deltaobj.push("port4mapping", usb2portmapcount++);
				currentStartPoint = 4;
			}else if(usb3bEnable4) {
				deltaobj.push("usb3port4mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable4){
				deltaobj.push("usb3port4mapping", 0);
				if(bEnable4) {
					usb2port4MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port4mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port5
			if(bEnable5 && usb3bEnable5) {
				deltaobj.push("usb3port5mapping", usb3portmapcount++);
				deltaobj.push("port5mapping", usb2portmapcount++);
				currentStartPoint = 5;
			} else if(usb3bEnable5) {
				deltaobj.push("usb3port5mapping", usb3portmapcount++);
				var portSplitState = $('#port5splittinggroup').find(':checked').val();
				if (!bEnable5) {
					if (portSplitState == 1) {
						deltaobj.push("port5mapping", 0);
					}
				} else {
					if (portSplitState == 1) {
						deltaobj.push("port5mapping", (usb3portmapcount - 1));
					}
				}
				
			} else if (!usb3bEnable5){
				deltaobj.push("usb3port5mapping", 0);
				if(bEnable5) {
					usb2port5MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port5mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port6
			if(bEnable6 && usb3bEnable6) {
				deltaobj.push("usb3port6mapping", usb3portmapcount++);
				deltaobj.push("port6mapping", usb2portmapcount++);
				currentStartPoint = 6;
			} else if(usb3bEnable6) {
				deltaobj.push("usb3port6mapping", usb3portmapcount++);
				var portSplitState = $('#port6splittinggroup').find(':checked').val();
				if (!bEnable6) {
					if (portSplitState == 1) {
						deltaobj.push("port6mapping", 0);
					}
				} else {
					if (portSplitState == 1) {
						deltaobj.push("port6mapping", (usb3portmapcount - 1));
					}
				}
				
			} else if (!usb3bEnable6){
				deltaobj.push("usb3port6mapping", 0);
				if(bEnable6) {
					usb2port6MapLaterFlag = true;
				} else {
					deltaobj.push("port6mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port7
			if(bEnable7 && usb3bEnable7) {
				deltaobj.push("usb3port7mapping", usb3portmapcount++);
				deltaobj.push("port7mapping", usb2portmapcount++);
				currentStartPoint = 7;
			}else if(usb3bEnable7) {
				deltaobj.push("usb3port7mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable7){
				deltaobj.push("usb3port7mapping", 0);
				if(bEnable7) {
					usb2port7MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port7mapping", 0);
				}
			} else {
				//Do nothing
			}
			// USB2.0 Port mapping
			
			
			if (currentStartPoint == 7) {
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}
				
				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 6) {
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 5) {
				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 4) {
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 3) {
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 2) {
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}

				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
			}
		} else if (bEnable1 && usb3bEnable1) {
			currentStartPoint = 1;
			deltaobj.push("usb3port1mapping", usb3portmapcount++);
			deltaobj.push("port1mapping", usb2portmapcount++);
			
			//Handling port2
			if(bEnable2 && usb3bEnable2) {
				deltaobj.push("usb3port2mapping", usb3portmapcount++);
				deltaobj.push("port2mapping", usb2portmapcount++);
				currentStartPoint = 2;
			}else if(usb3bEnable2) {
				deltaobj.push("usb3port2mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable2){
				deltaobj.push("usb3port2mapping", 0);
				if(bEnable2) {
					//deltaobj.push("port2mapping", usb2portmapcount++); Must map later
					usb2port2MapLaterFlag = true;
				} else {
					deltaobj.push("port2mapping", 0);
				}
			} else {
				//Do nothing
			}

			//handling port3
			if(bEnable3 && usb3bEnable3) {
				deltaobj.push("usb3port3mapping", usb3portmapcount++);
				deltaobj.push("port3mapping", usb2portmapcount++);
				currentStartPoint = 3;
			}else if(usb3bEnable3) {
				deltaobj.push("usb3port3mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable3){
				deltaobj.push("usb3port3mapping", 0);
				if(bEnable3) {
					usb2port3MapLaterFlag = true;
					//deltaobj.push("port3mapping", usb2portmapcount++); Must map later
				} else {
					deltaobj.push("port3mapping", 0);
				}
			} else {
				//Do nothing
			}

			//handling port4
			if(bEnable4 && usb3bEnable4) {
				deltaobj.push("usb3port4mapping", usb3portmapcount++);
				deltaobj.push("port4mapping", usb2portmapcount++);
				currentStartPoint = 4;
			}else if(usb3bEnable4) {
				deltaobj.push("usb3port4mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable4){
				deltaobj.push("usb3port4mapping", 0);
				if(bEnable4) {
					usb2port4MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port4mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port5
			if(bEnable5 && usb3bEnable5) {
				deltaobj.push("usb3port5mapping", usb3portmapcount++);
				deltaobj.push("port5mapping", usb2portmapcount++);
				currentStartPoint = 5;
			} else if(usb3bEnable5) {
				deltaobj.push("usb3port5mapping", usb3portmapcount++);
				var portSplitState = $('#port5splittinggroup').find(':checked').val();
				if (!bEnable5) {
					if (portSplitState == 1) {
						deltaobj.push("port5mapping", 0);
					}
				} else {
					if (portSplitState == 1) {
						deltaobj.push("port5mapping", (usb3portmapcount - 1));
					}
				}
				
			} else if (!usb3bEnable5){
				deltaobj.push("usb3port5mapping", 0);
				if(bEnable5) {
					usb2port5MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port5mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port6
			if(bEnable6 && usb3bEnable6) {
				deltaobj.push("usb3port6mapping", usb3portmapcount++);
				deltaobj.push("port6mapping", usb2portmapcount++);
				currentStartPoint = 6;
			} else if(usb3bEnable6) {
				deltaobj.push("usb3port6mapping", usb3portmapcount++);
				var portSplitState = $('#port6splittinggroup').find(':checked').val();
				if (!bEnable6) {
					if (portSplitState == 1) {
						deltaobj.push("port6mapping", 0);
					}
				} else {
					if (portSplitState == 1) {
						deltaobj.push("port6mapping", (usb3portmapcount - 1));
					}
				}
				
			} else if (!usb3bEnable6){
				deltaobj.push("usb3port6mapping", 0);
				if(bEnable6) {
					usb2port6MapLaterFlag = true;
				} else {
					deltaobj.push("port6mapping", 0);
				}
			} else {
				//Do nothing
			}
			
			//handling port7
			if(bEnable7 && usb3bEnable7) {
				deltaobj.push("usb3port7mapping", usb3portmapcount++);
				deltaobj.push("port7mapping", usb2portmapcount++);
				currentStartPoint = 7;
			}else if(usb3bEnable7) {
				deltaobj.push("usb3port7mapping", usb3portmapcount++);
				
			} else if (!usb3bEnable7){
				deltaobj.push("usb3port7mapping", 0);
				if(bEnable7) {
					usb2port7MapLaterFlag = true;
					//deltaobj.push("port4mapping", usb2portmapcount++);Must map Later
				} else {
					deltaobj.push("port7mapping", 0);
				}
			} else {
				//Do nothing
			}
			// USB2.0 Port mapping
			
			
			if (currentStartPoint == 7) {
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}
				
				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 6) {
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 5) {
				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
				
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 4) {
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
				
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 3) {
				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
				if (usb2port2MapLaterFlag) {
					deltaobj.push("port2mapping", usb2portmapcount++);
				}
			}
			
			if (currentStartPoint == 2) {
				if (usb2port3MapLaterFlag) {
					deltaobj.push("port3mapping", usb2portmapcount++);
				}

				if (usb2port4MapLaterFlag) {
					deltaobj.push("port4mapping", usb2portmapcount++);
				}
				
				if (usb2port5MapLaterFlag) {
					deltaobj.push("port5mapping", usb2portmapcount++);
				}

				if (usb2port6MapLaterFlag) {
					deltaobj.push("port6mapping", usb2portmapcount++);
				}
				
				if (usb2port7MapLaterFlag) {
					deltaobj.push("port7mapping", usb2portmapcount++);
				}
				
				if (usb2port1MapLaterFlag) {
					deltaobj.push("port1mapping", usb2portmapcount++);
				}
			}
		}
	}
		if (enable_lpm == true) {
				
				alert("The change in LPM Enable will cause change in the USB bcdUSB");
				update_status_message("The change in LPM Enable will cause change in the USB bcdUSB");
		}
			
		//Adding non-removable state of all downstream ports depending on the state of "nrModified"
		if (nrModified) {
			
			var nr1 = ($("#nrdeviceport1").is(':checked'))?"1":"0";
			var nr2 = ($("#nrdeviceport2").is(':checked'))?"1":"0";
			var nr3 = ($("#nrdeviceport3").is(':checked'))?"1":"0";
			var nr4 = ($("#nrdeviceport4").is(':checked'))?"1":"0";
			var nr5 = ($("#nrdeviceport5").is(':checked'))?"1":"0";
			var nr6 = ($("#nrdeviceport6").is(':checked'))?"1":"0";
			var nr7 = 0;
			if (portsAvailable == 7) {
				nr7 = ($("#nrdeviceport7").is(':checked'))?"1":"0";
			}
			
			if(bEnable1 == true )
			{
				if(nr1Modified == false)
				{
					deltaobj.push("nrdeviceport1", nr1);
					
				}else{
				}
			} else {
				if(nr1Modified == false)
				{
					if (nr1UserModified) {
						modifiedWidgets.push("nrdeviceport1");
					}
					deltaobj.push("nrdeviceport1", 0);
					
				}else{
				}
			}
			
			if(bEnable2 == true)
			{
				if(nr2Modified == false)
				{
					deltaobj.push("nrdeviceport2", nr2);
					
				}else{
				}
			} else {
				if(nr2Modified == false)
				{
					if (nr2UserModified) {
						modifiedWidgets.push("nrdeviceport2");
					}
					deltaobj.push("nrdeviceport2", 0);
					
				}else{
				}
			}
			
			if(bEnable3 == true )
			{
				if(nr3Modified == false)
				{
					deltaobj.push("nrdeviceport3", nr3);
					
				}else{
				}
			} else {
				if(nr3Modified == false)
				{
					if (nr3UserModified) {
						modifiedWidgets.push("nrdeviceport3");
					}
					deltaobj.push("nrdeviceport3", 0);
					
				}else{
				}
			}
			
			if(bEnable4 == true )
			{
				if(nr4Modified == false)
				{
					deltaobj.push("nrdeviceport4", nr4);
					
				}else{
				}
			}else {
				if(nr4Modified == false)
				{
					if (nr4UserModified) {
						modifiedWidgets.push("nrdeviceport4");
					}
					deltaobj.push("nrdeviceport4", 0);
					
				}else{
				}
			}
			
			if(bEnable5 == true)
			{
				if(nr5Modified == false)
				{
					deltaobj.push("nrdeviceport5", nr5);
					
				}else{
				}
			} else {
				if(nr5Modified == false)
				{
					if (nr5UserModified) {
						modifiedWidgets.push("nrdeviceport5");
					}
					deltaobj.push("nrdeviceport5", 0);
					
				}else{
				}
			}
			
			if(bEnable6 == true )
			{
				if(nr6Modified == false)
				{
					deltaobj.push("nrdeviceport6", nr6);
					
				}else{
				}
			} else {
				if(nr6Modified == false)
				{
					if (nr6UserModified) {
						modifiedWidgets.push("nrdeviceport6");
					}
					deltaobj.push("nrdeviceport6", 0);
					
				}else{
				}
			}
			
			if (portsAvailable == 7) {
				if(bEnable7 == true )
				{
					if(nr7Modified == false)
					{
						deltaobj.push("nrdeviceport7", nr7);
						
					}else{
					}
				} else {
					if(nr7Modified == false)
					{
						if (nr7UserModified) {
							modifiedWidgets.push("nrdeviceport7");
						}
						deltaobj.push("nrdeviceport7", 0);
						
					}else{
					}
				}
			}
			nrModified = false;
			nr1Modified = false;
			nr2Modified = false;
			nr3Modified = false;
			nr4Modified = false;
			nr5Modified = false;
			nr6Modified = false;
			nr7Modified = false;
		}

		if (usb3nrModified) {
			
			var usb3nr1 = ($("#usb3nrdeviceport1").is(':checked'))?"1":"0";
			var usb3nr2 = ($("#usb3nrdeviceport2").is(':checked'))?"1":"0";
			var usb3nr3 = ($("#usb3nrdeviceport3").is(':checked'))?"1":"0";
			var usb3nr4 = ($("#usb3nrdeviceport4").is(':checked'))?"1":"0";
			var usb3nr5 = ($("#usb3nrdeviceport5").is(':checked'))?"1":"0";
			var usb3nr6 = ($("#usb3nrdeviceport6").is(':checked'))?"1":"0";
			var usb3nr7;
			if (portsAvailable == 7) {
				usb3nr7 = ($("#usb3nrdeviceport7").is(':checked'))?"1":"0";
			}
			
			if(usb3bEnable1 === true )
			{
				if(usb3nr1Modified === false)
				{
					deltaobj.push("usb3nrdeviceport1", usb3nr1);
				}else{
				}
			} else {
				if(usb3nr1Modified === false)
				{
					if (usb3nr1UserModified) {
						modifiedWidgets.push("usb3nrdeviceport1");
					}
					deltaobj.push("usb3nrdeviceport1", 0);
				}else{
				}
			}
			if(usb3bEnable2 === true)
			{
				if(usb3nr2Modified === false)
				{
					deltaobj.push("usb3nrdeviceport2", usb3nr2);
				}else{
				}
			} else {
				if(usb3nr2Modified === false)
				{
					if (usb3nr2UserModified) {
						modifiedWidgets.push("usb3nrdeviceport2");
					}
					deltaobj.push("usb3nrdeviceport2", 0);
				}else{
				}
			}
			if(usb3bEnable3 === true )
			{
				if(usb3nr3Modified === false)
				{
					deltaobj.push("usb3nrdeviceport3", usb3nr3);
				}else{
				}
			} else {
				if(usb3nr3Modified === false)
				{
					if (usb3nr3UserModified) {
						modifiedWidgets.push("usb3nrdeviceport3");
					}
					deltaobj.push("usb3nrdeviceport3", 0);
				}else{
				}
			}
			if(usb3bEnable4 === true )
			{
				if(usb3nr4Modified === false)
				{
					deltaobj.push("usb3nrdeviceport4", usb3nr4);
				}else{
				}
			}else {
				if(usb3nr4Modified === false)
				{
					if (usb3nr4UserModified) {
						modifiedWidgets.push("usb3nrdeviceport4");
					}
					deltaobj.push("usb3nrdeviceport4", 0);
				}else{
				}
			}
			
			if(usb3bEnable5 === true)
			{
				if(usb3nr5Modified === false)
				{
					deltaobj.push("usb3nrdeviceport5", usb3nr5);
				}else{
				}
			} else {
				if(usb3nr5Modified === false)
				{
					if (usb3nr5UserModified) {
						modifiedWidgets.push("usb3nrdeviceport5");
					}
					deltaobj.push("usb3nrdeviceport5", 0);
				}else{
				}
			}
			if(usb3bEnable6 === true )
			{
				if(usb3nr6Modified === false)
				{
					deltaobj.push("usb3nrdeviceport6", usb3nr6);
				}else{
				}
			} else {
				if(usb3nr6Modified === false)
				{
					if (usb3nr6UserModified) {
						modifiedWidgets.push("usb3nrdeviceport6");
					}
					deltaobj.push("usb3nrdeviceport6", 0);
				}else{
				}
			}
			if (portsAvailable == 7) {
				if(usb3bEnable7 === true )
				{
					if(usb3nr7Modified === false)
					{
						deltaobj.push("usb3nrdeviceport7", usb3nr7);
					}else{
					}
				}else {
					if(usb3nr7Modified === false)
					{
						if (usb3nr7UserModified) {
							modifiedWidgets.push("usb3nrdeviceport7");
						}
						deltaobj.push("usb3nrdeviceport7", 0);
					}else{
					}
				}
			}
			usb3nrModified = false;
			usb3nr1Modified = false;
			usb3nr2Modified = false;
			usb3nr3Modified = false;
			usb3nr4Modified = false;
			usb3nr5Modified = false;
			usb3nr6Modified = false;
			usb3nr7Modified = false;
		}

		var stringToSet = "";
		var wKey;
		var wVal;
		var flag = 0;

		if (deltaobj.length != 0) {
			for (var i = deltaobj.length; i >= 0; i = i - 2) {
				wKey = deltaobj[i];
				wVal = deltaobj[i+1];
				if ((typeof wKey === 'undefined') || (typeof wVal === 'undefined')) {
					// Do nothing
				} else {
					stringToSet = wKey + ",,," + wVal + ";;;" + stringToSet;
					flag++;
				}
			}
		}

		if (iniFile) {
			iniFile_fullPath = getFullPathINI();
			modifiedWidgets.push("xdataprogram");
			stringToSet = "xdataprogram,,," + iniFile_fullPath + ";;;" + stringToSet;
			flag++;
		}
		
		//Initializing the values with "-1".
		var regOptionChosen = -1;
		var Regadd = -1;
		var RegVal = -1;
		
		//Getting the data from the respective UI fields
		regOptionChosen = $("#Regoperationgroup").find(':checked').val();
		Regadd = $("#Regaddress").val();
		RegVal = $("#Regvalue").val();
		
		if ((regOptionChosen ) && (Regadd) && (RegVal)) { //|| (regOptionChosen == 0)
			
			if (typeof regOptionChosen === 'undefined') {
				alert("Please choose an appropriate action under the Direct Register Access.");
				errorFlag = true;
				return;
			}
		
			if(regOptionChosen == 0)
			{
				Regop = "XMODE_WRITE_BYTE";
			}
			else if(regOptionChosen == 1)
			{
				Regop = "XMODE_SET_BITS";
			}
			else if(regOptionChosen == 2)
			{
				Regop = "XMODE_CLEAR_BITS"
			}
			else
			{
				Regop = "";
				//do nothing
			}
			
			var isOKAddr = /^[0-9A-Fa-f]{4}$/i.test(Regadd);
			var newRegVal = RegVal.replace(/\s+/g, "");
			var isOKVal = /^[0-9A-Fa-f]+$/i.test(newRegVal);
			
			if ((Regadd == "") || (RegVal == "")) {
				alert("Either the value of register address or the register value is not entered under the Direct Register Access.");
				errorFlag = true;
				return;
			}
			
			if (!isOKAddr) {
				alert("The Register Address entered under the Direct Register Access must be a 4 digit hexadecimal number.");
				errorFlag = true;
			}
			
			if (!isOKVal) {
				alert("The Register value entered under the Direct Register Access is not a valid hexadecimal number.");
				errorFlag = true;
			}
			
			if (isOKAddr && isOKVal) {
				if (Regop.length == 0) {
					alert("Please choose appropriate register operation.");
					errorFlag = true;
				} else {
					if (Regadd && RegVal) {
						if (RegString) {
							RegString = Regop + "+" + Regadd + "+" + newRegVal + "+" + RegString;
						} else {
							RegString = Regop + "+" + Regadd + "+" + newRegVal;
						}
					} else {
						alert("Either Register address or Register value is not added.");
						errorFlag = true;
					}
				}
			}
		}
		
		if (RegString) {
			stringToSet = "xdataentry,,," + RegString + ";;;" + stringToSet;
			modifiedWidgets.push("xdataentry");
			flag++;
		}

		var displayChange = "";
		for (var i = 0; i < modifiedWidgets.length; i++) {
			if(i%4 == 0)
			{
				if (displayChange) {
					displayChange = "\n"+Mapping[modifiedWidgets[i]] + ", " + displayChange;
				} else {
					displayChange = Mapping[modifiedWidgets[i]];
				}
			} else {
				if (displayChange) {
					displayChange = Mapping[modifiedWidgets[i]] + ", " + displayChange;
				}
			}
		}
		
		if (flag == 0 && errorFlag == false) {
			alert("No changes detected for offline configuration.");
			update_status_message("No changes detected for offline configuration.");
		} else {
			if(errorFlag === false)
			{
				var option = confirm("Configuration file will be generated with the following device settings\n" + displayChange);
				
				if (option) {
					var result = setOfflineConfiguration(HUB_FAMILY_INDEX, stringToSet,"0");

					if (result) {
						alert("Offline configuration was created successfully");
						update_status_message("Offline configuration was created successfully for the following widgets.\n" + displayChange);
					} else {
						alert("Offline configuration failed.");
						update_status_message("Offline configuration failed.");		
					}
				} else {
					update_status_message("Generation of configuration file was terminated by the user.");
				}
				
				//clean up
				numberofportState = false;
				enable_lpm = false;
				enable_swapupstreamdpdm = false;
				hceenablemanu = false;
				hceenableprod  = false;
				hceenableser = false;
				
				//Variables are reverted to Zero
				resetVariables();
			}else{
			}
		}
});

function resetVariables () {
	vid_check = 0;
	pid_check = 0;
	did_check = 0;
	usb3vid_check = 0;
	usb3pid_check = 0;
	usb3did_check = 0;
	usb3vcd_check = 0;
	hce_vid_check = 0;
	hce_pid_check = 0;
	hce_did_check = 0;
	usbvcd_check = 0;
	languageid_check = 0;
	usb3languageid_check = 0;
	hce_languageid_check = 0;
	manufacturer_check = 0;
	product_check = 0;
	serial_check = 0;
	hce_manufacturer_check = 0;
	hce_product_check = 0;
	hce_serial_check = 0;
	usb3manufacturer_check = 0;
	usb3product_check = 0;
	usb3serial_check = 0;
	usb3uuid_check = 0;
	maxpowerself_check = 0;
	hubcmaxpowerself_check = 0;
	maxpowerbus_check = 0;
	hubcmaxpowerbus_check = 0;
	hub3maxpowerselfbus_check = 0;
	flexconnect_check = 0;
	hsdisable_check = 0;
	hceenable_check = 0;
	lpmenable_check = 0;
	swapupstreamdpdm_check = 0;
	swapport1dpdm_check = 0;
	swapport2dpdm_check = 0;
	swapport3dpdm_check = 0;
	swapport4dpdm_check = 0;
	swapport5dpdm_check = 0;
	swapport6dpdm_check = 0;
	swapport7dpdm_check = 0;
	nrdeviceport1_check = 0;
	nrdeviceport2_check = 0;
	nrdeviceport3_check = 0;
	nrdeviceport4_check = 0;
	nrdeviceport5_check = 0;
	nrdeviceport6_check = 0;
	nrdeviceport7_check = 0;
	enableport1_check = 0;
	enableport2_check = 0;
	enableport3_check = 0;
	enableport4_check = 0;
	enableport5_check = 0;
	enableport6_check = 0;
	enableport7_check = 0;
	usb3nrdeviceport1_check = 0;
	usb3nrdeviceport2_check = 0;
	usb3nrdeviceport3_check = 0;
	usb3nrdeviceport4_check = 0;
	usb3nrdeviceport5_check = 0;
	usb3nrdeviceport6_check = 0;
	usb3nrdeviceport7_check = 0;
	usb3enableport1_check = 0;
	usb3enableport2_check = 0;
	usb3enableport3_check = 0;
	usb3enableport4_check = 0;
	usb3enableport5_check = 0;
	usb3enableport6_check = 0;
	usb3enableport7_check = 0;
	usb3port1mapping_check = 0;
	usb3port2mapping_check = 0;
	usb3port3mapping_check = 0;
	usb3port4mapping_check = 0;
	usb3port5mapping_check = 0;
	usb3port6mapping_check = 0;
	usb3port7mapping_check = 0;
	port1mapping_check = 0;
	port2mapping_check = 0;
	port3mapping_check = 0;
	port4mapping_check = 0;
	port5mapping_check = 0;
	port6mapping_check = 0;
	port7mapping_check = 0;
	port5splittinggroup_check = 0;
	port6splittinggroup_check = 0;
	prtpwr5usb3splitgroup_check = 0;
	prtpwr6usb3splitgroup_check = 0;
	pstimeoutgroup_check = 0;
	hubpowergroup_check = 0;
	upstreambatterysettingsgroup_check = 0;
	suspendindicationgroup_check = 0;
	downstreamBCsettingport1group_check = 0;
	downstreamBCsettingport2group_check = 0;
	downstreamBCsettingport3group_check = 0;
	downstreamBCsettingport4group_check = 0;
	downstreamBCsettingport5group_check = 0;
	downstreamBCsettingport6group_check = 0;
	downstreamBCsettingport7group_check = 0;
	PHYBOOSTUL_check = 0;
	PHYBOOSTULdownstreamport1_check = 0;
	PHYBOOSTULdownstreamport2_check = 0;
	PHYBOOSTULdownstreamport3_check = 0;
	PHYBOOSTULdownstreamport4_check = 0;
	PHYBOOSTULdownstreamport5_check = 0;
	PHYBOOSTULdownstreamport6_check = 0;
	PHYBOOSTULdownstreamport7_check = 0;
	SQUELCHUL_check = 0;
	SQUELCHULdownstreamport1_check = 0;
	SQUELCHULdownstreamport2_check = 0;
	SQUELCHULdownstreamport3_check = 0;
	SQUELCHULdownstreamport4_check = 0;
	SQUELCHULdownstreamport5_check = 0;
	SQUELCHULdownstreamport6_check = 0;
	SQUELCHULdownstreamport7_check = 0;
	downstreamport1HsRiseFallUL_check = 0;
	downstreamport2HsRiseFallUL_check = 0;
	downstreamport3HsRiseFallUL_check = 0;
	downstreamport4HsRiseFallUL_check = 0;
	downstreamport5HsRiseFallUL_check = 0;
	downstreamport6HsRiseFallUL_check = 0;
	downstreamport7HsRiseFallUL_check = 0;
	upstreamHsRiseFallUL_check = 0;
	iniFileID_check = 0;
}